#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
const int N = 2e5 + 5, inf = 1e9;
vector<int> dx = {0, 1, -1, 0};
vector<int> dy = {1, 0, 0, -1};
int n, c = 0;
char arr[2][N];
bool vis[2][N];

bool check(int x, int y) {
    return (x >= 0 && x < 2 && y >= 0 && y < n);
}

void dfs(int x, int y) {
    c++;
    vis[x][y] = 1;
    for(int i = 0; i < 4; i++) {
        int xx = x + dx[i];
        int yy = y + dy[i];
        if(!check(xx, yy)) continue;
        if(vis[xx][yy]) continue;
        dfs(xx, yy);
    }
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
//    int n; cin >> n;
//    vector<int> a(n + 1, 0);
//    vector<int> in(n + 1, 0);
//    for(int i = 0; i < n; i++) {
//        cin >> a[i];
//        in[a[i]] = i + 1;
//    }
//    vector<int> cur(n + 1);
//    for(int i = 1; i <= n; i++) cur[i] = i;
//    set<pair<int, int>> seen;
//    vector<pair<int, int>> ans;
//    int c = 0;
//    for(int i = 1; i <= n; i++) {
//        for(int j = 2; j <= n - c; j++) {
//            if(in[j] < in[j - 1]) {
//                swap(in[j], in[j - 1]);
//                swap(cur[j], cur[j - 1]);
//                seen.insert({cur[j - 1], cur[j]});
//                ans.push_back(make_pair(cur[j - 1], cur[j]));
//            }
//        }
//        c++;
//    }
//    vector<int> pos(n + 1, 0);
//    for(int i = 1; i <= n; i++) pos[a[i]] = i;
//    for(int i = 1; i <= n; i++) {
//        for(int j = 1; j <= n; j++) {
//            if(i == j) continue;
//            if(seen.count({i, j}) || seen.count({j, i})) continue;
//            if(pos[j] - pos[i] == 1)
//            seen.insert({i, j});
//            seen.insert({j, i});
//            ans.push_back(make_pair(j, i));
//            ans.push_back(make_pair(i, j));
//        }
//    }
//    cout << ans.size() << endl;
//    for(auto &u : ans) {
//        cout << u.first << ' ' << u.second << endl;
//    }

    int t; cin >> t;
    while(t--) {
        cin >> n;
        string r1, r2; cin >> r1 >> r2;
        for(int i = 0; i < 2; i++) {
            for(int j = 0; j < n; j++) {
                vis[i][j] = 0;
                arr[i][j] = (i == 0 ? r1[j] : r2[j]);
                if(arr[i][j] == '#') vis[i][j] = 1;
            }
        }
        bool ok = 1;
        for(int i = 0; i < 2; i++) {
            for(int j = 0; j < n; j++) {
                if(!vis[i][j]) {
                    c = 0;
                    dfs(i, j);
                    if(c & 1) {
                        ok = 0;
                        break;
                    }
                }
            }
            if(!ok) break;
        }
        bool mul = 0;
        for(int i = 0; i < n; i++) if(r1[i] == '.' || r2[i] == '.') mul = 1;
        for(int i = 1; i < n; i++) {
            if(r1[i] == r2[i] && r1[i] == r1[i - 1] && r2[i] == r2[i - 1]) continue;
            mul = 0;
            break;
        }
        if(mul && ok) {
            cout << "Multiple\n";
        } else if(ok) {
            cout << "Unique\n";
        } else {
            cout << "None\n";
        }
    }
    return 0;
}
