#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
using namespace std;

#define ll long long

void solve() {
    int n;
    cin >>  n;
    vector<vector<ll>> v(2, vector<ll> (n));
    vector<vector<ll>> dp(n, vector<ll> (4, 0));

    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            char x;
            cin >> x;
            if (x == '#')
                v[i][j] = 1;
            else
                v[i][j] = 0;
        }
    }

    ll value = v[0][0] * 2 + v[1][0];
    if (value == 0) {
        dp[0][3] = 1;
    }
    dp[0][value] = 1;
    ll g = 2;
    for (int i = 1; i < n; ++i) {
        ll a = v[0][i];
        ll b = v[1][i];

        if (a == 0 && b == 0) {
            dp[i][0] = min(g, dp[i - 1][3]);
            dp[i][1] = min(g, dp[i - 1][2]);
            dp[i][2] = min(g, dp[i - 1][1]);
            dp[i][3] = min(g, dp[i - 1][3] + dp[i - 1][0]);
        }
        if (a == 0 && b == 1) {
            dp[i][1] = min(g, dp[i - 1][3]);
            dp[i][3] = min(g, dp[i - 1][1]);
        }
        if (a == 1 && b == 0) {
            dp[i][2] = min(g, dp[i - 1][3]);
            dp[i][3] = min(g, dp[i - 1][2]);
        }
        if (a == 1 && b == 1) {
            dp[i][3] = min(g, dp[i - 1][3]);
        }
    }


    if (dp[n - 1][3] == 0)
        cout << "None\n";
    else if (dp[n - 1][3] == 1)
        cout << "Unique\n";
    else
        cout << "Multiple\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
