#include <bits/stdc++.h>

#define int long long

using namespace std;

bool flag = false;

int evaluate_exp(string &s) {
    if (s.empty()) {
        flag = true;
        return -1;
    }
    int result = 0;
    int curr = 0, op = 1, num = 0;
    for (int k = 0; k < s.size(); k++) {
        if (s[k] == '+' || s[k] == '-') {
            if (k == s.size() - 1 || k == 0 || num == 0) {
                flag = true;
                return -1;
            }
            if (op) {
                result += curr;
            } else {
                result -= curr;
            }
            if (s[k] == '+')
                op = 1;
            else
                op = 0;
            curr = 0;
            num = 0;
            continue;
        }
        int d = s[k] - '0';
        curr = (curr * 10) + d;
        num++;
        if (num == 11 || (num >= 2 && curr < 10)) {
            flag = true;
            return -1;
        }
    }

    if (op) {
        result += curr;
    } else {
        result -= curr;
    }
    return result;
}

bool evaluate(string &s) {
    string first = "", second = "";
    int ind = 0;
    for (int k = 0; k < s.size(); k++) {
        if (s[k] == '=') {
            if (ind == 1) {
                return false;
            }
            ind = 1;
            continue;
        }
        if (ind) {
            first += s[k];
        } else {
            second += s[k];
        }
    }
    flag = false;
    int result = evaluate_exp(first) == evaluate_exp(second);
    return result && (!flag);
}

int32_t main() {
    string s;
    cin >> s;
    if (evaluate(s)) {
        cout << "Correct" << endl;
        return 0;
    }
    for (int k = 0; k < s.size(); k++) {
        if (s[k] == '+' || s[k] == '-' || s[k] == '=')
            continue;
        string l = s.substr(0, k);
        string r = s.substr(k + 1);
        for (int i = 0; i <= l.size(); i++) {
            string new_l = l.substr(0, i) + s[k] + l.substr(i);
            new_l += r;
            if (evaluate(new_l)) {
                cout << new_l << endl;
                return 0;
            }
        }
        for (int i = 0; i <= r.size(); i++) {
            string new_r = r.substr(0, i) + s[k] + r.substr(i);
            new_r = l + new_r;
            if (evaluate(new_r)) {
                cout << new_r << endl;
                return 0;
            }
        }
    }

    cout << "Impossible" << endl;

    return 0;
}
