#include <iostream>
#include <vector>
#include <unordered_map>

int main() {
	std::cin.tie(NULL);
	std::cout.tie(NULL);
	int n; std::cin >> n;
	std::vector<int> standing(n);
	std::unordered_map<int, int> map;

	for (int i = 0; i < n; ++i) {
		std::cin >> standing[i];
		map[standing[i]] = i;
	}

	std::vector<int> cur(n);
	for (int i = 1; i < n + 1; i++) {
		cur[i - 1] = i;
	}

	std::vector<int> print;
	long long swap = 0;
	for (int i = 0; i < n; i++) {
		int j = standing[i] - 1;
		while (standing[i] != cur[j]) {
			j++;
		}
		while (j > map.at(standing[i])) {
			int temp = cur[j];
			print.push_back(standing[i]);
			print.push_back(cur[j - 1]);
			swap++;

			cur[j] = cur[j - 1];
			cur[j - 1] = temp;


			j--;
		}
	}

	std::vector<int> tars(n);
	std::unordered_map<int, int> map2;
	for (int i = 0; i < n; i++) {
		tars[i] = n - i;
		map2[tars[i]] = i;
	}

	for (int i = 0; i < n; i++) {
		int j = n - tars[i];
		while (tars[i] != cur[j]) {
			j++;
		}
		while (j > map2.at(tars[i])) {
			int temp = cur[j];
			print.push_back(tars[i]);
			print.push_back(cur[j - 1]);
			swap++;

			cur[j] = cur[j - 1];
			cur[j - 1] = temp;


			j--;
		}
	}


	for (int i = 0; i < n; i++) {
		int j = n - standing[i];
		while (standing[i] != cur[j]) {
			j++;
		}
		while (j > map.at(standing[i])) {
			int temp = cur[j];
			print.push_back(standing[i]);
			print.push_back(cur[j - 1]);
			swap++;

			cur[j] = cur[j - 1];
			cur[j - 1] = temp;


			j--;
		}
	}

	std::cout << swap << std::endl;

    for (int i = 0; i < print.size(); i+=2) {
        std::cout << print[i] << " " << print[i + 1] << std::endl;
    }

	return 0;
}