#include <bits/stdc++.h>

using namespace std;

template <typename T_container, typename T = typename enable_if
        <!is_same<T_container, string>::value, typename
        T_container::value_type>::type>
ostream& operator<<(ostream &os, const T_container &v){
    os << '{';
    string sep;
    for (const T &x:v){
        os << sep << x;
        sep = ", ";
    }
    return os << '}';
}

void dbg_out(){cerr<<endl;}
template <typename Head, typename... Tail> void dbg_out(Head H
        ,Tail... T){cerr<<' '<<H; dbg_out(T...);}

#define dbg(...) dbg_out(__VA_ARGS__)
#define pi pair<int, int>
#define pb push_back
#define ft first
#define sd second
#define all(x) (x).begin(), (x).end()

#define TEST_CASES
#define vt vector

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vt<pair<int64_t, int64_t>> asd;
    {
        vt<int64_t> a(n), d(n);
        for(int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        for(int i = 0; i < n; ++i) {
            cin >> d[i];
        }
        vt<pair<int64_t, int64_t>> segments;
        for(int i = 0; i < n; ++i) {
            segments.emplace_back(d[i]- a[i], d[i]);
        }
        stable_sort(segments.begin(), segments.end(), [&](auto x, auto y) -> bool {
            return x.second < y.second;
        });
        for(int i = n - 1; i >= 0; --i) {
            int j = i;
            int64_t left = segments[i].first;
            while(j - 1 >= 0 and segments[j-1].second >= left) {
                --j;
                left -= segments[j].second - segments[j].first;
            }
            asd.emplace_back(left, segments[i].second);
            i = j;
        }
        sort(asd.begin(), asd.end());
    }
    vt<int64_t> l(m);
    for(int i = 0; i < m; ++i) {
        cin >> l[i];
        if(i) {
            l[i] += l[i-1];
        }
    }
    vt<pair<int64_t, int>> qs;
    for(int i = 0; i < q; ++i) {
        int64_t when; cin >> when;
        qs.emplace_back(when, i);
    }
    sort(qs.begin(), qs.end());
    int64_t used = 0;
    vt<int> res(q, - 1);
    int j = 0, k = -1;
    for(auto [time, id] : qs) {
        while(j < int(asd.size()) and asd[j].second <= time) {
            used += asd[j].second - asd[j].first;
            ++j;
        }
        auto real = used;
        if(j < int(asd.size()) and asd[j].first <= time) {
            real += time - asd[j].first;
        }
        while(k + 1 < m and l[k + 1] <= time - real) {
            ++k;
        }
        res[id] = k + 1;
    }
    for(auto x: res) {
        cout << x << ' ';
    }
    cout << '\n';
}

int main() {
//    freopen("C:\\work\\untitled\\inp.txt", "r", stdin);
    cin.tie(0)->sync_with_stdio(0);
    int tt = 1;
#ifdef TEST_CASES
    cin >>tt;
#endif
    while(tt--)
        solve();
    return 0;
}