#include <bits/stdc++.h>

#define int long long

using namespace std;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<array<int, 2>> a(n + 1);
    vector<int> task(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> task[i];
        a[i][1] = task[i];
    }
    vector<int> dead(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> dead[i];
        a[i][0] = dead[i];
    }
    sort(a.begin(), a.end());
    sort(dead.begin(), dead.end());
    vector<int> epis(m + 1);
    for (int i = 1; i <= m; i++) {
        cin >> epis[i];
    }
    vector<int> times(n + 1);
    for (int i = n; i >= 1; i--) {
        if (i == n) {
            times[i] = a[i][0] - a[i][1];
        } else {
            times[i] = min(a[i][0], times[i + 1]) - a[i][1];
        }
    }
    vector<int> pre_task(n + 1);
    for (int i = 1; i <= n; i++) {
        pre_task[i] = pre_task[i - 1] + a[i][1];
    }
    vector<int> pre_epis(m + 1);
    for (int i = 1; i <= m; i++) {
        pre_epis[i] = pre_epis[i - 1] + epis[i];
    }
    for (int it = 0; it < q; it++) {
        int t;
        cin >> t;
        int k = lower_bound(dead.begin(), dead.end(), t) - dead.begin();
        int have = (k <= n ? times[k] - pre_task[k - 1] : t);
        //cout << it << ": " << times[k] << ' ' << pre_task[k - 1] << ' ' << have << '\n';
        int ans = lower_bound(pre_epis.begin(), pre_epis.end(), have) - pre_epis.begin() - 1;
        cout << ans << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt;
    cin >> tt;
    while (tt--) solve();
}
