#include <string>
#include <iostream>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <algorithm>
#include <numeric>
#include <limits>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>

#pragma GCC optimize("Ofast")

using namespace std;

bool comp(pair<int, int> a, pair<int, int> b) {
    return a.second < b.second;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int n; cin >> n;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    
    vector<int> order(n + 1);
    for (int i = 1; i <= n; i++) {
        order[i] = i;
    }
    vector<pair<int, int>> res;
    vector<int> new_order;
    for (int i = n; i >= 1; i--) {
        new_order.push_back(order.back());
        order.pop_back();
        for (int j = order.size() - 1; j >= 1; j--) {
            res.push_back(make_pair(new_order.back(), order[j]));
        }
    }
    for (auto &v: new_order) order.push_back(v);
    vector<int> curr_pos(n + 1);
    for (int i = n; i >= 1; i--) {
        int curr_pos;
        for (int j = 1; j <= n; j++) {
            if (order[j] == a[i]) {
                curr_pos = j;
                break;
            }
        }
        for (int j = curr_pos; j < i; j++) {
            res.push_back(make_pair(order[j+1], order[j]));
            swap(order[j], order[j+1]);
        }
    }
    cout << res.size() << '\n';
    for (auto &v: res) cout << v.first << ' ' << v.second << '\n';
    return 0;
}