#include <bits/stdc++.h>
#define ll long long
#define f first
#define s second
#define mp make_pair
#define pb push_back
#define ppb pop_back
#define sk continue

using namespace std;

const int maxn = 1e6 + 111;
const ll inf = 1e9 + 7;
const ll INF = (ll)1e18;

pair <ll, bool> eval(string expression){

    expression += '+';

    ll res = 0;
    ll curr_num = 0;
    int num_len = 0;
    int sign = 1;
    bool lead_zero = false;

    for(int i = 0; i < expression.size(); i ++){
        if(expression[i] == '+'){
            if(num_len == 0){
                // cout << "\t\t\t NUM_LEN IS 0\n";
                return {0, false};
            }
            if(lead_zero && num_len != 1){
                // cout << "\t\t\t LEAD ZERO\n";
                return {0, false};
            }
            res += sign * curr_num;
            sign = 1;
            curr_num = 0;
            num_len = 0;
            lead_zero = false;
        }
        else if(expression[i] == '-'){
            if(num_len == 0){
                // cout << "\t\t\t NUM_LEN IS 0\n";
                return {0, false};
            }
            if(lead_zero && num_len != 1){
                // cout << "\t\t\t LEAD ZERO\n";
                return {0, false};
            }
            res += sign * curr_num;
            sign = -1;
            curr_num = 0;
            num_len = 0;
            lead_zero = false;
        }
        else{
            if(num_len == 0 && expression[i] == '0'){
                lead_zero = true;
            }
            curr_num = curr_num * 10 + (expression[i] - '0');
            num_len ++;
            if(num_len > 10){
                // cout << "\t\t\t NUM LEN IS GREATER THAN 10\n";
                return {0, false};
            }
        }
    }

    return {res, true};
}

bool check(string equation){

    for(int i = 0; i < equation.size(); i ++){
        if(equation[i] == '='){
            string left = "";
            string right = "";
            for(int j = 0; j < i; j ++){
                left += equation[j];
            }
            for(int j = i + 1; j < equation.size(); j ++){
                right += equation[j];
            }
            // cout << "\t\t" << left << ' ' << right << '\n';
            pair <ll, bool> left_res = eval(left);
            pair <ll, bool> right_res = eval(right);
            // return false;
            return (left_res.s == true && left_res == right_res);
        }
    }

    assert(false);

    return false;
}

int main () {

    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(NULL);

    string equation;

    cin >> equation;

    int n = equation.size();

    if(check(equation)){
        cout << "Correct\n";
        return 0;
    }

    for(int to_move = 0; to_move < n; to_move ++){
        if(equation[to_move] < '0' || equation [to_move] > '9'){
            continue;
        }
        for(int move_to = 0; move_to < n; move_to ++){
            string new_equation = "";
            if(new_equation.size() == move_to){
                new_equation += equation[to_move];
            }
            for(int i = 0; i < n; i ++){
                if(i == to_move){
                    continue;
                }
                new_equation += equation[i];
                if(new_equation.size() == move_to){
                    new_equation += equation[to_move];
                }
            }
            // cout << '\t' << new_equation << '\n';
            if(check(new_equation)){
                cout << new_equation << '\n';
                return 0;
            }
        }
    }

    cout << "Impossible\n";

    return 0;
}
