#include<bits/stdc++.h>

using namespace std;
const int N = 2e5 + 5;
int cnt[3][N];
char a[3][N];
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while(t--){
        int n;
        cin >> n;
        for(int i = 1; i <= 2; i++){
            for(int j = 1; j <= n; j++){
                cin >> a[i][j];
                cnt[i][j] = 0;
            }
        }

        for(int i = 1; i <= 2; i++){
            for(int j = 1; j <= n; j++){
                if(a[i][j] == '#') continue;
                if(i - 1 > 0 && a[i - 1][j] == '.'){
                    cnt[i][j]++;
                    cnt[i-1][j]++;
                }
                if(j - 1 > 0 && a[i][j - 1] == '.'){
                    cnt[i][j]++;
                    cnt[i][j-1]++;
                }
            }
        }
        queue<pair<int, int>> q;
        for(int i = 1; i <= 2; i++){
            for(int j = 1; j <= n; j++){
                if(cnt[i][j] == 1) q.push({i, j});
            }
        }
        while(q.size()){
            int i = q.front().first, j = q.front().second;
            q.pop();
            if(cnt[i][j] != 1) continue;
            int new_i = 0, new_j = 0;
            if(i - 1 > 0 && a[i-1][j] == '.'){
                new_i = i - 1;
                new_j = j;
            }else if(i + 1 <= 2 && a[i+1][j] == '.'){
                new_i = i + 1;
                new_j = j;
            }else if(j + 1 <= n && a[i][j+1] == '.'){
                new_i = i;
                new_j = j + 1;
            }else{
                new_i = i;
                new_j = j - 1;
            }
            a[i][j] = '#';
            cnt[i][j] = 0;
            a[new_i][new_j] = '#';
            cnt[new_i][new_j] = 0;
            int to_i = 0, to_j = 0;
            if(new_i - 1 > 0 && a[new_i-1][new_j] == '.'){
                to_i = new_i - 1;
                to_j = new_j;
                cnt[to_i][to_j]--;
                if(cnt[to_i][to_j] == 1) q.push({to_i, to_j});
            }
            if(new_i + 1 <= 2 && a[new_i+1][new_j] == '.'){
                to_i = new_i + 1;
                to_j = new_j;
                cnt[to_i][to_j]--;
                if(cnt[to_i][to_j] == 1) q.push({to_i, to_j});
            }
            if(new_j + 1 <= n && a[new_i][new_j+1] == '.'){
                to_i = new_i;
                to_j = new_j + 1;
                cnt[to_i][to_j]--;
                if(cnt[to_i][to_j] == 1) q.push({to_i, to_j});
            }
            if(new_j - 1 > 0 && a[new_i][new_j-1] == '.'){
                to_i = new_i;
                to_j = new_j - 1;
                cnt[to_i][to_j]--;
                if(cnt[to_i][to_j] == 1) q.push({to_i, to_j});
            }
        }
        bool flag = false;
        for(int i = 1; i <= 2; i++){
            for(int j = 1; j <= n; j++){
                if(a[i][j] == '.' && cnt[i][j] == 0){
                    flag = true;
                }
            }
        }
        if(flag){
            cout << "None\n";
        }else{
            for(int i = 1; i <= 2; i++){
                for(int j = 1; j <= n; j++){
                    if(a[i][j] == '.'){
                        flag = true;
                    }
                }
            }
            if(flag) cout << "Multiple\n";
            else cout << "Unique\n";
        }
    }
}
