#include<bits/stdc++.h>

#define DEBUGSTR_WNAME(os, name, a) \
    do { (os) << (name) << " = " << (a) << std::endl; } while(false)

#define DEBUGSTR(os, a) DEBUGSTR_WNAME((os), #a, (a))
#define DEBUG(a) DEBUGSTR_WNAME(std::cout, #a, (a))

#define ll long long
#define ld long double

#define pii pair<int, int>
#define vi vector<int>
#define vl vector<ll>

#define all(x) x.begin(), x.end()
#define sz(x)  (int)x.size()
#define pb push_back
#define fi first
#define se second

using namespace std;

const int N = (int)2e5 + 2000;
const int M = (int)1e7 + 200;
const ll mod = (ll)1e9+7;
const ll inf = (ll)1e18 + 7;
const char nl = '\n';



void solve() {
    int n;
    cin >> n;
    vector< vector<char> > s( 2, vector<char>(n) );
    for(int i = 0; i < 2; i++) {
        for(int j = 0; j < n; j++) {
            cin >> s[i][j];
        }
    }
    int mult = 0;
    for(int j = 0; j < n; j++) {
        if(s[0][j] == '.' && s[1][j] == '#'
           && (j+1 < n && s[0][j+1] == '#')) {
            cout << "None";
            return;
        }
        if(s[0][j] == '.' && s[1][j] == '.'
           && (j+1 < n && s[0][j+1] == '.')) {
            if(s[1][j+1] == '.') {
                mult = 1;
                s[0][j] = '#';
                s[1][j] = '#';
                s[1][j+1] = '#';
                s[0][j+1] = '#';
            } else {
                s[0][j] = '#';
                s[1][j] = '#';
            }
            continue;
        }
        if(s[0][j] == '.' && s[1][j] == '.') {
            s[0][j] = '#';
            s[1][j] = '#';
            continue;
        }
        if(s[0][j] == '.' && (j+1 < n && s[0][j+1] == '.')) {
            s[0][j] = '#';
            s[0][j+1] = '#';
            continue;
        }
        if(s[1][j] == '.' && (j+1 < n && s[1][j+1] == '.')) {
            s[1][j] = '#';
            s[1][j+1] = '#';
            continue;
        }
    }
    for(int i = 0; i < 2; i++)
        for(int j = 0; j < n; j++)
            if(s[i][j] == '.') {
                cout << "None";
                return;
            }
    if(mult)
        cout << "Multiple";
    else
        cout << "Unique";
}

int main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int test = 1;
    cin >> test;
    while(test--) {
        solve();
        cout << nl;
    }
}
