// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <map>
#include <math.h>
#define int long long

using namespace std;

map<int, int> indexes;
map<pair<int, int>, int> swaps;
vector<pair<int, int>> swap_vec;
map<int, int> indexes_rev;

void bubble_sort(vector<int>& vec) {
	for (int i = 0; i < vec.size(); i++) {

		int minJ = i;
		int minEl = vec[i];
		for (int j = i; j < vec.size(); j++) {
			if (vec[j] < minEl) {
				minJ = j;
				minEl = vec[j];
			}
		}

		int k = minJ;
		while (k != i) {
			swap(vec[k], vec[k - 1]);
			swaps[{ vec[k - 1], vec[k] }]++;
			swap_vec.push_back({ vec[k - 1], vec[k] });
			k--;
		}
	}
}

//void bubble_sort(vector<int>& vec) {
//	int n = vec.size();
//
//	for (int i = 0; i < n; i++) {
//		for (int j = i; j < n; j++) {
//			if (vec[i] > vec[j]) {
//				swap(vec[i], vec[j]);
//				swaps[make_pair(vec[i], vec[j])]++;
//				swap_vec.push_back(make_pair(vec[i], vec[j]));
//				swap_cnt++;
//			}
//
//		}
//	}
//}

pair<int, int> get_pair(int a, int b) {
	if (a > b)
		swap(a, b);

	return make_pair(a, b);
}

int get_swaps(int a, int b) {
	return swaps[get_pair(a, b)];
}

#undef int
int main()
#define int long long
{
	int n;
	cin >> n;

	vector<int> vec(n);

	for (int i = 0; i < n; i++) {
		int tmp;
		cin >> tmp;
		indexes[tmp] = i;
		indexes_rev[i] = tmp;
	}

	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++) {
			if (i == j)
				continue;

			swaps[get_pair(i, j)] = 0;
		}
			

	for (int i = 1; i <= n; i++) {
		vec[i - 1] = indexes[i];
	}

	bubble_sort(vec);

	for (int i = 0; i < n - 1; i++) {
		int j = i, k = i + 1;

		int cnt = 0;

		while (true) {
			if (get_swaps(vec[j], vec[k]) != 0)
				break;

			swap_vec.push_back({ vec[k], vec[j] });
			swap(vec[k], vec[j]);
			swaps[get_pair(vec[j], vec[k])]++;

			cnt++;
			j++;
			k++;

			if (k == n)
				break;
		}

		while(cnt--) {
			j--;
			k--;

			swap_vec.push_back({ vec[k], vec[j] });
			swap(vec[k], vec[j]);
			swaps[get_pair(vec[j], vec[k])]++;
		}
	}

	cout << swap_vec.size() << endl;

	for(int i = 0; i < vec.size(); i++)
		if(i != vec[i])
			throw "Rishat loh";
	
	for (auto k : swaps)
		if (k.second > 2 || k.second == 0)
			throw "Ramis loh";

	for (int i = 0; i < swap_vec.size(); i++)
	{
		cout << indexes_rev[swap_vec[i].first] << " " << indexes_rev[swap_vec[i].second] << endl;
	}
}
