//
// Created by nef on 15.12.2024.
//

#include <bits/stdc++.h>
#define ll long long
const int mod = 1e9 + 7;

using namespace std;

const int N = 1000 + 11;

int a[N];
int p[N];
int used[N][N];

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        p[i] = i;
    }
    vector<pair<int, int>> ans;
    for (int i = n; i >= 1; i--) {
        int pos = -1;
        for (int j = 1; j <= n; j++) {
            if (a[i] == p[j]) {
                pos = j;
                break;
            }
        }
        assert(pos != -1);
        assert(pos <= i);
        for (int j = pos; j < i; j++) {
            swap(p[j], p[j + 1]);
            used[p[j]][p[j + 1]] = 1;
        }
    }
    for (int i = 1; i <= n; i++) {
        p[i] = i;
    }
    for (int i = n; i >= 1; i--) {
        int pos = -1;
        for (int j = 1; j <= n; j++) {
            if (a[i] == p[j]) {
                pos = j;
                break;
            }
        }
//        for (int j = 1; j < n; j++) {
//            if (!used[p[j]][p[j + 1]] && !used[p[j + 1]][p[j]]) {
//                ans.emplace_back(p[j], p[j + 1]);
//                ans.emplace_back(p[j + 1], p[j]);
//                used[p[j]][p[j + 1]] = 1;
//                used[p[j + 1]][p[j]] = 1;
//            }
//        }
        assert(pos != -1);
        assert(pos <= i);
        for (int j = pos; j < i; j++) {
            ans.emplace_back(p[j], p[j + 1]);
            swap(p[j], p[j + 1]);
            used[p[j]][p[j + 1]] = 1;
        }
    }
    for (int i = 1; i <= n; i++) {
        assert(p[i] == a[i]);
        int pos = -1;
        for (int j = i - 1; j >= 1; j--) {
            if (used[p[i]][p[j]] || used[p[j]][p[i]]) {
                break;
            }
            pos = j;
        }
        if (pos != -1) {
            for (int j = i; j > pos; j--) {
                ans.emplace_back(p[j - 1], p[j]);
                swap(p[j - 1], p[j]);
            }
            for (int j = pos; j < i; j++) {
                ans.emplace_back(p[j], p[j + 1]);
                swap(p[j], p[j + 1]);
            }
        }
    }
    cout << ans.size() << "\n";
    for (auto pr : ans) {
        cout << pr.second << " " << pr.first << "\n";
    }

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int T = 1;
    //cin >> T;

    while(T--) solve();

    return 0;
}