import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import static java.lang.String.valueOf;

//TIP To <b>Run</b> code, press <shortcut actionId="Run"/> or
// click the <icon src="AllIcons.Actions.Execute"/> icon in the gutter.
public class Main {
    static List<String> overtakes = new ArrayList<>();
    static List<String> overtakes1 = new ArrayList<>();

    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        int n = Integer.parseInt(reader.readLine());
        String[] line = reader.readLine().split(" ");
        int[] cars = new int[n];
        for (int i = 0; i < n; i++) {
            cars[i] = Integer.parseInt(line[i]);
        }
        int result = 0;
        int counter = 1;
        int start = 0, end = 0;
        for (int i = 1; i < cars.length; i++) {
            if (cars[i - 1] + 1 == cars[i]) {
                counter++;
                end = i;
            } else {
                result += counter * (counter - 1);
                counter = 1;
                addOvertakes(cars, start, end);
                start = i + 1;
            }
        }

        addOvertakes(cars, start, end);
        result += counter * (counter - 1);
        result += bubbleSort(cars);
        System.out.println(result);

        for (int i = overtakes.size() - 1; i >= 0; i--) {
            System.out.println(overtakes.get(i));
        }
        for (String val : overtakes1) {
            System.out.println(val);
        }
    }

    private static void addOvertakes(int[] cars, int startIdx, int endIdx) {
        for (int i = startIdx; i <= endIdx; i++) {
            for (int j = i + 1; j <= endIdx; j++) {
                String key = String.valueOf(cars[j]) + " " + String.valueOf(cars[i]);
                overtakes1.add(key);
            }

            for (int j = endIdx; j > i; j--) {
                String key = String.valueOf(cars[i]) + " " + String.valueOf(cars[j]);
                overtakes1.add(key);
            }
        }
    }

    private static int bubbleSort(int[] cars) {
        int counter = 0;
        while (true) {
            boolean shift = false;
            for (int i = cars.length - 1; i > 0; i--) {
                if (cars[i - 1] > cars[i]) {
                    int temp = cars[i];
                    cars[i] = cars[i - 1];
                    cars[i - 1] = temp;
                    shift = true;
                    counter++;
                    String key = valueOf(cars[i]) + " " + String.valueOf(cars[i-1]);
                    overtakes.add(key);
                }
            }

            if (!shift) break;
        }

        return counter;
    }
}