from sys import stdout, stdin


def super_eval(string):
    try:
        return True, eval(string)
    except Exception:
        return False, False


def valid(string: str):
    if string.startswith(('-', '+')):
        return False
    if string.endswith(('-', '+')):
        return False
    if not string:
        return False
    stack = list()
    for value in string:
        if value.isdigit():
            stack.append(value)
        else:
            s = ''.join(stack)
            if len(s) > 10:
                return False
            stack.clear()
            if s.startswith('0'):
                if s == '0':
                    continue
                else:
                    return False
    if len(stack) > 10:
        return False
    if stack:
        s = ''.join(stack)
        if s.startswith('0'):
            if s != '0':
                return False
    for i in range(len(string) - 1):
        if not string[i].isdigit() and not string[i + 1].isdigit():
            return False
    return True


def main():
    string = stdin.readline().rstrip()
    left, right = string.split('=')
    if super_eval(left)[0] is super_eval(right)[0] is True:
        if super_eval(left)[1] == super_eval(right)[1]:
            print('Correct')
            return

    for i in range(len(string)):
        if not string[i].isdigit():
            continue
        new_string = list(string)
        digit = new_string.pop(i)

        for j in range(len(new_string) + 1):
            new_string_2 = new_string.copy()
            try:
                new_string_2.insert(j, digit)
                new_string_2 = ''.join(new_string_2)
                left, right = new_string_2.split('=')
                if valid(left) and valid(right):
                    if super_eval(left)[0] and super_eval(right)[0]:
                        if super_eval(left)[1] == super_eval(right)[1]:
                            new_string_2 = ''.join(new_string_2)
                            print(new_string_2)
                            return

            except IndexError:
                continue

    print('Impossible')


def read_nums():
    return list(map(int, stdin.readline().split()))


def read_num():
    return int(stdin.readline().rstrip())


if __name__ == '__main__':
    "123456789+9876543210=1111111100+11-1"
    '''
    1000000000-10=9999999999
10000000000-1=9999999999
    '''
    main()