import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int n = in.nextInt();
        int[] arr = new int[n];
        int[] sortedArr = new int[n];
        for (int i = 0; i < n; i++) {
            arr[i] = in.nextInt();
            sortedArr[i] = i+1;
        }
        if (n == 1) {
            System.out.println(0);
            return;
        }
        ArrayList<Integer[]> overtakes = new ArrayList<>();
        int curIndex = 0;
        boolean isSwaped = false;
        while (!Arrays.equals(sortedArr, arr)) {
            if (sortedArr[curIndex] == arr[curIndex]) {
                curIndex = 0;
                isSwaped = false;
            } else {
                swap(sortedArr, curIndex, curIndex+1);
                isSwaped = true;
                curIndex++;
                Integer[] temp = {sortedArr[curIndex-1], sortedArr[curIndex]};
                overtakes.add(temp);
            }
            if (!isSwaped) curIndex++;
        }

        for (int i = 0; i < n-1; i++) {
            boolean isAdd = true;
            for (Integer[] overtake : overtakes) {
                if (overtake[0] == sortedArr[i] && overtake[1] == sortedArr[i+1]) {
                    isAdd = false;
                    break;
                }
                if (overtake[1] == sortedArr[i] && overtake[0] == sortedArr[i+1]) {
                    isAdd = false;
                    break;
                }

            }
            if (isAdd) {
                Integer[] swap1 = {sortedArr[i+1], sortedArr[i]};
                Integer[] swap2 = {sortedArr[i], sortedArr[i+1]};
                overtakes.add(swap1);
                overtakes.add(swap2);
            }
        }
        System.out.println(overtakes.size());
        for (Integer[] overtake : overtakes) {
            System.out.println(overtake[0] + " " + overtake[1]);
        }

    }
    static void swap(int[] arr, int first, int second) {
        int temp = arr[first];
        arr[first] = arr[second];
        arr[second] = temp;
    }
}
