

s = input()

# s = "123456789+9876543210=111111110+11-1"


def is_valid(exp):
    parts = []
    for i in exp:
        if not parts:
            parts.append(i)
        elif i in "-+=":
            parts.append(i)
            parts.append("")
        else:
            parts[-1] = parts[-1] + i
    for p in parts:
        if len(p) > 10:
            return False
        if p not in "-=+" and p[0] == "0":
            return False

    for i in range(1, len(parts)):
        if parts[i] in "-=+" and parts[i-1] in "-=+":
            return False
    if parts[-1] in "+=-":
        return False
    return True


def calc(exp):
    return eval(exp)


def is_correct(exp):
    part1, part2 = exp.split("=")
    return calc(part1) == calc(part2)


def main(s):
    for i in range(len(s)):
        if s[i] not in "1234567890":
            continue
        news = s[:i] + s[i+1:]

        for j in range(len(news)):
            exp = news[:j] + s[i] + news[j:]
            if is_valid(exp):
                if is_correct(exp):
                    print(exp)
                    return True

    return False


if is_correct(s):
    print("Correct")
elif not main(s):
    print("Impossible")



#