//Novosibirsk SU 1 CtrlAltDeFIT
// 001

#include <bits/stdc++.h>

using namespace std;
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define sz(x) (int)(x).size()
#define all(x) begin(x), end(x)
typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int maxn = 1e5 + 7;
vector<int> g[maxn];
int deg[maxn];

void add_edge(int v, int u) {
    deg[u]++;
    g[v].push_back(u);
}

void solve() {
    int n;
    cin >> n;
    vector<int> t(n);
    int cnt[4] = {0};
    int p_ut, p_st;
    for (int i = 0; i < n; ++i) {
        string s1, s2;
        cin >> s1 >> s2;
        if (s1[0] == 's') {
            t[i] += 2;
        }
        if (s2[0] == 't') {
            t[i] += 1;
        }
        cnt[t[i]] += 1;
        if (t[i] == 1) {
            p_ut = i;
        } else if (t[i] == 3) {
            p_st = i;
        }
    }
    if (!(cnt[1] + cnt[3] == 0 || (cnt[3] == 1 && cnt[1] == 0) || (cnt[3] == 1 && cnt[1] == 1))) {
        cout << -1;
        return;
    }
    if (cnt[1] + cnt[3] == 0) {
        if (cnt[2] != 0) {
            cout << -1;
            return;
        }
    }
    int q;
    cin >> q;
    rep(i, 0, q) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        if (t[a] == t[b]) {
            add_edge(a, b);
            continue;
        }
        if (cnt[1] + cnt[3] == 0) {
            assert(false);
            continue;
        } else if (cnt[1] == 0 && cnt[3] == 1) {
            if (t[a] == 3) {
                if (t[b] == 0) {
                    cout << -1;
                    return;
                }
                // st -> sf
                add_edge(a, b);
                continue;
            }
            if (t[a] == 0) {
                if (t[b] == 3) {
                    add_edge(a, b);
                } else {
                    add_edge(a, p_st);
                    add_edge(p_st, b);
                }
                continue;
            }
            //t[a] == 2;
            cout << -1;
            return;
        }
        assert(cnt[1] == 1 && cnt[3] == 1);
        if (t[a] == 0) {
            if (t[b] == 3) {
                add_edge(a, b);
            } else {
                add_edge(a, p_st);
                add_edge(p_st, b);
            }
            continue;
        }
        if (t[a] == 1) {
            if (t[b] != 0) {
                cout << -1;
                return;
            }
            add_edge(a, b);
            continue;
        }
        if (t[a] == 2) {
            if (t[b] == 3) {
                cout << -1;
                return;
            }
            if (t[b] == 0) {
                add_edge(a, p_ut);
                add_edge(p_ut, b);
            } else {
                add_edge(a, b);
            }
            continue;
        }
        assert(t[a] == 3);
        if (t[b] == 0) {
            add_edge(p_ut, b);
        }
    }
    if (cnt[1] == 0 && cnt[3] == 1) {
        for (int i = 0; i < n; ++i) {
            if (t[i] == 0) {
                add_edge(i, p_st);
            } else if (t[i] == 2) {
                add_edge(p_st, i);
            }
        }
    }
    if (cnt[1] == 1 && cnt[3] == 1) {
        for (int i = 0; i < n; ++i) {
            if (t[i] == 2) {
                add_edge(p_st, i);
                add_edge(i, p_ut);
            }
        }
        add_edge(p_st, p_ut);
    }
    set<pair<int, int>> s;
    for (int i = 0; i < n; ++i) {
        if (deg[i] == 0) {
            s.insert({t[i], i});
        }
    }
    vector<int> ans;
    while (!s.empty()) {
        int v = s.begin()->second;
        ans.push_back(v);
        s.erase(s.begin());
        for (int u: g[v]) {
            --deg[u];
            if (deg[u] == 0) {
                s.insert({t[u], u});
            }
        }
    }
    if (ans.size() != n) {
        cout << -1;
        return;
    }
    for (int i: ans) {
        cout << i + 1 << ' ';
    }
}

int main() {
//    freopen("input.txt", "r", stdin);
    cin.tie(0)->sync_with_stdio(false);
    cout << setprecision(15) << fixed;
    int t = 1;
    // cin >> t;
    rep(i, 0, t) {
        solve();
    }
    return 0;
}
