#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <string>

using namespace std;
#define int long long
#define Fast ios_base::sync_with_stdio(false);sin.tie(nullptr);cout.tie(nullptr);
bool mem;
bool flag = true;
int n;

int dfs(int x, int y, string& s1, string& s2, vector<bool>& used1, vector<bool>& used2) {
	int h = 1;
	if (y == 1) {
		used1[x] = true;
		if (s2[x] == '.' && !used2[x]) {
			h += dfs(x, 2, s1, s2,used1,used2);
		}
		if (s2[x] == '#') {
			mem = false;
		}

		if (x + 1 < n && s1[x + 1] == '.' && !used1[x+1]) {
			h += dfs(x + 1, 1, s1, s2, used1, used2);
		}
	}
	else {
		used2[x] = true;
		if (x + 1 < n && s2[x + 1] == '.' && !used2[x + 1]) {
			h += dfs(x + 1, 2, s1, s2, used1, used2);
		}
		if (s1[x] == '.' && !used1[x]) {
			h += dfs(x, 1, s1, s2, used1, used2);
		}
		if (s1[x] == '#') {
			mem = false;
		}
	}
	return h;
}


void solve() {
	mem = true;
	flag = false;
	cin >> n;
	string s1, s2;
	vector<bool> used1(n,false);
	vector<bool> used2(n,false);
	cin >> s1 >> s2;
	bool f = false;
	int cnt1 = 0, cnt2 = 0;
	for (int i = 0; i < n; i++) {
		if (s1[i] == '.' && used1[i] == false) {
			mem = true;
			int h = dfs(i, 1, s1, s2, used1, used2);
			if (h % 2 == 1) {
				cout << "None" << endl;
				return;
			}
			flag = flag || mem;
			f = true;
		}
		if (s2[i] == '.' && used2[i] == false) {
			mem = true;
			if (dfs(i, 2, s1, s2, used1, used2) % 2 == 1) {
				cout << "None" << endl;
				return;
			}
			flag = mem || flag;
			f = true;
		}
	}
	mem = flag;
	cout << (mem && f ? "Multiple" : "Unique") << endl;
}

signed main(){
	int t;
	cin >> t;
	while (t--) solve();
	return 0;
}

/*
4
10
#.......##
##..#.##..

6
...#..
..#...

8 
........
........

3
###
###

*/