#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <set>

using namespace std;

void solveA()
{
    int n;

    cin >> n;

    vector<int> arr(n);
    vector<int> base(n);
    string ans;
    int num = 0;

    for (int i = 0; i < n; i++)
    {
        cin >> arr[i];
        base[i] = i + 1;
    }

    for (int i = 0; i < n; i++)
    {
        int r;
        for (int j = i; j < n; j++)
            if (base[j] == arr[i])
                r = j;

        for (int l = i; l < r; r--)
        {
            ans += to_string(base[r]) + ' ' + to_string(base[r - 1]) + '\n';
            swap(base[r - 1], base[r]);
            num++;
        }
    }

    for (int i = 0; i < n - 1; i++)
    {
        if (arr[i] < arr[i + 1])
        {
            ans += to_string(arr[i + 1]) + ' ' + to_string(arr[i]) + '\n';
            ans += to_string(arr[i]) + ' ' + to_string(arr[i + 1]) + '\n';
            num += 2;
        }
    }
    cout << num << endl << ans;

    return;
}

void solveF()
{
    int n;
    cin >> n;

    string up, down;
    cin >> up >> down;

    bool uniq = true;
    bool valid = true;

    for (int i = 0; i < n; i += 1)
    {
        if (up[i] == '.' && down[i] == '.' &&
            up[i + 1] == '.' && down[i + 1] == '.')
            uniq = false;

        if (up[i] == '.' && down[i] == '.')
        {
            up[i] = '#';
            down[i] = '#';
            continue;
        }
        
        if (up[i] == '.' && up[i + 1] == '.' && i != n - 1)
        {
            up[i] = '#';
            up[i + 1] = '#';
            continue;
        }

        if (down[i] == '.' && down[i + 1] == '.' && i != n - 1)
        {
            down[i] = '#';
            down[i + 1] = '#';
            continue;
        }
        if (up[i] != '#' && down[i] == '#')
            valid = false;
        break;
    }
    if (valid)
    {
        if (uniq)
            cout << "Unique" << endl;
        else
            cout << "Multiple" << endl;
    }
    else
        cout << "None" << endl;
}

void solveE()
{
    stoll("1");
    string calc;
    vector<long long> nums;
    long long buferNum;
    int num = 0;
    int eqPos = 0;
    
    cin >> calc;
    string bufer;

    bool menus = false;
    bool eq = false;

    for (char n : calc)
    {
        switch (n)
        {
        case '=':
            buferNum = stoll(bufer);
            if (!eq) eqPos++;

            if (menus) buferNum *= -1;
            if (eq) buferNum *= -1;

            nums.push_back(buferNum);
            bufer.clear();
            menus = false;
            eq = true;
            break;
        case '-':
            buferNum = stoll(bufer);
            if (!eq) eqPos++;

            if (menus) buferNum *= -1;
            if (eq) buferNum *= -1;

            nums.push_back(buferNum);
            bufer.clear();
            menus = true;
            break;
        case '+':
            buferNum = stoll(bufer);
            if (!eq) eqPos++;

            if (menus) buferNum *= -1;
            if (eq) buferNum *= -1;

            nums.push_back(buferNum);
            bufer.clear();
            menus = false;
            break;

        default:
            bufer += n;
            break;
        }
    }
    buferNum = stoll(bufer);

    if (menus) buferNum *= -1;
    if (eq) buferNum *= -1;

    nums.push_back(buferNum);

    long long ans = 0;

    for (long long n : nums)
    {
        ans += n;
    }

    if (ans == 0)
    {
        cout << "Correct" << endl;
        return;
    }

    map<pair<string, string>, set<long long>> changes;

    int fromPos = 0;
    int toPos = 0;

    for (int i = 0; i < nums.size(); i++)
    {
        for (int j = 0; j < nums.size(); j++)
        {
            string is = to_string(nums[i]);
            if (is.length() == 1) break;
            string js = to_string(nums[j]);

            if (i != j)
            {
                for (int i2 = 0; i2 < is.length(); i2++)
                {
                    if (is[i2] == '-') continue;
                    for (int j2 = 0; j2 < js.length(); j2++)
                    {
                        if (i == 1 && j == 2 && j2 == 9 && i2 == 9)
                        {
                            eq = true;
                        }

                        int aboba = js.length();
                        if (js[j2] == '-') continue;
                        string buferi = is;
                        string buferj = js.substr(0, j2) + buferi[i2] + js.substr(j2, js.length());

                        buferi.erase(buferi.begin() + i2);

                        if (buferj.length() > 1)
                            if (buferj[0] == '0' || buferj[0] == '-' && buferj[1] == '0')
                                continue;
                        if (buferi.length() > 1)
                            if (buferi[0] == '0' || buferi[0] == '-' && buferi[1] == '0')
                                continue;
                        if (buferj[0] == '-' && buferj.length() > 11 ||
                            buferj.length() > 10)
                                continue;
                        if (buferi == "-")
                            continue;

                        long long change = nums[j] - stoll(buferj) + nums[i] - stoll(buferi);

                        if (change == ans)
                        {
                            calc.clear();
                            for (int k = 0; k < eqPos; k++)
                            {
                                if (k == i)
                                {
                                    if (buferi[0] != '-')
                                        calc += '+';
                                    calc += buferi;
                                }
                                else if (k == j)
                                {
                                    if (buferj[0] != '-')
                                        calc += '+';
                                    calc += buferj;
                                }
                                else
                                {
                                    if (nums[k] > 0)
                                        calc += '+';
                                    calc += to_string(nums[k]);
                                }
                            }
                            calc += '=';
                            for (int k = eqPos; k < nums.size(); k++)
                            {
                                if (k == i)
                                {
                                    if (buferi[0] == '-')
                                        calc += '+';
                                    calc += to_string(stoll(buferi) * -1);
                                }
                                else if (k == j)
                                {
                                    if (buferj[0] == '-')
                                        calc += '+';
                                    calc += to_string(stoll(buferj) * -1);
                                }
                                else
                                {
                                    if (nums[k] * -1 > 0)
                                        calc += '+';
                                    calc += to_string(nums[k] * -1);
                                }
                            }

                            if (calc[0] == '+')
                                calc.erase(calc.begin());
                            if (calc[calc.find("=") + 1] == '+')
                            {
                                calc.erase(calc.begin() + calc.find("=") + 1);
                            }

                            cout << calc << endl;

                            return;
                        }
                    }
                }
            }
            else
            {
                for (int i2 = 0; i2 < is.length(); i2++)
                {
                    if (is[i2] == '-') continue;
                    bufer = is;
                    char buferCh = bufer[i2];

                    for (int j2 = 0; j2 < js.length(); j2++)
                    {
                        if (js[j2] == '-') continue;
                        bufer = is;
                        bufer.erase(bufer.begin() + i2);
                        bufer = bufer.substr(0, j2) + buferCh + bufer.substr(j2, js.length());

                        if (bufer.length() > 1)
                            if (bufer[0] == '0' || bufer[0] == '-' && bufer[1] == '0')
                                continue;

                        long long change = nums[i] - stoll(bufer);

                        if (change == ans)
                        {
                            calc.clear();
                            for (int k = 0; k < eqPos; k++)
                            {
                                if (k == i)
                                {
                                    if (bufer[0] != '-')
                                        calc += '+';
                                    calc += bufer;
                                }
                                else
                                {
                                    if (nums[k] > 0)
                                        calc += '+';
                                    calc += to_string(nums[k]);
                                }
                            }
                            calc += '=';
                            for (int k = eqPos; k < nums.size(); k++)
                            {
                                if (k == i)
                                {
                                    if (stoll(bufer) * -1 > 0)
                                        calc += '+';
                                    calc += to_string(stoll(bufer) * -1);
                                }
                                else
                                {
                                    if (nums[k] * -1 > 0)
                                        calc += '+';
                                    calc += to_string(nums[k] * -1);
                                }
                            }

                            if (calc[0] == '+')
                                calc.erase(calc.begin());
                            if (calc[calc.find("=") + 1] == '+')
                            {
                                calc.erase(calc.begin() + calc.find("=") + 1);
                            }

                            cout << calc << endl;
                            
                            return;
                        }
                    }
                }
            }
        }
    }

    cout << "Impossible" << endl;

    return;
}
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cout.precision(100);

    int n;
    //cin >> n;

    //while (n--)
        solveE();

    return 0;
}