#pragma GCC optimize("Ofast", "fast-math", "uroll-loops")


#include <bits/stdc++.h>

using ll = long long;
using namespace std;

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n, 0);
    string s1, s2;
    cin >> s1 >> s2;
    for (ll i = 0; i < n; i++) {
        a[i] = ((s1[i] == '#') * 2) + (s2[i] == '#');
    }

    vector<vector<ll>> dp(n, vector<ll>(4, 0));
    dp[0][a[0]] = 1;
    for (ll i = 0; i < n - 1; i++) {
        for (ll j = 0; j < 4;++j){
            if ((j&a[i]) != a[i]) continue;
            if (dp[i][j] > 1) dp[i][j] = 2;
            if (j == 0){
                dp[i+1][a[i+1]] += dp[i][j];
                if (a[i+1] == 0) dp[i+1][3] += dp[i][j];
            }
            if (j == 1){
                if (a[i+1] == 1) dp[i+1][3] += dp[i][j];
                if (a[i+1] == 0) dp[i+1][1] += dp[i][j];
            }
            if (j == 2){
                if (a[i+1] == 2) dp[i+1][3] += dp[i][j];
                if (a[i+1] == 0) dp[i+1][2] += dp[i][j];
            }
            if (j == 3) {
                dp[i + 1][a[i + 1]] += dp[i][j];
            }
        }
    }
    if (dp[n-1][3] == 0) cout << "None\n";
    else if (dp[n-1][3] == 1) cout << "Unique\n";
    else cout << "Multiple\n";
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
