#include <bits/stdc++.h>

#define ll long long

using namespace std;

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  ll tt;
  cin >> tt;
  while (tt--) {
    ll n;
    cin >> n;
    n *= 2;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) { cin >> a[i]; a[i]--; }
    vector<vector<ll>> g(n);
    for (ll i = 0; i < n - 1; ++i) {
      ll u, v;
      cin >> u >> v;
      g[v - 1].push_back(u - 1);
      g[u - 1].push_back(v - 1);
    }
    // used, non-used
    vector<ll> dp1(n), dp2(n), par(n);
    auto dfs = [&](auto &&dfs, ll v, ll p = -1) -> void {
      ll s = 0;
      for (ll u : g[v]) {
        if (u == p) continue;
        dfs(dfs, u, v);
        s += max(dp1[u], dp2[u]);
        dp2[v] += max(dp1[u], dp2[u]);
      }
      for (ll u : g[v]) {
        if (u == p) continue;
        ll temp = s - max(dp1[u], dp2[u]) + dp2[u] + 1;
        if (dp1[v] < temp) {
          dp1[v] = temp;
          par[v] = u;
        }
      }
    };
    dfs(dfs, 0);
    set<ll> x, y;
    for (ll i = 0; i < n; ++i) x.insert(i);
    vector<pair<ll, ll>> b;
    auto wb = [&](auto &&wb, ll v, ll p = -1, bool can = true) -> void {
      if (can && dp1[v] > dp2[v]) {
        b.emplace_back(v, par[v]);
        x.erase(v);
        x.erase(par[v]);
        for (ll u : g[v]) {
          if (u == p) continue;
          if (u == par[v]) wb(wb, u, v, false);
          else wb(wb, u, v, true);
        }
      } else {
        for (ll u : g[v]) {
          if (u == p) continue;
          wb(wb, u, v, true);
        }
      }
    };
    wb(wb, 0);
    while (!x.empty()) {
      b.emplace_back(*x.begin(), *next(x.begin()));
      x.erase(x.begin());
      x.erase(x.begin());
    }
    n /= 2;
    vector<vector<ll>> id(n);
    for (ll i = 0; i < n; ++i) {
      id[a[b[i].first]].push_back(i);
      id[a[b[i].second]].push_back(i);
    }
    vector<bool> used(n);
    auto df = [&](auto &&df, ll v) -> void {
      used[v] = true;
      ll u = id[a[b[v].first]][0] ^ id[a[b[v].first]][1] ^ v;
      if (!used[u]) {
        if (a[b[u].first] == a[b[v].first]) {
          swap(b[u].first, b[u].second);
        }
        df(df, u);
      }
    };
    for (ll i = 0; i < n; ++i) {
      if (!used[i]) {
        df(df, i);
      }
    }
//    for (auto [x, y] : b) {
//      cout << a[x] << ' ' << a[y] << '\n';
//    }
//    cout << '\n';
//    for (ll i = 0; i < n; ++i) {
//      cout << id[i][0] << ' ' << id[i][1] << '\n';
//    }
//    cout << '\n';
//    for (auto [x, y] : b) {
//      cout << x << ' ' << y << '\n';
//    }
    for (ll i = 0; i < n; ++i) {
      id[a[b[i].first]][0] = i;
      id[a[b[i].second]][1] = i;
    }
    bool f = false;
    std::fill(used.begin(), used.end(), false);
    vector<pair<ll, ll>> result;
    auto fs = [&](auto &&fs, ll v) -> void {
      used[v] = true;
      ll val;
      if (f) {
        val = a[b[v].first];
        ll u = id[val][1];
        if (used[u]) return;
        result.emplace_back(b[v].second, b[u].second);
        swap(a[b[v].second], a[b[u].second]);
        f ^= true;
        fs(fs, u);
      } else {
        val = a[b[v].second];
        ll u = id[val][0];
        if (used[u]) return;
        result.emplace_back(b[v].first, b[u].first);
        swap(a[b[v].first], a[b[u].first]);
        f ^= true;
        fs(fs, u);
      }
    };
    for (ll i = 0; i < n; ++i) {
      if (!used[i]) {
        fs(fs, i);
      }
    }
    cout << result.size() << '\n';
    for (auto [x, y] : result) {
      cout << x + 1 << ' ' << y + 1 << '\n';
    }
  }
  return 0;
}
