// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#pragma warning (disable : 4996)
#include <iostream>
#include <string>

using namespace std;

bool isFree(const string& s, int pos) {
	if (pos < 0 || pos >= s.length()) return false;
	return s[pos] == '.';
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int T;
	cin >> T;

	for (int testId = 0; testId < T; testId++) {
		int n;
		cin >> n;

		string s1, s2;
		cin >> s1;
		cin >> s2;

		bool isPossible = true;
		bool isMultiple = false;
		for (int pos = 0; pos < n; pos++) {
			if (!isFree(s1, pos)) {
				if (!isFree(s2, pos)) continue;

				// put the 1x2 rectangle on s2
				if (isFree(s2, pos + 1)) s2[pos + 1] = '#';
				else {
					isPossible = false;
					break;
				}

				continue;
			}

			if (!isFree(s2, pos)) {
				if (!isFree(s1, pos)) continue;

				// put the 1x2 rectangle on s1
				if (isFree(s1, pos + 1)) s1[pos + 1] = '#';
				else {
					isPossible = false;
					break;
				}

				continue;
			}

			// both cells are free

			if (!isFree(s1, pos + 1)) {
				//pos++;
				continue;
			}
			else if (!isFree(s2, pos + 1)) {
				//pos++;
				continue;
			}
			else {
				// 2x2 is free
				isMultiple = true;
				pos++;
				continue;
			}
		}

		if (isPossible) {
			if (isMultiple) cout << "Multiple" << endl;
			else cout << "Unique" << endl;
		}
		else cout << "None" << endl;
	}

	return 0;
}
