#ifndef LOCAL
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define endl '\n'
using namespace std;
using ll = int64_t;

void solve() {
    int x;
    cin >> x;
    vector<int> a(16 * 20);
    a[2] = 20;
    a[3] = 1;
    int index1 = 3 * 16 + 15;
    int word_index = (1 << 16) - 16 + 15;
    auto set_break = [&](int i) {
        a[i] = a[i + 1] = a[i + 3] = 0;
        a[i + 2] = (1 << 16) - 1;
    };
    auto set_next = [&](int i, int nxt) {
        a[i] = a[i + 1] = a[i + 3] = 0;
        a[i + 2] = nxt;
    };
    int f = 16;
    for (int i = 0; i < 16; ++i) {
        set_break(f);
        set_break(f + 12);
        set_next(f + 8, f + 20);
        a[f + 4] = word_index - i;
        a[f + 6] = (f + 8);
        a[f + 5] = (f + 6) * 16;
        if (x & (1 << i)) {
            a[f + 5] += 3;
        } else {
            a[f + 5] += 2;
        }
        f += 16;
    }
    f += 4;
    a[f] = index1;
    a[f + 1] = 0;
    a[f + 2] = (1 << 16) - 1;
    for (int el : a) {
        vector<char> cur;
        for (int i = 0; i < 4; ++i) {
            int r = el % 16;
            if (r < 10) {
                cur.emplace_back(char(r + '0'));
            } else {
                cur.emplace_back(char(r - 10 + 'a'));
            }
            el /= 16;
        }
        reverse(all(cur));
        for (char tmp : cur) cout << tmp;
        cout << ' ';
    }
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../stream.in", "r", stdin);
    freopen("../stream.out", "w", stdout);
    auto start = clock();
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) solve();
#ifdef LOCAL
    cerr << "TIME: " << 1e3 * (clock() - start) / CLOCKS_PER_SEC << " ms\n";
#endif
    return 0;
}