#ifndef LOCAL
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define endl '\n'
using namespace std;
using ll = int64_t;
const ll INF = 1e18;
void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<pair<ll, ll>> tasks(n);
    for (auto& [d, a] : tasks) cin >> a;
    for (auto& [d, a] : tasks) cin >> d;
    sort(all(tasks));
    vector<ll> prefa(n + 1);
    for (int i = 0; i < n ;++i) prefa[i + 1] = prefa[i] +tasks[i].second;
    vector<ll> suffmin(n + 1);
    suffmin[n] = INF;
    for (int i = n - 1; i >= 0; --i) suffmin[i] = min(suffmin[i + 1], tasks[i].first - prefa[i + 1]);

    vector<ll> ep(m);
    for (ll& el : ep) cin >> el;
    vector<ll> pref(m + 1);
    for (int i = 0; i < m; ++i) pref[i + 1] = pref[i] + ep[i];
    while (q--) {
        ll t;
        cin >> t;
        auto it = upper_bound(all(tasks), pair{t, INF});
        int k = it - tasks.begin();
        ll mn = min(suffmin[k], t - prefa[k]);
        int rs = upper_bound(all(pref), mn) - pref.begin();
        cout << rs - 1 << ' ';
    }
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../stream.in", "r", stdin);
    freopen("../stream.out", "w", stdout);
    auto start = clock();
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int tt = 1;
     cin >> tt;
    while (tt--) solve();
#ifdef LOCAL
    cerr << "TIME: " << 1e3 * (clock() - start) / CLOCKS_PER_SEC << " ms\n";
#endif
    return 0;
}