#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <bitset>

using namespace std;
using ll = long long;
using vll =vector<ll>;
using pll=pair<ll, ll>;
using vpll = vector<pll>;
vector<vector<ll>> graph;
vector<ll> topo;
vector<bool> was;
vector<ll> nums;
void dfs(ll ver) {
	was[ver] = true;
	for (auto c : graph[ver]) {
		if (!was[c]) {
			dfs(c);
		}
	}
	topo.push_back(ver);
}
bool rprov(ll a, ll b)
{
	return nums[a] > nums[b];
}
bool prov(ll a, ll b)
{
	return nums[a] < nums[b];
}
void slove()
{
	ll n;
	cin >> n;
	graph.resize(n);
	was.resize(n);
	vector<string> ar(n);
	for (int i = 0; i < n; i++) {
		string s1, s2;
		cin >> s1 >> s2;
		ar[i] = s1[0];
		ar[i] += s2[0];
		
	}
	ll m;
	cin >> m;
	ll x, y;
	vector<vll> g(n);
	for (int i = 0; i < m; i++) {
		cin >> x >> y;
		x--;
		y--;
		graph[x].push_back(y);
		g[y].push_back(x);
	}
	for (int i = 0; i < n; i++) {
		if (!was[i]) {
			dfs(i);
		}
	}
	reverse(topo.begin(), topo.end());
	vector<vector<ll>> ans(5);
	ll root=-1;
	ll en = -1;
	for (int i = 0; i < ar.size(); i++) {
		if (ar[i] == "uf") {
			ans[0].push_back(i);
		}
		if (ar[i] == "st") {
			root = i;
			ans[1].push_back(i);
		}
		if (ar[i] == "sf") {
			ans[2].push_back(i);
		}
		if (ar[i] == "ut") {
			en = i;
			ans[3].push_back(i);
		}
	}
	nums.resize(n);
	for (int i = 0; i < topo.size(); i++) {
		nums[topo[i]] = i;
	}
	for (int i = 1; i < 5; i++) {
		sort(ans[i].begin(), ans[i].end(), prov);
	}
	sort(ans[0].begin(), ans[0].end(), rprov);
	vector<ll> p(n);
	vll d;
	for (auto c : ans[0])
	{
		bool flag = false;
		for (auto k :g[c])
		{
			if (ar[k] != "uf" || p[k] == 1)
			{
				p[c] = 1;
				ans[4].push_back(c);
				break;
			}
			
		}
		if (p[c] != 1)
		{
			d.push_back(c);
		}
	}
	ans[0] = d;
	sort(ans[4].begin(), ans[4].end(), prov);
	sort(ans[0].begin(), ans[0].end(), prov);
	vll na(n);
	ll po = 0;
	for (int i = 0; i < 5; i++)
	{
		for (auto c : ans[i])
		{
			na[c] = po;
			po++;
		}
	}
	for (int i = 0; i < n; i++)
	{
		for (auto c : graph[i])
		{
			if (na[i] > na[c])
			{
				cout << -1 << endl;
				return;
			}
		}
	}
	if (ans[0].size() == 0 && ans[1].size() == 0)
	{
		cout << -1;
		return;
	}
	if (ans[1].size() == 0)
	{
		ll t = 0;
		for (int i = 2; i < 5; i++)
		{
			t += ans[i].size();
		}
		if (t > 0)
		{
			cout << -1;
			return;
		}
	}
	if (ans[3].size() == 0)
	{
		if (ans[4].size() != 0)
		{
			cout << -1;
			return;
		}
	}
	if (ans[1].size() > 0 && ans[3].size() > 0)
	{
		for (auto c : graph[en])
		{
			if (c == root)
			{
				cout << -1;
				return;
			}
		}
		for (auto c : graph[en])
		{
			if (ar[c] != "uf")
			{
				cout << -1;
				return;
			}
		}
		for (auto c : ans[2])
		{
			for (auto k : graph[c])
			{
				if (k == root)
				{
					cout << -1;
					return;
				}
			}
		}
	}
	
	
	for (int i = 0; i < 5; i++)
	{
		for (auto c : ans[i])
		{
			cout << c + 1 << ' ';
		}
	}
}


int main()
{
	ll t = 1;;
	//cin >> t;
	while (t--)
	{
		slove();
	}

}
