#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;
using vi = vector<int>;


void solve() {
    int n; cin >> n;
    vector<string> v(2);
    rep(i, 2) cin >> v[i];
    vector<vi> dp(n + 1, vi(4));
    dp[0][0] = 1;
    for (int i = 0; i < n; ++i) {
        int need = 0;
        if (v[0][i] == '.') need |= 1;
        if (v[1][i] == '.') need |= 2;
        rep(mask, 4) {
            rep(bit, 2) {
                if (mask & (1 << bit)) {
                    if (v[bit][i] == '#') {
                        dp[i][mask] = -1;
                    }
                }
            }
            dp[i][mask] = min(dp[i][mask], 2);
        }
        if (dp[i][0] > 0 && dp[i][3] >= 0) {
            dp[i][3] += dp[i][0];
        }
        rep(mask, 4) {
            if (dp[i][mask] <= 0) continue;
            rep(mask2, 4) {
                if (mask & mask2) continue;
                if ((mask | mask2) != need) continue;
                dp[i+1][mask2] += dp[i][mask];
            }
        }
    }
    if (dp[n][0] == 0) {
        cout << "None\n";
        return;
    }
    if (dp[n][0] == 1) {
        cout << "Unique\n";
        return;
    }
    cout << "Multiple\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}