#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;
using ll = long long;
using vi = vector<int>;
using vl = vector<ll>;

const ll INF = 2e18;

using ld = long double;
using pt = pair<ld, ld>;

void solve() {
    ar<int, 2> W; cin >> W[0] >> W[1];
    vector<ar<int, 6>> d(2);
    rep(i, 2) rep(j, 6) cin >> d[i][j];

    vector<vi> kek;
    rep(p, 2) {
        ar<int, 2> len;
        rep(j, 2) {
            len[j] = 2 * (W[p] - d[j][p]);
        }
        int sz = lcm(len[0], len[1]);
        vector A(2, vector<pair<int, int>>(sz));
        rep(j, 2) {
            int x = d[j][p + 2];
            int v = d[j][p + 4];
            rep(pos, sz) {
                A[j][pos] = {x, x + d[j][p]};
                if (A[j][pos].first == 0) {
                    v = 1;
                } else if (A[j][pos].second == W[p]) {
                    v = -1;
                }
                x += v;
            }
        }
        vi cur(sz);
        rep(i, sz) {
            if (max(A[0][i].first, A[1][i].first) < min(A[0][i].second, A[1][i].second)) {
                cur[i] = 1;
            }
        }
        kek.push_back(cur);
    }

    int sz1 = kek[0].size();
    int sz2 = kek[1].size();

    ll total = lcm(1ll * sz1, 1ll * sz2);

    int g = gcd(sz1, sz2);
    vector<ll> sum(g);
    rep(i, sz2) sum[i % g] += kek[1][i];

    ll ans = 0;
    rep(i, sz1) {
        ans += 1ll * kek[0][i] * sum[i % g];
    }
    ll gc = gcd(total, ans);
    total /= gc;
    ans /= gc;
    cout << ans << '/' << total << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}