#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;
using li = long long;
using ld = long double;
using pii = pair<int, int>;


const int N = 2e5 + 13;

int dp[N][2][2];

void solve() {
    int n;
    cin >> n;

    string s[2];
    cin >> s[0] >> s[1];

    for(int i = 0; i <= n; i++) {
        for(int x = 0; x < 2; x++) {
            for(int y = 0; y < 2; y++) {
                dp[i][x][y] = 0;
            }
        }
    }
    dp[0][1][1] = 1;

    for(int i = 0; i < n; i++) {
        for(int x = 0; x < 2; x++) {
            for(int y = 0; y < 2; y++) {
                {
                    int nx = (x == 0);
                    int ny = (y == 0);

                    if(s[0][i] == '#') {
                        if(nx == 0)
                            nx = 1;
                        else
                            continue;
                    }

                    if(s[1][i] == '#') {
                        if(ny == 0)
                            ny = 1;
                        else
                            continue;
                    }


                    dp[i + 1][nx][ny] += dp[i][x][y];
                    if(nx == 0 && ny == 0) {
                        dp[i + 1][1][1] += dp[i][x][y];
                    }
                }
            }
        }

        for(int x = 0; x < 2; x++) {
            for(int y = 0; y < 2; y++) {
                dp[i + 1][x][y] = min(dp[i + 1][x][y], 2);
            }
        }
    }

    if(dp[n][1][1] == 0)
        cout << "None\n";
    else if(dp[n][1][1] == 1)
        cout << "Unique\n";
    else
        cout << "Multiple\n";
}

/*
4
10
#.......##
##..#.##..
6
...#..
..#...
8
........
........
3
###
###

1
3
...
.##

1
3
...
##.
*/

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while(t--)
        solve();
}

