#include <bits/stdc++.h>

#define f first
#define s second
#define int li

using namespace std;
using li = long long;
using ld = long double;
using pii = pair<int, int>;


void solve() {
    int n, m, q;
    cin >> n >> m >> q;

    vector <li> a(n);

    for(int i = 0; i < n; i++)
        cin >> a[i];

    vector <li> d(n);

    for(int i = 0; i < n; i++)
        cin >> d[i];

    vector <li> l(m);

    for(int i = 0; i < m; i++)
        cin >> l[i];

    vector <li> t(q);

    for(int i = 0; i < q; i++)
        cin >> t[i];

    vector <pair <li, li> > v;

    for(int i = 0; i < n; i++)
        v.push_back({d[i], a[i]});

    sort(v.begin(), v.end());

    for(int i = 0; i < n; i++)
    {
        d[i] = v[i].f;
        a[i] = v[i].s;
    }

    li cur = 1e18;

    for(int i = n - 1; i >= 0; i--)
    {
        d[i] = min(d[i], cur);
        cur = d[i] - a[i];
    }

    vector <li> pref(n + 1);

    for(int i = 0; i < n; i++)
        pref[i + 1] = pref[i] + a[i];

    vector <li> pe(m + 1);

    for(int i = 0; i < m; i++)
        pe[i + 1] = pe[i] + l[i];

    for(int i = 0; i < q; i++)
    {
        int j = lower_bound(d.begin(), d.end(), t[i]) - d.begin();

        li T = pref[j];

        if(j < n)
            T += max(0ll, t[i] - (d[j] - a[j]));

        T = t[i] - T;

        int k = upper_bound(pe.begin(), pe.end(), T) - pe.begin();

        cout << k - 1 << ' ';
    }

    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);



    int t;
    cin >> t;

    while(t--)
        solve();
}

