#pragma optimize("SEX_ON_THE_BEACH")

#include <bits/stdc++.h>

using namespace std;

using ll = long long int;
using ull = unsigned long long int;
using dd = double;
using ldd = long double;

#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define sz(x) (x).size()

#ifdef HOME
    #define debug(...) { cerr << #__VA_ARGS__ << " " << __VA_ARGS__ << endl; }
    #define say(...) { cerr << __VA_ARGS__ << endl; }
#else
    #define debug(...) 0;
    #define say(...) 0;
#endif


void solve(int test = 0) {
    int n;
    cin >> n;
    vector<pair<int, int>> arr;
    for (int i = 0; i < n; ++i) {
        string a, b;
        cin >> a >> b;
        arr.push_back({a == "set", b == "true"});
        debug(arr.back().ff);
        debug(arr.back().ss);
    }
    int m;
    cin >> m;
    vector<vector<int>> gr(n);
    vector<int> indeg(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        gr[a - 1].push_back(b - 1);
        indeg[b - 1]++;
    }
    vector<int> ans;
    set<pair<int, int>> tos;
    for (int i = 0; i < n; ++i) if (arr[i] == pair<int, int>{0, 0}) tos.insert({indeg[i], i});
    vector<int> was(n);
    while (tos.size()) {
        auto [d, v] = *tos.begin();
        debug(v);
        tos.erase(tos.begin());
        if (d != 0) break;
        ans.push_back(v);
        was[v] = 1;
        for (int to : gr[v]) {
            if (arr[to] == pair<int, int>{0, 0}) tos.erase({indeg[to], to});
            --indeg[to];
            if (arr[to] == pair<int, int>{0, 0}) tos.insert({indeg[to], to});
        }
    }
    {
        say("???");
        //for (int i : ans) cout << i + 1 << " ";
        say("");
    }
    if (accumulate(all(was), 0) == n) {
        for (int to : ans) {
            cout << to + 1 << " ";
        }
        return;
    }
    bool fnd;
    fnd = false;
    for (int i = 0; i < n; ++i) {
        if (arr[i] == pair<int, int>{1, 1}) {
            fnd = true;
            if (indeg[i]) {
                cout << -1;
                return;
            }
            for (int to : gr[i]) --indeg[to];
            ans.push_back(i);
            was[i] = 1;
            break;
        }
    }
    if (!fnd) {
        cout << -1;
        return;
    }
    {
        say("???");
        //for (int i : ans) cout << i + 1 << " ";
        say("");
    }
    if (accumulate(all(was), 0) == n) {
        for (int to : ans) {
            cout << to + 1 << " ";
        }
        return;
    }
    tos.clear();
    for (int i = 0; i < n; ++i) {
        if (arr[i] == pair<int, int>{1, 0}) tos.insert({indeg[i], i});
    }
    while (tos.size()) {
        auto [d, v] = *tos.begin();
        tos.erase(tos.begin());
        if (d != 0) break;
        ans.push_back(v);
        was[v] = 1;
        for (int to : gr[v]) {
            if (arr[to] == pair<int, int>{1, 0}) tos.erase({indeg[to], to});
            indeg[to]--;
            if (arr[to] == pair<int, int>{1, 0}) tos.insert({indeg[to], to});
        }
    }
    {
        say("???");
        //for (int i : ans) cout << i + 1 << " ";
        say("");
    }
    if (accumulate(all(was), 0) == n) {
        for (int to : ans) {
            cout << to + 1 << " ";
        }
        return;
    }
    fnd = false;
    for (int i = 0; i < n; ++i) {
        if (arr[i] == pair<int, int>{0, 1}) {
            if (indeg[i]) {
                cout << -1;
                return;
            }
            fnd = true;
            ans.push_back(i);
            was[i] = 1;
            for (int to : gr[i]) --indeg[to];
        }
    }
    if (!fnd) {
        cout << -1;
        return;
    }
    
    {
        say("???");
        //for (int i : ans) cout << i + 1 << " ";
        say("");
    }
    if (accumulate(all(was), 0) == n) {
        for (int to : ans) {
            cout << to + 1 << " ";
        }
        return;
    }

    tos.clear();
    for (int i = 0; i < n; ++i) {
        if (arr[i] == pair<int, int>{0, 0} && !was[i]) {
            tos.insert({indeg[i], i});
        }
    }
    while (tos.size()) {
        auto [d, v] = *tos.begin();
        tos.erase(tos.begin());
        if (d) break;
        was[v] = 1;
        ans.push_back(v);
        for (int to : gr[v]) {
            if (arr[to] == pair<int, int>{0, 0}) tos.erase({indeg[to], to});
            --indeg[to];
            if (arr[to] == pair<int, int>{0, 0}) tos.insert({indeg[to], to});
        }
    }
    
    {
        say("???");
        //for (int i : ans) cout << i + 1 << " ";
        say("");
    }
    if (accumulate(all(was), 0) == n) {
        for (int to : ans) {
            cout << to + 1 << " ";
        }
        return;
    }
    cout << -1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    for (int i = 1; i <= t; ++i) {
        solve(i);
        cout << '\n';
        say("=================================================");
    }
}