#include <bits/stdc++.h>

using namespace std;

constexpr int N = 4e5;

int64_t dist[N];
vector<pair<int, int64_t>> to[N], from[N], to1[N], from1[N];
int ans[N], odeg[N];

int main() {
  cin.tie(0)->sync_with_stdio(0);
  int n, m; cin >> n >> m;
  for (int i = 0, a, b, w; i < m; ++i) cin >> a >> b >> w, to[--a].push_back({--b, w}), from[b].push_back({a, w});
  constexpr int64_t inf = 1e18;
  {
    priority_queue pq{greater{}, vector<pair<int64_t, int>>{}};
    fill(dist, dist + n - 1, inf);
    pq.push({0, n - 1});
    while (pq.size()) {
      auto [d, v] = pq.top(); pq.pop();
      if (d != dist[v]) continue;
      for (auto& [u, c]: from[v]) if (auto nd = d + c; nd < dist[u]) {
        pq.push({dist[u] = nd, u});
      }
    }
  }
  for (int i = 0; i < n; ++i) {
    to1[i] = to[i];
    from1[i] = from[i];
    to1[i].erase(remove_if(to1[i].begin(), to1[i].end(), [&](auto x) { auto [j, c] = x; return dist[j] != dist[i] - c; }), to1[i].end());
    from1[i].erase(remove_if(from1[i].begin(), from1[i].end(), [&](auto x) { auto [j, c] = x; return dist[j] != dist[i] + c; }), from1[i].end());
    odeg[i] = to1[i].size();
  }
  vector<int> q, nq;
  fill(ans, ans + n, n);
  ans[n - 1] = n + 1;
  for (int i = 0; i < n; ++i) if (dist[i] == inf) {
    nq.push_back(i);
    ans[i] = -1;
  }
  for (int d = 0; swap(q = {}, nq), q.size(); ++d) {
    vector<int> q2, nq2{q};
    for (auto v: q)
    for (auto [u, _]: from[v]) if (ans[u] == n) {
      ans[u] = d;
      nq.push_back(u);
      nq2.push_back(u);
    }
    while (swap(q2 = {}, nq2), q2.size())
    for (auto v: q2)
    for (auto [u, _]: from1[v]) if (!--odeg[u] && ans[u] == n) {
      ans[u] = d;
      nq.push_back(u);
      nq2.push_back(u);
    }
  }
  cout << ans[0];
}
