#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

#define p_b push_back
#define e_b emplace_back
#define m_p make_pair
#define fi first
#define se second
#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF = 1e18 + 2;
const ll N = 1e6 + 2;

ve<ll> gr[N];
ll arr[N], dp[N][2], to[N];

void dfs(ll s, ll p) {
    ll sum = 0;
    for(ll i : gr[s]) {
        if(i == p) continue;
        dfs(i, s);
        sum += dp[i][0];
    }

    dp[s][0] = -INF;
    dp[s][1] = sum;
    for(ll i : gr[s]) {
        if(i == p) continue;
        ll cur = sum - dp[i][0] + dp[i][1] + 1;
        if(dp[s][0] < cur) {
            dp[s][0] = cur;
            to[s] = i;
        }
    }
}

ve<pll> pairs;

void rec(ll s, ll p, ll fl) {
    if(fl) {
        for(ll i : gr[s]) {
            if(i == p) continue;
            if(dp[i][0] > dp[i][1]) rec(i, s, 0);
            else rec(i, s, 1);
        }
        return;
    }

    pairs.PB({s, to[s]});
    rec(to[s], s, 1);
    for(ll i : gr[s]) {
        if(i == p || i == to[s]) continue;
        if(dp[i][0] > dp[i][1]) rec(i, s, 0);
        else rec(i, s, 1);
    }
}

set<ll> pos[N];

void solve() {
    ll n;
    cin >> n;
    n *= 2;

    pairs.clear();
    for(ll i = 0; i < n; i++) {
        gr[i].clear();
        pos[i].clear();
    }

    for(ll i = 0; i < n; i++) {
        cin >> arr[i];
        pos[arr[i]].insert(i);
    }
    for(ll i = 0; i < n - 1; i++) {
        ll a, b;
        cin >> a >> b;
        a--, b--;
        gr[a].PB(b);
        gr[b].PB(a);
    }

    dfs(0, 0);
    if(dp[0][0] > dp[0][1]) rec(0, 0, 0);
    else rec(0, 0, 1);

    ve<pll> ans;
    for(pll p : pairs) {
        if(arr[p.F] == arr[p.S]) continue;
        ll a = p.S, b;
        for(ll i : pos[arr[p.F]]) {
            if (i != a) b = i;
        }
        ans.PB({a, b});
        pos[arr[a]].erase(a);
        pos[arr[b]].erase(b);
        swap(arr[a], arr[b]);
        pos[arr[a]].insert(a);
        pos[arr[b]].insert(b);
    }

    cout << sz(ans) << endl;
    for(pll p : ans) {
        cout << p.F + 1 << ' ' << p.S + 1 << endl;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll q;
    cin >> q;
    while(q--) {
        solve();
    }

    return 0;
}
