#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define f first
#define s second
#define all(x) (x).begin(), (x).end()

using namespace std;


void solve(){
    int n_s;
    cin >> n_s;
    int n = n_s * 2;
    vector<int> colors(n + 1);
    vector<set<int>> swa(n_s + 1);
    vector<set<int>> cur_cols(n_s + 1);
    for(int i = 1; i <= n; i++) {
        cin >> colors[i];
        swa[colors[i]].insert(i);
        cur_cols[colors[i]].insert(i);
    }
    vector<vector<int>> g(n + 1);
    for(int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    vector<pii> dp(n + 1);
    vector<int> par(n + 1);
    vector<int> used(n + 1);
    auto compute_dp = [&](auto &&self, int v) -> void {
        used[v] = 1;
        pii best = {-1e9, 0};
        for(auto u: g[v]){
            if(used[u]) continue;
            self(self, u);
            dp[v].f += max(dp[u].f, dp[u].s);
            dp[v].s += max(dp[u].f, dp[u].s);
            best = max(best, {dp[u].f - max(dp[u].f, dp[u].s), u});
        }
        par[v] = best.s;
        dp[v].s += best.f + 1;
    };
    compute_dp(compute_dp, 1);
    vector<int> ok(n_s + 1);
    std::fill(used.begin(), used.end(), 0);
    auto getmatch = [&](auto &self, int v, int taken) -> void {
        used[v] = 1;
        for(auto u: g[v]) {
            if(used[u]) continue;
            if(par[v] == u) {
                par[u] = v;
                ok[colors[u]]++;
                ok[colors[v]]++;
                self(self, u, 0);
            }
            else {
                self(self, u, dp[v].f < dp[v].s ? 0 : 1);
            }
        }
    };
    getmatch(getmatch, 1, dp[1].f < dp[1].s ? 0 : 1);
    std::fill(used.begin(), used.end(), 0);
    vector<pii> ans;
    auto swap_edges = [&](int i, int j) {
        cur_cols[colors[i]].erase(i);
        cur_cols[colors[j]].erase(j);
        swa[colors[i]].erase(i);
        swa[colors[j]].erase(j);
        cur_cols[colors[i]].insert(j);
        cur_cols[colors[j]].insert(i);
        swap(colors[i], colors[j]);
        ans.emplace_back(i, j);
    };
    auto dfs = [&](auto &&dfs, int color) -> void {
        if(color == 0) return;
        int a = *cur_cols[color].begin(), b = *cur_cols[color].rbegin();
        if((par[a] == 0 && par[b] == 0) || par[a] == b) return;
        int v1 = *swa[color].begin();
        // int v2 = (swa.size() > 1 ? *swa[color].rbegin() : 0);
        int v = *swa[color].begin();
        int u = a ^ b ^ v;
        int ncol = colors[par[u]];
        swap_edges(v, par[u]);
        dfs(dfs, ncol);
    };
    for(int i = 1; i <= n_s; i++) if(ok[i] == 2) dfs(dfs, i);
    cout << ans.size() << '\n';
    for(auto [u, v]: ans) cout << u << ' ' << v << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}
