#include  <bits/stdc++.h>

typedef long long ll;

using namespace std;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<pair<ll, ll>> h(n);
    vector<ll>l(m);
    for (int i = 0; i < n; i++)
    {
        cin >> h[i].first;
    }
    for (int i = 0; i < n; i++)
    {
        cin >> h[i].second;
    }

    for (int i = 0; i < m; i++)
    {
        cin >> l[i];
    }

    sort(h.begin(), h.end(), [](auto x, auto y){
        return x.second < y.second;
    });

    vector<ll> pref(n + 1);

    for (int i = 0; i < n; i++)
    {
        pref[i + 1] = pref[i] + h[i].first;
    }
    vector<ll> suf_min(n + 1, 1e18);

    for (int i = n - 1;i >= 0; i--)
    {
        suf_min[i] = min(suf_min[i + 1], h[i].second - pref[i + 1]);
    }

    ll cur = 0;
    int taken = 0;

    vector<ll> times;

    for (int i = 0; i < n; i++)
    {
        while (taken < l.size() && -pref[i] + cur + l[taken] <= suf_min[i])
        {
            cur += l[taken];
            times.emplace_back(cur);
            taken++;
        }
        cur += h[i].first;
    }
    while (taken < l.size())
    {
        cur += l[taken];
        times.emplace_back(cur);
        taken++;
    }

    while (q--)
    {
        ll t;
        cin >> t;
        auto it = std::upper_bound(times.begin(), times.end(), t);
        cout << it - times.begin() << " ";
    }
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}