#include <bits/stdc++.h>
using namespace std;
#define int int64_t
#define ll int64_t
#define pb push_back
#define F first
#define S second
#define vi vector<ll>
#define pll pair<ll,ll>
#define vpll vector<pll>
#define endl '\n'
 
const ll N = 2e5 + 5;
vi g[N];
vpll pars;
 
 
ll dfs(ll v, ll p) {
 
    ll tk = -1;
 
    for(ll nxt : g[v]) if(nxt != p) {
        ll res = dfs(nxt, v);
        if(res) {
            tk = nxt;
        }
    }
 
    if(tk == -1) {
        return 1;
    } else {
        pars.pb({v, tk});
        return 0;
    }
}
 
 
void testcase() {
    ll n;
    cin >> n;
    ll a[n*2];
    pars.clear();
    for(ll i=0; i<2*n; i++) {
        cin >> a[i];
        a[i]--;
        g[i].clear();
    }
 
    for(ll i=0; i<2*n-1; i++) {
        ll u, v;
        cin >> u >> v;
        u--;v--;
        g[u].pb(v);
        g[v].pb(u);
    }
 
    dfs(0, -1);
 
 
    ll used[2 * n] = {};
    ll marked[2 * n] = {};
 
 
    ll ot[2 * n];
    for(ll i=0; i<2*n; i++) 
    {
        ot[i] = -1;
    }
 
    for(auto [x, y] : pars) {
        ot[x] = y;
        ot[y] = x;
    }
 
    set<ll> zn[n];
    for(ll i=0; i<n*2; i++) {
        zn[a[i]].insert(i);
    }

    vpll wtf;
    for(ll i=0; i<2 * n; i++) {
        if(ot[i] == -1) {
            ll val = a[i];
            ll nxt = *zn[val].begin();
            if(nxt == i) nxt = *zn[val].rbegin();

            if(ot[nxt] != -1) {
                wtf.pb({i, nxt});
            }
        }
    }
    vpll ans;

    for(ll i=1; i<wtf.size(); i++) {
        ll x, y;

        
        ans.pb({wtf[i-1].first, wtf[i].second});
        marked[wtf[i-1].first] = 1;
        marked[ wtf[i].second] = 1;
        
        zn[a[wtf[i-1].first]].erase(wtf[i-1].first);
        zn[a[wtf[i-1].first]].insert(wtf[i].second);
        zn[a[wtf[i].second]].erase(wtf[i].second);
        zn[a[wtf[i].second]].insert(wtf[i-1].first);
        a[wtf[i].second] = a[wtf[i-1].first];

        x = wtf[i].second;
        while(true) {
            if(ot[x] != -1) {
                if (marked[x]) {
                    if (marked[y]) break;
                    else x=y;
                }
                y = ot[x];
                if(a[x] == a[y]) break;
                ll val = a[x];
                ll nxt = *zn[val].begin();
                if(nxt == x) nxt = *zn[val].rbegin();
                ans.pb({y, nxt});
                marked[y] = 1;
                marked[nxt] = 1;
                if(y == nxt) while(true) ;
                zn[a[y]].erase(y);
                zn[a[y]].insert(nxt);
                zn[a[nxt]].erase(nxt);
                zn[a[nxt]].insert(y);
                a[nxt] = a[y];
                a[y] = a[x];
 
                x = nxt;
            } else {
                ll val = a[x];
                ll nxt = *zn[val].begin();
                if(nxt == x) nxt = *zn[val].rbegin();
 
                if(ot[nxt] == -1) break;


 
                x = ot[nxt];
                continue;
            }
 
        }
    }
 
 
    for(auto [x, y] : pars) {
        if(a[x] == a[y]) continue;
        while(true) {
            if(ot[x] != -1) {
                if (marked[x]) {
                    if (marked[y]) break;
                    else x=y;
                }
                y = ot[x];
                if(a[x] == a[y]) break;
                ll val = a[x];
                ll nxt = *zn[val].begin();
                if(nxt == x) nxt = *zn[val].rbegin();
                ans.pb({y, nxt});
                marked[y] = 1;
                marked[nxt] = 1;
                if(y == nxt) while(true) ;
                zn[a[y]].erase(y);
                zn[a[y]].insert(nxt);
                zn[a[nxt]].erase(nxt);
                zn[a[nxt]].insert(y);
                a[nxt] = a[y];
                a[y] = a[x];
 
                x = nxt;
            } else {
                ll val = a[x];
                ll nxt = *zn[val].begin();
                if(nxt == x) nxt = *zn[val].rbegin();
 
                if(ot[nxt] == -1) break;


 
                x = ot[nxt];
                continue;
            }
 
        }
    }
 
    cout << ans.size() << endl;
    for(auto [x, y] : ans) {
        assert(!used[x]);
        used[x] = 1;
        assert(!used[y]);
        used[y] = 1;
        cout << x + 1<< ' ' << y+1 << endl;
    }
}
int32_t main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
 
 
    ll tt;
    cin >> tt;
    while(tt--) {
        testcase();
    }
 
 
}