
#include <iostream>
#include <vector>
#include <set>
#include <numeric>
#include <algorithm>
#include <map>
#include <queue>
#include <stack>
#include <cmath>
#include <string>
#include <cstring>
#include <cassert>


#define forn(i, n) for(int i = 0; i < n; ++i)
#define all(v) v.begin(), v.end()

using ll = long long;
using ld = long double;

using namespace std;

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (auto& x : a) {
		cin >> x;
		--x;
	}
	vector<int> p(n);
	vector<pair<int, int>> ans;
	iota(p.begin(), p.end(), 0);
	for (int i = 0; i < n; ++i) {
		int pos = find(p.begin(), p.end(), a[i]) - p.begin();
		for (int j = pos; j + 1 < n; ++j) {
			ans.push_back({ p[j + 1], p[j] });
			swap(p[j], p[j + 1]);
		}
		for (int j = n - 2; j >= i; --j) {
			ans.push_back({ p[j + 1], p[j] });
			swap(p[j], p[j + 1]);
		}

	}
	//for (auto& x : p) {
	//	cout << x + 1 << ' ';
	//} cout << endl;
	cout << ans.size() << '\n';
	for (auto& x : ans) {
		cout << x.first + 1 << ' ' << x.second + 1 << '\n';
	} cout << '\n';
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);

	int t = 1;
	//cin >> t;
	forn(tt, t) solve();
}