#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <string>
#include <utility>
#include <cmath>
#include <stack>
#include <deque>
#include <bitset>
#include <fstream>
#include <cstdlib>
#include <unordered_map>
#include <unordered_set>
#include <cstdint>

#define int long long

using namespace std;

const int MOD7 = (int)1e9 + 7;
const int MOD9 = (int)1e9 + 7;

int gcd(int a, int b) {
	return (b == 0 ? a : gcd(b, a % b));
}

int binPow(int x, int y) {
	if (y == 0) {
		return 1;
	}

	if (y % 2 == 0) {
		int t = binPow(x, y / 2);
		return t * t;
	}

	return x * binPow(x, y - 1);
}

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;

bool check(vector<string>& v, vll& sign) {
	ll val = 0;

	for (int i = 0; i < v.size(); ++i) {
		val += stoll(v[i]) * sign[i];
	}

	return (val == 0);
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int t;
	cin >> t;
	for (int h = 0; h < t; h++) {
		int n;
		cin >> n;
		string s1, s2;
		vector<pair<int, int>>  cur(n+2);
		vector < ll> v1(n + 2), v2(n + 2), v3(n + 2), v4(n + 2);
		cin >> s1 >> s2;
		for (int i = 0; i < n; i++)
		{
			if (s1[i] == '.')
				cur[i].first = 1;
			if (s2[i] == '.')
				cur[i].second= 1;
		}
		cur[n] = { 0,0 };
		if (cur[0].first==0 && cur[0].second==0)
			v1[0] = 1;
		if (cur[0].first == 0 && cur[0].second == 1)
			v2[0] = 1;
		if (cur[0].first == 1 && cur[0].second == 0)
			v3[0] = 1;
		if (cur[0].first == 1 && cur[0].second == 1)
			v4[0] = 1;
		for (int i = 0; i < n; i++) {
			if (cur[i + 1].first == 0 && cur[i + 1].second == 0) {
				v1[i + 1] += v4[i];
				v1[i + 1] += v1[i];
			}else
			if (cur[i + 1].first == 1 && cur[i + 1].second == 0) {
				v1[i + 1] += v3[i];
				v3[i + 1] += v4[i]+v1[i];
			}
			else if (cur[i + 1].first == 0 && cur[i + 1].second == 1) {
				v1[i + 1] += v2[i];
				v2[i + 1] += v4[i]+v1[i];
			}
			else {
				v4[i + 1] += v4[i]+v1[i];
				v1[i + 2] += v4[i];
				//v1[i + 1] += v4[i];
				v2[i + 1] += v3[i];
				v3[i + 1] += v2[i];
			}
		}
		/*for (int i = 0; i <= n; i++)
			cout << v1[i]<<' ';
		cout << '\n';

		for (int i = 0; i <= n; i++)
			cout << v2[i] << ' ';
		cout << '\n';

		for (int i = 0; i <= n; i++)
			cout << v3[i] << ' ';
		cout << '\n';

		for (int i = 0; i <= n; i++)
			cout << v4[i] << ' ';
		cout << '\n';*/
		if (v1[n] == 0)
			cout << "None\n";
		else
			if (v1[n] == 1)
				cout << "Unique\n";
			else
				cout << "Multiple\n";
	}
}