#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <string>
#include <utility>
#include <cmath>
#include <stack>
#include <deque>
#include <bitset>
#include <fstream>
#include <cstdlib>
#include <unordered_map>
#include <unordered_set>
#include <cstdint>

#define int long long

using namespace std;

const int MOD7 = (int)1e9 + 7;
const int MOD9 = (int)1e9 + 7;

int gcd(int a, int b) {
	return (b == 0 ? a : gcd(b, a % b));
}

int binPow(int x, int y) {
	if (y == 0) {
		return 1;
	}

	if (y % 2 == 0) {
		int t = binPow(x, y / 2);
		return t * t;
	}

	return x * binPow(x, y - 1);
}

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	ll t;
	cin >> t;

	while (t--) {
		ll n, m, q;
		cin >> n >> m >> q;
		vpll v(n + 1);

		for (int i = 1; i <= n; ++i) {
			cin >> v[i].first;
		}

		for (int i = 1; i <= n; ++i) {
			cin >> v[i].second;
		}

		sort(v.begin(), v.end(), [](const pll& a, const pll& b) {return a.second < b.second; });
		vll preft(n + 1);

		for (int i = 1; i <= n; ++i) {
			preft[i] = preft[i - 1] + v[i].first;
		}

		vll ep(m + 1);

		for (int i = 1; i <= m; ++i) {
			cin >> ep[i];
		}

		vll prefe(m + 1);

		for (int i = 1; i <= m; ++i) {
			prefe[i] = prefe[i - 1] + ep[i];
		}

		vpll qr(q + 1);

		for (int i = 1; i <= q; ++i) {
			cin >> qr[i].first;
			qr[i].second = i;
		}

		vll suff(n + 1);
		suff[n] = v[n].second - v[n].first;

		for (int i = n - 1; i > 0; --i) {
			suff[i] = v[i].second - v[i].first - max(0ll, (v[i].second - suff[i + 1]));
		}

		for (int i = 1; i < qr.size(); ++i) {
			ll l = 0, r = n;

			while (l < r - 1) {
				ll m = (l + r) / 2;

				if (v[m].second <= qr[i].first) {
					l = m;
				}
				else {
					r = m;
				}
			}

			ll ind = l;

			if (v[r].second <= qr[i].first) {
				ind = r;
			}

			ll val;

			if (ind == n) {
				val = qr[i].first - preft[ind];
			}
			else {
				val = min(qr[i].first, suff[ind + 1]) - preft[ind];
			}

			l = 0, r = m;

			while (l < r - 1) {
				ll m = (l + r) / 2;

				if (prefe[m] <= val) {
					l = m;
				}
				else {
					r = m;
				}
			}

			ll ans = l;

			if (prefe[r] <= val) {
				ans = r;
			}

			cout << ans << ' ';
		}

		cout << '\n';
	}
}