#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>
#include <set>
#include <bitset>
#include <deque>
#include <string>


using namespace std;
//#define LOCAL
#define int long long

using ld = long double;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vector<int>>;
using ii = pair<int, int>;
using pii = pair<int, int>;


#define fore(i, b, e) for (int i = (b); i < (e); ++i)
#define foree(i, b, e) for (int i = (b); i <= (e); ++i)
#define ford(i, b, e) for (int i = (e) - 1; i >= (b); --i)
#define fordd(i, b, e) for (int i = (e); i >= (b); --i)
#define pb push_back
#define ff first
#define ss second

#define all(x) (x).begin(), (x).end()



using namespace std;

void precalc();
void solve();


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	cin >> t;
	precalc();
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", 'w', stdout);
#endif

	while (t--) {
		solve();
	}

}

void precalc() {

}

void solve() {

	int N;
	cin >> N;

	vector<string> field(2);
	cin >> field[0] >> field[1];

	vvi dp(N + 1, vi(4, 0));
	dp[0][0] = 1;

	for (int i = 0; i < N; i++) {
		int curr_mask = -1;
		if (field[0][i] == '.' && field[1][i] == '.') { // 0
			curr_mask = 0;
		}
		if (field[0][i] == '#' && field[1][i] == '.') { // 1
			curr_mask = 1;
		}
		if (field[0][i] == '.' && field[1][i] == '#') { // 2
			curr_mask = 2;
		}
		if (field[0][i] == '#' && field[1][i] == '#') { // 3
			curr_mask = 3;
		}

		if (curr_mask == 0) {
			dp[i + 1][0] += dp[i][0];
			dp[i + 1][3] += dp[i][0];

			dp[i + 1][2] += dp[i][1];
			dp[i + 1][1] += dp[i][2];

			dp[i + 1][0] += dp[i][3];
		}
		if (curr_mask == 1) {
			dp[i + 1][2] += dp[i][0];
			dp[i + 1][0] += dp[i][2];
		}
		if (curr_mask == 2) {
			dp[i + 1][1] += dp[i][0];
			dp[i + 1][0] += dp[i][1];
		}
		if (curr_mask == 3) {
			dp[i + 1][0] += dp[i][0];
		}

		for (int j = 0; j < 4; j++) {
			if (dp[i + 1][j] > 10) {
				dp[i + 1][j] = 2;
			}
		}

	}

	if (dp[N][0] == 0) {
		cout << "None\n";
	}
	else if (dp[N][0] == 1) {
		cout << "Unique\n";
	}
	else {
		cout << "Multiple\n";
	}

}