#include <bits/stdc++.h>
#define i2 array<int,2>
#define l2 array<ll,2>
using namespace std;
typedef long long ll;

const ll MAX_T = 1e16;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<ll> a(n);
    vector<ll> d(n);
    vector<ll> hard_d(n);
    vector<ll> l(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<l2> hmw(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
//        hmw[n] = {d[i] - a[i], i};
        hmw[i] = {d[i], i};
    }
    std::sort(hmw.begin(), hmw.end());
    for (int i = n - 1; i >= 0; --i) {
        int id = hmw[i][1];

        if (i == n - 1) {
            hard_d[i] = d[id] - a[id];
        } else {
            hard_d[i] = min(d[id], hard_d[i + 1]) - a[id];
        }
    }

    vector<ll> ep_end(m);
    int IT = 0;
    ll tim = 0;
    for (int i = 0; i < m; ++i) {
        cin >> l[i];
        if (i > 0 && ep_end[i - 1] >= MAX_T) {
            ep_end[i] = MAX_T;
            continue;
        }

        while (IT < n && tim + l[i] > hard_d[IT]) {
            int id = hmw[IT][1];
            tim += a[id];
            IT++;
        }

        tim += l[i];
        ep_end[i] = tim;
//        if (IT == n) {
//            ep_end[i] = tim + l[i];
//            continue;
//        }
    }

    for (int i = 0; i < q; ++i) {
        ll cur_t;
        cin >> cur_t;

        size_t id = std::upper_bound(ep_end.begin(), ep_end.end(), cur_t) - ep_end.begin();

        cout << id << " ";
    }
    cout << '\n';
}

signed main() {
    int t = 1;
#ifdef KEK
    freopen("../input", "r", stdin);
    freopen("../output", "w", stdout);
    cin >> t;
#else
    cin.tie(0); cout.tie(0); std::ios::sync_with_stdio(false);
    cin >> t;
#endif
    for (int i = 0; i < t; ++i) {
        solve();
    }
}