
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

void solve() {
	int n;
	cin >> n;
	vector<int>a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	vector<int>found(n + 1);
	vector<pair<int, int>> ans;
	for (int i = n - 1; i >= 0; i--) {
		found[a[i]] = 1;
		vector<int>before;
		for (int j = 1; j < a[i]; ++j) {
			if(!found[j])
				before.push_back(j);
		}
		for (int j = (int)before.size() - 1; j >= 0; j--) {
			ans.push_back({ a[i],before[j] });
		}
		for (int j = 0; j < before.size(); j++)
		{
			ans.push_back({ before[j], a[i] });
		}
		for (int j = a[i]+1; j < n+1; j++)
		{
			if (!found[j])
				ans.push_back({ j,a[i] });
		}
	}
	cout << ans.size() << "\n";
	for (const auto& u : ans) {
		cout << u.first << " " << u.second << "\n";	
	}
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(20);
#ifdef _MY
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}
