
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cassert>
using namespace std;
using ll = long long;


void solve() {
	int n;
	cin >> n;
	vector<string>a(2);
	cin >> a[0] >> a[1];
	bool has_mult = false;
	for (int i = 0; i < a[0].size();) {
		if (i + 1 < a[0].size() && a[0][i] == '.' && a[1][i] == '.'
			&& a[1][i + 1] == '.' && a[0][i + 1] == '.') {
			i += 2;
			has_mult = true;
			continue;
		}
		if (a[0][i] == '.' && a[1][i] == '.') {
			a[0][i] = '#';
			a[1][i] = '#';
			++i;
			continue;
		}

		if (a[0][i] == '#' && a[1][i] == '#') {
			++i;
			continue;
		}

		int j = 0;
		if (a[1][i] == '.')
			j = 1;
		if (i + 1 == a[0].size() || a[j][i + 1] == '#') {
			cout << "None" << "\n";
			return;
		}
		a[j][i] = a[j][i + 1] = '#';
		++i;
	}
	if (has_mult) {
		cout << "Multiple" << "\n";
	}
	else {
		cout << "Unique" << "\n";
	}

}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(20);
#ifdef _MY
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}
