//
// Created by nef on 15.12.2024.
//

#include "F.h"
#include<bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
#define pb push_back
#define all(x) (x).begin(),(x).end()
#define int ll

void solve() {
    int n;
    cin >> n;

    string s, t;
    cin >> s >> t;

    bool multiple = false;
    int i = 0, j = 0;
    while(i < n || j < n) {
        while(i < n && s[i] == '#') i++;
        while(j < n && t[j] == '#') j++;

        if(i == n && j == n) break;

        if(i < j) {
            if(i + 1 >= n || s.substr(i, 2) != "..") {
                cout << "None\n";
                return;
            } else i += 2;
        } else if(j < i) {
            if(j + 1 >= n || t.substr(j, 2) != "..") {
                cout << "None\n";
                return;
            } else j += 2;
        } else {
            if(i + 1 < n && j + 1 < n && s.substr(i, 2) == ".." && t.substr(j, 2) == "..") {
                multiple = true;
            }
            i++;
            j++;
        }
    }

    cout << (multiple ? "Multiple" : "Unique") << '\n';
}


signed main() {
    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}