import sys

input = sys.stdin.readline

def solve():
    n = int(input())
    s1 = list(input()[:n])
    s2 = list(input()[:n])
    dp = [[0 for i in range(4)] for j in range(n + 1)]
    dp[0][3] = 1
    for i in range(n):
        dp[i][0] = min(dp[i][0], 2)
        dp[i][1] = min(dp[i][1], 2)
        dp[i][2] = min(dp[i][2], 2)
        dp[i][3] = min(dp[i][3], 2)
        x = (s1[i] == '#') * 2 + (s2[i] == '#')
        dp[i + 1][x] += dp[i][0]
        if x == 0:
            dp[i + 1][3] += dp[i][0]
        if (x & 1) == 0:
            dp[i + 1][x + 1] += dp[i][2]
        if ((x >> 1) & 1) == 0:
            dp[i + 1][x + 2] += dp[i][1]
        dp[i + 1][x] += dp[i][3]
    if dp[n][3] == 0:
        print('None')
    elif dp[n][3] == 1:
        print('Unique')
    else:
        print('Multiple')

iter = 1
iter = int(input())
for _ in range(iter):
    solve()