#include <bits/stdc++.h>

#define i4 int32_t
#define u4 uint32_t
#define i8 int64_t
#define u8 int64_t

#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front

using namespace std;

template<class T>
using Vec = vector<T>;

template<class T, class V>
using Pair = pair<T, V>;


void Solve() {
    i4 n, m, q;
    cin >> n >> m >> q;

    Vec<Pair<i8, i8>> task(n);
    Vec<i8> l(m);

    for (auto& to : task) {
        cin >> to.second;
    }

    for (auto& to : task) {
        cin >> to.first;
    }

    for (auto& to : l) {
        cin >> to;
    }

    Vec<Pair<i8, i8>> t(q);

    for (i4 i = 0; i < q; ++i) {
        cin >> t[i].first;
        t[i].second = i;
    }

    sort(t.begin(), t.end());

    sort(task.begin(), task.end());


    for (i4 i = 1; i < n; ++i) {
        task[i].second += task[i - 1].second;
    }


    for (i4 i = 1; i < m; ++i) {
        l[i] += l[i - 1];
    }

    Vec<i8> d(n);

    for (i4 i = 0; i < n; ++i) {
        d[i] = task[i].first - task[i].second;
    }

    for (i4 i = n - 2; i >= 0; --i) {
        d[i] = min(d[i], d[i + 1]);
    }

    i4 it = 0;

    Vec<i4> res(q);
    for (i4 i = 0; i < q; ++i) {
        while (it < n && t[i].first >= task[it].first) {
            ++it;
        }

        i8 s = 0;
        if (it == n) {
            s = t[i].first - task[n - 1].second;
        } else {
            s = d[it];
        }

        s = min(s, t[i].first - (it == 0 ? 0 : task[it - 1].second));

        res[t[i].second] = upper_bound(l.begin(), l.end(), s) - l.begin();
    }

    for (auto to : res) {
        cout << to << ' ';
    }
    cout << '\n';

}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    i4 t = 1;
    cin >> t;

    for (i4 iter = 0; iter < t; ++iter) {
        Solve();
    }
}
