#include <bits/stdc++.h>

using namespace std;

#define SP ' '
#define LF '\n'
#define rep(i, a, b) for(ll i = (a); i < (b); i++)
#define all(x) (x).begin(), (x).end()

using ll = long long;
using ull = unsigned long long;
using ld = long double;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;


	using p = pair<bool, bool>;

	// {is_set, is_true}
	vector<p> ops(n);
	rep(i, 0, n) {
		string a, b;
		cin >> a >> b;

		ops[i] = p{a == "set", b == "true"};
	}

	vector<int> vcnt(n);

	vector<vector<int>> g(n);

	int m;
	cin >> m;
	rep(i, 0, m) {
		int u, v;
		cin >> u >> v;
		u--; v--;

		vcnt[v]++;
		g[u].push_back(v);
	}

	map<p, deque<int>> curr;

	vector<int> ans;

	rep(i, 0, n) {
		if (vcnt[i] == 0) {
			curr[ops[i]].push_back(i);
		}
	}

	vector<p> order = {
		p{false, false},
		p{true, true},
		p{true, false},
		p{false, true},
		p{false, false},
	};

	map<p, int> aboba;

	bool reg = false;

	for (auto x : order) {
		while (curr[x].size()) {
			if ((reg != x.first) != x.second) {
				cout << -1 << LF;
				return 0;
			}
			if (reg != x.first) reg = !reg;

			aboba[x]++;
			auto v = curr[x].front();
			curr[x].pop_front();
			ans.push_back(v);
			for (auto to : g[v]) {
				vcnt[to]--;
				if (vcnt[to] == 0) {
					curr[ops[to]].push_back(to);
				}
			}
		}
	}

	if (aboba[order[1]] > 1 || aboba[order[3]] > 1) {
		cout << -1 << LF;
		return 0;
	}

	if (ans.size() != n) {
		cout << -1 << LF;
		return 0;
	}

	rep(i, 0, n) {
		cout << (ans[i] + 1) << SP;
	}
}
