def is_correct_number(number):
    if number[0] == '0' and len(number) > 1:
        return False
    if len(number) > 10:
        return False
    for char in number:
        if not ('0' <= char <= '9'):
            return False
    return True

def is_correct_expression(expression):
    digits = "0123456789"
    operators = "+-="
    buf = ""
    bufs = []
    i =0
    while i < len(expression):
        while (i<len(expression) and expression[i] in digits):
            buf += expression[i]
            i+=1
        if (len(buf)>0):
            bufs.append(buf)
            buf = ""
        while (i<len(expression) and expression[i] in operators):
            buf += expression[i]
            i+=1
        if (len(buf) > 0):
            bufs.append(buf)
            buf = ""
    if (len(bufs)%2==0):
        return False
    if "==" not in bufs:
        return False
    for i in range(0, len(bufs), 2):
        if not (is_correct_number(bufs[i])):
            return False
    for i in range(1, len(bufs), 2):
        if bufs[i]!="==" and( len(bufs[i]) >1 or bufs[i][0] not in operators):
            return False
    return True


def fix_expression(expression):
    allowed_symbols = "0123456789"
    for i in range(len(expression)):
        removed_symbol = expression[i]
        if removed_symbol not in allowed_symbols:
            continue
        new_expression = ""
        for j in range(len(expression)):
            if i == j:
                continue
            new_expression += expression[j]
        for j in range(len(expression)):
            renew_expression = ""
            for k in range(len(new_expression)):
                if k==j:
                    renew_expression += removed_symbol
                renew_expression += new_expression[k]
            if j == len(new_expression):
                renew_expression += removed_symbol
            if not (is_correct_expression(renew_expression)):
                continue
            if eval(renew_expression) == True:
                return renew_expression
    return "Impossible"

def main():
    expression = input()
    expression = expression.replace("=", "==")
    if eval(expression) == True:
        print("Correct")
        return
    expression = fix_expression(expression)
    expression = expression.replace("==", "=")
    print(expression)

main()
