#include <bits/stdc++.h>

#define long long long

using namespace std;

void solve()
{
    int n;
    cin >> n;

    vector<string> a(2);

    cin >> a[0] >> a[1];

    vector<vector<long>> dp(n + 1, vector<long>(4));

    dp[0][3] = 1;

    for(int i = 1; i <= n; i++)
    {
        if(a[0][i - 1] == '#' && a[1][i - 1] == '#')
        {
            dp[i][3] = dp[i - 1][3];
        }
        else if(a[0][i - 1] == '.' && a[1][i - 1] == '.')
        {
            dp[i][3] = min(2ll, dp[i - 1][0] * 2);
            dp[i][3] = min(2ll, dp[i][3] + dp[i - 1][3]);
            dp[i][2] = dp[i - 1][1];
            dp[i][1] = dp[i - 1][2];
            dp[i][0] = dp[i - 1][3];
        }
        else if(a[0][i - 1] == '#' && a[1][i - 1] == '.')
        {
            dp[i][1] = dp[i - 1][3];
            dp[i][3] = dp[i - 1][1];
        }
        else
        {
            dp[i][2] = dp[i - 1][3];
            dp[i][3] = dp[i - 1][2];
        }
    }

    if(dp[n][3] == 0)
    {
        cout << "None\n";
    }
    else if(dp[n][3] == 1)
    {
        cout << "Unique\n";
    }
    else if(dp[n][3] == 2)
    {
        cout << "Multiple\n";
    }
}

int32_t main() {
    int t = 1;
    cin >> t;
    while (t-->0) {
        solve();
    }
}
/*
4
10
#.......##
##..#.##..
6
...#..
..#...
8
........
........
3
###
###



8
8
........
###..###
5
...#.
.#...
7
.....#.
...#...
3
...
.#.
7
.#.....
...#...
8
.......#
.##..#..
4
..#.
.#..
4
...#
#...
3
#.#
...
 */
