#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define pbc push_back
#define mp make_pair
#define all(v) begin(v),end(v)
#define vin(v) for (auto &el : v) cin >> el

mt19937 rnd(179);

template<typename T1, typename T2>
inline void chkmin(T1 &x, const T2 &y) {
    if (y < x) {
        x = y;
    }
}

template<typename T1, typename T2>
inline void chkmax(T1 &x, const T2 &y) {
    if (y > x) {
        x = y;
    }
}

void add(vector<int>& dp, int ind, int cnt) {
    dp[ind] = min(dp[ind] + cnt, 2);
}

void solve() {
    int n;
    cin >> n;
    vector <string> a(2);
    for (int i = 0; i < 2; ++i) cin >> a[i];
    vector <int> dp(4);
    dp[3] = 1;

    for (int i = 0; i < n; ++i) {
        vector <int> ndp(4);
        for (int mask = 0; mask < 4; ++mask) {
            for (int edge1 = 0; edge1 < 2; ++edge1) {
                for (int edge2 = 0; edge2 < 2; ++edge2) {
                    for (int edge3 = 0; edge3 < 2; ++edge3) {
                        int c0 = 0;
                        int c1 = 0;
                        if (a[0][i] == '#') c0 = 1;
                        if (a[1][i] == '#') c1 = 1;

                        if (edge1 && (mask & 1)) continue;
                        if (edge2 && (mask & 2)) continue;
                        if (!edge1 && !(mask & 1)) continue;
                        if (!edge2 && !(mask & 2)) continue;
                        if (edge1) c0++;
                        if (edge2) c1++;
                        if (edge3) {
                            c0++;
                            c1++;
                        }
                        if (c0 > 1 || c1 > 1) continue;
                        int nmask = 0;
                        if (c0) nmask |= 1;
                        if (c1) nmask |= 2;
                        add(ndp, nmask, dp[mask]);
                    }
                }
            }
        }
        dp = ndp;
    }

    if (dp[3] == 0) cout << "None\n";
    else if (dp[3] == 1) cout << "Unique\n";
    else cout << "Multiple\n";
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    cout.precision(20), cout.setf(ios::fixed);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}