#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define pbc push_back
#define mp make_pair
#define all(v) begin(v),end(v)
#define vin(v) for (auto &el : v) cin >> el

mt19937 rnd(179);

template<typename T1, typename T2>
inline void chkmin(T1 &x, const T2 &y) {
    if (y < x) {
        x = y;
    }
}

template<typename T1, typename T2>
inline void chkmax(T1 &x, const T2 &y) {
    if (y > x) {
        x = y;
    }
}

#define int ll

struct vec {
    int a, b, c, d;

    auto operator<=>(const vec &other) const = default;
};

vec operator+(const vec &a, const vec &b) {
    return {a.a + b.a, a.b + b.b, a.c + b.c, a.d + b.d};
}

vec operator-(const vec &a, const vec &b) {
    return {a.a - b.a, a.b - b.b, a.c - b.c, a.d - b.d};
}

vec operator*(const vec &a, int x) {
    return {a.a * x, a.b * x, a.c * x, a.d * x};
}

vec zero = {0, 0, 0, 0};

vec rot(vec v) {
    return {-v.d, v.a, v.b, v.c};
}

vector<pair<vec, vec>> normalize(vector<pair<vec, vec>> arr) {
    for (auto &el : arr) {
        if (el.second < el.first) {
            swap(el.first, el.second);
        }
    }
    sort(all(arr));
    for (int i = (int)arr.size() - 1; i >= 0; --i) {
        arr[i].second = arr[i].second - arr[0].first;
        arr[i].first = arr[i].first - arr[0].first;

    }
    return arr;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<vec, vec>> arr;
    vec cur = {0, 0, 0, 0};
    int dir = 0;
    for (int i = 0; i < n; ++i) {
        string type;
        cin >> type;
        if (type == "rotate") {
            int a;
            cin >> a;
            a /= 45;
            dir += a;
            dir %= 8;
        } else {
            int d;
            cin >> d;
            vec nxt = cur;
            vec dirr = {0, 0, 0, 0};
            if (dir % 4 == 0) {
                dirr.a = 1;
            } else if (dir % 4 == 1) {
                dirr.b = 1;
            } else if (dir % 4 == 2) {
                dirr.c = 1;
            } else {
                dirr.d = 1;
            }
            if (dir / 4) {
                dirr = zero - dirr;
            }
            dirr = dirr * d;
            nxt = nxt + dirr;
            if (type == "draw") {
                arr.pbc({cur, nxt});
            }
            cur = nxt;
        }
    }
    // cout << arr.size() << endl;
    for (int i = 0; i < 8; ++i) {
        vector<pair<vec, vec>> other;
        map<array<int, 3>, vector<pair<vec, vec>>> bebra;
        for (auto &el : arr) {
            if (el.first.a == el.second.a) {
                other.pbc(el);
            } else {
                if (el.second < el.first) {
                    swap(el.first, el.second);
                }
                bebra[{el.first.b, el.first.c, el.first.d}].pbc(el);
            }
        }
        for (auto &el : bebra) {
            auto arr = el.second;
            sort(all(arr));
            vector<pair<vec, vec>> kek;
            for (auto el : arr) {
                if (!kek.empty() && kek.back().second == el.first) {
                    kek.back().second = el.second;
                } else {
                    kek.pbc(el);
                }
            }
            for (auto &el : kek) {
                other.pbc(el);
            }
        }
        arr = other;
        for (auto &el : arr) {
            el.first = rot(el.first);
            el.second = rot(el.second);
        }
    }
    arr = normalize(arr);
    auto arr0 = arr;
    for (int i = 1; i <= 8; ++i) {
        for (auto &el : arr) {
            el.first = rot(el.first);
            el.second = rot(el.second);
        }
        arr = normalize(arr);
        if (arr == arr0) {
            cout << i * 45 << '\n';
            return;
        }
    }
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    cout.precision(20), cout.setf(ios::fixed);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}