#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define pbc push_back
#define mp make_pair
#define all(v) begin(v),end(v)
#define vin(v) for (auto &el : v) cin >> el

mt19937 rnd(179);

template<typename T1, typename T2>
inline void chkmin(T1 &x, const T2 &y) {
    if (y < x) {
        x = y;
    }
}

template<typename T1, typename T2>
inline void chkmax(T1 &x, const T2 &y) {
    if (y > x) {
        x = y;
    }
}

vector <vector <int>> g;
vector <int> p, gl;
vector <int> used;

void dfs(int v) {
    for (int i : g[v]) {
        if (i == p[v]) continue;
        gl[i] = gl[v] + 1;
        p[i] = v;
        dfs(i);
    }
}

void solve() {
    int n;
    cin >> n;
    vector <int> a(2 * n);
    for (int i = 0; i < 2 * n; ++i) cin >> a[i];
    g.assign(2 * n, {});
    for (int i = 0; i < 2 * n - 1; ++i) {
        int x, y;
        cin >> x >> y; --x; --y;
        g[x].push_back(y);
        g[y].push_back(x);
    }

    gl.assign(2 * n, 0);
    p.assign(2 * n, -1);
    used.assign(2 * n, 0);

    dfs(0);

    vector <pair <int, int>> ord;
    for (int i = 0; i < 2 * n; ++i) {
        ord.emplace_back(gl[i], i);
    }
    sort(ord.rbegin(), ord.rend());
    vector <pair <int, int>> edges;
    for (auto i : ord) {
        int v = i.second;
        if (p[v] == -1 || used[v] || used[p[v]]) continue;
        used[v] = used[p[v]] = 1;
        edges.emplace_back(v, p[v]);
    }

    vector <vector <int>> me(n);
    for (int i = 0; i < 2 * n; ++i) {
        --a[i];
        me[a[i]].push_back(i);
    }

    vector <int> num_edge(2 * n, -1);
    int ln = edges.size();
    for (int i = 0; i < ln; ++i) {
        num_edge[edges[i].first] = num_edge[edges[i].second] = i;
    }

    vector <int> used_edges(ln);
    vector <int> used_v(2 * n);
    vector <pair <int, int>> opers;

    for (int i = 0; i < 2 * n; ++i) {
        if (used_v[i] || num_edge[i] != -1) continue;
        int oth = i ^ me[a[i]][0] ^ me[a[i]][1];
        if (num_edge[oth] == -1) {
            used_v[i] = used_v[oth] = 1;
            continue;
        }

        int cnt_flex = 0;

        while (num_edge[oth] != -1) {
            used_edges[num_edge[oth]] = 1;
            cnt_flex++;
            oth = oth ^ edges[num_edge[oth]].first ^ edges[num_edge[oth]].second;
            oth = oth ^ me[a[oth]][0] ^ me[a[oth]][1];
        }
        used_v[i] = used_v[oth] = 1;

        int last_ind;
        int real_ind;

        opers.emplace_back(i ^ me[a[i]][0] ^ me[a[i]][1], oth);
        last_ind = i ^ me[a[i]][0] ^ me[a[i]][1];
        real_ind = oth;

        for (int oper = 0; oper < cnt_flex - 1; ++oper) {
            int mem = me[a[real_ind]][0] ^ me[a[real_ind]][1] ^ real_ind;
            int kek = edges[num_edge[last_ind]].first ^ edges[num_edge[last_ind]].second ^ last_ind;
            opers.emplace_back(mem, kek);
            last_ind = mem;
            real_ind = kek;
        }
    }

    for (int e = 0; e < ln; ++e) {
        if (used_edges[e]) continue;
        int last_ind = edges[e].first;
        int real_ind = last_ind;

        while (!used_edges[num_edge[last_ind]]) {
            used_edges[num_edge[last_ind]] = 1;
            int mem = me[a[real_ind]][0] ^ me[a[real_ind]][1] ^ real_ind;
            int kek = edges[num_edge[last_ind]].first ^ edges[num_edge[last_ind]].second ^ last_ind;
            if (used_edges[num_edge[mem]]) break;
            opers.emplace_back(mem, kek);
            last_ind = mem;
            real_ind = kek;
        }
    }

    cout << opers.size() << "\n";
    for (auto i : opers) {
        cout << i.first + 1 << " " << i.second + 1 << "\n";
    }
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    cout.precision(20), cout.setf(ios::fixed);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}