#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
	template <typename K, typename V, typename Comp = less<K>>
using rbt_map = tree<K, V, Comp, rb_tree_tag, tree_order_statistics_node_update>;
	template <typename K, typename Comp = less<K>>
using rbt_set = rbt_map<K, null_type, Comp>;
	template <typename T>
void relax_min(T& a, const T& b) {
	if (b < a) a = b;
}
	template <typename T>
void relax_max(T& a, const T& b) {
	if (a < b) a = b;
}


#define all(x) (x).begin(), (x).end()
#define ft first
#define sc second

ld const PI = acos(-1);
int const N = 3e5 + 4;
int const inf = 1e9 + 7;
int const mod = 998244353;
ll const INF = 1e18; 

void solve() {
	int n;
	cin >> n;

	vector<int> vc(n);
	for (auto &i : vc) {
		cin >> i;
		i--;
	}

	vector<pair<int, int>> ans;
	for (int i = n - 1; i >= 0; i--) {
		auto ind = find(vc.begin(), vc.end(), i) - vc.begin();
		for (; ind > 0; ind--) {
			ans.push_back({vc[ind - 1], vc[ind]});
			swap(vc[ind - 1], vc[ind]);
		}

		for (; ind != i; ind++) {
			ans.push_back({vc[ind], vc[ind + 1]});
			swap(vc[ind], vc[ind + 1]);
		}
	}

	cout << ans.size() << endl;
	reverse(ans.begin(), ans.end());
	for (auto [a, b] : ans) {
		cout << a + 1 << ' ' << b + 1<< endl;
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t = 1;
	#ifdef LOCAL
	freopen("in", "r", stdin);
	freopen("out", "w", stdout);
	//cin >> t;
	#endif
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}

/*
3
2 3 1
*/