#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
//#define int long long
using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
	template <typename K, typename V, typename Comp = less<K>>
using rbt_map = tree<K, V, Comp, rb_tree_tag, tree_order_statistics_node_update>;
	template <typename K, typename Comp = less<K>>
using rbt_set = rbt_map<K, null_type, Comp>;
	template <typename T>
void relax_min(T& a, const T& b) {
	if (b < a) a = b;
}
	template <typename T>
void relax_max(T& a, const T& b) {
	if (a < b) a = b;
}


#define all(x) (x).begin(), (x).end()
#define ft first
#define sc second

ld const PI = acos(-1);
int const N = 3e5 + 4;
int const inf = 1e9 + 7;
int const mod = 998244353;
ll const INF = 1e18; 

int const M = 16 * 17;
int mem[M];
string hx = "0123456789abcdef";

void print_mem() {
	for (int x : mem) {
		for (int q = 3; q >= 0; --q) {
			int d = (x >> (4 * q));
			cout << hx[d & 15];
		}				
		cout << ' ';
	}
	cout << '\n';
}

void solve() {
	fill(mem, mem + M, 0);
	int x;
	cin >> x;
	int dummy_bit = 6 * 16;
	int zero_bit = dummy_bit + 1;
	int one_bit = dummy_bit + 2;
	int ans_bit = (1 << 16) - 16;
	int end_pos = (1 << 12) - 1;
	int fail_pos = 16 * 16 + 3;
	int input_bit = ans_bit;	
	
	mem[one_bit >> 4] |= (1 << (one_bit & 15));

	for (int b = 0; b < 16; ++b) {
		int l = 16 * b;
		mem[l + 0] = input_bit + b;
		mem[l + 1] = ((l + 5) << 4) + 2;
		mem[l + 2] = l + 3;
		mem[l + 3] = mem[l + 4] = dummy_bit;
		mem[l + 5] = (l + 8);
		mem[l + 8] = mem[l + 9] = mem[l + 12] = mem[l + 13] = dummy_bit;
		mem[l + 10] = 16 * (b + 1);
		mem[l + 14]	= fail_pos;
		if (x & (1 << b)) swap(mem[l + 10], mem[l + 14]);					
	}	
	int l = 16 * 16;
	mem[l + 0] = one_bit;
	mem[l + 1] = mem[l + 4] = ans_bit;
	mem[l + 3] = zero_bit;
	mem[l + 2] = mem[l + 5] = end_pos;

	print_mem();
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t = 1;
	#ifdef LOCAL
	freopen("in", "r", stdin);
	freopen("out", "w", stdout);
	//cin >> t;
	#endif
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}