#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
	template <typename K, typename V, typename Comp = less<K>>
using rbt_map = tree<K, V, Comp, rb_tree_tag, tree_order_statistics_node_update>;
	template <typename K, typename Comp = less<K>>
using rbt_set = rbt_map<K, null_type, Comp>;
	template <typename T>
void relax_min(T& a, const T& b) {
	if (b < a) a = b;
}
	template <typename T>
void relax_max(T& a, const T& b) {
	if (a < b) a = b;
}


#define all(x) (x).begin(), (x).end()
#define ft first
#define sc second

ld const PI = acos(-1);
int const inf = 1e9 + 7, P = 1 << 17;
int const mod = 998244353;
ll const INF = 1e18; 

int const N = 2e5 + 4;
pii hw[N], segs[N];
ll lens[N];
ll sl[N];

void solve() {
	int n, m, q;
	cin >> n >> m >> q;
	for (int i = 0; i < n; ++i) {
		cin >> hw[i].second;
	}		
	for (int i = 0; i < n; ++i) {
		cin >> hw[i].first;
	}
	for (int i = 0; i < m; ++i) {
		cin >> sl[i];
		if (i) sl[i] += sl[i - 1];
	}
	sort(hw, hw + n);
	int R = 1e16; 
	int cnts = 0;
	for (int i = n - 1; i >= 0; --i) {
		auto& [d, a] = hw[i];
		if (d < R) {
			segs[cnts++] = pii{d, R};	
			R = d;
		}
		R -= a;
	}
	if (R > 0) {
		segs[cnts++] = pii{0, R};	
	}
	reverse(segs, segs + cnts);
	for (int i = 0; i < cnts; ++i) {
		auto& [l, r] = segs[i];
		lens[i + 1] = lens[i] + (r - l);	
	}
	while (q--) {
		int t;
		cin >> t;
		int l = 0;
		for (int p = P; p; p >>= 1) {
			l += p;
			if (l > cnts || segs[l - 1].second > t) {
				l -= p;
			}
		}
		ll sumlen = lens[l];
		if (l < cnts) {
			auto& [ql, qr] = segs[l];
			sumlen += max(0ll, t - ql); 
		}
		int ans = upper_bound(sl, sl + m, sumlen) - sl;
		cout << ans << ' ';
	}
	cout << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t = 1;
	#ifdef LOCAL
	freopen("in", "r", stdin);
	freopen("out", "w", stdout);
	//cin >> t;
	#endif
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}