#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define show(x) cout << "[debug " << __LINE__ << "] " << x << endl
#else
#define show(x) ((void)0)
#endif

void solve() {
    int n;
    cin >> n;

    vector<string> s(2);
    cin >> s[0] >> s[1];

    bool not_unique = false;
    bool ok = true;

    int i = 0;

    for (; i < n - 1; i++) {
        if (s[0][i] == '.' && s[1][i] == '.' && s[0][i + 1] == '.' && s[1][i + 1] == '.') {
            not_unique = true;
            i++;
        } else if (s[0][i] == '.' && s[1][i] == '.') {
            // pass
        } else if (s[0][i] == '.' && s[0][i + 1] == '.') {
            s[0][i] = s[0][i + 1] = '#';
        } else if (s[1][i] == '.' && s[1][i + 1] == '.') {
            s[1][i] = s[1][i + 1] = '#';
        } else if (s[0][i] == '#' && s[1][i] == '#') {
            // pass
        } else {
            show(i);
            ok = false;
            break;
        }
    }

    if (!ok) {
        cout << "None\n";
        return;
    }

    if (i == n - 1) {
        ok = (s[0][i] == '.' && s[1][i] == '.') || (s[0][i] == '#' && s[1][i] == '#');
    }

    if (ok && not_unique) {
        cout << "Multiple\n";
    } else if (ok) {
        cout << "Unique\n";
    } else {
        cout << "None\n";
    }

}

bool isdig(char c) {
    return c >= '0' && c <= '9';
}

vector<string> buf;

bool check(string s) {
//    cerr << s << endl;
    buf.clear();
    string cur = "";
    for (int i = 0; i < s.size(); i++) {
        if (isdig(s[i])) {
            cur += s[i];
        } else {
            if (cur != "") {
                buf.push_back(cur);
            }
            cur = "";
            cur += s[i];
            buf.push_back(cur);
            cur = "";
        }
    }
    if (cur.size()) {
        buf.push_back(cur);
    }
    auto good_number = [](const string &s) {
        if (s.size() == 1) {
            return true;
        }
        if (s.size() == 0) {
            return false;
        }
        if (s[0] == '0') {
            return false;
        }
        if (s.size() > 10) {
            return false;
        }
        return true;
    };
    auto to_number = [](const string &s) {
        long long x = 0;
        for (auto c: s) {
            x = x * 10 + (c - '0');
        }
        return x;
    };

    char last_oper = '+';
    bool is_last_word_number = false; //true;
    pair<long long, long long> res = {0, 0};
    long long *res_part = &res.first;
    for (const auto &word: buf) {
        if (0)cerr << word << endl;
        if (word == "") {
            return false;
        }
        if (isdig(word[0])) {
            // number
            if (!good_number(word)) {
                return false;
            }
            auto cur_number = to_number(word);
            if (last_oper == '+' || last_oper == '=') {
                *res_part += cur_number;
            } else if (last_oper == '-') {
                *res_part -= cur_number;
            }
            is_last_word_number = true;
        } else {

            if (/*last_oper != '=' && */!is_last_word_number) {
                return false;
            }
            if (word[0] == '+') {
//                res_part += cur_number;
            } else if (word[0] == '-') {
//                res_part -= cur_number;
            } else if (word[0] == '=') {
                res_part = &res.second;
            }
            last_oper = word[0];
            is_last_word_number = false;
        }
    }
    if (!is_last_word_number) {
        return false;
    }
    if (buf[0] == "=" || buf.back() == "=") {
        return false;
    }
//    if(0)cerr << res.first << ' ' << res.second << endl;
    return res.first == res.second;
}

void correct() {
    cout << "Correct" << endl;
    exit(0);
}

void find_ans(string s) {
    cout << s << endl;
    exit(0);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    string s;
    cin >> s;
    if (check(s)) {
        correct();
    }
//    return 0;

    for (int i = 0; i < s.size(); i++) {
        string cur = s;
        if (!isdig(s[i])) {
            continue;
        }
        for (int j = i - 1; j >= 0; j--) {
            swap(cur[j], cur[j + 1]);
        }
        if (check(cur)) {
            find_ans(cur);
        }
        for (int j = 1; j < s.size() - 1; j++) {
            if (0)cerr << i << ' ' << j << endl;
//            string cur = s;
            swap(cur[j], cur[j - 1]);

            if (check(cur)) {
                find_ans(cur);
            }
        }
    }

    cout << "Impossible" << endl;

    return 0;
}