#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <stdlib.h>
#include <stdio.h>

//#define int long long
#define ll long long

using namespace std;

void solve() {
    int n;
    cin >> n;

    vector<vector<int>> field(2, vector<int> (n));
    for(int i = 0; i < 2; i++){
        string s;
        cin >> s;
        for(int j = 0; j < n; j++){
            field[i][j] = s[j] == '.' ? 0 : 1;
        }
    }

    if(n == 1 && field[0][0] != field[1][0]){
        cout << "None" << "\n";
        return;
    }

    bool mult = false;
    int c1 = 0;
    int c2 = 0;
    for(int i = 0; i < n; i++){
        if(i + 1 < n && field[0][i] == 0 && field[0][i+1] == 0 && field[1][i] == 0 && field[1][i+1] == 0
        && c1 == 0 && c2 == 0){
            mult = true;
        }
        if(field[0][i] == 1 && c1 != 0){
            cout << "None" << "\n";
            return;
        }
        if(field[1][i] == 1 && c2 != 0){
            cout << "None" << "\n";
            return;
        }
        if(field[0][i] == 0 && field[1][i] == 0 && c1 == 0 && c2 == 0){
            continue;
        }
        if(field[0][i] == 0 && field[1][i] == 0 && c1 == 1 && c2 == 1){
            c1 = 0;
            c2 = 0;
            continue;
        }
        if(field[0][i] == 0 && field[1][i] == 0){
            c1 = (c1 + 1) % 2;
            c2 = (c2 + 1) % 2;
            continue;
        }
        if(field[0][i] == 0 && field[1][i] == 1){
            c1 = (c1 + 1) % 2;
        }
        if(field[0][i] == 1 && field[1][i] == 0){
            c2 = (c2 + 1) % 2;
        }
    }

    if(mult){
        cout << "Multiple" << "\n";
        return;
    }

    cout << "Unique" << "\n";


}

int main() {
    std:ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    for(int i = 0; i < t; i++){
        solve();
    }
    return 0;
}
