#include <bits/stdc++.h>
#pragma gcc optimize("O3, unroll-loops")
#pragma gcc target ("avx2")
using namespace std;

vector <int> gr[400001];
bool us[400001];
void dfs (int v, int &k)
{
    us[v] = 1;
    k++;

    for (auto u : gr[v])
    {
        if (!us[u])
        {
            dfs(u, k);
        }

    }
    return;
}

int del[400001];
queue <pair <int, bool> > q;
void fd (int v, bool f)
{
    int kdel = 0, ndel = 0;
    for (auto u : gr[v])
    {
        if (del[u])
            kdel++;
        else
            ndel = u;
    }

    if (kdel == gr[v].size() - 1)
    {
        del[v] = 1;
        q.push({ndel, 1});
    }
    else if (f)
    {
        del[v] = 1;
        for (auto u : gr[v])
            if (!del[u])
                q.push({u, 0});
    }
}

void solve()
{
    int n;
    cin >> n;

    fill(us, us + 2 * n, 0);
    fill(del, del + 2 * n, 0);
    for (int i = 0; i < 2 * n; i++) gr[i].clear();

    char c[2*n];
    for (int i  = 0; i < n; i++)
    {
        cin >> c[i];
        if (i > 0 && c[i] == '.' && c[i-1] == '.')
        {
            gr[i].push_back(i-1);
            gr[i-1].push_back(i);
        }
    }
    for (int i = n; i < 2 * n; i++)
    {
        cin >> c[i];
        if (i > n && c[i] == '.' && c[i-1] == '.')
        {
            gr[i].push_back(i-1);
            gr[i-1].push_back(i);
        }
        if (c[i] == '.' && c[i-n] == '.')
        {
            gr[i].push_back(i-n);
            gr[i-n].push_back(i);
        }
    }

    for (int i = 0; i < 2 * n; i++)
    {
        if (c[i] == '#')
            continue;

        if (!us[i])
        {
            int k = 0;
            dfs(i, k);

            //cout << k << endl;
            if (k & 1)
            {
                cout << "None";
                return;
            }
        }

        if (gr[i].size() == 1)
        {
            q.push({i, 0});
        }
    }

    while (!q.empty())
    {
        fd(q.front().first, q.front().second);
        q.pop();
    }

    for (int i = 0; i < n; i++)
    {
        if (c[i] == '#')
            continue;

        if (!del[i])
        {
            //cout << i << endl;
            cout << "Multiple";
            return;
        }
    }


    cout << "Unique";
    return;
}
int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
    {
        solve();
        cout << "\n";
    }
    return 0;
}
/*
10
#.......##
##..#.##..
6
...#..
..#...
8
........
........
3
###
###

*/

