#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct homework {
    ll time, deadline;
};

struct call {
    ll time, index;
};

bool operator<(call a, call b) {
    return a.time < b.time;
}
bool operator<(homework a, homework b) {
    if(a.deadline != b.deadline) {
        return a.deadline < b.deadline;
    }
    return a.time > b.time;
}
void solve() {
    ll n, m, q;
    cin >> n >> m >> q;
    vector < homework > homeworks(n);
    vector < call > queries(q);
    vector < ll > series(m);
    for(int i = 0; i < n; i++) {
        cin >> homeworks[i].time;
    }
    for(int i = 0; i < n; i++) {
        cin >> homeworks[i].deadline;
    }
    for(int i = 0; i < m; i++) {
        cin >> series[i];
    }
    for(int i = 0; i < q; i++) {
        cin >> queries[i].time;
        queries[i].index = i;
    }
    sort(queries.begin(), queries.end());
    sort(homeworks.begin(), homeworks.end());
    ll time = 0, last_hw = 0, last_series = 0, series_cnt = 0;
    vector < pair < ll, ll > > times;
    while(last_series < series.size() ||
    last_hw < homeworks.size()) {
        if(last_series < series.size() &&
                (last_hw == homeworks.size() || time + series[last_series] <=
        homeworks[last_hw].deadline - homeworks[last_hw].time)) {
            series_cnt++;
            time += series[last_series];
//            cout << "Series comleted" << " " << time << "\n";
            last_series++;
            times.emplace_back(time, series_cnt);
        } else {
            time += homeworks[last_hw].time;
//            cout << "Homework comleted" << " " << time << "\n";
            last_hw++;
        }
    }
//    for(auto &[i, j]: times) {
//        cout << i << " " << j << "\n";
//    }
    vector < ll > ans(queries.size());
    for(int i = 0; i < q; i++) {
        ll l = -1, r = (ll)times.size();
        while(r - l > 1) {
            ll mid = (r + l) / 2;
            if(times[mid].first <= queries[i].time) {
                l = mid;
            } else {
                r = mid;
            }
        }
        ans[queries[i].index] = times[l].second;
    }
    for(auto i: ans) {
        cout << i << " ";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll T = 1;
    cin >> T;
    while(T--) {
        solve(), cout << "\n";
    }
    return 0;
}
