#include <iostream>
#include <vector>

using namespace std;

int main() {
	int n, count = 0;
	cin >> n;
	vector<int> arr(n);
	vector<vector<bool>> mat(n, vector<bool>(n));

	for (int i = 0; i < n; i++) {
		cin >> arr[i];
		mat[i][i] = true;
	}

	if (n == 1) {
		cout << 0;
		return 0;
	}
	if (n == 2) {
		if (arr[0] == 1) cout << 2 << endl << 2 << ' ' << 1 << endl << 1 << ' ' << 2;
		else cout << 1 << endl << 2 << ' ' << 1;
		return 0;
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (arr[i] > arr[j]) {
				mat[arr[i] - 1][arr[j] - 1] = true;
				swap(arr[i], arr[j]);
			}
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (mat[j][i] == mat[i][j] && mat[i][j] == false) {
				mat[j][i] = true;
				mat[i][j] = true;
			}
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (mat[j][i] == true && i != j) count++;
		}
	}

	cout << count << endl;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (mat[j][i] == 1 && j != i) {
				cout << j + 1 << ' ' << i + 1 << endl;
			}
		}
	}
}