#include <bits/stdc++.h>
#define ll long long

using namespace std;

ll n, m, q;
pair<ll,ll> a[200005];
ll prl[200005];
ll pra[200005];
ll mn[200005];

void solve() {
    cin >> n >> m >> q;
    for (int i = 1; i <= n; i++) {
        cin >> a[i].first;
    }
    for (int i = 1; i <= n; i++) {
        cin >> a[i].second;
    }
    sort(a + 1, a + n + 1, [&](auto p1, auto p2) {
        return p1.second < p2.second;
    });
    mn[n + 1] = 1e18;
    for (int i = n; i > 0; i--) {
        mn[i] = min(mn[i + 1], a[i].second) - a[i].first;
    }
    pra[0] = 0;
    for (int i = 1; i <= n; i++) {
        pra[i] = a[i].first + pra[i - 1];
    }
    prl[0] = 0;
    for (int i = 1; i <= m; i++) {
        cin >> prl[i];
        prl[i] += prl[i - 1];
    }
    while (q--) {
        ll t;
        cin >> t;
        ll l = 1, r = n + 1;
        while (l < r) {
            ll w = (l + r) / 2;
            if (mn[w] > t) {
                r = w;
            } else {
                l = w + 1;
            }
        }
        ll tm;
        if (l == 1) {
            tm = t;
        } else {
            if (a[l - 1].second > t) {
                tm = mn[l - 1] - pra[l - 2];
            } else {
                tm = t - pra[l - 1];
            }
        }
        l = 0, r = m;
        while (l < r) {
            ll w = (l + r + 1) / 2;
            if (tm < prl[w]) {
                r = w - 1;
            } else {
                l = w;
            }
        }
        cout << l << " ";
    }
    cout << endl;
}

int main() {
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

/*
 4
10
#.......##
##..#.##..
6
...#..
..#...
8
........
........
3
###
###
 */