#include <bits/stdc++.h>
#define ll long long

using namespace std;

ll n, m, q;
ll a[200005];
vector<ll> cl[200005];
vector<ll> c[200005];
ll dp[200006][2], lst[200005];
vector<pair<ll, ll>> ans;
vector<pair<ll, ll>> st;
bool used[200001];
using Chain = vector<pair<pair<ll, ll>, ll>>;
vector<Chain> chains;

void dfs(ll h, ll p = -1) {
    ll sum1 = 0;
    dp[h][0] = 0;
    dp[h][1] = 0;
    for (auto to : c[h]) {
        if (to != p) {
            dfs(to, h);
            sum1 += dp[to][1];
        }
    }
    dp[h][0] = dp[h][1] = sum1;
    lst[h] = -1;
    for (auto to : c[h]) {
        if (to != p) {
            if (sum1 - dp[to][1] + dp[to][0] + 1 > dp[h][1]) {
                dp[h][1] = sum1 - dp[to][1] + dp[to][0] + 1;
                lst[h] = to;
            }
        }
    }
}

void dfs_2(ll h, ll p = -1, bool t = true) {
    if (!t || lst[h] == -1) {
        for (auto to : c[h]) {
            if (to != p) {
                dfs_2(to, h, true);
            }
        }
    } else {
        for (auto to : c[h]) {
            if (to != p && to != lst[h]) {
                dfs_2(to, h, true);
            }
        }
        st.emplace_back(h, lst[h]);
        dfs_2(lst[h], h, false);
    }
}

void dfs_3(ll c, ll h, Chain& ch) {
    if (used[c]) {
        return;
    }
    used[c] = true;
    ll nxt = (a[st[c].first] == h ? a[st[c].second] : a[st[c].first]);
    ch.push_back({{h, nxt}, c});
    ll nxtc = -1;
    for (auto u : cl[nxt]) {
        if (u != c && !used[u]) {
            nxtc = u;
            break;
        }
    }
    if (nxtc != -1)
    dfs_3(nxtc, nxt, ch);
}

void solve() {
    cin >> n;
    st.clear();
    ans.clear();
    chains.clear();
    for (int i = 1; i <= 2 * n; i++) {
        c[i].clear();
        cl[i].clear();
        dp[i][0] = 0;
        dp[i][1] = 0;
        lst[i] = -1;
    }
    for (int i = 1; i <= 2 * n; i++) {
        cin >> a[i];
    }
    for (int i = 1; i < 2 * n; i++) {
        ll x, y;
        cin >> x >> y;
        c[x].push_back(y);
        c[y].push_back(x);
    }
    dfs(1);
    dfs_2(1);
//    for (auto [x, y] : st) {
//        cout << x << " - " << y << endl;
//    }
    for (int i = 0; i < st.size(); i++) {
        auto [x, y] = st[i];
        cl[a[x]].push_back(i);
        cl[a[y]].push_back(i);
    }
    for (int i = 0; i < st.size(); i++) {
        used[i] = false;
    }
    for (int i = 1; i <= n; i++) {
        if (cl[i].size() == 1 && !used[cl[i][0]]) {
            chains.emplace_back();
            dfs_3(cl[i][0], i, chains.back());
        }
    }
    for (int i = 1; i <= n; i++) {
        if (cl[i].size() == 2 && !used[cl[i][0]]) {
            chains.emplace_back();
            dfs_3(cl[i][0], i, chains.back());
        }
    }
    auto get_edge = [&](pair<pair<ll, ll>, ll> zv) -> pair<ll, ll> {
        return a[st[zv.second].first] == zv.first.first ?
            make_pair(st[zv.second].first, st[zv.second].second) :
            make_pair(st[zv.second].second, st[zv.second].first);
    };
    for (auto& ch : chains) {
        int sz = ch.size();
        bool zz = (ch[0].first.first == ch.back().first.second);
        int i = (sz - 1) / 2, j = i;
        for (int it = 0; it < sz - 1; it++) {
            if (it & 1) {
                i--;
                auto ea = get_edge(ch[i]);
                auto eb = get_edge(ch[j]);
                ans.emplace_back(ea.second, eb.second);
                swap(a[ea.second], a[eb.second]);
            } else {
                j++;
                auto ea = get_edge(ch[i]);
                auto eb = get_edge(ch[j]);
                ans.emplace_back(ea.first, eb.first);
                swap(a[ea.first], a[eb.first]);
            }
        }
        if (!zz) {
            if (sz & 1) {
                auto e = get_edge(ch[i]);
                for (int ii = 1; ii <= 2 * n; ii++) {
                    if (ii != e.second && a[ii] == ch[i].first.second) {
                        ans.emplace_back(ii, e.first);
                        break;
                    }
                }
            } else {
                auto e = get_edge(ch[j]);
                for (int ii = 1; ii <= 2 * n; ii++) {
                    if (ii != e.first && a[ii] == ch[j].first.first) {
                        ans.emplace_back(ii, e.second);
                        break;
                    }
                }
            }
        }
    }
    cout << ans.size() << endl;
    for (auto [x, y] : ans) {
        cout << x << " " << y << endl;
    }

}

int main() {
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

/*
 4
10
#.......##
##..#.##..
6
...#..
..#...
8
........
........
3
###
###
 */