#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <array>
#include <cmath>
#include <bitset>
#include <queue>
#include <deque> 
#include <numeric>
#include <iomanip>

using namespace std;
typedef long long li;
typedef long double ld;

void solve() {
	int n; cin >> n;
	vector<int> v(n);
	vector<int> cur(n);
	iota(cur.begin(), cur.end(), 0);
	map<int, int> p;
	for (int i = 0; i < n; ++i) {
		cin >> v[i];
		--v[i];
		p[i] = i;
	}
	map<pair<int, int>, int> u;
	vector<pair<int, int>> ans;
	for (int i = 0; i < n; ++i) {
		int id = p[v[i]] + 1;
		while (id != n) {
			ans.push_back({ cur[id++] + 1, cur[p[v[i]]] + 1});
		}
		--id;
		while (id != p[v[i]]) {
			ans.push_back({ cur[p[v[i]]] + 1, cur[id--] + 1 });
		}
		while (p[v[i]] > i) {
			swap(cur[p[v[i]]], cur[p[v[i]] - 1]);
			--p[v[i]];
			++p[cur[p[v[i]] + 1]];
			u[{v[i], cur[p[v[i]] + 1]}] = 1;
			ans.push_back({ v[i] + 1, cur[p[v[i]] + 1] + 1 });
		}
	}
	cout << ans.size() << '\n';
	for (auto& x : ans) {
		cout << x.first << ' ' << x.second << '\n';
	}
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	int t = 1;
	//cin >> t;
	while (t--) solve();
}