#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <array>
#include <cmath>
#include <bitset>
#include <queue>
#include <deque>	
#include <numeric>
#include <iomanip>

using namespace std;
typedef long long li;
typedef long double ld;

void solve() {
	int n; cin >> n;
	string a, b; cin >> a >> b;
	int h = 0;
	int f = 0, g = 0;
	for (int i = 0; i < n; ++i) {
		if (f) {
			if (a[i] == '#') {
				cout << "None\n";
				return;
			}
			f ^= 1;
			a[i] = '#';
		}
		if (g) {
			if (b[i] == '#') {
				cout << "None\n";
				return;
			}
			g ^= 1;
			b[i] = '#';
		}

		if (a[i] == '#' && b[i] == '#') continue;
		if (a[i] == '#') {
			g = 1;
		}
		if (b[i] == '#') {
			f = 1;
		}
		if (a[i] == b[i] && a[i] == '.' && i < n - 1) {
			if (a[i + 1] == b[i + 1] && a[i + 1] == '.') {
				h = 1;
			}
		}
	}
	if (f || g) {
		cout << "None\n";
		return;
	}
	cout << (h ? "Multiple" : "Unique") << '\n';
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	int t = 1;
	cin >> t;
	while (t--) solve();
}
