#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <array>
#include <cmath>
#include <bitset>
#include <queue>
#include <deque> 
#include <numeric>
#include <iomanip>

using namespace std;
typedef long long li;
typedef long double ld;

void solve() {
	int n, m, q; cin >> n >> m >> q;
	vector<pair<li, int>> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i].second;
	}
	for (int i = 0; i < n; i++) {
		cin >> a[i].first;
	}
	vector<int> l(m);
	for (int i = 0; i < m; i++) {
		cin >> l[i];
	}
	vector<pair<li, int>> t(q);
	for (int i = 0; i < q; i++) {
		cin >> t[i].first;
		t[i].second = i;
	}
	sort(t.begin(), t.end());
	vector<li> p(m + 1, 0);
	for (int i = 1; i < m + 1; i++) {
		p[i] = p[i - 1] + l[i - 1];
	}
	int k = 0, d = 0;
	li cur = 0;
	sort(a.begin(), a.end());
	vector<li> time(n + 1, 1e16);
	vector<int> ans(q);
	for (int i = n - 1; i >= 0; i--) {
		time[i] = min(a[i].first, time[i + 1]) - a[i].second;
	}
	for (int i = 0; i < q; i++) {
		while (d < n && a[d].first <= t[i].first) {
			cur += a[d].second;
			d++;
		}
		li tmp = cur + p[k];
		while (k < m && tmp + l[k] <= time[d] && tmp + l[k] <= t[i].first) {
			tmp += l[k];
			k++;
		}
		ans[t[i].second] = k;
	}
	for (int i = 0; i < q; ++i) cout << ans[i] << ' ';
	cout << '\n';
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	int t = 1;
	cin >> t;
	while (t--) solve();
}