#include <bits/stdc++.h>
using namespace std;
using ll=long long;
using pi=pair<int,int>;

template<typename T>
ostream& operator<<(ostream& ost, vector<T>& v){
    ost<<"[";
    for(auto x : v)
        ost<<x<<" ";
    return ost<<"]\n";
}


vector<int> mem((1<<12)-1, 0);

void write(int i, int a, int b, int c){
    mem[4*i] = a;
    mem[4*i+1] = b;
    mem[4*i+2] = 4*c;
}

void print(int x){
    string s;
    for (int i = 0; i < 4; ++i) {
        int rem = x%16;
        char c = char(rem > 9 ? 'a' + rem - 10 : '0' + rem);
        s += c;
        x /= 16;
    }
    std::reverse(s.begin(), s.end());
    cout<<s<<" ";
}

void solve(){
    int n;
    cin>>n;
    int lw_fb = (1<<16) - 16, lw = (1<<12)-1;
    write(0, 0, 0, 3);
    mem[3] = (1<<16)-1;
    mem[7] = 0;
    write(1, 48, lw_fb, lw);
    write(2, 112, lw_fb, lw);
    int cur = 3;
    for(int i = 0; i < 16; ++i){
        int next = cur + 1, ncur;
        if(next%2 == 1)
            ++next;
        ncur = next + 2;
        bool bit = n & (1<<i);
        write(cur, lw_fb + i, 64*cur + 34, next);
        write(next, 0, 0, bit? 2 : i == 15? 1 : ncur);
        write(next + 1, 0, 0, !bit? 2 : i == 15? 1 : ncur);
        cur = ncur;
    }
    for (int i = 0; i < cur*4; ++i) {
        print(mem[i]);
    }

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n = 1;
    //cin >> n;
    while(n--)
        solve();
}