#include <bits/stdc++.h>

using namespace std;
using pi = pair<int, int>;
using ll = long long;
using u16 = uint16_t;

vector<u16> gen_code(u16 x) {
    vector<u16> res(1 << 12);

    const int IO = (1 << 12) - 1;

    const int STATE_WIN = 16 * 16;
    const int STATE_LOSE = 16 * 16 + 16;

    const int POS_0 = 0; // life hack :)
    const int POS_1 = 4;

    for (int k = 0; k < 16; ++k) {
        const int sh = k * 16;

        const int A = sh, B = sh + 4, R0 = sh + 8, R1 = sh + 12;
        res[A+0] = (IO << 4) + k;
        res[A+1] = ((B+2) << 4) + 2;
        res[A+2] = B;
        res[B+2] = R0;

        const int W = ((x >> k) & 1) ? R1 : R0;
        const int L = R0 ^ R1 ^ W;

        res[W+2] = (k + 1) * 16;
        res[L+2] = STATE_LOSE;
    }

    res[STATE_WIN] = POS_1;
    res[STATE_WIN+1] = IO << 4;
    res[STATE_WIN+2] = 1 << 12;


    res[STATE_LOSE] = POS_0;
    res[STATE_LOSE+1] = IO << 4;
    res[STATE_LOSE+2] = 1 << 12;

    return res;
}

u16 emulate(vector<u16>& code, u16 input) {
    code.resize(1 << 12);
    code[(1 << 12) - 1] = input;

    int IP = 0, count = 0;
    while (true) {
        ++count;
        if (count > 1000) {
            exit(-1);
        }
        if (IP >= (1 << 12) - 2) {
            break;
        }

        int a = code[IP];
        int b = code[IP+1];
        u16 c = code[IP+2];

        cout << "IP=" << IP << ", a=" << bitset<16>(a) << ", b=" << bitset<16>(b) << ", c=" << bitset<16>(c) << endl;

        const bool bit = code[a >> 4] & (1 << (a & 15));
        int y = 1 << (b & 15);

        if (bit) {
            code[b >> 4] = code[b >> 4] | y;
        } else {
            code[b >> 4] = code[b >> 4] & ~y;
        }

        IP = c;
    }

    cout << "result " << bitset<16>(code[(1 << 12) - 1]);
    return code[(1 << 12) - 1];
}

void solve() {
    int x; cin >> x;
    auto prog = gen_code(x);

//    int y; cin >> y;
//    emulate(prog, y);
    prog.pop_back();

    int penis = 0;
    for (int x : prog) {
        const char* A = "0123456789abcdef";
        for (int j = 4; j--; ) {
            int w = (x >> (j * 4)) & 15;
            cout << A[w];
        }

        ++penis;
        cout << (penis == 8 ? '\n' : ' ');
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}


/*
2
1 2 3
10
15
5 5
5 15 20
3 4 5
8 100 8
10 150 20
2 32 1 1
9 200 51 50 10
 */