#include <bits/stdc++.h>

using namespace std;
#define ll long long

vector<set<int>> g;
vector<bool> used;
int n;

pair<int, int> comp(int v) {
    used[v] = true;
    pair<int, int> sm = {0, 0};
    if (v < n) {
        if (v % 2 == 0) ++sm.first;
        else sm.second++;
    } else {
        if ((v - n) % 2 == 1) ++sm.first;
        else sm.second++;
    }
    for (int q : g[v]) {
        if (used[q]) continue;
        pair<int, int> sm2 = comp(q);
        sm.first += sm2.first;
        sm.second += sm2.second;
    }
    return sm;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        cin >> n;
        string s1, s2;
        cin >> s1 >> s2;
        g.resize(2 * n);
        g.assign(2 * n, set<int> ());
        used.resize(2 * n);
        used.assign(2 * n, false);
        set<pair<int, int>> free;
        for (int i = 0; i < n; ++i) {
            if (s1[i] != '.') {
                used[i] = true;
                continue;
            }
            if (i > 0 && s1[i - 1] == '.') {
                g[i].insert(i - 1);
            }
            if (i + 1 < n && s1[i + 1] == '.') {
                g[i].insert(i + 1);
            }
            if (s2[i] == '.') {
                g[i].insert(i + n);
            }
            free.insert({g[i].size(), i});
        }

        for (int i = 0; i < n; ++i) {
            if (s2[i] != '.') {
                used[i + n] = true;
                continue;
            }
            if (i > 0 && s2[i - 1] == '.') {
                g[i + n].insert(i + n - 1);
            }
            if (i + 1 < n && s2[i + 1] == '.') {
                g[i + n].insert(i + n + 1);
            }
            if (s1[i] == '.') {
                g[i + n].insert(i);
            }
            free.insert({g[i + n].size(), i + n});
        }
        bool ok = true;
        bool multiple = false;
        while (!free.empty()) {
            auto pr = *free.begin();
            if (pr.first == 0) {
                ok = false;
                break;
            }
            if (pr.first > 1) {
                multiple = true;
            }
            int v = pr.second;
            int u = *g[v].begin();
            free.erase(free.find(pr));
            free.erase(free.find({g[u].size(), u}));
            used[v] = used[u] = true;
            for (int q : g[v]) {
                if (q == u) continue;
                free.erase(free.find({g[q].size(), q}));
                g[q].erase(v);
                free.insert({g[q].size(), q});
            }
            for (int q : g[u]) {
                if (q == v) continue;
                free.erase(free.find({g[q].size(), q}));
                g[q].erase(u);
                free.insert({g[q].size(), q});
            }
            g[u].clear();
            g[v].clear();
        }
        if (ok && !multiple) {
            cout << "Unique\n";
        } else if (!ok) {
            cout << "None\n";
        } else {
            cout << "Multiple\n";
        }
    }
}