

def solve(srt_task_times: list, srt_deadlines: list, series_times: list, discuss_times: list):
    summary_task_time_for_i_pos = [0] * len(srt_task_times)
    summary_task_time_for_i_pos[0] = srt_task_times[0]
    for i in range(1, len(srt_task_times)):
        summary_task_time_for_i_pos[i] = srt_task_times[i] + summary_task_time_for_i_pos[i-1]

    dif_between_deadline_and_task_time = [0] * len(srt_task_times)

    for i in range(0, len(summary_task_time_for_i_pos)):
        dif_between_deadline_and_task_time[i] = srt_deadlines[i]-summary_task_time_for_i_pos[i]

    minimums = [0] * len(dif_between_deadline_and_task_time)
    minimums[-1] = dif_between_deadline_and_task_time[-2]
    for i in range(len(minimums)-2, -1, -1):
        minimums[i] = min(dif_between_deadline_and_task_time[i], minimums[i+1])

    ans = []

    i = 0
    j = 0 #for series
    cur_time = 0
    summary_ser_time = 0
    cur_min = -1
    max_time = 0

    while i < len(minimums):
        if minimums[i] != cur_min:
            cur_min = minimums[i]
            max_time = minimums[i]

        while j < len(series_times) and summary_ser_time+series_times[j] <= max_time:
            summary_ser_time += series_times[j]
            ans.append(cur_time+summary_ser_time)
            max_time -= series_times[j]
            j += 1

        cur_time = summary_task_time_for_i_pos[i]
        i += 1


    series_for_discuss = [0] * len(discuss_times)
    cnt = 0
    i = 0
    for j in range(0, len(discuss_times)):
        dt = discuss_times[j][0]
        while i < len(ans) and ans[i] <= dt:
            cnt += 1
            i += 1
        series_for_discuss[j] = [discuss_times[j][1], cnt]
    series_for_discuss.sort()
    series_for_discuss = [i[1] for i in series_for_discuss]
    return series_for_discuss




j = int(input())
for _ in range(j):
    n, m, q = list(map(int, input().split()))
    task_times = list(map(int, input().split()))
    deadlines = list(map(int, input().split()))
    series_times = list(map(int, input().split()))
    discuss_times = list(map(int, input().split()))
    discuss_times = [[discuss_times[i],i] for i in range(0, len(discuss_times))]
    discuss_times.sort()
    task_time_and_dedalines = []
    for i in range(0, len(task_times)):
        task_time_and_dedalines.append([deadlines[i],task_times[i]])
    task_time_and_dedalines.sort()
    task_times = [i[1] for i in task_time_and_dedalines]
    deadlines = [i[0] for i in task_time_and_dedalines]
    task_times.append(0)
    deadlines.append(999999999999)


    slv = solve(task_times, deadlines, series_times, discuss_times)
    print(*slv)