#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using vll = vector<ll>;
using vpl = vector<pll>;
using vbo = vector<bool>;

#define all(a) a.begin(),a.end()
#define sor(a) sort(all(a))
#define sz(a) (ll)(a.size())

#define FOR(i, a, b) for (ll i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for (ll i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for(auto &i: a)

namespace solve_J {
    void solve() {
        ll n, m, q;
        cin >> n >> m >> q;
        vpl tasks(n);
        F0R(i, n) {
            cin >> tasks[i].second;
        }
        F0R(i, n) {
            cin >> tasks[i].first;
        }
        sor(tasks);
        vll films(m);
        F0R(i, m) {
            cin >> films[i];
        }
        vll time(n + 1);
        time[n] = 1e16;
        R0F(i, n) {
            time[i] = min(tasks[i].first, time[i + 1]) - tasks[i].second;
        }
        vll cnt_film(m + 1);
        cnt_film[0] = 0;
        F0R(i, m) {
            cnt_film[i + 1] = cnt_film[i] + films[i];
        }
        vll cnt_task(n + 1);
        cnt_task[0] = 0;
        F0R(i, n) {
            cnt_task[i + 1] = cnt_task[i] + tasks[i].second;
        }
        F0R(_, q) {
            ll t;
            cin >> t;
            ll l = 0, r = m + 1;
            while (r - l > 1) {
                ll bm = (l + r) / 2;
                ll bl = 0, br = n + 1;
                while (br - bl > 1) {
                    ll bbm = (bl + br) / 2;
                    if (cnt_film[bm] + cnt_task[bbm] <= t) {
                        bl = bbm;
                    } else {
                        br = bbm;
                    }
                }
                if (cnt_film[bm] + cnt_task[bl] <= min(t, time[bl])) {
                    l = bm;
                } else {
                    r = bm;
                }
            }
            cout << l << ' ';
        }
        cout << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        solve_J::solve();
    }
}