#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <bits/stdc++.h>


#define len(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define allr(a) a.rbegin(), a.rend()
#define pb push_back
#define F first
#define S second

using namespace std;

char letter(int bits) {
    return bits <= 9 ? '0' + bits : 'a' + (bits  - 10);
}

string encode(int a) {
    string result(4, '0');
    for (int i = 0; i < 4; i++) {
        result[i] = letter((a >> (3 - i) * 4) & 15);
    }
    return result;
}

int32_t main() {
#ifdef MY_DEBUG
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    int x;
    cin >> x;
    int s12 = 1 << 12;
    int s16 = 1 << 16;
    vector<int> ans(s12);
    for (int i = 0; i < 16; i++) {
        int shift = 16 * i;
        if (x >> i & 1) {
            ans[shift] = 16 * (s12 - 1) + i;
            ans[shift + 1] = 16 * (shift + 2) + 2;
            ans[shift + 2] = shift + 7;

            ans[shift + 3] = 16 * (s12 - 2);
            ans[shift + 4] = 16 * (s12 - 1);
            ans[shift + 5] = s12 - 1;

            ans[shift + 7] = s16 - 16;
            ans[shift + 8] = s16 - 16;
            ans[shift + 9] = shift + 16;
        } else {
            ans[shift] = 16 * (s12 - 1) + i;
            ans[shift + 1] = 16 * (shift + 2) + 2;
            ans[shift + 2] = shift + 3;

            ans[shift + 3] = s16 - 16;
            ans[shift + 4] = s16 - 16;
            ans[shift + 5] = shift + 16;

            ans[shift + 7] = 16 * (s12 - 2);
            ans[shift + 8] = 16 * (s12 - 1);
            ans[shift + 9] = s12 - 1;
        }
    }
    ans[s12 - 2] = 1 << 15;
    ans[16 * 16] = 16 * (s12 - 2) + 15;
    ans[16 * 16 + 1] = 16 * (s12 - 1);
    ans[16 * 16 + 2] = s12 - 1;
    for (int i = 0; i < s12 - 1; i++) {
        cout << encode(ans[i]) << '\n';
    }
}