#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define len(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define allr(a) a.rbegin(), a.rend()

using namespace std;

struct T {
    int a = 0;
    T(int x = 0): a(x) {};
    T operator+(const T &t) {
        return {min(t.a + a, 2)};
    }
};

int main() {
#ifdef MY_DEBUG
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<vector<char> > a(n, vector<char>(2));
        for (int i = 0; i < 2; i++) {
            for (int j = 0; j < n; j++) {
                cin >> a[j][i];
            }
        }
        vector<vector<T> > dp(n + 1, vector<T>(4));
        dp[0][3] = 1;
        for (int i = 1; i <= n; i++) {
            if (a[i - 1][0] == '.' && a[i - 1][1] == '.') {
                dp[i][0] = dp[i - 1][3];
                dp[i][1] = dp[i - 1][2];
                dp[i][2] = dp[i - 1][1];
                dp[i][3] = dp[i - 1][0] + dp[i - 1][3];
            }
            if (a[i - 1][0] == '#' && a[i - 1][1] == '.') {
                dp[i][1] = dp[i - 1][3];
                dp[i][3] = dp[i - 1][1];
            }
            if (a[i - 1][0] == '.' && a[i - 1][1] == '#') {
                dp[i][2] = dp[i - 1][3];
                dp[i][3] = dp[i - 1][2];
            }
            if (a[i - 1][0] == '#' && a[i - 1][1] == '#') {
                dp[i][3] = dp[i - 1][3];
            }
        }
        if (dp[n][3].a == 2) {
            cout << "Multiple\n";
        } else if (dp[n][3].a == 1) {
            cout << "Unique\n";
        } else {
            cout << "None\n";
        }
    }
}
