#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

#define forn(i, n) for (ll i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()

void solve() {
	ll n, m, q;
	cin >> n >> m >> q;

	vector<ll> a(n), d(n), l(m);
	forn(i, n) {
		cin >> a[i];
	}
	forn(i, n) {
		cin >> d[i];
	}


	vector<ll> idx(n);
	iota(all(idx), 0);

	sort(all(idx), [&](int i, int j) {
		return a[i] < a[j];
	});

	{
		auto c = a;
		forn(i, n) {
			a[i] = c[idx[i]];
		}
	}

	{
		auto c = d;
		forn(i, n) {
			d[i] = c[idx[i]];
		}
	}

	forn(i, m) {
		cin >> l[i];
	}

	auto a_pref = a;
	forn(i, n) {
		if (i) {
			a_pref[i] += a_pref[i - 1];
		}
	}

	auto l_pref = l;
	forn(i, m) {
		if (i) {
			l_pref[i] += l_pref[i - 1];
		}
	}

	vector<ll> suf_a(n);
	suf_a.back() = d.back() - a.back(); 
	for (int i = n - 2; i >= 0; --i) {
		suf_a[i] = min(suf_a[i + 1], d[i]) - a[i];
	}

	while (q--) {
		ll t;
		cin >> t;

		// tasks to do 
		auto it = upper_bound(all(d), t) - d.begin();
		ll remain = 0;
		if (it == 0) {
			remain = t;
		} else {
			remain = min(t, (it < n ? suf_a[it] : t)) - a_pref[it - 1];
		}
		auto watch_idx = upper_bound(all(l_pref), remain) - l_pref.begin();
		cout << watch_idx << " ";
	}
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	cin >> t;

	while (t--) {
		solve();
	}
}