#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve() {
    int n;
    cin >> n;

    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }

    set<pair<int, int>> s;
    unordered_map<int, int> pos;

    for (int i = 0; i < n; ++i) {
        pos[v[i]] = i;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (v[i] < v[j]) {
                s.emplace(v[i], v[j]);
            }
        }
    }

    vector<pair<int, int>> ans;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        a[i] = i + 1;
    }

    for (int _ = 0; _ < n; ++_) {
        for (int cur_idx = n - 1; cur_idx > 0; --cur_idx) {
            int cur = a[cur_idx];
            int prev = a[cur_idx - 1];

            auto p = make_pair(prev, cur);
            if (s.contains(p)) {
                ans.emplace_back(cur, prev);
                ans.emplace_back(prev, cur);
                s.erase(p);
                continue;
            }

            if (pos[cur] == cur_idx) {
                continue;
            }

            ans.emplace_back(cur, prev);
            swap(a[cur_idx], a[cur_idx-1]);
        }
    }


    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i].first << " " << ans[i].second << '\n';
    }

//    for (int i = 0; i < n; ++i) {
//        cout << v[i] << " - " << a[i] << endl;
//    }
//    for (int i = 0; i < n; ++i) {
//        assert(a[i] == v[i]);
//    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    cout.flush();
}
