#include <bits/stdc++.h>

using namespace std;

void dfs(int nd, pair<int, int>& res, vector<set<int>>& g, vector<int>& used, int fl = 0) {
    used[nd] = 1;
    if (fl) {
        ++res.second;
    } else {
        ++res.first;
    }
    for (auto x : g[nd]) {
        if (!used[x]) {
            dfs(x, res, g, used, 1 - fl);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    string a, b;
    cin >> a >> b;
    vector<set<int>> g(n + n);
    for (int i = 1; i < n; ++i) {
        if (a[i] == '.' && a[i - 1] == '.') {
            g[i].insert(i - 1);
            g[i - 1].insert(i);
        }
    }
    for (int i = 1; i < n; ++i) {
        if (b[i] == '.' && b[i - 1] == '.') {
            g[i + n].insert(i - 1 + n);
            g[i - 1 + n].insert(i + n);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (a[i] == '.' && b[i] == '.') {
            g[i].insert(i + n);
            g[i + n].insert(i);
        }
    }
    set<pair<int, int>> non_empty_nod;

    for (int i = 0; i < n; ++i) {
        if (a[i] == '.') {
            non_empty_nod.insert({g[i].size(), i});
        }
    }
    for (int i = 0; i < n; ++i) {
        if (b[i] == '.') {
            non_empty_nod.insert({g[i + n].size(), i + n});
        }
    }
    bool check_dfs_req = false;
    while (!non_empty_nod.empty()) {
//        for (auto x : non_empty_nod) {
//            cout << x.first << " " << x.second << endl;
//        }
//        cout << endl;
        if (non_empty_nod.begin()->first == 0) {
            cout << "None\n";
            return;
        }
        if (non_empty_nod.begin()->first != 1) {
            check_dfs_req = true;
            break;
        }

        auto tmp = non_empty_nod.begin()->second;
        non_empty_nod.erase(non_empty_nod.begin());
        auto sosed = *g[tmp].begin();
        non_empty_nod.erase({g[sosed].size(), sosed});
        for (auto it_s : g[sosed]) {
            if (it_s != tmp) {
                non_empty_nod.erase({g[it_s].size(), it_s});
                g[it_s].erase(sosed);
                non_empty_nod.insert({g[it_s].size(), it_s});
            }
        }
    }
    if (!check_dfs_req) {
        cout << "Unique\n";
        return;
    }
    vector<int> used(n + n);
    bool find_boolshit = false;
    for (auto [_, x] : non_empty_nod) {
        if (!used[x]) {
            pair<int, int> res;
            dfs(x, res, g, used);
            if (res.first != res.second) {
                find_boolshit = true;
            }
        }
    }
    if (find_boolshit) {
        cout << "None\n";
    } else {
        cout << "Multiple\n";
    }
}

int main() {
    //freopen("input.txt", "r", stdin);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    cout.flush();
}
