#include <bits/stdc++.h>

using namespace std;

void add(int& a, int b) {
    a = min(a + b, 2);
}

void solve() {
    int n;
    string a, b;
    cin >> n >> a >> b;
    vector<int> mask(n);
    for (int i = 0; i < n; ++i) {
        mask[i] = (a[i] == '#') * 2 + (b[i] == '#');
    }
    vector<vector<int>> dp(n + 1, vector<int>(4));
    dp[0][3] = 1;
    for (int i = 0; i < n; ++i) {
        add(dp[i + 1][mask[i]], dp[i][3]);
        if (mask[i] < 2) {
            add(dp[i + 1][mask[i] + 2], dp[i][1]);
        }
        if (mask[i] % 2 == 0) {
            add(dp[i + 1][mask[i] + 1], dp[i][2]);
        }
        if (mask[i] == 0) {
            add(dp[i + 1][3], dp[i][0]);
        }
        if (mask[i] == 0) {
            add(dp[i + 1][3], dp[i][3]);
        }
    }
    if (dp[n][3] == 0) {
        cout <<"None\n";
    } else if (dp[n][3] == 1) {
        cout << "Unique\n";
    } else {
        cout << "Multiple\n";
    }
}

int main() {
    //freopen("input.txt", "r", stdin);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    cout.flush();
}
