#include <iostream>
#include <vector>

using namespace std;

const int N = 1e5;

bool fl[N];
bool op[N][2];
vector <int> g[N], og[N], ans, b;

void dfsLess(int v, bool q) {
	fl[v] = 1;
	for (auto x : og[v]) {
		if (fl[x]) continue;
		dfsLess(x, 1);
	}
	b.push_back(v);
	if (q) {
		for (auto x : g[v]) {
			if (fl[x]) continue;
			dfsLess(x, 1);
		}
	}
}

void dfsMore(int v, bool q) {
	fl[v] = 1;
	if (q) {
		for (auto x : og[v]) {
			if (fl[x]) continue;
			dfsMore(x, 1);
		}
	}
	b.push_back(v);
	for (auto x : g[v]) {
		if (fl[x]) continue;
		dfsMore(x, 1);
	}
}

bool fl2[N];

bool check(int v, bool q, bool wasU) {
	fl2[v] = 1;
	if (q) {
		for (auto x : og[v]) {
			if (fl2[x]) continue;
			wasU |= check(x, 1, wasU);
		}
	}
	if ((wasU && op[v][0] == 1) || (wasU && op[v][0] == 0 && op[v][0] == 1)) {
		cout << -1;
		exit(0);
	}
	wasU |= (op[v][0] == 0);
	for (auto x : g[v]) {
		if (fl2[x]) continue;
		check(x, 1, wasU);
	}
}

int main() {
	int n;
	cin >> n;
	int k = 0;
	vector <int> t;
	for (int i = 0; i < n; i++) {
		string s[2];
		cin >> s[0] >> s[1];
		op[i][0] = (s[0] == "set");
		op[i][1] = (s[1] == "true");
		k += op[i][1];
		if (op[i][1]) t.push_back(i);
	}
	if (t.size() == 2 && op[t[0]][0] == 0) swap(t[0], t[1]);
	int m;
	cin >> m;
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back(v);
		og[v].push_back(u);
	}


	if (k == 0) {
		for (int i = 0; i < n; i++) {
			if (op[i][0] == 1) {
				cout << -1;
				return 0;
			}
		}
		vector <int> ans;
		for (int i = 0; i < n; i++) {
			if (!fl[i]) {
				dfsLess(i, 0);
				for (auto x : b) ans.push_back(x);
				b.clear();
				ans.pop_back();
				dfsMore(i, 0);
				for (auto x : b) ans.push_back(x);
			}
		}
		for (auto x : ans) cout << x + 1 << ' ';
	}
	else if (k == 1) {
		vector <int> ans;
		dfsLess(t[0], 0);
		b.pop_back();
		for (auto x : b) {
			if (op[x][0] == 1) {
				cout << -1;
				return 0;
			}
		}
		for (auto x : b) ans.push_back(x);
		b.clear();
		dfsMore(t[0], 0);
		for (auto x : b) {
			if (op[x][1] == 0) {
				cout << -1;
				return 0;
			}
		}
		for (auto x : b) ans.push_back(x);
		vector <int> first, last;
		for (int i = 0; i < n; i++) {
			if (op[i][0] == 0 && !fl[i]) {
				b.clear();
				dfsLess(i, 0);
				b.pop_back();
				for (auto x : b) first.push_back(x);
				b.clear();
				dfsMore(i, 0);
				for (auto x : b) first.push_back(x);
			}
		}
		for (int i = 0; i < n; i++) {
			if (op[i][0] == 1 && !fl[i]) {
				b.clear();
				dfsLess(i, 0);
				b.pop_back();
				for (auto x : b) ans.push_back(x);
				b.clear();
				dfsMore(i, 0);
				for (auto x : b) ans.push_back(x);
			}
		}
		for (auto x : first) cout << x + 1 << ' ';
		for (auto x : ans) cout << x + 1 << ' ';
	}
	else {
		vector <int> first;
		check(t[0], 0, 0);

		vector <int> ans;
		dfsLess(t[0], 0);
		b.pop_back();
		for (auto x : b) {
			if (op[x][0] == 1) {
				cout << -1;
				return 0;
			}
		}
		b.clear();
		dfsMore(t[0], 0);
		if (fl[t[1]]) {
			for (auto x : b) {
				if (op[x][0] == 1) ans.push_back(x);
			}
			for (int i = 0; i < n; i++) {
				if (!fl[i] && op[i][0] == 1) {
					b.clear();
					dfsLess(i, 0);
					b.pop_back();
					for (auto x : b) ans.push_back(x);
					b.clear();
					dfsMore(i, 0);
					for (auto x : b) ans.push_back(x);
				}
			}
			ans.push_back(t[1]);
			for (auto x : b) {
				if (op[x][0] == 0 && x != t[1]) ans.push_back(x);
			}
			for (int i = 0; i < n; i++) {
				if (!fl[i] && op[i][0] == 0) {
					b.clear();
					dfsLess(i, 0);
					b.pop_back();
					for (auto x : b) ans.push_back(x);
					b.clear();
					dfsMore(i, 0);
					for (auto x : b) ans.push_back(x);

				}
			}
		}
		else {
			for (auto x : b) {
				if (op[x][0] == 1) ans.push_back(x);
			}
			for (int i = 0; i < n; i++) {
				if (!fl[i] && op[i][0] == 1) {
					b.clear();
					dfsLess(i, 0);
					b.pop_back();
					for (auto x : b) ans.push_back(x);
					b.clear();
					dfsMore(i, 0);
					for (auto x : b) ans.push_back(x);
				}
			}
			vector <int> dop;
			for (auto x : b) {
				if (op[x][0] == 0 && x != t[1]) dop.push_back(x);
			}
			b.clear();

			dfsLess(t[1], 0);
			for (auto x : b) if (x != t[1]) first.push_back(x);
			ans.push_back(t[1]);
			for (auto x : dop) ans.push_back(x);
			b.clear();
			dfsMore(t[1], 0);
			for (auto x : b) {
				if (op[x][0] == 1) {
					cout << -1;
					return 0;
				}
				else if (x != t[1]) ans.push_back(x);
			}
			for (int i = 0; i < n; i++) {
				if (!fl[i] && op[i][0] == 0) {
					b.clear();
					dfsLess(i, 0);
					b.pop_back();
					for (auto x : b) ans.push_back(x);
					b.clear();
					dfsMore(i, 0);
					for (auto x : b) ans.push_back(x);
				}
			}
		}
		for (auto x : first) cout << x + 1 << ' ';
		for (auto x : ans) cout << x + 1 << ' ';
	}
}