#include <iostream>
#include <vector>
#include <string>

#define ll long long

using namespace std;
bool correct(string& st, ll n) {
	if (st[0] == '+' || st[0] == '-' || st[0] == '=')return false;
	if (st[n - 1] == '+' || st[n - 1] == '-' || st[n - 1] == '=')return false;
	for (int i = 0; i < n; i++) {
		if (st[i] == '0') {
			if (i == 0 || st[i - 1] == '+' || st[i - 1] == '-' || st[i - 1] == '=') {
				if (i + 1 < n && (st[i + 1] >= '0' && st[i + 1] <='9'))return false;
			}
		}
		if (st[i] == '+' || st[i] == '-' || st[i] == '=') {
			if (i + 1 < n) {
				if (st[i + 1] == '=' || st[i + 1] == '-' || st[i + 1] == '+')return false;
			}
		}
	}
	ll dl = 0;
	for (int i = 0; i < n; i++) {
		if (st[i] >= '0' && st[i] <= '9')dl++;
		if (dl > 10)return false;
		if (st[i] == '+' || st[i] == '-' || st[i] == '=')dl = 0;
	}
	if (dl > 10) return false;
	return true;
}
bool check(string& st, ll n) {
	ll ok = 0, z = 0;
	if (!correct(st, n))return false;
	vector<ll>ans(2, 0);
	ll kol = 0;
	for (int i = 0; i < n; i++) {
		if (st[i] == '=') {
			if (z == 0)ans[ok] += kol;
			else ans[ok] -= kol;
			z = 0;
			kol = 0;
			ok = 1, kol = 0;
		}
		if (st[i] == '+') {
			if (z == 0)ans[ok] += kol;
			else ans[ok] -= kol;
			z = 0;
			kol = 0;
		}
		if (st[i] == '-') {
			if (z == 0)ans[ok] += kol;
			else ans[ok] -= kol;
			z = 1;
			kol = 0;
		}
		if (st[i] >= '0' && st[i] <= '9') kol = kol * 10 + st[i] - '0';
	}
	if (z == 0)ans[ok] += kol;
	else ans[ok] -= kol;

	if (ans[0] == ans[1])return true;
	return false;
}

int main() {
	string st;
	ll n;
	cin >> st;
	n = st.size();
	if (check(st, n)) {
		cout << "Correct";
	}
	else {
		for (int i = 0; i < n; i++) {
			if (st[i] != '+' && st[i] != '-' && st[i] != '=') {
				string c = "";
				c += st[i];
				for (int j = 0; j < n; j++) {
					string st1 = st;
					st1.erase(i, 1);
					st1.insert(j, c);
					if (check(st1, st1.size())) {
						cout << st1;
						return 0;
					}
				}
			}
		}
		cout << "Impossible";
	}

}