#include <iostream>
#include <vector>

using namespace std;

const int N = 1e3;

int a[N], f[N + 1];

int sum(int l, int r) {
	int res = 0;
	for (int i = l; i <= r; i++) res += f[i];
	return res;
}

int main() {
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) cin >> a[i];
	vector <pair <int, int> > ans;
	int l = 0, r = n - 1;
	for (int i = 1; i <= N; i++) f[i] = 1;
	while (l < r) {

		int left = sum(a[l] + 1, n) + (r - l);
		int right = sum(0, a[r] - 1) + (r - l);
		if (left > right) {
			for (int j = a[l] + 1; j <= n; j++) {
				if (!f[j]) continue;
				ans.push_back({ j, a[l] });
			}
			for (int j = n; j >= 1; j--) {
				if (!f[j] || j == a[l]) continue;
				ans.push_back({ a[l], j });
			}
			f[a[l]] = 0;
			l++;
		}
		else {
			for (int j = a[r] - 1; j >= 1; j--) {
				if (!f[j]) continue;
				ans.push_back({ a[r], j });
			}
			for (int j = 1; j <= n; j++) {
				if (!f[j] || j == a[r]) continue;
				ans.push_back({ j, a[r] });
			}
			f[a[r]] = 0;
			r--;
		}
	}
	cout << ans.size() << '\n';
	for (auto x : ans) cout << x.first << ' ' << x.second << '\n';
}