#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <stack>

using namespace std;

#define  int long long

bool comp(pair<int, int> a, pair<int, int> b) {
    return a.second < b.second;
}

void Solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> res(q + 1);
    vector<pair<int, int> > a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].second;
    }
    sort(a.begin(), a.end(), comp);
    vector<int> fil(m);
    for (int i = 0; i < m; i++) {
        cin >> fil[i];
    }
    for (int i = 1; i < m; i++) {
        fil[i] += fil[i - 1];
    }
    vector<pair<int, int> > t(q);
    for (int i = 0; i < q; i++) {
        cin >> t[i].first;
        t[i].second = i;
    }
    sort(t.begin(), t.end());

    int curPos = n;
    int pref = 0;
    bool isBad = 0;
    int curT = 0;
    for (int i = 0; i < n; i++) {
        if (curT + a[i].first > a[i].second) {
            isBad = 1;
            break;
        }
        curT += a[i].first;
    }
    for (int i = 0; i < n; i++) {
        if (a[i].second < pref + a[i].first) {
            isBad = true;
        }
        if (a[i].second < t[0].first) {
            pref += a[i].first;
        } else {
            curPos = i;
            break;
        }
    }
    stack<pair<int, int> > st;
    st.push({1e18, 0});
    int act = 1e18;
    for (int i = n - 1; i >= curPos; i--) {
        act = min(act, a[i].second) - a[i].first;
        st.push({act, i});
//        cout << "add " << act << ' ' << i << endl;
    }
    if (act < 0) {
        isBad = true;
    }
    if (!isBad) {
        res[t[0].second] = max(0ll, min(st.top().first, t[0].first) - pref);
    } else {
        res[t[0].second] = 0;
    }
    int lstAns = res[t[0].second];
    for (int i = 1; i < q; i++) {
        while (!st.empty() && a[curPos].second < t[i].first) {
            if (a[st.top().second].second < pref + a[st.top().second].first) {
                isBad = true;
//                cout << i << " : " << "gg" << endl;
            }
            pref += a[st.top().second].first;
            st.pop();
            if (pref > st.top().first) {
                isBad = true;
            }
            if (!isBad) {
                res[t[i].second] = max(0ll, min(st.top().first, t[i].first) - pref);
            } else {
                res[t[i].second] = 0;
            }
            lstAns = res[t[i].second];
            curPos++;
        }
        res[t[i].second] = lstAns;
    }
//    for (int i = 0; i < q; i++) {
//        cout << res[i] << " ";
//    }
//    cout << endl;
    for (int i = 0; i < q; i++) {
        cout << (int)(upper_bound(fil.begin(), fil.end(), res[i]) - fil.begin()) << " ";
    }
    cout << endl;
}

signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie();
    int q;
    cin >> q;
    for (int t = 0; t < q; t++) {
        Solve();
    }
}

