#include <bits/stdc++.h>

using namespace std;
#define int long long

struct Kek{
    int sum, dedl;
};

void solve() {
    int n,m,q;
    std::cin >> n >> m >> q;
    std::vector<Kek> a(n);
    std::vector<int> rem_time(n), l(m), t_(q);
    for (int i = 0; i < n; ++i){
        std::cin >> a[i].sum;
    }
    for (int i = 0; i < n; ++i){
        std::cin >> a[i].dedl;
    }
    for (int i = 0; i < m; ++i){
        std::cin >> l[i];
        if (i > 0) l[i] += l[i-1];
    }
    for (int i = 0; i < q; ++i){
        std::cin >> t_[i];
    }
    std::sort(a.begin(), a.end(), [&](Kek l, Kek r) {
        if (l.dedl == r.dedl) return l.sum < r.sum;
        return l.dedl < r.dedl;
    });
    for (int i = 0; i < n; ++i) {
        if (i > 0) a[i].sum += a[i - 1].sum;
    }
    for (int i = 0; i < n; ++i) {
        rem_time[i] = a[i].dedl - a[i].sum;
    }
    for (int i = n - 2; i >= 0; --i){
        rem_time[i] = std::min(rem_time[i], rem_time[i+1]);
    }
    std::vector<int> s_times;
    int L_l = 0;
    for (int i = 0; i < n; ++i) {
        while (L_l < m && rem_time[i] >= l[L_l]) {
            s_times.push_back(l[L_l] + (i > 0 ? a[i - 1].sum : 0));
            L_l++;
        }
    }
    while (L_l < m) {
        s_times.push_back(a.back().sum + l[L_l]);
        L_l++;
    }
    for (auto t : t_){
        int i = std::upper_bound(s_times.begin(), s_times.end(), t) - s_times.begin();
        std::cout << i << ' ';
    }
    std::cout << '\n';
}

signed main() {
    int t;
    std::cin >> t;
    while(t--) {
        solve();
    }
}
