#include <bits/stdc++.h>
using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int tt;
  cin >> tt;
  while (tt--) {
    int n;
    cin >> n;
    vector<vector<char>> grid(2, vector<char>(n, 0));
    for (int i = 0; i < 2; i++) {
      for (int j = 0; j < n; j++) {
        cin >> grid[i][j];
      }
    }
    vector<vector<int>> steps = {{1,  0},
                                 {-1, 0},
                                 {0,  1},
                                 {0,  -1}};
    bool ok = true;
    queue<pair<int, int>> que;
    vector<vector<bool>> vis(2, vector<bool>(n, false));
    for (int i = 0; i < 2; i++)
      for (int j = 0; j < n; j++) {
        if (vis[i][j] || grid[i][j] == '#') {
          continue;
        }
        vis[i][j] = true;
        que.push({i, j});
        int val = 0;
        while (!que.empty()) {
          ++val;
          auto [x, y] = que.front();
          que.pop();
          for (int to = 0; to < 4; to++) {
            int cx = x + steps[to][0];
            int cy = y + steps[to][1];
            if (cx >= 0 && cx < 2 && cy >= 0 && cy < n && !vis[cx][cy] && grid[cx][cy] == '.') {
              que.push({cx, cy});
              vis[cx][cy] = true;
            }
          }
        }
        ok &= (val % 2 == 0);
      }
    if (!ok) {
      cout << "None" << '\n';
      continue;
    }
    using pq_t = array<int, 3>;
    set<pq_t, greater<pq_t>> se;
    bool multiply = false;
    vector<vector<int>> val(2, vector<int>(n, 0));
    for (int i = 0; i < 2; i++) {
      for (int j = 0; j < n; j++) {
        if (grid[i][j] == '#') {
          continue;
        }
        int value = 0;
        for (int k = 0; k < 4; k++) {
          int ci = i + steps[k][0];
          int cj = j + steps[k][1];
          if (ci >= 0 && ci < 2 && cj >= 0 && cj < n && grid[ci][cj] == '#') {
            value++;
          }
        }
        val[i][j] = value;
        se.insert({value, i, j});
      }
    }
    auto recalc = [&](int i, int j) {
      if (val[i][j] != 0) {
        se.erase({val[i][j], i, j});
        int value = 0;
        for (int k = 0; k < 4; k++) {
          int ci = i + steps[k][0];
          int cj = j + steps[k][1];
          if (ci >= 0 && ci < 2 && cj >= 0 && cj < n && grid[ci][cj] == '#') {
            value++;
          }
        }
        val[i][j] = value;
        se.insert({value, i, j});
      }
    };
    bool multiple = false;
    bool bad = false;
    while (!se.empty()) {
      auto [value, x, y] = (*se.begin());
      se.erase(se.begin());
      if (grid[x][y] == '#') {
        continue;
      }
      int possible = 0;
      for (int k = 0; k < 4; k++) {
        int cx = x + steps[k][0];
        int cy = y + steps[k][1];
        if (cx >= 0 && cx < 2 && cy >= 0 && cy < n) {
          possible++;
        }
      }
      int rem = possible - value;
      if (rem <= 0) {
        continue;
      }
      if (rem > 1) {
        multiple = true;
      }
      for (int k = 0; k < 4; k++) {
        int cx = x + steps[k][0];
        int cy = y + steps[k][1];
        if (cx >= 0 && cx < 2 && cy >= 0 && cy < n && grid[cx][cy] == '.') {
          grid[cx][cy] = '#';
          grid[x][y] = '#';
          val[cx][cy] = 0;
          for (int kk = 0; kk < 4; kk++) {
            int nx = x + steps[kk][0];
            int ny = y + steps[kk][1];
            if (nx >= 0 && nx < 2 && ny >= 0 && ny < n && grid[nx][ny] != '#') {
              recalc(nx, ny);
            }
          }
          for (int kk = 0; kk < 4; kk++) {
            int nx = cx + steps[kk][0];
            int ny = cy + steps[kk][1];
            if (nx >= 0 && nx < 2 && ny >= 0 && ny < n && grid[nx][ny] != '#') {
              recalc(nx, ny);
            }
          }
          break;
        }
      }
    }
    int fr = 0;
    for (int i = 0; i < 2; i++, cout << '\n') {
      for (int j = 0; j < n; j++) {
        fr += (grid[i][j] == '.' ? 1 : 0);
      }
    }
    if (fr > 0) {
      cout << "None\n";
      continue;
    }
    if (bad) {
      continue;
    }
    cout << (multiple ? "Multiple" : "Unique") << endl;
  }
}