#include <algorithm>
#include <iostream>
#include <map>
#include <numeric>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()

char hx(int x) {
  static string alph = "abcdef";
  if (x <= 9) {
    return '0' + x;
  } else {
    return alph[x - 10];
  }
}

string lhx(int x) {
  string res = "";
  for (int i = 0; i < 4; ++i) {
    res.push_back(hx(x % 16));
    x /= 16;
  }
  reverse(ALL(res));
  return res;
}

signed main() {
  int x;
  cin >> x;
  cout << "fff0 0022 0008 0000\n";
  cout << "0000 0000 0000 0000\n";  // unused
  for (int k = 0; k < 15; ++k) {
    if (x >> k & 1) {
      cout << "0000 fff0 0fff 0000\n";
      cout << "fff" << hx(k + 1) << ' ' << lhx((8 * (k + 1) + 6) * 16 + 2)
           << ' ' << lhx(8 * (k + 2)) << " 0000\n";
    } else {
      cout << "fff" << hx(k + 1) << ' ' << lhx((8 * (k + 1) + 2) * 16 + 2)
           << ' ' << lhx(8 * (k + 2)) << " 0000\n";
      cout << "0000 fff0 0fff 0000\n";
    }
  }
  if (x >> 15 & 1) {
    cout << "0000 fff0 0fff 0000\n";
    cout << "0004 fff0 0fff 0000\n";
  } else {
    cout << "0004 fff0 0fff 0000\n";
    cout << "0000 fff0 0fff 0000\n";
  }
  return 0;
}