#include<bits/stdc++.h>

using namespace std;

bool check(string s) {

    for (int i = 0; i < (int)s.size() - 1; i++) {
        if (s[i] == '0' && (i == 0 || !isdigit(s[i - 1])) && isdigit(s[i + 1])) {
            return false;
        }
    }

    char last = '+';
    string num;
    bool flag = false;
    long long ans = 0;
    for (const auto& x : s) {
        if (isdigit(x)) {
            num += x;
        } else {
            if (flag) {
                if (last == '+') last = '-';
                else last = '+';
            }
            if (num.size() > 10) {
                return false;
            }
            long long val;
            stringstream ss;
            ss << (last + num);
            ss >> val;
            ans += val;
            last = x;
            num.clear();
            if (x == '=') {
                flag = true;
                last = '+';
            }
        }
    }

    return ans == 0LL;
}

int main() {
#ifdef LOCAL
    freopen( "input.txt" , "r", stdin );
    freopen( "output.txt" , "w", stdout );
#endif // LOCAL

    string s; cin >> s;

    if (check(s + "#")) {
        cout << "Correct\n";
        return 0;
    }

    for (int i = 0; i < s.size(); i++) {
        if (!isdigit(s[i])) continue;
        string h = s;
        h.erase(i, 1);
        h = s[i] + h;
        for (int j = 0; j < h.size(); j++) {
            if (j) swap(h[j - 1], h[j]);
            if (check(h + "#")) {
                cout << h << "\n";
                return 0;
            }
        }
    }

    cout << "Impossible\n";

    return 0;
}
