#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()

using namespace std;

const ll mod = 1e9+7;
const ll MAXN = 1e5+10;

void start(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

ll gcd(ll a, ll b){
    while(a){
        b %= a;
        swap(a, b);
    }
    return b;
}

pair<bool, bool> fill(vector<bool>& a, int n){
    bool mul = false;
    for(int i = 0; i < n; ++i){
        int mask = 0;
        if (a[i * 2]) {
            mask += 1;
        }
        if (a[i * 2 + 1]) {
            mask += 2;
        }
        if (a[i * 2 + 2]) {
            mask += 4;
        }
        if (a[i * 2 + 3]) {
            mask += 8;
        }
        if (mask == 1 || mask == 5) {
            a[i*2 + 1] = true;
            a[i*2 + 3] = true;
        } else if (mask == 2 || mask == 10) {
            a[i*2 + 0] = true;
            a[i*2 + 2] = true;
        } else if (mask == 4 || mask == 8 || mask == 12) {
            a[i*2 + 0] = true;
            a[i*2 + 1] = true;
        } else if (mask == 9 || mask == 6 || mask == 13 || mask == 14) {
            return {false, true};
        } else if (mask == 0){
            mul = true;
        }
    }
    return {mul, false};
}

void a(int n,vector<vector<int>> v,vector<int> tp,int up,int dn,vector<int>dg){
    stack<int> s1;
    stack<int> s0;
    bool upp = false;
    bool dnn = false;
    for(int i = 0;i<n;++i){
        if(dg[i]==0){
            if(tp[i]==1) s1.push(i);
            if(tp[i]==0) upp = true;
            if(tp[i]==2) dnn = true;
            if (tp[i]==3) s0.push(i);
        }
    }
    vector<int> ans;
    while(!s0.empty()){
        int f = s0.top();s0.pop();
        ans.push_back(f);
        for(auto i:v[f]){
            dg[i]--;
            if(dg[i]==0){
                if(tp[i]==1) s1.push(i);
                if(tp[i]==0) upp = true;
                if(tp[i]==2) dnn = true;
                if (tp[i]==3) s0.push(i);
            }
        }
    }
    if(upp) {
        ans.push_back(up);
        for (auto i: v[up]) {
            --dg[i];
            if (dg[i] == 0) {
                if (tp[i] == 1) s1.push(i);
                if (tp[i] == 0) upp = true;
                if (tp[i] == 2) dnn = true;
                if (tp[i] == 3) s0.push(i);
            }
        }
        while (!s1.empty()) {
            int f = s1.top();
            s1.pop();
            ans.push_back(f);
            for (auto i: v[f]) {
                dg[i]--;
                if (dg[i] == 0) {
                    if (tp[i] == 1) s1.push(i);
                    if (tp[i] == 0) upp = true;
                    if (tp[i] == 2) dnn = true;
                    if (tp[i] == 3) s0.push(i);
                }
            }
        }
        if (dnn) {
            ans.push_back(dn);
            for (auto i: v[dn]) {
                --dg[i];
                if (dg[i] == 0) {
                    if (tp[i] == 1) s1.push(i);
                    if (tp[i] == 0) upp = true;
                    if (tp[i] == 2) dnn = true;
                    if (tp[i] == 3) s0.push(i);
                }
            }

            while (!s0.empty()) {
                int f = s0.top();
                s0.pop();
                ans.push_back(f);
                for (auto i: v[f]) {
                    dg[i]--;
                    if (dg[i] == 0) {
                        if (tp[i] == 1) s1.push(i);
                        if (tp[i] == 0) upp = true;
                        if (tp[i] == 2) dnn = true;
                        if (tp[i] == 3) s0.push(i);
                    }
                }
            }
        }
    }
    if(ans.size()==n){
        for(auto i:ans)  cout<<i+1<<' ';
        exit(0);
    }
}

void b(int n,vector<vector<int>> v,vector<int> tp,int up,int dn,vector<int>dg){
    stack<int> s1;
    stack<int> s0;
    bool upp = false;
    bool dnn = false;
    for(int i = 0;i<n;++i){
        if(dg[i]==0){
            if(tp[i]==1) s1.push(i);
            if(tp[i]==0) upp = true;
            if(tp[i]==2) dnn = true;
            if (tp[i]==3) s0.push(i);
        }
    }
    vector<int> ans;

    if (upp) {
        ans.push_back(up);
        for (auto i: v[up]) {
            --dg[i];
            if (dg[i] == 0) {
                if (tp[i] == 1) s1.push(i);
                if (tp[i] == 0) upp = true;
                if (tp[i] == 2) dnn = true;
                if (tp[i] == 3) s0.push(i);
            }
        }

        while (!s1.empty()) {
            int f = s1.top();
            s1.pop();
            ans.push_back(f);
            for (auto i: v[f]) {
                dg[i]--;
                if (dg[i] == 0) {
                    if (tp[i] == 1) s1.push(i);
                    if (tp[i] == 0) upp = true;
                    if (tp[i] == 2) dnn = true;
                    if (tp[i] == 3) s0.push(i);
                }
            }


            if (dnn) {
                ans.push_back(dn);
                for (auto i: v[dn]) {
                    --dg[i];
                    if (dg[i] == 0) {
                        if (tp[i] == 1) s1.push(i);
                        if (tp[i] == 0) upp = true;
                        if (tp[i] == 2) dnn = true;
                        if (tp[i] == 3) s0.push(i);
                    }
                }
                while (!s0.empty()) {
                    int f = s0.top();
                    s0.pop();
                    ans.push_back(f);
                    for (auto i: v[f]) {
                        dg[i]--;
                        if (dg[i] == 0) {
                            if (tp[i] == 1) s1.push(i);
                            if (tp[i] == 0) upp = true;
                            if (tp[i] == 2) dnn = true;
                            if (tp[i] == 3) s0.push(i);
                        }
                    }
                }
            }
        }
    }
    if(ans.size()==n){
        for(auto i:ans)  cout<<i+1<<' ';
        exit(0);
    }
}

void solve(){
    int n;cin>>n;
    vector<vector<int>> v(n);
    vector<int> tp(n);
    for(int i = 0;i<n;++i){
        string a ,b;cin>>a>>b;
        if(a=="set"){
            if(b=="true") tp[i] = 0;
            else tp[i] = 1;
        }
        else{
            if(b=="true") tp[i] = 2;
            else tp[i] = 3;
        }
    }

    int m;cin>>m;
    vector<int> dg(n);
    for(int i = 0;i<m;++i){
        int a,b;cin>>a>>b;--a;--b;
        v[a].push_back(b);
        dg[b]++;
    }
    int up = -1;
    int dn = -1;
    for(int i = 0;i<n;++i){
        if(tp[i]==0){
            if (up!=-1) {cout<<-1;exit(0);}
            up = i;
        }
        if(tp[i]==2) {
            if (dn != -1) {
                cout << -1;
                exit(0);
            }
            dn = i;
        }
    }

    a(n,v,tp,up,dn,dg);
    b(n,v,tp,up,dn,dg);
    cout<<-1;

}

int main() {
    start();
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }

    return 0;
}