#include <bits/stdc++.h>

using namespace std;

vector<int> path;
int n;
map<int, unordered_set<int>> activ, parn, child;
unordered_map<int, int> type, abx;


bool dfs(bool state, int turn){
    if(turn==n){
        return true;
    }
    if(state){
        for(auto i: activ[10]){
            for(auto j: parn[i]){
                child[j].erase(i);
                if(child[j].size()==0){
                    activ[type[j]].insert(j);
                }
            }
            path[turn]=i;
            activ[10].erase(i);
            if(dfs(state, turn+1)){
                return true;
            }
            else{
                activ[10].insert(i);
                for(auto j: parn[i]){
                    child[j].insert(i);
                    if(child[j].size()>=1){
                        activ[type[j]].erase(j);
                    }
                }
            }
        }
        if(activ[21].size()==1){
            if(activ[10].empty()){
                auto i=*(activ[21].begin());
                for(auto j: parn[i]){
                    child[j].erase(i);
                    if(child[j].size()==0){
                        activ[type[j]].insert(j);
                    }
                }
                path[turn]=i;
                activ[21].erase(i);
                if(dfs(false, turn+1)){
                    return true;
                }
                else{
                    activ[21].insert(i);
                    for(auto j: parn[i]){
                        child[j].insert(i);
                        if(child[j].size()>=1){
                            activ[type[j]].erase(j);
                        }
                    }
                }
            }
        }
    }
    else{
        for(auto i: activ[20]){
            for(auto j: parn[i]){
                child[j].erase(i);
                if(child[j].size()==0){
                    activ[type[j]].insert(j);
                }
            }
            path[turn]=i;
            activ[20].erase(i);
            if(dfs(state, turn+1)){
                return true;
            }
            else{
                activ[20].insert(i);
                for(auto j: parn[i]){
                    child[j].insert(i);
                    if(child[j].size()>=1){
                        activ[type[j]].erase(j);
                    }
                }
            }
        }
        if(activ[11].size()==1){
            if(activ[20].empty()){
                auto i=*(activ[11].begin());
                for(auto j: parn[i]){
                    child[j].erase(i);
                    if(child[j].size()==0){
                        activ[type[j]].insert(j);
                    }
                }
                path[turn]=i;
                activ[11].erase(i);
                if(dfs(true, turn+1)){
                    return true;
                }
                else{
                    activ[11].insert(i);
                    for(auto j: parn[i]){
                        child[j].insert(i);
                        if(child[j].size()>=1){
                            activ[type[j]].erase(j);
                        }
                    }
                }
            }
        }
    }
    return false;
}

void solve(){
    cin>>n;
    path.resize(n);
    for(int i=1; i<=n; ++i){
        string a, b;
        cin>>a>>b;
        if(a=="set"){
            if(b=="false"){
                type[i]=10;
                abx[10]++;
            }
            else{
                type[i]=11;
                abx[11]++;
            }
        }
        else{
            if(b=="false"){
                type[i]=20;
                abx[20]++;
            }
            else{
                type[i]=21;
                abx[21]++;
            }
        }
    }
    int q;
    cin>>q;
    while(q--){
        int l, r;
        cin>>l>>r;
        child[r].insert(l);
        parn[l].insert(r);
    }
    for(int i=1; i<=n; ++i){
        if(child.count(i)==0){
            activ[type[i]].insert(i);
        }
    }
    if(dfs(false, 0)){
        for(auto i: path){
            cout<<i<<' ';
        }
    }
    else{
        cout<<-1;
    }
    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int t=1;
//    cin>>t;
    while(t--){
        solve();
        cout<<'\n';
    }
    return 0;
}
