#include <bits/stdc++.h>
#define sz(_a) ((int)((_a).size()))

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> par;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const par tur[4] = {{-1, 0}, {0, -1}, {1, 0}, {0, 1}};

inline signed solve() {

    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> ra(n);
    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        --b[i];
    }
    iota(a.begin(), a.end(), 0);
    iota(ra.begin(), ra.end(), 0);

    vector<par> ans;
    for (int i = 0; i < n; ++i) {
        int st = ra[b[i]];
        while (st < n - 1) {
            ans.emplace_back(a[st + 1], a[st]);
            swap(a[st], a[st + 1]);
            swap(ra[a[st]], ra[a[st + 1]]);
            ++st;
        }
        while (st > i + 1) {
            ans.emplace_back(a[st], a[st - 1]);
            swap(a[st], a[st - 1]);
            swap(ra[a[st]], ra[a[st - 1]]);
            --st;
        }
    }
    cout << sz(ans) << '\n';
    for (auto [x, y] : ans) {
        cout << x + 1 << ' ' << y + 1 << '\n';
    }

    return 0;
}

signed main() {
#ifdef MAKS
    freopen("in.txt", "r", stdin);
#endif // MAKS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(10);
    cerr << fixed << setprecision(3);
    int t_t = 1;
    // cin >> t_t;
    while (t_t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
