#include <bits/stdc++.h>
#define sz(_a) ((int)((_a).size()))

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> par;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const par tur[4] = {{-1, 0}, {0, -1}, {1, 0}, {0, 1}};

#define NONE return cout << "None", 0;

inline signed solve() {
    int n;
    cin >> n;
    string s[2];
    cin >> s[0] >> s[1];
    vector<vector<int>> a(n + n);
    vector<bool> used(n + n);

    bool mult = false;
    /*for (int i = 0; i < n - 1; ++i) {
        if (s[i][0] == '.' && s[i][1] == '.' && s[i + 1][0] == '.' && s[i + 1][1] == '.') {
            mult = true;
        }
    }*/

    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            int ind = i * n + j;
            if (s[i][j] == '#') {
                used[i * n + j] = true;
                continue;
            }
            for (auto [dx, dy] : tur) {
                int nx = i + dx;
                int ny = j + dy;
                if (nx < 0 || ny < 0 || nx >= 2 || ny >= n || s[nx][ny] == '#') {
                    continue;
                }
                a[ind].push_back(nx * n + ny);
            }
        }
    }

    auto dfs = [&](auto&& self, int v, int p, int& c_e, int& c_o) -> void {
        used[v] = true;
        if ((v / n + v % n) & 1) {
            ++c_o;
        } else {
            ++c_e;
        }
        for (int to : a[v]) {
            if (to != p) {
                if (used[to]) {
                    mult = true;
                } else {
                    self(self, to, v, c_e, c_o);
                }
            }
        }
    };

    for (int i = 0; i < n + n; ++i) {
        if (!used[i]) {
            int cnt_e = 0, cnt_o = 0;
            dfs(dfs, i, -1, cnt_e, cnt_o);
            if (cnt_e != cnt_o) {
                NONE;
            }
        }
    }
    if (mult) {
        cout << "Multiple";
    } else {
        cout << "Unique";
    }

    return 0;
}

signed main() {
#ifdef MAKS
    freopen("in.txt", "r", stdin);
#endif // MAKS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(10);
    cerr << fixed << setprecision(3);
    int t_t = 1;
    cin >> t_t;
    while (t_t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
