#include <bits/stdc++.h>
#define sz(_a) ((int)((_a).size()))

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> par;
typedef pair<ll, ll> parl;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const par tur[4] = {{-1, 0}, {0, -1}, {1, 0}, {0, 1}};



inline signed solve() {

    int n, m, q;
    cin >> n >> m >> q;

    vector<parl> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].second;
    }
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first;
    }
    sort(p.begin(), p.end(), greater<parl>());

    ll lst = LLONG_MAX;
    vector<parl> fr;
    for (auto [d, a] : p) {
        if (d < lst) {
            fr.emplace_back(d, lst);
            lst = d;
        }
        lst -= a;
    }
    fr.emplace_back(0, lst);
    reverse(fr.begin(), fr.end());

    int cur = 0;
    vector<int> en(m);
    for (int i = 0; i < m; ++i) {
        ll l;
        cin >> l;
        while (fr[cur].first + l > fr[cur].second) {
            fr[cur + 1].first -= fr[cur].second - fr[cur].first;
            ++cur;
        }
        fr[cur].first += l;
        en[i] = fr[cur].first;
    }

    for (int i = 0; i < q; ++i) {
        ll t;
        cin >> t;
        int y = upper_bound(en.begin(), en.end(), t) - en.begin();
        cout << y << ' ';
    }

    return 0;
}

signed main() {
#ifdef MAKS
    freopen("in.txt", "r", stdin);
#endif // MAKS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(10);
    cerr << fixed << setprecision(3);
    int t_t = 1;
    cin >> t_t;
    while (t_t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
