#include <bits/stdc++.h>

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> color(2 * n);
    for (auto& i : color) {
        std::cin >> i;
        i--;
    }

    std::vector<std::pair<int, int>> edg(2 * n - 1);
    for (auto& [u, v] : edg) {
        std::cin >> u >> v;
        u--, v--;
    }
    std::vector<int> dg(2 * n), link(2 * n);
    for (auto& [u, v] : edg) {
        dg[u]++, dg[v]++;
        link[u] ^= v;
        link[v] ^= u;
    }

    std::vector<bool> used(2 * n);
    std::vector<std::pair<int, int>> mt;
    for (int i = 0; i < n; i++) {
        for (int j = i; dg[j] == 1;) {
            int t = link[j];
            dg[t]--, dg[j]--;
            if (!used[t] && !used[j]) {
                used[t] = true, used[j] = true;
                mt.push_back({j, t});
            }
            link[t] ^= j;
            j = t;
        }
    }

    std::vector<std::vector<int>> gr(2 * n);
    for (auto& [i, j] : mt) {
        gr[i].push_back(j);
        gr[j].push_back(i);
    }
    std::vector<int> cum(n);
    for (int i = 0; i < 2 * n; i++) {
        if (cum[color[i]] != -1) {
            int j = cum[color[i]];
            gr[i].push_back(j);
            gr[j].push_back(i);
        }
        cum[color[i]] = i;
    }

    used.assign(2 * n, 0);
    std::vector<std::pair<int, int>> ans;
    for (int i = 0; i < 2 * n; i++) {
        if (!used[i]) {
            std::vector<int> vec;
            auto dfs = [&](auto dfs, int v) {
                if (used[v]) {
                    return;
                }
                used[v] = true;
                vec.push_back(v);
                for (auto t : gr[v]) {
                    dfs(dfs, t);
                }
            };
            dfs(dfs, i);

            for (int i = 1; 2 * i < vec.size(); i++) {
                ans.emplace_back(vec[i], vec.rbegin()[i - 1]);
            }
        }
    }

    std::cout << ans.size() << "\n";
    for (auto [u, v] : ans) {
        std::cout << u + 1 << " " << v + 1 << "\n";
    }
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
