#include <bits/stdc++.h>
#define size(a) (ll)(a).size()
#define int long long

using namespace std;
typedef long double ld;
typedef long long ll;

const int INF = INT_MAX;
const int INF_LL = LLONG_MAX;
const ld EPS = 1e-9;
const ll MOD = 1e9 + 7;
const int MAXN = 1e5+7;
int used[MAXN];
vector<int> g[MAXN];

void dfs(int v, vector<int>& order) {
    used[v] = true;
    for (int u : g[v]) {
        if (!used[u]) {
            dfs(u, order);
        }
    }
    order.push_back(v);
}

void solve() {
    int n;
    cin >> n;
    vector<int> types(n);
    int num_set = 0;
    vector<int> trues(2, -1);
    int idx = 0;
    for (int i = 0 ; i < n; ++i) {
        string type1, truth;
        cin >> type1 >> truth;

        if (type1 == "set") {
            num_set++;
            types[i] = 0;
        } else {
            types[i] = 1;
        }

        if (truth == "true") {
            trues[idx] = i;
            idx += 1;
        }
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        g[a-1].push_back(b-1);
    }

    if (idx == 0) {
        if (num_set != 0) {
            cout << -1 << endl;
        } else {
            vector<int> order;
            for (int i = 0; i < n; ++i) used[i] = false;
            for (int i = 0; i < n; ++i) {
                if (!used[i]) {
                    dfs(i, order);
                }
            }
            for (int i = 0; i < n; ++i) {
                cout << order[n-i-1] + 1 << " ";
            }
        }
        return;
    }
    if (idx == 1) {
        if (types[trues[0]] == 1) {
            cout << -1 << endl;
        } else {
            for (int i = 0; i < n; ++i) {
                if (i == trues[0]) {
                    continue;
                }
                if (types[i] == 1) {
                    g[i].push_back(trues[0]);
                } else {
                    g[trues[0]].push_back(i);
                }
            }
            vector<int> order;
            for (int i = 0; i < n; ++i) used[i] = false;
            for (int i = 0; i < n; ++i) {
                if (!used[i]) {
                    dfs(i, order);
                }
            }
            vector<int> pos(n);
            for (int i = 0; i < n; ++i) {
                pos[order[i]] = i;
            }
            for (int i = 0; i < n; ++i) {
                for (int el : g[i]) {
                    if (pos[el] > pos[i]) {
                        cout << -1 << endl;
                        return;
                    }
                }
            }
            for (int i = 0; i < n; ++i) {
                cout << order[n-i-1] + 1 << " ";
            }
        }
        return;
    }
    if (idx == 2) {
        vector<int> order;
        if (types[trues[0]] == types[trues[1]]) {
            cout << -1 << endl;
        } else {
            if (types[trues[0]] == 1) {
                swap(trues[0], trues[1]);
            }
            dfs(trues[1], order);
            for (int i = 0; i < n; ++i) {
                if (types[i] == 1) continue;
                if (!used[i]) {
                    dfs(i, order);
                }
            }
            g[trues[0]].push_back(trues[1]);
            for (int i = 0; i < n; ++i) {
                if (i == trues[0] || i == trues[1]) {
                    continue;
                } else {
                    if (types[i] == 0) {
                        g[i].push_back(trues[1]);
                        g[trues[0]].push_back(i);
                    } else {
                        if (!used[i]) {
                            g[i].push_back(trues[0]);
                        } else {
                            g[trues[1]].push_back(i);
                        }
                    }
                }
            }
            for (int i = 0; i < n; ++i) used[i] = false;
            order = {};
            for (int i = 0; i < n; ++i) {
                if (!used[i]) {
                    dfs(i, order);
                }
            }

            vector<int> pos(n);
            for (int i = 0; i < n; ++i) {
                pos[order[i]] = i;
            }
            for (int i = 0; i < n; ++i) {
                for (int el : g[i]) {
                    if (pos[el] > pos[i]) {
//                        cout << i << " " << el << endl;

                        cout << -1 << endl;
                        return;
                    }
                }
            }
            for (int i = 0; i < n; ++i) {
                cout << order[n-i-1] + 1 << " ";
            }
        }
        return;
    }


}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    cout.precision(20);

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
