#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
const int N = 2e5 + 5, inf = 1e9;

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n; cin >> n;
    vector<int> a(n + 1, 0);
    vector<pair<int, int>> in(n + 1, {0, 0});
    vector<int> pos(n + 1, 0);
    for(int i = 1; i <= n; i++) {
        cin >> a[i];
        in[a[i]].first = i;
        in[a[i]].second = a[i];
        pos[a[i]] = i;
    }
    vector<pair<int, int>> ans;
    set<pair<int, int>> used;
    vector<int> cur(n + 1, 0);
    for(int i = 1; i <= n; i++) cur[i] = i;
    sort(in.rbegin(), in.rend());
    for(int i = 0; i < n; i++) {
        for(int j = in[i].second + 1; j <= n; j++) {
            if(pos[j] < in[i].first) {
                used.insert({j, in[i].second});
                swap(cur[j], cur[in[i].second]);
                ans.push_back(make_pair(j, in[i].second));

            }
        }
    }
    vector<int> res(n + 1, 0);
    for(int i = 1; i <= n; i++) {
        res[cur[i]] = i;
    }
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= n; j++) {
            if(i == j) continue;
            if(used.count({i, j}) || used.count({j, i})) continue;
            if(cur[i] - cur[j] == 1) {
                used.insert({i, j});
                used.insert({j, i});
                ans.push_back(make_pair(i, j));
                ans.push_back(make_pair(j, i));
            }
        }
    }
    cout << ans.size() << endl;
    for(auto &u : ans) {
        cout << u.first << ' ' << u.second << endl;
    }
    return 0;
}
