#include <iostream>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <numeric>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <fstream>
#include <memory>
#include <thread>
// cout<<fixed<<setprecision(10)<<res<<endl;


using namespace std;

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);

	int n; cin >> n;

	vector<int> res(n);
	vector<int> v(n+1); // ricxvi - posicia
	for (int i = 1; i <= n; i++) {
		cin >> res[i-1];
		v[res[i - 1]] = i;
	}

	
	vector<pair<int, int>> ans;
	for (int i = n; i > 1; i--) {
		for (int j = i - 1; j >= 1; j--) {
			ans.push_back({ i, j });
		}
	}

	vector<int> reverse(n);
	for (int i = 0; i < n; i++) reverse[i] = n - i;

	for (int i = 1; i < n; i++) {
		int curr = n - i;
		for (int j = i - 1; j >= 0; j--) {
			if (v[curr] < v[reverse[j]]) {
				ans.push_back({ curr, reverse[j] });
				swap(reverse[j], reverse[j + 1]);
			}
			else break;
		}
	}

	cout << ans.size() << endl;

	for (int i = 0; i < ans.size(); i++) cout << ans[i].first << " " << ans[i].second << endl;


}