#include <iostream>
#include <vector>
#include <utility>
#include <array>
#include <algorithm>
#include <set>
#define pii pair<int, int>

using namespace std;



const int MAX = 1e6 + 100;

void solve(){
    int n; cin >> n;
    string s[2];
    cin >> s[0] >> s[1];
    bool last = 0;
    bool multiple = 0;
    for(int i = 0; i < n; ++i){
        if(s[0][i] == '.' && s[1][i] == '.'){
            s[0][i] = '#';
            s[1][i] = '#';
            if(last) multiple = 1;
            last = 1;
        }
        else if(s[0][i] == '#' && s[1][i] == '.'){
            if(i == n - 1 || s[1][i + 1] == '#'){
                cout << "None" << '\n';
                return;
            }
            s[1][i + 1] = '#';
            s[1][i] = '#';
            last = 0;
        }
        else if(s[1][i] == '#' && s[0][i] == '.') {
            if(i == n - 1 || s[0][i + 1] == '#'){
                cout << "None" << '\n';
                return;
            }
            s[0][i + 1] = '#';
            s[0][i] = '#';
            last = 0;
        }
        else{
            last = 0;
        }
    }
    if(multiple){
        cout << "Multiple\n";
    }
    else{
        cout << "Unique\n";
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while(t--){
        solve();
    }
}