#include <bits/stdc++.h>

#define int long long
#define pii pair<int,int>
#define x first
#define y second

using namespace std;
const int N = 1e5 + 1;
vector<int> g[N];
vector<int> pas1, pas2, pas3;

int col[N], used[N];

void DFS(int v, int c) {
    used[v] = 1;
    for (auto to: g[v]) {
        if (col[v] == col[to] && used[to] == 0) {
            DFS(to, c);
        }
    }
    if (c == 1) {
        pas1.push_back(v);
    }
    if (c == 2) {
        pas2.push_back(v);
    }
    if (c == 3) {
        pas3.push_back(v);
    }
}

int32_t main() {
    int n;
    cin >> n;
    int set_t = 0, unset_t = 0;
    int set_t_i = -1, unset_t_i = -1;
    vector<int> set_f, unset_f;
    vector<int> ind(n + 1, -1);
    for (int k = 1; k <= n; k++) {
        string a, b;
        cin >> a >> b;
        if (b == "true") {
            if (a == "set") {
                set_t++;
                set_t_i = k;
                ind[k] = 1;
            } else {
                unset_t++;
                unset_t_i = k;
                ind[k] = 3;
            }
            continue;
        }
        if (a == "set") {
            set_f.push_back(k);
            ind[k] = 2;
        } else {
            unset_f.push_back(k);
            ind[k] = 0;
        }
    }
    int m;
    cin >> m;
    vector<pii > ed;
    map<pii, int> mp;
    vector<int> b3(n + 1, 0);
    for (int k = 1; k <= m; k++) {
        int a, b;
        cin >> a >> b;
        mp[{a, b}] = 1;
        ed.emplace_back(a, b);
        g[b].push_back(a);
        if (ind[a] > ind[b]) {
            if (ind[b] == 0) {
                ind[b] = 4;
                continue;
            }
            cout << -1 << endl;
            return 0;
        }
    }

    vector<int> a1, a2, a3;
    for (int k = 1; k <= n; k++) {
        if (ind[k] == 0) {
            a1.push_back(k);
            col[k] = 1;
        }
        if (ind[k] == 2) {
            a2.push_back(k);
            col[k] = 2;
        }
        if (ind[k] == 4) {
            a3.push_back(k);
            col[k] = 3;
        }
    }

    for (int k = 1; k <= n; k++) {
        if (!used[k] && col[k] != 0)
            DFS(k, col[k]);
    }

    for (auto i: ed) {
        if (ind[i.x] > ind[i.y] || (col[i.x] != 0 && col[i.y] != 0 && col[i.x] > col[i.y])) {
            cout << -1 << endl;
            return 0;
        }
    }

    if (set_t == 2 || unset_t == 2) {
        cout << -1 << endl;
        return 0;
    }
    if (set_t == 1 && unset_t == 0) {
        if (pas1.empty()) {
            cout << -1 << endl;
            return 0;
        }
        if (!pas3.empty()) {
            cout << -1 << endl;
            return 0;
        }
    }
    if (set_t == 0 && unset_t == 1) {
        cout << -1 << endl;
        return 0;
    }
    if (set_t == 0 && unset_t == 0) {
        if (!pas2.empty() || !pas3.empty()) {
            cout << -1 << endl;
            return 0;
        }
    }
    for (auto i: pas1)
        cout << i << ' ';
    if (set_t)
        cout << set_t_i << ' ';
    for (auto i: pas2)
        cout << i << ' ';
    if (unset_t)
        cout << unset_t_i << ' ';
    for (auto i: pas3)
        cout << i << ' ';
    return 0;
}

/*
5
set true
unset true
set false
unset false
unset false
2
1 4
5 2

3
unset true
unset false
set true
0


2
unset false
set true
1
2 1

 */