#pragma GCC optimize("O3")
#include <bits/stdc++.h>
using namespace std;
#define int long long
#define endl '\n'
#define F first
#define S second
#define all(v) (v).begin(), (v).end()
#define pb push_back
#define pii pair<int , int>

const int N = 2e5 + 6;

vector<int> a[N];
vector<int> order[2];
map<int, string> mp;
int xx[N], yy[N], idx[N];
int used[N];

void DFS(int node, int blk){
    used[node] = 1;
    for(int i : a[node]){
        if(!used[i] && mp[i] == mp[node]){
            DFS(i, blk);
        }
    }
    order[blk].pb(node);
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    vector<int> st, sf, ut, uf;
    string ty, res;
    int n, m;
    cin >> n;
    for(int i = 1; i <= n; i++){
        cin >> ty >> res;
        if(ty == "set"){
            if(res == "true"){
                st.pb(i);
                mp[i] = "st";
            }
            else{
                sf.pb(i);
                mp[i] = "sf";
            }
        }
        else{
            if(res == "true"){
                ut.pb(i);
                mp[i] = "ut";
            }
            else{
                uf.pb(i);
                mp[i] = "uf";
            }
        }
    }
    cin >> m;
    for(int i = 0, x, y; i < m; i++){
        cin >> x >> y;
        a[x].pb(y);
        xx[i] = x;
        yy[i] = y;
    }
    for(int i = 1; i <= n; i++){
        if(mp[i] == "sf" && !used[i]){
            DFS(i, 0);
        }
    }
    if(st.size()) order[0].pb(st[0]);
    reverse(all(order[0]));
    if(ut.size()) order[0].pb(ut[0]);

    for(int i = 1; i <= n; i++){
        if(mp[i] == "uf"){
            for(int j : a[i]){
                if(mp[j] != "uf"){
                    a[j].pb(0);
                }
            }
        }
        else{
            for(int j : a[i]){
                if(mp[j] == "uf"){
                    a[0].pb(j);
                }
            }
        }
    }
    mp[0] = "uf";
    for(int i = 0; i <= n; i++){
        if(mp[i] == "uf" && !used[i]){
            DFS(i, 1);
        }
    }
    reverse(all(order[1]));
    vector<int> ans;
    for(int i : order[1]){
        if(i == 0){
            for(int j : order[0]){
                ans.pb(j);
            }
            continue;
        }
        ans.pb(i);
    }
    for(int i = 0; i < ans.size(); i++){
        idx[ans[i]] = i;
    }
    for(int i = 0; i < m; i++){
        if(idx[xx[i]] > idx[yy[i]]){
            cout << -1;
            return 0;
        }
    }
    bool ok = 0;
    for(int i : ans){
        if(mp[i] == "st"){
            if(ok == 1){
                cout << -1;
                return 0;
            }
            ok = 1;
        }
        if(mp[i] == "ut"){
            if(ok == 0){
                cout << -1;
                return 0;
            }
            ok = 0;
        }
        if(mp[i] == "sf"){
            if(ok == 0){
                cout << -1;
                return 0;
            }
        }
        if(mp[i] == "uf"){
            if(ok == 1){
                cout << -1;
                return 0;
            }
        }
    }
    for(int i : ans) cout << i << " ";
}
