def solve():
    n, m, q = map(int, input().split())
    h = list(map(int, input().split()))
    d = list(map(int, input().split()))

    dh = sorted([(di, hi) for di, hi in zip(d, h)])

    et = list(map(int, input().split()))
    queries = list(map(int, input().split()))

    def dp(cur_time, time_limit, cur_hid, cur_sid):
        if cur_sid == m or cur_time + et[cur_sid] > time_limit:
            return 0

        if cur_hid == n:
            s = 0
            while cur_sid < m and et[cur_sid] + cur_time <= time_limit:
                s += 1
                cur_time += et[cur_sid]
                cur_sid += 1
            return s

        if cur_time + et[cur_sid] + dh[cur_hid][1] > dh[cur_hid][0]:
            return dp(cur_time + dh[cur_hid][1], time_limit, cur_hid + 1, cur_sid)

        if cur_time + et[cur_sid] <= time_limit:
            watch = 1 + dp(cur_time + et[cur_sid], time_limit, cur_hid, cur_sid + 1)
        else:
            watch = 0

        if cur_time + dh[cur_hid][1] <= time_limit:
            dohome = dp(cur_time + dh[cur_hid][1], time_limit, cur_hid + 1, cur_sid)
        else:
            dohome = 0
        return max(watch, dohome)

    for query in queries:
        print(dp(0, query, 0, 0), end=' ')
    print()


for _ in range(int(input())):
    solve()
