#include <bits/stdc++.h>
/*
 * Играйте в майнкрафт на моём сервере
 * подробности на сайте vec.kpvk.edu.kz
 */
using namespace std;

void mineSwap(vector<int> *v, int index1, int index2){
    int temp = (*v)[index1];
    (*v)[index1] = (*v)[index2];
    (*v)[index2] = temp;
}

int mineFind(vector<int> v, int value){
    for (int i = 0; i < v.size(); ++i){
        if (v[i] == value) return i;
    }
}

int main() {
    int n; cin>>n;
    vector<int>v(n);
    vector<int> start(n);
    int matrix[n+1][n+1];

    for (int i = 0; i < n+1; ++i){
        for (int j = 0; j < n+1; ++j)
        matrix[i][j] = 0;
    }

    for (int i = 0; i < n; ++i) {
        cin>>v[i];
        start[i]=v[i];
    }
    sort(start.begin(),start.end());

    for (int i = 0; i < n-1; ++i){
        int indexOfCar = mineFind(start, v[i]);
        for (int j = indexOfCar; j > i; --j){
            mineSwap(&start, j, j-1);
            matrix[start[j]][start[j-1]] = 1;
        }
    }
    int ans = 0;
    for (int i = 1; i < n+1; ++i){
        for (int j = 1; j < n+1; ++j){
            if (i != j && matrix[i][j] == 0 && matrix[j][i] == 0) {
                if (abs(mineFind(v, i) - mineFind(v, j)) == 1){
                    matrix[i][j] = 1;
                    matrix[j][i] = 1;
                }
            }
            ans += matrix[i][j];
        }
    }
    cout << ans << "\n";
    for (int i = 1; i < n+1; ++i) {
        for (int j = 1; j < n + 1; ++j) {
            if (matrix[i][j] != 0)
            cout << j << " " << i << "\n";
        }
    }
}
