#include <bits/stdc++.h>
//#pragma GCC target("avx,avx2,fma")

using namespace std;

#define forn(i,a,b) for (ll i = (a); i < (b); i++)
#define sz(a) (int)a.size()
#define pb push_back
#define eb emplace_back
#define all(a) a.begin(), a.end()
#define srt(a) sort(all(a))
#define rall(a) a.rbegin(), a.rend()
#define srtrev(a) sort(rall(a))
#define rev(a) reverse(all(a))


using ll = long long;
using vi = vector<int>;
using vll = vector<ll>;
using vvi = vector<vi>;
using vvll = vector<vll>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vpii = vector<pii>;
using vpll = vector<pll>;
using vs = vector<string>;
using vb = vector<bool>;

const ll MOD = 998244353;

template<typename A, typename B> ostream& operator<< (ostream &os, const pair<A, B> &p) { return os << '(' << p.first << ", " << p.second << ')';}
template<typename Tc, typename T = typename enable_if<!is_same< Tc, string>::value, typename Tc::value_type>::type> ostream& operator<<(ostream &os, const Tc &v) { os << '{'; string s; for (const T &x : v) os << s << x, s = ", "; return os << '}'; }
void d() { cerr << endl; }
template<typename Head, typename... Tail> void d(Head H, Tail... T) { cerr << ' ' << H; d(T...);}

#ifdef NOT_OJ
#define dbg(...) cerr << "(" << #__VA_ARGS__ << "):", d(__VA_ARGS__)
#else
#define dbg(...)
#endif
constexpr ll INF = 1e16;
void solve() {
    ll n,m,q; cin >> n >> m >> q;
    vpll homeworks(n), t(q);
    vll l(m);
    for (ll i=0; i<n; i++) cin >> homeworks[i].second;
    for (ll i=0; i<n; i++) cin >> homeworks[i].first;
    forn(i, 0, m)
        cin >> l[i];
    forn(i, 0, q) {
        cin >> t[i].first;
        t[i].second = i;
    }
    srt(homeworks);
    srt(t);

    ll deadline = INF;
    vpii r(n);
    for (ll i = n - 1; i >= 0; --i) {
        deadline = min(deadline, homeworks[i].first);
        ll beg = deadline - homeworks[i].second;
        r[i] = {beg, deadline};
        deadline = beg;
    }
    dbg(r);

    vll ps(m + 1);
    forn(i, 0, m)
        ps[i + 1] = ps[i] + l[i];
    dbg(ps);

    vpll e;
    for (auto& [x, y] : r) {
        e.emplace_back(x, -1);
        e.emplace_back(y, -2);
    }
    forn(i, 0, q)
        e.emplace_back(t[i]);
    srt(e);

    bool in = 0;
    ll cnt = 0, cur = 0;
    vll res(q);
    for (auto& [i, type] : e) {
        dbg(i, type);
        if (type == -1) {
            cnt += i - cur;
            in = 1;
        } else if (type == -2) {
            cur = i;
            in = 0;
        } else {
            if (!in) {
                cnt += i - cur;
                cur = i;
            }
            res[type] = upper_bound(all(ps), cnt) - ps.begin() - 1;
        }
    }
    for (auto& i : res)
        cout << i << ' ';
    cout << '\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin.exceptions(cin.failbit);

    int tt; cin >> tt;
    while (tt --> 0)
        solve();


    return 0;
}

/*
2
1 2 3
10 15
5 5
5 15 20
3 4 5
8 100 8
10 150 20
2 32 1 1
9 200 51 50 10

3 4 20
8 4 8
10 13 30
1 1 1 2
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20

1 1 1 1 1 1 1 1 1 1 1 1 1 2 3 3 4 4 4 4

3 4 20
4 4 4
12 13 5
1 1 1 2
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20

3 4 5
8 100 8
10 150 20
2 32 1 1
1 2 3 4 5
 */
