#include <bits/stdc++.h>

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define int long long

using namespace std;

typedef long long ll;
const int N = 50005;
int anot(int cur)
{
    if (cur == 180)
        return 0;

    if (cur == 225)
        return 45;

    if (cur == 270)
        return 90;

    if (cur == 315)
        return 135;

    assert(0);
}
int chr(int cur, int x, int y)
{
    if (cur == 0)
        return y;
    if (cur == 1)
        return x - y;
    if (cur == 2)
        return x;
    if (cur == 3)
        return x - y;
    assert(0);
}
int get_type(int cur)
{
    return (cur / 45);
}
pair<int, int> cof(int cur)
{
    if (cur == 0)
        return {0, 1};
    if (cur == 45)
        return {1, 1};
    if (cur == 90)
        return {1, 0};
    if (cur == 135)
        return {1, -1};
    if (cur == 180)
        return {0, -1};
    if (cur == 225)
        return {-1, -1};
    if (cur == 270)
        return {-1, 0};
    if (cur == 315)
        return {-1, 1};
    assert(0);
}
map<int, map<int, int>> mp[4], sv[2][4];
int d[N], n;
string type[N];
vector<pair<int, pair<int, int>>> points, tmp;
int destr[N];
bool cmp(const pair<int, pair<int, int>> a, const pair<int, pair<int, int>> b)
{
    if (a.second != b.second)
        return a < b;
    return a.first < b.first;
}

vector<pair<int, pair<int, int>>> solve(int st, int id)
{
    for (int tp = 0; tp < 4; tp++)
    {
        mp[tp].clear();
    }
    int cur = st;
    int x = 0, y = 0;
    points.clear();
    for (int i = 1; i <= n; i++)
    {
        if (type[i] == "move")
        {
            x += (d[i] * cof(cur).first);
            y += (d[i] * cof(cur).second);
        }
        else if (type[i] == "draw")
        {
            int n_x = (d[i] * cof(cur).first) + x;
            int n_y = (d[i] * cof(cur).second) + y;
            if (cur == 0 || cur == 45 || cur == 90 || cur == 135)
            {
                // cout << "was " << cur << endl;
                if (mp[get_type(cur)][x][y] == 0)
                {
                    points.pb({get_type(cur), {x, y}});
                }
                mp[get_type(cur)][x][y] = max(mp[get_type(cur)][x][y], d[i]);
            }
            else
            {
                if (mp[get_type(anot(cur))][n_x][n_y] == 0)
                {
                    points.pb({get_type(anot(cur)), {n_x, n_y}}); // !!!
                }
                mp[get_type(anot(cur))][n_x][n_y] = max(mp[get_type(anot(cur))][n_x][n_y], d[i]);
            }
            x = n_x;
            y = n_y;
        }
        else if (type[i] == "rotate")
        {
            (cur += d[i]) %= 360;
        }
    }
    int m = (int)points.size();
    for (int i = 0; i < m; i++)
    {
        destr[i] = 0;
    }
    for (int i = 0; i < m; i++)
    {
        if (destr[i])
            continue;
        for (int j = 0; j < i; j++)
        {
            if (destr[j])
                continue;
            int a = i;
            int b = j;
            if (points[a].first == points[b].first)
            {
                int tp = points[a].first;
                int x_i = points[a].second.first;
                int y_i = points[a].second.first;
                int x_j = points[b].second.first;
                int y_j = points[b].second.second;

                int val_i = mp[points[i].first][x_i][y_i];
                int val_j = mp[points[j].first][x_j][y_j];

                if (chr(tp, x_i, y_i) != chr(tp, x_j, y_j))
                {
                    continue;
                }
                if (tp == 1 || tp == 2)
                {
                    if (x_i > x_j)
                    {
                        swap(a, b);
                        swap(x_i, x_j);
                        swap(y_i, y_j);
                        swap(val_i, val_j);
                    }
                    int R1 = x_i + val_i;
                    if (R1 >= x_j)
                    {
                        mp[points[a].first][x_i][y_i] = max(mp[points[a].first][x_i][y_i], abs(x_i - x_j) + mp[points[b].first][x_j][y_j]);
                        destr[b] = 1;
                    }
                }
                else
                {
                    if (tp == 0)
                    {
                        if (y_i > y_j)
                        {
                            swap(a, b);
                            swap(x_i, x_j);
                            swap(y_i, y_j);
                            swap(val_i, val_j);
                        }
                        int R1 = y_i + val_i;
                        if (R1 >= y_j)
                        {
                            mp[points[a].first][x_i][y_i] = max(mp[points[a].first][x_i][y_i], abs(y_i - y_j) + mp[points[b].first][x_j][y_j]);
                            destr[b] = 1;
                        }
                    }
                    else
                    {
                        if (x_i > x_j)
                        {
                            swap(a, b);
                            swap(x_i, x_j);
                            swap(y_i, y_j);
                            swap(val_i, val_j);
                        }
                        int R1 = x_i + val_i;
                        if (R1 >= x_j)
                        {
                            mp[points[a].first][x_i][y_i] = max(mp[points[a].first][x_i][y_i], abs(x_i - x_j) + mp[points[b].first][x_j][y_j]);
                            destr[b] = 1;
                        }
                    }
                }
            }
        }
    }
    for (int tp = 0; tp < 4; tp++)
    {
        sv[id][tp] = mp[tp];
    }
    tmp.clear();
    for (int i = 0; i < m; i++)
    {
        if (!destr[i])
        {
            tmp.pb({points[i].first, {points[i].second.first, points[i].second.second}});
        }
    }
    return tmp;
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> type[i] >> d[i];
    }
    vector<pair<int, pair<int, int>>> og = solve(0, 0);
    sort(og.begin(), og.end());
    for (pair<int, pair<int, int>> el : og)
    {
        int el1 = el.first;
        int el2 = el.second.first;
        int el3 = el.second.second;
        //   cout << el1 << ' ' << el2 << ' ' << el3 << ' ' << sv[0][el1][el2][el3] << endl;
    }
    // cout << endl;
    for (int b = 45; b < 360; b += 45)
    {
        // dont forget to clear
        vector<pair<int, pair<int, int>>> ch = solve(b, 1);
        bool ok = 1;
        if ((int)ch.size() != (int)og.size())
        {
            ok = 0;
            continue;
        }
        for (pair<int, pair<int, int>> el : ch)
        {
            int el1 = el.first;
            int el2 = el.second.first;
            int el3 = el.second.second;
            // cout << el1 << ' ' << el2 << ' ' << el3 << ' ' << sv[1][el1][el2][el3] << endl;
        }
        sort(ch.begin(), ch.end(), &cmp);
        int m = ch.size();
        int dx = ch[0].second.first - og[0].second.first;
        int dy = ch[0].second.second - og[0].second.second;
        for (int i = 0; i < m; i++)
        {
            ok &= (ch[i].first == og[i].first);
            ok &= (ch[i].second.first - og[i].second.first == dx);
            ok &= (ch[i].second.second - og[i].second.second == dy);
            int xc = ch[i].second.first;
            int yc = ch[i].second.second;
            int tpc = ch[i].first;

            int xo = og[i].second.first;
            int yo = og[i].second.second;
            int tpo = og[i].first;
            ok &= (sv[0][tpo][xo][yo] == sv[1][tpc][xc][yc]);
        }
        if (ok)
        {
            cout << b;
            return 0;
        }
    }
    cout << 360;
    // return 0;
}