#include <bits/stdc++.h>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<int> id(n);
    vector<int> ff, ft, tt, tf;
    for (int i = 0; i < n; i++) {
        string s, t;
        cin >> s >> t;
        if (s == "unset" && t == "false") {
            ff.push_back(i);

        } else if (s == "set" && t == "false"){
            tt.push_back(i);
            id[i] = 3;
        } else if (s == "set" && t == "true") {
            ft.push_back(i);
            id[i] = 1;
        } else {
            tf.push_back(i);
            id[i] = 2;
        }
    }
    if (tf.size() >= 2 || ft.size() >= 2) {
        cout << -1;
        return 0;
    }
    int m;
    cin >> m;
    vector<vector<int>> e(n);
    vector<int> deg(n);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        e[v].push_back(u);
        deg[u]++;
    }
    vector<int> ans;
    vector<int> used(n);
    auto dfs = [&](auto self, int u, int f) -> void {
        used[u] = 1;
        ans.push_back(u);

        for (auto v : e[u]) {
            --deg[v];
            if (id[v] == f && deg[v] == 0 && used[v] == 0) {
                self(self, v, f);
            }
        }
    };

    int cur = 0;
    for (int i : ff) {
        if (used[i] == 0 && deg[i] == 0) {
            dfs(dfs, i, 0);
        }
    }
    for (int i : ft) {
        if (used[i] == 0 && deg[i] == 0) {
            dfs(dfs, i, 1);
            cur = 1;
        }
    }
    for (int i : tt) {
        if (used[i] == 0 && deg[i] == 0) {
            if (cur == 0) {
                cout << "-1";
                return 0;
            }
            dfs(dfs, i, 3);
        }
    }
    for (int i : tf) {

        if (used[i] == 0 && deg[i] == 0) {

            if (cur == 0) {
                cout << "-1";
                return 0;
            }
            cur = 0;
            dfs(dfs, i, 2);
        }
    }
    for (int i : ff) {
        if (used[i] == 0 && deg[i] == 0) {
            if (cur == 1) {
                cout << "-1";
                return 0;
            }

            dfs(dfs, i, 0);
        }
    }

    if (ans.size() != n) {
        cout << -1;
        return 0;
    }

    for (int i : ans) {
        cout << i + 1 << " ";
    }
    return 0;
}
