#include<bits/stdc++.h>
using namespace std;

char a[2][200001];
int sz[2][200001];

int dx[4] = {0, 0, 1, -1};
int dy[4] = {1, -1, 0, 0};

void solve() {
    int n;
    cin >> n;

    for (int i = 0; i < n;i++) {
        cin >> a[0][i];
        sz[0][i] = (-1);
    }
    for (int i = 0; i < n;i++) {
        cin >> a[1][i];
        sz[1][i] = (-1);
    }
    queue <pair<int, int>> q;
    for (int i = 0; i < 2; i++) {
        for (int j = 0; j < n; j++) {
            if (a[i][j] == '.') {
                sz[i][j] = 0;
                if (i > 0 and a[i - 1][j] == '.') sz[i][j]++;
                if (j > 0 and a[i][j - 1] == '.') sz[i][j]++;
                if (i < 1 and a[i + 1][j] == '.') sz[i][j]++;
                if (j < n - 1 and a[i][j + 1] == '.') sz[i][j]++;
                if (sz[i][j] == 1) q.push({i, j});
            }
        }
    }
    while ( q.size() ) {
        int x = q.front().first;
        int y = q.front().second;
        q.pop();

        for (int i = 0; i < 4; i++) {
            int tox = x + dx[i];
            int toy = y + dy[i];

            if (tox < 0 or toy < 0 or tox > 1 or toy >= n or sz[tox][toy] < 1) continue;
            sz[tox][toy] = -1 ;
            sz[x][y] = -1;
            for (int j = 0; j < 4; j++) {
                int toxx = tox + dx[j];
                int toyx= toy + dy[j];

                if (toxx < 0 or toyx < 0 or toxx > 1 or toyx >= n or sz[toxx][toyx] < 1) continue;
                sz[toxx][toyx] -- ;
                if(sz[toxx][toyx] == 1) q.push({toxx, toyx});
            }
            break;
        }
    }

    int check = 0;
    for (int i = 0; i < 2; i++) {
        for(int j = 0; j < n; j++) {
            if(sz[i][j] == 0) {
                check = -1;
                break;
            }
            if(sz[i][j] > 1) {
                check = 1;
            }
        }
    }

    if(check == -1) cout << "None\n";
    else if(check == 1) cout << "Multiple\n";
    else cout << "Unique\n";
}


signed main() {
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}







/*
1
10
#.......##
##..#.##..
*/
