#include<bits/stdc++.h>

#define DEBUGSTR_WNAME(os, name, a) \
    do { (os) << (name) << " = " << (a) << std::endl; } while(false)

#define DEBUGSTR(os, a) DEBUGSTR_WNAME((os), #a, (a))
#define DEBUG(a) DEBUGSTR_WNAME(std::cout, #a, (a))

#define ll long long
#define ld long double

#define pii pair<int, int>
#define vi vector<int>
#define vl vector<ll>

#define all(x) x.begin(), x.end()
#define sz(x)  (int)x.size()
#define pb push_back
#define fi first
#define se second

using namespace std;

const int N = (int)2e5 + 2000;
const int M = (int)1e7 + 200;
const ll mod = (ll)1e9+7;
const ll inf = (ll)1e18 + 7;
const char nl = '\n';

struct task{
    ll a;
    ll d;
    ll need;
    ll pr = 0;
};

void print(string name, ll (&arr) [N], int n) {
    cout << name << " [";
    for(int i = 1; i <= n; i++) {
        cout << arr[i];
        if(n != i)
            cout << ", ";
    }
    cout << "]" << endl;
}
void print(task (&arr)[N], int n) {
    cout << "d" << " [";
    for(int i = 1; i <= n; i++) {
        cout << arr[i].d;
        if(n != i)
            cout << ", ";
    }
    cout << "]" << endl;

    cout << "a" << " [";
    for(int i = 1; i <= n; i++) {
        cout << arr[i].a;
        if(n != i)
            cout << ", ";
    }
    cout << "]" << endl;

    cout << "pr" << " [";
    for(int i = 1; i <= n; i++) {
        cout << arr[i].pr;
        if(n != i)
            cout << ", ";
    }
    cout << "]" << endl;

    cout << "need" << " [";
    for(int i = 1; i <= n; i++) {
        cout << arr[i].need;
        if(n != i)
            cout << ", ";
    }
    cout << "]" << endl;

    cout << endl;
}

bool cmp(task x, task y) {
    if(y.d > x.d)
        return true;
    if(y.d == x.d && y.a > x.a)
        return true;
    return false;
}

int n, m, q;
task tasks[N];
ll l[N], pr[N];

void clr() {
    for(int i = 0; i <= n+5; i++) {
        tasks[i].a = tasks[i].d = tasks[i].need = tasks[i].pr = 0;
    }
    for(int i = 0; i <= m+5; i++)
        l[i] = pr[i] = 0;
}

bool check(int col, ll t) {
    int l = 0, r = n + 1;
    while(r - l > 1) {
        int mid = (r + l) / 2;
        if(tasks[mid].d <= t)
            l = mid;
        else r = mid;
    }
    int pos=l;
   // DEBUG(pos);

    ll sum = tasks[pos].pr + pr[col];

  // DEBUG(sum);
    if(sum > t)
        return false;
    ll rest_time = tasks[pos+1].d - sum;
    if(pos == n) {
        return true;
    }
   // cout << "can ? " << tasks[pos+1].need + tasks[pos+1].a  << endl;
    if(tasks[pos+2].need + tasks[pos+1].a <= rest_time) {
        return true;
    }
    return false;
}

void solve() {
    cin >> n >> m >> q;
    clr();
    for(int i = 1; i <= n; i++) {
        cin >> tasks[i].a;
    }
    for(int i = 1; i <= n; i++) {
        cin >> tasks[i].d;
    }
    sort(tasks+1, tasks+1+n, &cmp);
    for(int i = 1; i <= n; i++)
        tasks[i].pr = tasks[i-1].pr + tasks[i].a;
    ll need_time = 0;
    for(int i = n; i >= 1; i--) {
        ll x = tasks[i].d - tasks[i-1].d - tasks[i+1].need - tasks[i].a;
        if(x >= 0)
            tasks[i].need = 0;
        else
            tasks[i].need = -x;
    }
  //  print(tasks, n);

    for(int i = 1; i <= m; i++) {
        cin >> l[i];
        pr[i] = pr[i-1] + l[i];
    }
   // print("pr for l", pr, m);

    for(int i = 1; i <= q; i++) {
        ll t;
        cin >> t;
        int l = 0, r = m + 1;
        while(r - l > 1) {
            int mid = (l + r) / 2;
        //    DEBUG(mid);
            if(check(mid, t))
                l = mid;
            else
                r = mid;
        }
       // DEBUG(l);
        cout << l << " ";
    }

}

int main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int test = 1;
    cin >> test;
    while(test--) {
        solve();
        cout << nl;
    }
}
