#define ll long long
#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;

    vector<pair<ll, ll>> a(n, {0, 0});
    vector<ll> len(m, 0);
    vector<ll> t(q, 0);

    for (int i = 0; i < n; i++) {
        cin >> a[i].second;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
    }
    for (int i = 0; i < m; i++) {
        cin >> len[i];
        if (i > 0) len[i] += len[i - 1];
    }
    for (int i = 0; i < q; i++) {
        cin >> t[i];
    }

    sort(a.begin(), a.end());

    vector<ll> pre(n, 0), suf(n, 0);
    for (int i = 0; i < n; i++) {
        pre[i] = a[i].second;
        if (i > 0) pre[i] += pre[i - 1];
    }

    for (int i = n - 1; i >= 0; i--) {
        if (i == n - 1) {
            suf[i] = a[i].first - a[i].second;
        } else {
            if (suf[i + 1] < a[i].first) a[i].first = suf[i + 1];
            suf[i] = a[i].first - a[i].second;
        }
    }

    for (int k = 0; k < q; k++) {
        int l = 0, r = n - 1, i = -1;
        while (l <= r) {
            int mid = (l + r) / 2;
            if (a[mid].first <= t[k]) {
                i = mid;
                l = mid + 1;
            } else {
                r = mid - 1;
            }
        }
        ll x = 0, y = t[k];
        if (i != -1) {
            x += pre[i];
        }
        if (i < n - 1) {
            y = min(suf[i + 1], y);
        }

        ll free = y - x;
        l = 0; r = m - 1; i = 0;
        while (l <= r) {
            int mid = (l + r) / 2;
            if (len[mid] <= free) {
                i = mid + 1;
                l = mid + 1;
            } else {
                r = mid - 1;
            }
        }

        cout << i << ' ';
    }
    cout << '\n';
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin.exceptions(cin.failbit);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
}
