#include <bits/stdc++.h>
#define ll long long
const int mod = 1e9 + 7;

using namespace std;

const int N = 1e6 + 233;

int dp[N][2], who[N];

vector<int>g[N];
int cnt[N];

int c[N];

void dfs(int v, int p = -1) {
    who[v] = 0;
    for (int to : g[v]) {
        if (to != p) {
            dfs(to, v);
        }
    }
    for (int to : g[v]) if (to != p) {
        dp[v][0] += max(dp[to][1], dp[to][0]);
    }
    for (int to : g[v]) if (to != p) {
        int cur = dp[v][0] - max(dp[to][1], dp[to][0]) + dp[to][0] + 1;
        if (dp[v][1] < cur) {
            dp[v][1] = cur;
            who[v] = to;
        }
    }
}

vector<pair<int,int>>mm;
vector<int>cp[N];
int mtt[N];

int ng(int x) {
    return cp[c[x]][0] == x ? cp[c[x]][1] : cp[c[x]][0];
}

void calc(int v, int t, int p = -1) {
    if (t == 0) {
        for (int to : g[v]) if (to != p) {
            calc(to, dp[to][1] > dp[to][0], v);
        }
    } else {
        mm.emplace_back(v, who[v]);
        for (int to : g[v]) if (to != p) {
            if (to == who[v]) calc(to, 0, v);
            else calc(to, dp[to][1] > dp[to][0], v);
        }
    }
}

int used[N];

void solve() {
    int n;
    cin >> n;
    mm.clear();
    for (int i = 1 ; i <= n ; ++ i) cp[i].clear();
    for (int i = 1 ; i <= 2 * n ; ++ i) {
        cin >> c[i];
        cp[c[i]].push_back(i);
        mtt[i] = 0;
        dp[i][0] = dp[i][1] = 0;
        cnt[i] = 0;
    }
    for (int i = 1 ; i <= 2 * n ; ++ i) {
        g[i].clear();
    }
    for (int i = 1 ; i < 2 * n ; ++ i) {
        int a, b;
        cin >> a >> b;
        g[a].emplace_back(b);
        g[b].emplace_back(a);
    }
    dfs(1);
    vector<pair<int,int>>ans;
    calc(1, dp[1][1] > dp[1][0]);
    for (auto [a, b] : mm) {
        mtt[a] = b;
        mtt[b] = a;
    }
    for (int i = 1 ; i <= 2 * n ; ++ i) {
        if (!mtt[i]) continue;
        cnt[c[i]]++;
    }
    for (int ii = 1 ; ii <= 2 * n ; ++ ii) {
        if (used[ii]) continue;
        if (mtt[ii] == 0) continue;
        if (cnt[c[ii]] == 1) {
            vector<vector<int>>vec;
            int v = ii;
            while (1) {
                used[v] = 1;
                vec.push_back({v, mtt[v]});
                used[mtt[v]] = 1;
                v = ng(mtt[v]);
                if (used[v] || mtt[v] == 0) break;
            }
            for (auto x : vec) {
                auto a = x[0];
                auto b = x[1];
            }
            int i = 0;
            while (i + 2 < vec.size()) {
                ans.emplace_back(vec[i][1], vec[1+i][1]);
                ans.emplace_back(vec[i][0], vec[2+i][0]);
                ans.emplace_back(vec[2+i][1], ng(vec[i][0]));
                i += 3;
            }
            if (i + 1 == vec.size()) {
                ans.emplace_back(vec[i][0], ng(vec[i][1]));
            }
            else if (i + 2 == vec.size()) {
                ans.emplace_back(vec[i][1], ng(vec[i][0]));
                ans.emplace_back(vec[i+1][0], ng(vec[i+1][1]));
            }
        }
    }
    for (int i = 1 ; i <= 2 * n ; ++ i) {
        if (used[i]) continue;
        if (mtt[i] == 0) continue;
        vector<vector<int>>vec;
        int v = i;
        while (1) {
            used[v] = 1;
            vec.push_back({v, mtt[v]});
            used[mtt[v]] = 1;
            v = ng(mtt[v]);
            if (used[v]) break;
        }
        for (auto x : vec) {
            auto a = x[0];
            auto b = x[1];
        }
        int l = 0, r = vec.size() - 1;
        int ii = 0;
        while (l < r) {
            if (ii == 0) {
                ans.emplace_back(vec[l][0], vec[r][0]);
                --r;
            } else {
                ans.emplace_back(vec[l][1], vec[r][1]);
                ++l;
            }
            ii ^= 1;
        }
    }
    cout << ans.size() << "\n";
    for (auto [a, b] : ans) {
        cout << a << " " << b << "\n";
    }

}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0);

    int T = 1;
    cin >> T;

    while (T--) solve();

    return 0;
}