//Novosibirsk SU 1 CtrlAltDeFIT
// 001

#include <bits/stdc++.h>

using namespace std;
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define sz(x) (int)(x).size()
#define all(x) begin(x), end(x)
typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<pair<ll, ll>> tasks(n);
    for (int i = 0; i < n; ++i) {
        cin >> tasks[i].second;
    }
    for (int i = 0; i < n; ++i) {
        cin >> tasks[i].first;
    }
    sort(all(tasks));
    reverse(all(tasks));
    vector<pair<ll, ll>> busy;
    ll p = tasks[0].first;
    for (auto task: tasks) {
        p = min(p, task.first);
        busy.push_back({p - task.second, p});
        p -= task.second;
    }
    reverse(all(busy));
    vector<ll> pref_busy(busy.size() + 1, 0);
    for (int i = 0; i < sz(busy); ++i) {
        pref_busy[i + 1] = pref_busy[i] + busy[i].second - busy[i].first;
    }
    vector<ll> l(m + 1, 0);
    for (int i = 0; i < m; ++i) {
        ll x;
        cin >> x;
        l[i + 1] = l[i] + x;
    }

    for (int i = 0; i < q; ++i) {
        ll t;
        cin >> t;
        int p = upper_bound(all(busy), pair<ll, ll>{t, 0}) - busy.begin();
        --p;
        ll kek = t ;
        while (p >= 0 && busy[p].second >= t) {
            if (busy[p].first <= t && t <= busy[p].second) {
                kek -= t - busy[p].first;
            }
            --p;
        }
        kek -= pref_busy[p + 1];
        int ans = upper_bound(all(l), kek) - l.begin();
        --ans;
        cout << ans << ' ';
    }
    cout << '\n';
}

int main() {
//    freopen("input.txt", "r", stdin);
    cin.tie(0)->sync_with_stdio(false);
    cout << setprecision(15) << fixed;
    int t = 1;
     cin >> t;
    rep(i, 0, t) {
        solve();
    }
    return 0;
}
