#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

int main() {
    string output;
    long long cases;
    cin >> cases;
    for (long long c = 0; c < cases; c++) {
        long long n, m, q;
        cin >> n >> m >> q;
        vector<pair<long long, long long>> tasks(n);
        for (long long i = 0; i < n; i++) {
            cin >> tasks[i].first;
        }
        for (long long i = 0; i < n; i++) {
            cin >> tasks[i].second;
            tasks[i].first = tasks[i].second - tasks[i].first;
        }
        vector<long long> episodes(m);
        for (long long i = 0; i < m; i++) {
            cin >> episodes[i];
        }
        vector<long long> discusses(q);
        for (long long i = 0; i < q; i++) {
            cin >> discusses[i];
        }
        // init ends
        std::sort(tasks.begin(), tasks.end());

//        for (auto &merged_task: tasks) {
//            std::cout << merged_task.first << " " << merged_task.second << endl;
//        }

        cout << endl;

        vector<pair<long long, long long>> merged_tasks;

        merged_tasks.push_back(tasks[n - 1]);

        for (long long i = n - 2; i >= 0; i--) {
            if (tasks[i].second >= merged_tasks[0].first) {
                merged_tasks[0].first -= tasks[i].second - tasks[i].first;
            } else {
                merged_tasks.insert(merged_tasks.begin(), tasks[i]);
            }
        }

//        for (auto &merged_task: merged_tasks) {
//            std::cout << merged_task.first << " " << merged_task.second << endl;
//        }

        cout << endl;

        long long watched = 0;
        long long last = 0;
        long long cur_discus = 0;

        vector<long long> sorted_discusses(discusses);
        sort(sorted_discusses.begin(), sorted_discusses.end());


        std::map<long long, long long> answers;

        //todo long long
        for (long long i = 0;;) {
            long long meet_time = sorted_discusses[cur_discus];

            if (i < merged_tasks.size() && merged_tasks[i].first <= meet_time ) {
                long long free_time = merged_tasks[i].first - last;
                if (free_time<0) {
                    answers.clear();
                    break;
                }
                for (long long j = watched; j < episodes.size(); j++) {
                    if (episodes[j] <= free_time) {
                        watched++;
                        free_time-=episodes[j];
                    } else {
                        break;
                    }
                }
                last = merged_tasks[i].second-free_time;
                i++;
            } else {
                long long free_time = meet_time - last;
                for (long long j = watched; j < episodes.size(); j++) {
                    if (episodes[j] <= free_time) {
                        watched++;
                        free_time-=episodes[j];
                        last += episodes[j];
                    } else {
                        break;
                    }
                }
                answers[meet_time] = watched;
                cur_discus++;
                if (cur_discus == q) break;
            }
        }

        for (long long i = 0; i < q; i++) {
            std::cout << answers[discusses[i]] << " ";
        }
        std::cout<<endl;
    }
    return 0;
}
