input = """
24=55-13
1000000000-10=9999999999
2+2=4
123456789+9876543210=111111110+11-1
10+9=10
12+34=64
"""[1:-1].split("\n").__iter__().__next__

# codegup

from time import time
import re

class MyException(Exception): pass

reg = re.compile("[+-]")
sp = reg.split

def run(E): # old
    s_arr = sp(E)
    plus = True
    res = 0
    pos = -1
    for s_num in s_arr:
        num = int(s_num)
        pos += len(s_num) + 1
        if plus: res += num
        else: res -= num
        try: plus = E[pos] == "+"
        except IndexError: pass
    return res

def run(E):
    num = 0
    plus = True
    res = 0
    for L in E:
        if L.isdigit():
            if not num and L == "0": raise MyException
            num = num * 10 + ord(L) - 48
            prev_digit = True
        else:
            if plus: res += num
            else: res -= num
            num = 0
            plus = L == "+"
    if plus: return res + num
    return res - num

def run_del(E, del_i):
    num = 0
    plus = True
    res = 0
    prev_digit = False
    for i, L in enumerate(E):
        if i == del_i: continue
        if L.isdigit():
            if not num and L == "0": raise MyException
            num = num * 10 + ord(L) - 48
            prev_digit = True
        else:
            if not prev_digit: raise MyException
            if plus: res += num
            else: res -= num
            num = 0
            plus = L == "+"
            prev_digit = False
    if not prev_digit: raise MyException
    if plus: return res + num
    return res - num

def run_ins(E, ins_i, ins):
    num = 0
    plus = True
    res = 0
    for i, L in enumerate(E):
        if i == ins_i:
            if not num and not ins: raise MyException
            num = num * 10 + ins
        if L.isdigit():
            if not num and L == "0": raise MyException
            num = num * 10 + ord(L) - 48
        else:
            if plus: res += num
            else: res -= num
            num = 0
            plus = L == "+"
    if plus: return res + num
    return res - num

def run_ins_end(E, ins):
    num = 0
    plus = True
    res = 0
    for L in E:
        if L.isdigit():
            if not num and L == "0": raise MyException
            num = num * 10 + ord(L) - 48
        else:
            if plus: res += num
            else: res -= num
            num = 0
            plus = L == "+"
    if not num and not ins: raise MyException
    num = num * 10 + ins
    if plus: return res + num
    return res - num

def meow(s):
    arr = []
    for i, letter in enumerate(s):
        if letter.isdigit(): arr.append(i)
    return tuple(arr)

def solve():
    La = meow(L)
    Ra = meow(R)
    oL = list(L)
    oR = list(R)
    Lres = run(oL)
    Rres = run(oR)
    for i in La:
        ins = ord(L[i]) - 48
        for j in Ra:
            try:
                if run_del(oL, i) == run_ins(oR, j, ins): return L[:i] + L[i+1:] + "=" + R[:j] + L[i] + R[j:]
                # print(L[:i] + L[i+1:], R[:j] + L[i] + R[j:], run_del(oL, i) == run_ins(oR, j, ins))
            except MyException: pass
        try:
            if run_del(oL, i) == run_ins_end(oR, ins): return L[:i] + L[i+1:] + "=" + R + L[i]
        except MyException: pass
    for j in Ra:
        ins = ord(R[j]) - 48
        for i in La:
            try:
                if run_ins(oL, i, ins) == run_del(oR, j): return L[:i] + R[j] + L[i:] + "=" + R[:j] + R[j+1:]
                # print(L[:i] + R[j] + L[i:], R[:j] + R[j+1:], run_ins(oL, i, ins) == run_del(oR, j))
            except MyException: pass
        try:
            if run_ins_end(oL, ins) == run_del(oR, j): return L + R[j] + "=" + R[:j] + R[j+1:]
        except MyException: pass
    for ii in range(len(La) - 1):
        i = La[ii]
        a = oL[i]
        for jj in range(ii + 1, len(La)):
            j = La[jj]
            b = oL[j]
            oL[i], oL[j] = b, a
            try:
                # print("".join(oL) + "=" + R, run(oL) == Rres)
                if run(oL) == Rres: return "".join(oL) + "=" + R
            except MyException: pass
            oL[i], oL[j] = a, b
    for ii in range(len(Ra) - 1):
        i = Ra[ii]
        a = oR[i]
        for jj in range(ii + 1, len(Ra)):
            j = Ra[jj]
            b = oR[j]
            oR[i], oR[j] = b, a
            try:
                if Lres == run(oR): return L + "=" + "".join(oR)
                # print(L + "=" + "".join(oR), Lres, run(oR))
            except MyException: pass
            oR[i], oR[j] = a, b
    return "Impossible"

L, R = input().split("=")

if run(L) == run(R):
    print("Correct")
else:
    # T = time()
    print(solve())
    # print(1 / (time() - T))
