#include <bits/stdc++.h>

using namespace  std;

#define int long long

int comp[2][1000000], cl[2][1000000], n;
string s[2];
int ones, twos;

void dfs(int i, int j, int c, int cmp) {
    if (cl[j][i] != 0) {
        return;
    }
    cl[j][i] = c;
    if (c == 1) {
        ones++;
    } else {
        twos++;
    }
    comp[j][i] = cmp;
    c = (c % 2) + 1;
    if (i + 1 < n && s[j][i + 1] == '.') {
        dfs(i + 1, j, c, cmp);
    }
    if (j - 1 >= 0 && s[j - 1][i] == '.') {
        dfs(i, j - 1, c, cmp);
    }
    if (j + 1 < 2 && s[j + 1][i] == '.') {
        dfs(i, j + 1, c, cmp);
    }
}

void solve() {
   cin >> n;
   cin >> s[0] >> s[1];
   int color = 1;
   bool flag = true;
   for (int i = 0; i < n; i++) {
       for (int j = 0; j < 2; j++) {
            if (s[j][i] == '.' && cl[j][i] == 0) {
                ones = 0;
                twos = 0;
                dfs(i, j, 1, color++);
                if (ones != twos) {
                    flag = false;
                }
            }
       }
   }
   set<int> st;
   for (int i = 0; i < n; i++) {
       if (s[0][i] != s[1][i]) {
           if (s[0][i] == '.') {
               st.insert(comp[0][i]);
           } else {
               st.insert(comp[1][i]);
           }
       }
   }
   if (!flag) {
       cout << "None\n";
   }
   else if (st.size() != color - 1) {
       cout << "Multiple\n";
   }
   else {
       cout << "Unique\n";
   }
   for (int i = 0; i < n; i++) {
       for (int j = 0; j < 2; j++) {
           cl[j][i] = 0;
           comp[j][i] = 0;
       }
   }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt;
    cin >> ttt;
    while(ttt--) {
        solve();
    }
    return 0;
}
