#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define endl '\n'
#define CONT(c) begin(c), end(c)

queue<int> q[2][2];
const int N = 1e5 + 1;
vector<int> depends[N];
int deg[N];
pair<int, int> tp[N];
vector<int> order;

void p(int v)
{
    auto [t1, t2] = tp[v];
    q[t1][t2].push(v);
}

bool extract(queue<int>& q)
{
    if (q.empty())
        return false;
    auto v = q.front();
    q.pop();
    order.push_back(v);
    for (auto to : depends[v]) {
        --deg[to];
        assert(deg[to] >= 0);
        if (!deg[to])
            p(to);
    }
    return true;
}

int main()
{
#ifdef MY
    freopen("in.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif // MY
    int n;
    cin >> n;
    string t, vl;
    for (int i = 1; i <= n; ++i) {
        cin >> t >> vl;
        tp[i].first = t == "set";
        tp[i].second = vl == "true";
    }
    int m;
    cin >> m;
    while (m--) {
        int a, b;
        cin >> a >> b;
        depends[a].pb(b);
        ++deg[b];
    }
    for (int v = 1; v <= n; ++v)
        if (deg[v] == 0)
            p(v);
    // unset false
    while (extract(q[0][0])) {}
    // set true
    if (extract(q[1][1])) {
        // set false
        while (extract(q[1][0])) {}
        // unset true
        if (extract(q[0][1])) {
            // unset false
            while (extract(q[0][0])) {}
        }
    }
    if (order.size() == n) {
        for (auto e : order)
            cout << e << " ";
    } else {
        cout << -1;
    }
}
