#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <bitset>

using namespace std;
using ll = long long;
using vll =vector<ll>;
using pll=pair<ll, ll>;
using vpll = vector<pll>;

void slove()
{
	ll n, m, q;
	cin >> n >> m >> q;
	vector<pll> hom(n);
	for (int i = 0; i < n; i++)
	{
		cin >> hom[i].second;
	}
	for (int i = 0; i < n; i++)
	{
		cin >> hom[i].first;
	}
	sort(hom.begin(), hom.end());
	vector<ll> sr(m);
	for (int i = 0; i < m; i++)
		cin >> sr[i];
	vll psr(m);
	psr[0] = sr[0];
	for (int i = 1; i < m; i++)
	{
		psr[i] = sr[i] + psr[i - 1];
	}
	vll call(q);
	for (int i = 0; i < q; i++)
		cin >> call[i];
	sort(call.begin(), call.end());
	map<ll, ll> tr;
	for (int i = 0; i < q; i++)
		tr[call[i]] = i;
	vector<ll> ans(q);
	vector<pll> scl;
	for (auto h : hom)
	{
		scl.push_back({ h.first - h.second, h.first });
	}
	for (auto cl : call)
	{
		scl.push_back({ cl, cl });
	}
	sort(scl.begin(), scl.end());
	ll t = n - 1;
	vll dp(q + 1);
	dp[q] = 0;
	ll inf = 1e18;
	vector<ll> A(n);
	A[0] = hom[0].second;
	for (int i = 1; i < n; ++i)
		A[i] = A[i - 1] + hom[i].second;
	for (int i = q - 1; i >= 0; i--)
	{
		inf = 1e18;
		while (t > 0 && hom[t].first > call[i])
		{
			inf = min(hom[t].first - hom[t].second, inf);
			t--;
		}
		dp[i] = inf;
	}
	ll i=0, t = 0;
	ll sum = 0;

	for (auto c : scl)
	{
		if (c.first == c.second)
		{
			while (i < n && hom[i].second <= c.first)
			{
				sum += hom[i].second;
				i++;
			}
			ll sec = dp[t] - sum;
			ll an = upper_bound(psr.begin(), psr.end(), sec) - psr.begin();
			ans[tr[c.first]] = an;
			t++;
		}
		
	}
	for (auto c : ans)
	{
		cout << c << ' ';
	}
	cout << endl;
}


int main()
{
	ll t = 1;;
	cin >> t;
	while (t--)
	{
		slove();
	}

}
