#include <iostream>
#include <iomanip>
#include <vector>
#include <deque>
#include <queue>
#include <string>
#include <set>
#include <map>
#include <numeric>
#include <algorithm>

using namespace std;

void F() {
	int n;
	cin >> n;
	string s[2];
	cin >> s[0] >> s[1];
	for (int i = 0; i < n - 1; i++) {
		if (s[0][i] != s[1][i]) {
			if (s[0][i] == '#') {
				if (s[1][i + 1] != '#')
					s[1][i] = s[1][i + 1] = '#';
			}
			else {
				if (s[0][i + 1] != '#')
					s[0][i] = s[0][i + 1] = '#';
			}
		}
	}
	for (int i = n - 1; i > 0; i--) {
		if (s[0][i] != s[1][i]) {
			if (s[0][i] == '#') {
				if (s[1][i - 1] != '#')
					s[1][i] = s[1][i - 1] = '#';
			}
			else {
				if (s[0][i - 1] != '#')
					s[0][i] = s[1][i - 1] = '#';
			}
		}
	}
	for (int i = 0; i < 2; i++)
		for (int j = 0; j < n; j++) {
			if (s[i][j] == '.') {
				int k = 1;
				if (j > 0 && s[1][j - 1] != '#')
					k = 0;
				if (j < n - 1 && s[i][j + 1] != '#')
					k = 0;
				if (s[i ^ 1][j] != '#')
					k = 0;
				if (k) {
					cout << "None" << '\n';
					return;
				}
			}
		}
	for (int i = 0; i < n - 1; i++)
		if (s[0][i] == '.' && s[1][i] == '.' && s[0][i + 1] == '.' && s[1][i + 1] == '.') {
			cout << "Multiple" << '\n';
			return;
		}
	cout << "Unique" << '\n';
}

int main() {
#ifdef ROMA
	FILE* stream;
	freopen_s(&stream, "input.txt", "r", stdin);
	//freopen_s(&stream, "output.txt", "w", stdout);
#endif
	cin.tie(0)->sync_with_stdio(0);
	int t = 1;
	cin >> t;
	while (t--)
		F();
}