#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;
using vi = vector<int>;

const int N = 1e5 + 5;
int tp[N];
int res[N];
vi g[N];
vi gr[N];
bool used[N];

void kek(vi &a) {
    vi nx;
    for(auto &x : a) {
        if (used[x]) continue;
        nx.push_back(x);
    }
    a = nx;
}

vi ts;
void dfs_g(int v) {
    used[v] = true;
    for(auto &u : g[v]) {
        if (used[u]) continue;
        dfs_g(u);
    }
    ts.push_back(v);
}

void dfs_gr(int v) {
    used[v] = true;
    for(auto &u : gr[v]) {
        if (used[u]) continue;
        dfs_g(u);
    }
    ts.push_back(v);
}

void solve() {
    int n; cin >> n;
    map<pair<int, int>, vi> who;
    rep(i, n) {
        string t, r; cin >> t >> r;
        if (t == "set") {
            tp[i] = 1;
        } else {
            tp[i] = 0;
        }
        if (r == "true") {
            res[i] = 1;
        } else {
            res[i] = 0;
        }
        who[make_pair(tp[i], res[i])].push_back(i);
    }
    int m; cin >> m;
    rep(_, m) {
        int a, b; cin >> a >> b;
        a--;
        b--;
        g[a].emplace_back(b);
        gr[b].emplace_back(a);
    }

    int sz = n;
    vi ans;
    int nx = 1;

    {
        vi must;
        rep(i, n) {
            if (tp[i] == 1) {
                dfs_gr(i);
            } else if (res[i] == 1) {
                dfs_gr(i);
            }
        }
        for(auto &i : ts) {
            if (tp[i] == 0 && res[i] == 0) {
                must.push_back(i);
            } else {
                used[i] = false;
            }
        }
        swap(must, ts);
    }

    rep(_, 2) {
        pair<int, int> wtf = make_pair(nx, 1);
        auto wh = who[wtf];
        kek(wh);
        if (wh.empty()) break;
        dfs_gr(wh[0]);
        if (nx == 1) {
            for(auto i : who[make_pair(1, 0)]) {
                if (used[i]) continue;
                dfs_gr(i);
            }
        }

        nx ^= 1;
    }

    rep(i, n) if (!used[i]) dfs_gr(i);

    vi position(n);
    rep(i, n) position[ts[i]] = i;
    rep(i, n) {
        for(auto j : g[i]) {
            if (position[i] > position[j]) {
                cout << "-1\n";
                return;
            }
        }
    }

    assert(ts.size() == n);
    int value = 0;
    for(auto &i : ts) {
        int ret = (tp[i] != value);
        if (ret != res[i]) {
            cout << "-1\n";
            return;
        }
        value = tp[i];
    }
    for(auto &i : ts) cout << i + 1 << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}