#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;
using ll = long long;
using vi = vector<int>;
using vl = vector<ll>;

const ll INF = 2e18;

void solve() {
    int n, m, q; cin >> n >> m >> q;
    vector<pair<ll, ll>> a(n);
    vl l(m);
    rep(i, n) cin >> a[i].second;
    rep(i, n) cin >> a[i].first;
    rep(i, m) cin >> l[i];
    sort(all(a));

    vector<pair<ll, ll>> segs;
    reverse(all(a));
    for(auto &[di, ti] : a) {
        ll last = di;
        if (!segs.empty() && segs.back().first <= last) {
            segs.back().first -= ti;
        } else {
            segs.emplace_back(di - ti, di);
        }
    }
    reverse(all(segs));

    vector<pair<ll, int>> t(q);
    rep(i, q) cin >> t[i].first;
    rep(i, q) t[i].second = i;
    sort(all(t));
    vl ans(q);

    int seg = 0;
    ll cur = 0;
    segs.emplace_back(INF, INF);

    int res = 0;
    for(auto &[ti, i] : t) {
        while (res < m && cur + l[res] <= ti) {
            if (cur + l[res] <= segs[seg].first) {
                cur += l[res];
                res++;
                continue;
            }
            ll len = segs[seg].second - segs[seg].first;
            segs[seg].first = cur;
            segs[seg].second = cur + len;
            cur += len;
            seg++;
            continue;
        }
        ans[i] = res;
    }
    rep(i, q) cout << ans[i] << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}