#include <bits/stdc++.h>
using namespace std;
 
#define rep(i, a, b) for (int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define allr(x) rbegin(x), rend(x)
#define sz(x) (int) (x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
 
const char nl = '\n';
 
void change(array<ll, 6> &res) {
    res = {-res[3], res[0], res[1], res[2], (res[4] + 45) % 360, res[5]};
}
 
map<array<ll, 4>, vector<array<ll, 2>>> mpa, mpb;
 
const ll inf2 = 1e18;
 
void process_1(const vector<array<ll, 6>> &a, map<array<ll, 4>, vector<array<ll, 2>>> &res_map, array<ll, 4> shift={0,0,0,0}) {
    res_map.clear();
 
    for (auto const &[x_, tx_, y_, ty_, rot, d]: a) {
        ll x = x_ + shift[0];
        ll tx = tx_ + shift[1];
        ll y = y_ + shift[2];
        ll ty = ty_ + shift[3];
        if (rot == 0) {
            res_map[{inf2, tx, y, ty}].push_back({x, x + d});
        } else if (rot == 45) {
            res_map[{x, inf2, y, ty}].push_back({tx, tx + d});
        } else if (rot == 90) {
            res_map[{x, tx, inf2, ty}].push_back({y, y + d});
        } else if (rot == 135) {
            res_map[{x, tx, y, inf2}].push_back({ty, ty + d});
        } else if (rot == 0 + 180) {
            res_map[{inf2, tx, y, ty}].push_back({x - d, x});
        } else if (rot == 45 + 180) {
            res_map[{x, inf2, y, ty}].push_back({tx - d, tx});
        } else if (rot == 90 + 180) {
            res_map[{x, tx, inf2, ty}].push_back({y - d, y});
        } else if (rot == 135 + 180) {
            res_map[{x, tx, y, inf2}].push_back({ty - d, ty});
        }
    }
}
 
bool check_2(const vector<array<ll, 2>> &a, const vector<array<ll, 2>> &b) {
    map<ll, vector<pair<int, int>>> mp;
    for (auto const &[x, y]: a) {
            mp[x].push_back({0, 1});
            mp[y].push_back({0, -1});
    }
     
    for (auto const &[x, y]: b) {
            mp[x].push_back({1, 1});
            mp[y].push_back({1, -1});
    }
 
    array<ll, 2> cnt = {0, 0};
    for (auto const &[pt, v]: mp) {
        for (auto const &p: v) cnt[p.first] += p.second;
 
        if (cnt[0] > 0 && cnt[1] == 0) return false;
        if (cnt[0] == 0 && cnt[1] > 0) return false;
    }
 
    return true;
}
 
int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin.exceptions(cin.failbit);
 
    int n;
    cin >> n;
 
    ll rot = 0;
    array<ll, 4> p_pos = {0, 0, 0, 0};
 
    vector<array<ll, 6>> a;
    while (n--) {
        string s;
        cin >> s;
 
        ll d;
        cin >> d;
 
        if (s == "draw") {
            a.push_back({p_pos[0], p_pos[1], p_pos[2], p_pos[3], rot, d});
        } else if (s == "rotate") {
            rot = (rot + d) % 360;
        } else {
        }
 
        if (s == "draw" || s == "move") {
            if (rot == 0) p_pos[0] += d;
            if (rot == 45) p_pos[1] += d;
            if (rot == 90) p_pos[2] += d;
            if (rot == 135) p_pos[3] += d;
            if (rot == 0 + 180) p_pos[0] -= d;
            if (rot == 45 + 180) p_pos[1] -= d;
            if (rot == 90 + 180) p_pos[2] -= d;
            if (rot == 135 + 180) p_pos[3] -= d;
        }
    }
 
    process_1(a, mpa);
    auto b = a;
    int ans_rot = 1;
    for (int ans_rot = 1; ans_rot <= 7; ans_rot++) {
        for (int i = 0; i < sz(a); i++) {
            change(b[i]);
        }
 
        process_1(b, mpb);
 
        vector<array<ll, 4>> tk1;
        for (auto p: mpb) {
            array<ll, 4> k1;
            k1 = p.first;
            sort(all(p.second));
            for (auto [x, y]: p.second) {
                if (k1[0] == inf2) k1[0] = x;
                else if (k1[1] == inf2) k1[1] = x;
                else if (k1[2] == inf2) k1[2] = x;
                else k1[3] = x;
                break;
            }
            tk1.push_back(k1);
        }
        array<ll, 4> k1 = *min_element(all(tk1));
        
 
        set<array<ll, 4>> shifts;
        for (auto p: mpa) {
            array<ll, 4> k2 = p.first;
            sort(all(p.second));
            for (auto [x, y]: p.second) {
                if (k2[0] == inf2) k2[0] = x;
                else if (k2[1] == inf2) k2[1] = x;
                else if (k2[2] == inf2) k2[2] = x;
                else k2[3] = x;
                break;
            }
 
            shifts.insert({k2[0] - k1[0], k2[1] - k1[1], k2[2] - k1[2], k2[3] - k1[3]});
            //break;
        }

        for (auto shift: shifts) {
 
            process_1(b, mpb, shift);
 
            set<array<ll, 4>> keys;
            for (auto const &p: mpa) keys.insert(p.first);
            for (auto const &p: mpb) keys.insert(p.first);
 
            bool ok = true;
            for (auto key: keys) {
                if (!check_2(mpa[key], mpb[key])) {
                    ok = false;
                    break;
                }
            }
 
            if (ok) {
                cout << ans_rot * 45 << endl;
                return 0;        
            }
            break;
        }
 
        
    }
 
    cout << 360 << endl;
}