#include <bits/stdc++.h>
using namespace std;
#define int long long

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> a(n);
    vector<int> d(n);
    vector<int> s(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> s[i];
    }
    vector<pair<int, int>> sorted_deds(n);
    for (int i = 0; i < n; i++) {
        sorted_deds[i] = {d[i], a[i]};
    }
    sort(sorted_deds.begin(), sorted_deds.end());
    vector<int> pref_sum(n, 0);
    for (int i = 0; i < n; i++) {
        if (i != 0) {
            pref_sum[i] = pref_sum[i - 1];
        }
        pref_sum[i] += sorted_deds[i].second;
    }
    for (int i = 0; i < n; i++) {
        sorted_deds[i].first -= pref_sum[i];
    }
    vector<int> suf_min(n + 1, 1e18);
    for (int i = n - 1; i >= 0; i--) {
        suf_min[i] = min(sorted_deds[i].first, suf_min[i + 1]);
    }
    vector<int> takes;
    int cur_time = 0;
    int mov_ind = 0;
    int cur_ind = 0;
    int mov_sum = 0;
    while(true) {
        if (suf_min[cur_ind] - mov_sum >= s[mov_ind]) {
            cur_time += s[mov_ind];
            mov_sum += s[mov_ind];
            mov_ind++;
            takes.push_back(cur_time);
            if (mov_ind == m) {
                break;
            }
        }
        else {
            cur_time += sorted_deds[cur_ind].second;
            cur_ind++;
        }
    }
    for (int i = 0; i < q; i++) {
        int a;
        cin >> a;
        auto it = upper_bound(takes.begin(), takes.end(), a);
        int diff = it - takes.begin();
        cout << diff << ' ';
    }
    cout << '\n';
}


int32_t main()
{
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}
