#include <iostream>
#include <vector>
#include <array>

using namespace std;

using ll = long long;
using vi = vector<int>;
using vl = vector<ll>;
using pii = array<int, 2>;

const ll MOD = 10102001;

void solve() {
    int n;
    cin >> n;
    array<string, 2> s;
    cin >> s[0] >> s[1];
    s[0].push_back('#');
    s[1].push_back('#');
    vector<vi> dp(n + 2, vi(4));
    dp[0][3] = 1;
    for (int i = 1; i <= n + 1; ++i) {
        for (int m1 = 0; m1 < 4; ++m1) {
            vi per;
            if (m1 == 0) {
                per.push_back(0);
                per.push_back(3); 
            } else if (m1 == 1) {
                per.push_back(2);
            } else if (m1 == 2) {
                per.push_back(1);
            } else {
                per.push_back(0);
            }
            for (int m2 : per) {
                if (s[0][i - 1] == '#') {
                    if (m2 & 1) continue;
                    m2 ^= 1;
                }
                if (s[1][i - 1] == '#') {
                    if (m2 & 2) continue;
                    m2 ^= 2;
                }
                dp[i][m2] += dp[i - 1][m1];
                dp[i][m2] %= MOD;
            }
        }
    }
    int ans = dp[n + 1][3];
    if (ans == 0) {
        cout << "None\n";
    } else if (ans == 1) {
        cout << "Unique\n";
    } else {
        cout << "Multiple\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) solve();
}