#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) begin(a), end(a)
#define len(a) int((a).size())
#define rep(i, n) for (int i = 0; i < (n); i++)

mt19937 rnd;

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    rep(itr, t){
        int n, m, q;
        cin >> n >> m >> q;
        vector<pair<ll, ll>> tasks(n);
        rep(i, n){
            cin >> tasks[i].first;
        }
        rep(i, n){
            cin >> tasks[i].second;
        }
        sort(all(tasks), [&](const pair<ll, ll> &a, const pair<ll, ll> &b){
            return a.second < b.second;
        });
        ll last = 1e18;
        for(int i = n - 1; i >= 0; i -= 1){
            last = min(last, tasks[i].second);
            tasks[i].second = last;
            last -= tasks[i].first;
        }
        assert(last >= 0);
        vector<ll> episodes(m);
        rep(i, m){
            cin >> episodes[i];
        }
        vector<ll> pepisodes(m + 1);
        pepisodes[0] = 0;
        rep(i, m){
            pepisodes[i + 1] = pepisodes[i] + episodes[i];
        }
        vector<ll> ptasks(n + 1);
        ptasks[0] = 0;
        last = 0;
        rep(i, n){
            ll len = tasks[i].second - last - tasks[i].first;
            ptasks[i + 1] = ptasks[i] + len;
            last = tasks[i].second;
        }
        rep(i, q){
            ll t;
            cin >> t;
            ll tl = -1;
            ll tr = n;
            while(tl + 1 < tr){
                ll tm = (tl + tr) / 2;
                if(tasks[tm].second >= t){
                    tr = tm;
                } else{
                    tl = tm;
                }
            }
            ll can = ptasks[tr];
            ll last = 0;
            if(tr > 0){
                last = tasks[tr - 1].second;
            }
            ll diff = t - last;
            if(tr < n){
                diff = min(diff, tasks[tr].second - last - tasks[tr].first);
            }
            can += diff;
            tl = 0;
            tr = m + 1;
            while(tl + 1 < tr){
                ll tm = (tl + tr) / 2;
                if(pepisodes[tm] <= can){
                    tl = tm;
                } else{
                    tr = tm;
                }
            }
            cout << tl << " ";
        }
        cout << "\n";
    }
    return 0;
}


/*
1
3 4 3
8 100 8
10 150 20
2 32 1 1
51 50 10


2
1 2 3
10
15
5 5
5 15 20
3 4 5
8 100 8
10 150 20
2 32 1 1
9 200 51 50 10
*/