#include<iostream>
#include<vector>
#include<map>
#include<set>

using namespace std;

#define int long long

vector<pair<int, int>> ans;

void SWAP(int i, int j,vector<int>& cur)
{
	if (j < i)swap(i, j);
	ans.push_back({ cur[i],cur[j]  });
	swap(cur[i], cur[j]);
}

void solve() {
	int n; cin >> n;
	vector<int> p(n), cur(n);
	for (int i = 0; i < n; i++)
	{
		cin >> p[i]; cur[i] = i + 1;
	}
	
	for (int i = n - 1; i >= 0; i--)
	{
		int num = p[i];
		int k;
		for (int j = 0; j < n; j++)
		{
			if (cur[j] == num)
			{
				k = j; break;
			}
		}
		while (k != 0)
		{
			SWAP(k, k - 1,cur); k--;
		}
		while (k != i)
		{
			SWAP(k, k + 1, cur); k++;
		}
	}
	cout << ans.size() << endl;
	for (auto [x, y] : ans)
	{
		cout << y << " " << x << endl;
	}
}

signed main()
{
	ios::sync_with_stdio(false); cin.tie(0);
	solve();
	return 0;
}