#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 1;
const int MOD = 998244353;
const int INF = 1e9;
const ll INFLL = 1e18;

void solve() {
    int n;
    cin >> n;
    int p[n], a[n];
    int pos[n];
    iota(pos, pos + n, 0);
    iota(a, a + n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
        --p[i];
    }
    vector <pair <int, int>> ans;
    for (int i = 0; i < n; ++i) {
        int j = pos[p[i]];
        for (int l = j + 1; l < n; ++l) {
            ans.emplace_back(a[l], a[j]);
        }
        for (int l = n - 1; l >= j + 1; --l) {
            ans.emplace_back(a[j], a[l]);
        }
        while (i != j) {
            ans.emplace_back(a[j], a[j - 1]);
            pos[a[j - 1]] = j;
            pos[a[j]] = j - 1;
            swap(a[j], a[j - 1]);
            j--;
        }
    }
    cout << ans.size() << '\n';
    for (auto [x, y] : ans ) {
        cout << x + 1 << " " << y + 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

    int tests = 1;
    // cin >> tests;
    while (tests--) solve();
    return 0;
}
