 #include <iostream>
 #include <set>
 #include <map>
 #include <vector>
using namespace std;

map<int, set<int>> m;
map<int, vector<int>> mUsl;

struct Node {
    bool reg;
    int num;
    set<int> prevNums;
    vector<Node*> child;
};

void createTree(Node* node){
    if (node->reg){
        for (int numNode : m[2]){
            if (!node->prevNums.contains(numNode)){
                bool flag = true;
                if (mUsl[numNode].size() != 0) {
                    for (int p : mUsl[numNode]) {
                        if (!node->prevNums.contains(p)) {
                            flag = false;
                            break;
                        }
                    }
                }

                if (flag){
                    Node *newNode = new Node();
                    newNode->reg = false;
                    newNode->num = numNode;
                    newNode->prevNums = node->prevNums;
                    newNode->prevNums.insert(numNode);
                    node->child.push_back(newNode);
                    createTree(newNode);
                }
            }
        }

        for (int numNode : m[3]){
            if (!node->prevNums.contains(numNode)){
                bool flag = true;
                if (mUsl[numNode].size() != 0) {
                    for (int p : mUsl[numNode]) {
                        if (!node->prevNums.contains(p)) {
                            flag = false;
                            break;
                        }
                    }
                }
                if (flag){
                    Node *newNode = new Node();
                    newNode->reg = true;
                    newNode->num = numNode;
                    newNode->prevNums = node->prevNums;
                    newNode->prevNums.insert(numNode);
                    node->child.push_back(newNode);
                    createTree(newNode);
                }
            }
        }
    } else {
        for (int numNode : m[0]){
            if (!node->prevNums.contains(numNode)){
                bool flag = true;
                if (mUsl[numNode].size() != 0) {
                    for (int p : mUsl[numNode]) {
                        if (!node->prevNums.contains(p)) {
                            flag = false;
                            break;
                        }
                    }
                }
                if (flag){
                    Node *newNode = new Node();
                    newNode->reg = false;
                    newNode->num = numNode;
                    newNode->prevNums = node->prevNums;
                    newNode->prevNums.insert(numNode);
                    node->child.push_back(newNode);
                    createTree(newNode);
                }
            }
        }

        for (int numNode : m[1]){
            if (!node->prevNums.contains(numNode)){
                bool flag = true;
                if (mUsl[numNode].size() != 0) {
                    for (int p : mUsl[numNode]) {
                        if (!node->prevNums.contains(p)) {
                            flag = false;
                            break;
                        }
                    }
                }
                if (flag){
                    Node *newNode = new Node();
                    newNode->reg = true;
                    newNode->num = numNode;
                    newNode->prevNums = node->prevNums;
                    newNode->prevNums.insert(numNode);
                    node->child.push_back(newNode);
                    createTree(newNode);
                }
            }
        }
    }
}

vector<string> ans;
int n;
void dfs(Node* node, string line){
    for (auto ch : node->child){
            string newline = line + to_string(ch->num);
            dfs(ch, newline);
    }
    if (line.size() == n)
        ans.push_back(line);
}

int main() {
    cin >> n;

    for (int i = 1; i <= n; i++){
        string s1, s2;
        cin >> s1 >> s2;
        if (s1 == "set"){
            if (s2 == "true"){
                m[1].insert(i);
            }
            if (s2 == "false"){
                m[3].insert(i);
            }
        }
        if (s1 == "unset"){
            if (s2 == "true"){
                m[2].insert(i);
            }
            if (s2 == "false"){
                m[0].insert(i);
            }
        }
    }

    int k;
    cin >> k;
    for (int i = 0; i < k; i++){
        int a1, a2;
        cin >> a1 >> a2;
        mUsl[a2].push_back(a1);
    }

    Node* root = new Node();
    root->reg = false;
    root->num = 0;
    createTree(root);
    dfs(root, "");
    bool flaggg = false;
    for (string s : ans){
        if (s.length() == n){
            for (char ch : s)
                cout << ch << " ";
            flaggg = true;
        }
    }

    if (!flaggg)
        cout << "-1";

    return 0;
}

/*
5
set true
unset true
set false
unset false
unset false
4
1 4
5 2
 */