#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
using namespace std;
const int N = 1e5+5;
string str[N];
vector<int> g[N];
vector<int> deleted;
int cnt[N];
int delete_all(string del, int n)
{
    queue<int> q;
    for(int i = 1; i <= n; i++)
        if(cnt[i] == 0)
            q.push(i);
    int ok = 0;
    while(q.size())
    {
        auto cur = q.front();
        q.pop();
        if(str[cur] != del) continue;
        // cout << cur << " " << del << endl;
        ok = 1;
        cnt[cur] = -1;
        deleted.push_back(cur);
        for(auto to: g[cur])
        {
            if(cnt[to] <= 0) continue;
            cnt[to]--;
            if(!cnt[to]) q.push(to);
        }
    }
    return ok;
}
void solve() {
    int n;
    cin >> n;
    getline(cin, str[0]);
    for(int i = 0; i < n; i++)
    {
        getline(cin, str[i + 1]);
    }
    int m;
    cin >> m;
    for(int i = 0; i < m; i++)
    {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        cnt[v]++;
    }
    delete_all("unset false", n);
    if(delete_all("set true", n))
    {
        delete_all("set false", n);
        if(delete_all("unset true", n))
            delete_all("unset false", n);
    }
    if(deleted.size() == n)
    {
        for(auto to: deleted)
            cout << to << " ";
    }
    else cout << -1 << endl;
    
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    // freopen("input.txt", "r", stdin);

    int t = 1; 
    // cin >> t;

    while (t--) {
        solve();
    }
}
