#include <bits/stdc++.h>

using namespace std;

#define int long long

bool isDigit(char c) {
    return '0' <= c && c <= '9';
}

int eval(string s) {
    int result = 0;

    if (s.front() != '-') {
        s = "+" + s;
    }

    int sum = 0;

    for (int i = 0; i < s.size(); ) {
        // cout << "=====================" << endl;
        // cout << i << endl;
        // cout << s << endl;

        char sign = s[i];

        string num = "";

        int kek = -1;

        for (int j = i + 1; j <= s.size(); j++) {
            if (j == s.size() || !isDigit(s[j])) {
                kek = j;
                break;
            }

            num += s[j];
        }

        if (num.size() > 10 || num.size() > 1 && num.front() == '0' || num.size() == 0) {
            return -1;
        }

        sum += (sign == '-' ? -1 : +1) * stoll(num);

        i = kek;
    }

    return sum;
}

bool isOk(string s) {
    if (s.front() == '=' || s.back() == '=' || std::count(s.begin(), s.end(), '=') != 1) {
        return false;
    }

    bool was = false;
    string l = "", r = "";

    for (int i = 0; i < s.size(); i++) {
        if (s[i] == '=') {
            was = true;
        } else if (was) {
            r += s[i];
        } else {
            l += s[i];
        }
    }

    int ql = eval(l);
    int qr = eval(r);

    if (ql == -1 || qr == -1) {
        return false;
    }

    return ql == qr;
}

void solve() {
    string s; cin >> s;
    
    if (isOk(s)) {
        cout << "Correct" << '\n';
    } else {
        for (int i = 0; i < s.size(); i++) {
            if (isDigit(s[i])) {
                char c = s[i];
                s.erase(s.begin() + i);
                int sz = s.size();

                for (int j = 0; j <= sz; j++) {
                    s.insert(s.begin() + j, c);

                    if (isOk(s)) {
                        cout << s << '\n';
                        return;
                    }

                    s.erase(s.begin() + j);
                }

                s.insert(s.begin() + i, c);
            }
        }

        cout << "Impossible\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    // freopen("input.txt", "r", stdin);

    int t = 1; 
    // cin >> t;

    while (t--) {
        solve();
    }
}
