import sys

input = lambda: sys.stdin.readline().rstrip()

def ii():
    return int(input())


def expr_res(s: str):
    op = '+'
    res = 0
    i = 0
    while i < len(s):
        cur_num = ''
        while i < len(s) and s[i].isdigit():
            cur_num += s[i]
            i += 1
        if (len(cur_num) > 10 or cur_num == ''):
            return None
        res += int(cur_num) * (1 if op == '+' else -1)
        if i >= len(s):
            break
        op = s[i]
        if op == '=':
            return res, s[i+1:]
        i += 1
    return res, ''


def check(s: str):
    if (not s[0].isdigit()) or (not s[-1].isdigit()):
        return False
    for i in range(len(s)):
        if s[i] == '0' and (i < len(s)-1 and s[i+1].isdigit()) and (i == 0 or (not s[i-1].isdigit())):
            return False
    exp1 = expr_res(s)
    if exp1 is None:
        return False
    res1, s = exp1
    exp2 = expr_res(s)
    if exp2 is None:
        return False
    res2, s = exp2
    return res1 == res2


def main():
    s = input()
    if check(s):
        print('Correct')
        return
    for i, ch in enumerate(s):
        if not ch.isdigit():
            continue
        s_without_ch = s[:i] + s[i+1:]
        for j in range(len(s)):
            if j == i:
                continue
            new_s = s_without_ch[:j] + ch + s_without_ch[j:]
            if check(new_s):
                print(new_s)
                return
    print('Impossible')


main()
