import sys

input = lambda: sys.stdin.readline().rstrip()




vectors = ((0, 1), (-1, 0), (0, -1), (1, 0))
def neighbors(arr, i, j):
    count = 0
    for x in vectors:
        ii = i + x[0]
        jj = j + x[1]
        if 0 <= ii < 2 and 0 <= jj < len(arr[0]) and arr[ii][jj] == '.':
            count += 1
    return count

def ii():
    return int(input())

def main():
    t = int(input())
    for _ in range(t):
        n = int(input())
        s1 = input()
        s2 = input()
        arr = [s1, s2]
        leav = []
        neigbarr = [[0] * n for i in range(2)]
        count = 0
        for i in range(2):
            for j in range(n):
                if arr[i][j] == '#':
                    neigbarr[i][j] = -1
                else:
                    count += 1
                    neig = neighbors(arr, i, j)
                    neigbarr[i][j] = neig
                    if neig == 1:
                        leav.append((i, j))
        if count % 2 != 0:
            print('None')
            continue
        while leav:
            newleav = []
            for x in leav:
                i, j = x
                di, dj = -10, -10
                for direct in vectors:
                    ii = i + direct[0]
                    jj = j + direct[1]
                    if 0 <= ii < 2 and 0 <= jj < n and arr[ii][jj] == '.' and neigbarr[ii][jj] > 0:
                        di, dj = ii, jj
                        break
                if di == dj == -10:
                    continue
                neigbarr[i][j] = -1
                neigbarr[di][dj] = -1
                for direct in vectors:
                    ii = di + direct[0]
                    jj = dj + direct[1]
                    if 0 <= ii < 2 and 0 <= jj < n  and neigbarr[ii][jj] > 0:
                        neigbarr[ii][jj] -= 1
                        if neigbarr[ii][jj] == 1:
                            newleav.append((ii, jj))
            leav = newleav
        c2 = 0
        c0 = 0
        for i in range(2):
            for j in range(n):
                if neigbarr[i][j] == 0:
                    c0 += 1
                elif neigbarr[i][j] == 2:
                    c2 += 1
        if c0 != 0:
            print('None')
        else:
            if c2 != 0:
                print('Multiple')
            else:
                print('Unique')





main()