#include <bits/stdc++.h>
#define int long long
using namespace std;


const int N=1e6+10;
int cnt;
int vis[N];
int jog[N];
vector<int>E[N];
pair<int,int>op[N];
int n,m,k,q,x,y;
vector<int>v[3];

void dfs1(int nd){
    vis[nd] = 1;

    if(op[nd].first == 1) jog[nd] = 1;
    else jog[nd] = 2;

    for(auto i : E[nd]){
        if(vis[i] == 0){
            dfs1(i);
        }
        if(jog[i] == -1){
            jog[nd] = -1;
            return;
        }
        if(jog[i] == 2){
            if(op[nd].first == 1){
                jog[nd] = -1;
                return;
            }
        }
    }
    if(jog[nd] != -1) v[jog[nd]].push_back(nd);
}

void dfs2(int nd){
    vis[nd] = 1;

    if(op[nd].first == 0) jog[nd] = 1;
    else jog[nd] = 2;

    for(auto i : E[nd]){
        if(vis[i] == 0){
            dfs2(i);
        }

        if(jog[i] == -1){
            jog[nd] = -1;
            return;
        }
        if(jog[i] == 1){
            if(op[i].first == 0 and op[i].second == 1 and op[nd].first == 0){
                jog[nd] = 3;
            }
            continue;
        }
        if(jog[i] == 2){
            if(op[nd].first == 0) jog[nd] = 3;
            continue;
        }
        if(jog[i] == 3){
            if(op[nd].first == 1){
                jog[nd] = -1;
                return;
            }
            jog[nd] = 3;
        }
    }
    if(jog[nd] != -1) v[jog[nd]].push_back(nd);
}

int32_t main()
{
    cin >> n;
    for(int i = 1;i <= n;i++){
        string s1,s2;
        cin >> s1 >> s2;
        if(s1 == "set"){
            op[i].first = 1;
        }
        else op[i].first = 0;
        if(s2 == "true"){
            op[i].second = 1;
            cnt++;
        }
        else op[i].second = 0;
    }
    cin >> m;
    for(int i = 1;i <= m;i++){
        int x,y;
        cin >> x >> y;
        E[x].push_back(y);
    }
    if(cnt == 0){
        bool ok = 1;
        for(int i = 1;i <= n;i++){
            if(op[i].first == 1){
                ok = 0;
                break;
            }
        }
        if(!ok){
            return cout<<-1,0;
        }
        for(int i = 1;i <= n;i++) if(vis[i] == 0) dfs1(i);
        reverse(v[2].begin(),v[2].end());
        for(auto i : v[2]) cout<<i<<' ';
        return 0;
    }

    if(cnt == 1){
        bool ok = 1;
        int idx = -1;
        for(int i = 1;i <= n;i++){
            if(op[i].first == 0 and op[i].second == 1){
                ok = 0;
                break;
            }
            if(op[i].first == 1 and op[i].second == 1){
                idx = i;
            }
        }
        if(!ok){
            return cout<<-1,0;
        }

        ok = 1;
        for(int i = 1;i <= n;i++){
            if(i == idx) continue;
            for(auto j : E[i]){
                if(j == idx){
                    if(op[i].first == 1){
                        ok = 0;
                        break;
                    }
                }
            }
        }
        if(!ok) return cout<<-1,0;
        for(int i = 1;i <= n;i++){
            if(vis[i] == 0){
                dfs1(i);
            }
        }
        for(int i = 1;i <= n;i++){
            if(jog[i] == -1){
                return cout<<-1,0;
            }
        }
        reverse(v[1].begin(),v[1].end());
        reverse(v[2].begin(),v[2].end());
        for(auto i : v[2]) cout<<i<<' ';
        cout<<idx<<' ';
        for(auto i : v[1]) if(i != idx) cout<<i<<' ';
        return 0;
    }

    assert(cnt <= 2);

    int idx1 = -1;
    int idx2 = -1;
    for(int i = 1;i <= n;i++){
        if(op[i].first == 1 and op[i].second == 1) idx1 = i;
        if(op[i].first == 0 and op[i].second == 1) idx2 = i;
    }

    for(int i = 1;i <= n;i++){
        for(auto j : E[i]){
            if(j == idx1 and op[i].first == 1){
                return cout<<-1,0;
            }
        }
    }

    for(int i = 1;i <= n;i++){
        if(vis[i] == 0){
            dfs2(i);
        }
    }

    for(int i = 1;i <= n;i++){
        if(jog[i] == -1){
            return cout<<-1,0;
        }
    }

    if(jog[idx2] == 3){
        return cout<<-1,0;
    }
    reverse(v[1].begin(),v[1].end());
    reverse(v[2].begin(),v[2].end());
    reverse(v[3].begin(),v[3].end());
    for(auto i : v[3]) cout<<i<<' ';
    cout<<idx1<<' ';
    for(auto i : v[2]) if(i != idx1) cout<<i<<' ';
    cout<<idx2<<' ';
    for(auto i : v[1]) if(i != idx2) cout<<i<<' ';
    return 0;
}
