#include <bits/stdc++.h>

using namespace std;

const int N = 1 << 12;
int ans[N];
int X;

int lsb(int x) {
    assert(x != 0);
    for (int i = 0;; ++i) {
        if (x >> i & 1)
            return i;
    }
}

void do_set(int i, int w_num, int b_num, int val) {
    assert(val < 2);
    ans[i] = (i << 4);
    if (val == 1) {
        ans[i] |= lsb(ans[i]);
    }
    ans[i + 1] = (w_num << 4) | b_num;
}

void do_copy(int i, int w1, int b1, int w2, int b2) {
    ans[i] = (w1 << 4) | b1;
    ans[i + 1] = (w2 << 4) | b2;
}

char to_char(int x) {
    if (x < 10) return '0' + x;
    return 'a' + (x - 10);
}

string pretty(int x) {
    string res;
    for (int i = 0; i < 4; ++i) {
        res += to_char(x % 16);
        x /= 16;
    }
    reverse(res.begin(), res.end());
    return res;
}

void set_bit(int& a, int i, int x) {
    if (x == 1) {
        a |= 1 << i;
    } else {
        a &= ((1 << 25) - 1) ^ (1 << i);
    }
}

void emulate(int w) {
    vector<int> was_ans(ans, ans + N);
    ans[N - 1] = w;
    int ip = 0;
    int cnt = 0;
    for (int it = 0; it < N; ++it, ++cnt) {
        if (ip >= N - 2)
            break;
        int a = ans[ip], b = ans[ip + 1], c = ans[ip + 2];
        set_bit(ans[b >> 4], b & 15, (ans[a >> 4]) >> (a & 15) & 1);
        ip = ans[ip + 2];
    }
    if (w == X) {
        assert(ans[N - 1] & 1);
    } else {
        assert(!(ans[N - 1] & 1));
    }
    copy(ans, ans + N, was_ans.begin());
}

void solve() {
    cin >> X;
    ans[2] = 8;
    do_copy(0, N - 1, 0, 2, 2);
    for (int i = 8, b = 0; b < 16; b++, i += 8) {
        if ((X >> b & 1) == 1) {
            do_set(i, N - 1, 0, 0);
            ans[i + 2] = N - 1;

            if (b + 1 == 16) {
                do_set(i + 4, N - 1, 0, 1);
                ans[i + 6] = N - 1;
                break;
            }
            do_copy(i + 4, N - 1, b + 1, i + 6, 2);
            ans[i + 6] = i + 8;
        } else {
            do_set(i + 4, N - 1, 0, 0);
            ans[i + 6] = (1 << 12) - 1;

            if (b + 1 == 16) {
                do_set(i, N - 1, 0, 1);
                ans[i + 2] = N - 1;
                break;
            }
            do_copy(i, N - 1, b + 1, i + 2, 2);
            ans[i + 2] = i + 8;
        }
    }
    for (int i = 0; i < N - 1; ++i) {
        cout << pretty(ans[i]) << " ";
    }
}

int32_t main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    solve();
    return 0;
}
