#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>
#include <map>

using namespace std;

/*
    std::set<int> passed;
    std::vector<std::set<int>> overtook(n);
    for (int i = n - 1; i >= 0; --i) {
        int elem = v[i];
        for (int it : passed) {
            if (it > elem) {
                break;
            }
            overtook[elem].insert(it);
        }
        passed.insert(elem);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) {
                continue;
            }
            if (overtook[i].count(j) == 0 && overtook[j].count(i) == 0) {
                cout <<
            }
        }
    }
 */

int findIndex(const std::vector<int> &v, int elem) {
    for (int i = 0; i < v.size(); ++i) {
        if (v[i] == elem) {
            return i;
        }
    }
    throw std::runtime_error("");
}

int main() {
    int n;
    std::cin >> n;
    std::vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> v[i];
        --v[i];
    }
    std::reverse(v.begin(), v.end());
    std::vector<int> current(n);
    for (int i = 0; i < n; ++i) {
        current[i] = i;
    }
    std::vector<std::pair<int, int>> ans;
    for (int turnElem : v) {
        int index = findIndex(current, turnElem);
        for (int i = index; i > 0; --i) {
            ans.emplace_back(current[i] + 1, current[i - 1] + 1);
            std::swap(current[i], current[i - 1]);
        }
    }
    std::cout << ans.size() << std::endl;
    for (auto x : ans) {
        std::cout << x.first << ' ' << x.second << '\n';
    }
    return 0;
}
