#include <bits/stdc++.h>

#define i4 int32_t
#define u4 uint32_t
#define i8 int64_t
#define u8 int64_t

#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front

using namespace std;

template<class T>
using Vec = vector<T>;

template<class T, class V>
using Pair = pair<T, V>;

bool Parse(string s) {
    Vec<char> op[2];
    Vec<string> num[2];

    i4 it = 0;

    string cur = "";

    for (i4 i = 0; i < s.size(); ++i) {
        if (s[i] == '+' || s[i] == '-' || s[i] == '=') {
            if (cur.size() == 0) {
                return false;
            }

            if (cur.size() > 10 || (cur[0] == '0' && cur.size() != 1)) {
                return false;
            }

            num[it].pb(cur);

            if (s[i] == '=') {
                it = 1;
            } else {
                op[it].pb(s[i]);
            }
            cur = "";
        } else {
            cur += s[i];
        }
    }

    if (cur.size() > 10 || cur.size() == 0 || (cur[0] == '0' && cur.size() != 1)) {
        return false;
    }

    num[it].pb(cur);

    if (num[0].size() == 0 || num[1].size() == 0) {
        return false;
    }

    i8 left = stoll(num[0][0]);

    for (i4 i = 0; i < op[0].size(); ++i) {
        if (op[0][i] == '+') {
            left += stoll(num[0][i + 1]);
        }

        if (op[0][i] == '-') {
            left -= stoll(num[0][i + 1]);
        }
    }

    i8 right = stoll(num[1][0]);

    for (i4 i = 0; i < op[1].size(); ++i) {
        if (op[1][i] == '+') {
            right += stoll(num[1][i + 1]);
        }

        if (op[1][i] == '-') {
            right -= stoll(num[1][i + 1]);
        }
    }

    if (right == left) {
        return true;
    }
    return false;
}

void Solve() {
   string s;
   cin >> ws;
   getline(cin, s);

   if (Parse(s)) {
    cout << "Correct" << '\n';
    return;
   }

    bool res = false;
    string correct;

   for (i4 i = 0; i < s.size(); ++i) {
        if (s[i] == '+' || s[i] == '-' || s[i] == '=') {
            continue;
        }

        string t = s;
        t.erase(i, 1);

        for (i4 j = 0; j <= t.size(); ++j) {
            string z = t;
            string tmp = "";
            tmp += s[i];
            z.insert(j, tmp);

            res |= Parse(z);

            if (res) {
                correct = z;
                break;
            }
        }

        if (res) {
            break;
        }
   }

   if (res) {
        if (correct == s) {
            cout << "Correct" << '\n';
        } else {
            cout << correct << '\n';
        }
   } else {
       cout << "Impossible" << '\n';
   }

}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif


    i4 t = 1;
//    cin >> t;

    for (i4 iter = 0; iter < t; ++iter) {
        Solve();
    }
}


