#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
vector <vector <int>> types (4);
vector <int> type(100005);
vector <vector <int>> g(100005);
vector <int> pref;
vector <int> topp;
vector <int> used(100005, 0);
vector <int> used2(100005, 0);
vector <int> used3(100005, 0);
int cycle = 0;
int flag = 0;
int get_type(string s1, string s2) {
    if (s1 == "set") {
        if (s2 == "true") return 0;
        else return 1;
    } else {
        if (s2 == "true") return 2;
        else return 3;
    }
}

void dfs (int v) {
    used[v] = 1;
    if (type[v] != 3) flag = 1;
    for (auto u : g[v]) {
        if (used[u] == 1) {
            cycle = 1;
            cout << "-1\n";
            exit(0);
        } else if (used[u] == 0) {
            dfs(u);
        }
    }
    topp.push_back(v);
    used[v] = 2;
}

void dfs2 (int v) {
    used2[v] = 1;
    if (type[v] != 3) flag = 1;
    for (auto u : g[v]) {
        if (used2[u] == 1) {
            cycle = 1;
            cout << "-1\n";
            exit(0);
        } else if (used2[u] == 0) {
            dfs2(u);
        }
    }
    //t.push_back(v);
    used2[v] = 2;
}

void dfs3 (int v) {
    used[v] = 1;
    if (type[v] != 3) flag = 1;
    for (auto u : g[v]) {
        if (used[u] == 1) {
            cycle = 1;
            cout << "-1\n";
            exit(0);
        } else if (used[u] == 0) {
            dfs3(u);
        }
    }
    pref.push_back(v);
    used[v] = 2;
}

bool is_correct (vector <int> &a) {
    int n = a.size();
    if (type[a[0]] != 3 && type[a[0]] != 0) return false;
    int i = 0;
    //for (auto now : a) {
   //     cout << type[now] << ' ';
    //}
    //cout << '\n';
    while (i < n && type[a[i]] == 3) {
        ++i;
    }
    //cout << i << '\n';
    if (i == n) return true;
    while (i < n && type[a[i]] == 0) {
        ++i;
    }
    //cout << i << '\n';
    if (i == n) return true;
    if (type[a[i]] == 3) return false;
    while (i < n && type[a[i]] == 1 && i < n) {
        ++i;
    }
    //cout << i << '\n';
    if (i == n) return true;
    if (type[a[i]] == 3) return false;
    while (i < n && type[a[i]] == 2 && i < n) {
        ++i;
    }
    //cout << i << '\n';



    if (i == n) return true;
    if (type[a[i]] != 3) return false;
    while (i < n && type[a[i]] == 3 && i < n) {
        ++i;
    }
    if (i == n) return true;
    return false;
}

void solve()
{
    int n;
    cin >> n;

    for (int i = 1; i <= n; ++i) {
        string s1, s2;
        cin >> s1 >> s2;
        types[get_type(s1, s2)].push_back(i);
        type[i] = get_type(s1, s2);
    }

    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
    }

    if (types[0].size() > 1) {
        cout << -1;
        return;
    }

    if (types[2].size() > 1) {
        cout << -1;
        return;
    }
    int st, ut;
    if (types[0].size() >= 1)
        st = types[0][0];
    else st = 100001;
    if (types[2].size() >= 1)
        ut = types[2][0];
    else ut = 100001;

    //set_true -> unset
    if (st != 100001 && ut != 100001)
    for (auto v : g[st]) {
        if (type[v] == 3) {
            g[ut].push_back(v);
        }
    }

    //set_false -> unset
    if (ut != 100001)
    for (auto now : types[1]) {
        for (auto v : g[now]) {
            if (type[v] == 3) {
                g[ut].push_back(v);
            }
        }
    }

    //unset_false -> set
    if (st != 100001)
    for (auto now : types[3]) {
        for (auto v : g[now]) {
            if (type[v] == 1) {
                g[now].push_back(st);
            }
        }
    }

    //set_true -> unset_true
    if (st != 100001 && ut != 100001)
    g[st].push_back(ut);

    //set_true -> set_false
    if (st != 100001)
    for (auto now : types[1]) {
        g[st].push_back(now);
    }

    //set_false -> unset_true
    if (ut != 100001)
    for (auto now : types[1]) {
        g[now].push_back(ut);
    }
   // for (int i = 1; i <= n; ++i) {
    //   if (used[i] == 0 && type[i] != 3) dfs(i);
    //}
    for (int i = 1; i <= n; ++i) {
        flag = 0;
        //if (used[i] == 0) dfs2(i);
        //if (flag == 0 /*&& used2[i] == 0*/) {
        //    dfs3(i);
        //} else {
        if (used[i] == 0)
            dfs(i);
        //}
        //flag = 0;
    }
    //for (auto now : pref) {
   //     cout << now << ' ';
    //}
    reverse (topp.begin(), topp.end());
    if (!is_correct(topp)) {
        cout << -1;
        return;
    }

    for (auto now : topp) {
        cout << now << ' ';
    }
    cout << '\n';
}

int main() {
    cin.tie(nullptr); cout.tie(nullptr);
    ios_base::sync_with_stdio(0);
    cout.precision(10);

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}
