#include <bits/stdc++.h>

#define ll long long
#define pl pair<ll,ll>
#define vl vector<ll>
#define vvl vector<vl>
#define all(a) a.begin(), a.end()

using namespace std;

const int N = 200500;

string ans[3] {"None", "Unique", "Multiple"};

vector<pl> transes {
    {3, 3},
    // {3, 3},
    {1, 1},
    {2, 2},
    {3, 0},
    {0, 0},
    // {0, 3},
};

void solve() {
    ll n; cin >> n;
    vvl dp(n+2, vl(4, 0));

    vector<string> field(2);
    for (string &i : field) cin >> i, i += '#';


    auto canMask = [&field, &n](int i, int mask) -> ll {
        ll bit0 = field[0][i] == '#';
        ll bit1 = field[1][i] == '#';
        ll bits = bit0 | bit1 << 1;
        return (bits & mask) == 0;
    };

    auto getMask = [&field, &n](int j) -> ll {
        ll bit0 = (field[0][j] == '#');
        ll bit1 = (field[1][j] == '#');
        // cerr << j << ' ' << field[0][j] << ' ' << field[1][j] << bit0 << ' ' << bit1 << endl;
        ll bits = bit0 | (bit1 << 1);
        return bits;
    };

    dp[0][3] = 1;
    for (ll i = 0; i <= n; i++) {
        for (ll mask = 0; mask < 4; mask++) dp[i][mask] = min(2ll, dp[i][mask]);
        // for (ll mask = 0; mask < 4; mask++) cerr << i << ' ' << mask << " -> " << dp[i][mask] << '\n';
        for (ll mask = 0; mask < 4; mask++) {
            for (auto [mask0, mask1] : transes) {
                if (mask0 & mask) continue;
                if ((mask0 | mask) != 3) continue;
                if (!canMask(i, mask1)) continue;
                if (i == 0 && mask == 3) {
                    // cerr << "DEBUG: " << getMask(i) << ' ' << field[0][i] << ' ' << field[1][i] << ' ' << mask1 << '\n';
                }
                // cerr << i << ' ' << mask << " -> " << dp[i][mask] << '\n';
                dp[i+1][getMask(i) | mask1] += dp[i][mask];
            }
            
            // // Hor Hor
            // dp[i][mask] = min(2ll, dp[i][mask]);
            // if (mask == 0 && canHor(0, i) && canHor(1, i)) {
            //     dp[i+1][3] += 1;
            // }

            // // Ver Ver
            // if (mask == 0 && canVer(0, i) && canVer(0, i+1)) {
            //     dp[i+1][3] += 1;
            // }

            // // Ver
            // if (mask == 0 && canVer(0, i) && canVer(0, i+1)) {
            //     dp[i+1][3] += 1;
            // }
        }
    }

    // cerr << accumulate(all(dp[n+1]), 0ll) << endl;
    cout << ans[min(2ll, accumulate(all(dp[n+1]), 0ll))] << '\n';
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--) solve();
}