#include <bits/stdc++.h>

#define ll long long
#define pl pair<ll,ll>
#define vl vector<ll>
#define all(a) a.begin(), a.end()

using namespace std;

void solve() {
    ll n; cin >> n;
    ll m; cin >> m;
    ll q; cin >> q;

    vector<pl> hws(n);
    for (auto &[d, a] : hws) cin >> a;
    for (auto &[d, a] : hws) cin >> d;
    
    
    sort(all(hws));
    auto copy_hws = hws;
    for (ll i = 1; i < n; i++) hws[i].second += hws[i-1].second;

    vector<ll> ds(n);
    for (ll i = 0; i < n; i++) {
        ds[i] = hws[i].first - hws[i].second;
    }
    vl suff(n, ds[n-1]);
    for (ll i = n-2; i >= 0; i--) suff[i] = min(suff[i+1], ds[i]);
    
    vl serials(m);
    for (auto &i : serials) cin >> i;


    // for (ll i : suff) cout << i << '\n';
    vl timings;
    {
        ll i = 0;
        ll j = 0;
        ll curt = 0, shift = 0;

        while (i < n && j < m) {
            // cerr << i << ' ' << j << ' ' << serials[j] << ' ' << suff[i] << ' ' << shift << ' ' << curt << '\n';
            if (shift + serials[j] <= suff[i]) {
                shift += serials[j];
                curt += serials[j];
                timings.push_back(curt);
                j++;
            }
            else {
                curt += copy_hws[i].second;
                i++;
            }
        }

        while (j < m) {
            shift += serials[j];
            curt += serials[j];
            timings.push_back(curt);
            j++;
        }
    }

    // for (ll i : timings) cerr << i << ' '; cerr << '\n';

    while (q--) {
        ll x; cin >> x;
        cout << distance(timings.begin(), upper_bound(all(timings), x)) << ' ';
    }

    cout << '\n';
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--) solve();
}