#include <iostream>
#include <iomanip>
#include <chrono>
#include <string>
#include <vector>
#include <stdio.h>
#define ff first
#define ss second

using namespace std;
using ll = long long;
using pii = pair<int, int>;



void test_case() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<pii> ans(0);
    vector<int> p(n);
    for (int i = 0; i < n; i++) {
        p[i] = i + 1;
    }
    for (int i = 0; i < n; i++) {
        int v = a[i];
        int j = i;
        while (p[j] != v) j++;
        while (j < n - 1) {
            ans.emplace_back(p[j + 1], p[j]);
            swap(p[j], p[j + 1]);
            j++;
        }
        while (j > i) {
            ans.emplace_back(p[j], p[j - 1]);
            swap(p[j - 1], p[j]);
            j--;
        }
    }

    cout << ans.size() << endl;
    for (pii i : ans) cout << i.ff << " " << i.ss << endl;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int t = 1;
    //cin >> t;

    while (t--) {
        test_case();
    }
#ifdef LOCAL
    fprintf(stdout, "\n>>Runtime: %.3f ms\n", (double) (clock() - tStart) / CLOCKS_PER_SEC * 1000);
#endif
    return 0;
}
