#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pr;

#define all(v) v.begin(), v.end()

mt19937_64 rnd(228);


void solve() {
    ll n;
    cin >> n;

    vector<ll> a(n);
    vector<ll> pos(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
        pos[a[i]] = i;
    }

    vector<ll> p(n);
    iota(all(p),0);

    sort(all(p),[&](ll x,ll y){
        return pos[x] < pos[y];
    });

    vector<ll> cur(n);
    vector<pr> ans;
    iota(all(cur),0);
    for(auto &v : p){
        ll position = 0;
        for (int i = 0; i < n; ++i) {
            if(cur[i] == v){
                position = i;
                break;
            }
        }

        for (int i = position; i < n-1; ++i) {
            ans.push_back({cur[i+1],cur[i]});
            swap(cur[i],cur[i+1]);
        }
        for (int i = n-1; i > pos[v]; --i) {
            ans.push_back({cur[i],cur[i-1]});

            swap(cur[i],cur[i-1]);
        }
    }

    cout << ans.size() << "\n";
    for(auto &[f,s] : ans){
        cout << f + 1 << " " << s + 1 << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0),cin.tie(0),cout.tie(0);

    int t = 1;
//    cin >> t;

    for (int i = 0; i != t; ++i) {
        solve();
    }

    return 0;
}