def calc(v):
    ans = 0
    x = 1
    cur = 0
    for c in v:
        if c == '-':
            ans += cur * x
            x = -1
            cur = 0
            continue
        if c == '+':
            ans += cur * x
            x = 1
            cur = 0
            continue
        cur = cur * 10 + ord(c) - ord('0')
    ans += cur * x
    return ans

def check(s):
    cnt = 0
    for i in range(len(s)):
        if s[i].isalnum():
            cnt += 1
            if cnt > 10:
                return False
        else:
            cnt = 0
    return True

def solve():
    s = input().strip()
    a, b = s.split('=')
    x, y = calc(a), calc(b)
    if calc(a) == calc(b):
        return 'Correct'

    for i in range(len(s)):
        if s[i].isalnum():
            if i + 1 < len(s):
                if s[i + 1] == '0' and (not s[i - 1].isalnum() or i - 1 == -1):
                    continue
            newstoadd = s[:i] + s[i + 1:]
            for j in range(len(s)):
                if not ((j == 0 or not newstoadd[j - 1].isalnum()) and s[i] == '0') or s[i] != '0':
                    news = newstoadd[:j] + s[i] + newstoadd[j:]
                    if check(news):
                        newa, newb = news.split('=')
                        if calc(newa) == calc(newb):
                            return news

    return 'Impossible'


print(solve())
