#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define show(x) cout << "[debug " << __LINE__ << "] " << x << endl
#else
#define show(x) ((void)0)
#endif

void solve() {
    int n;
    cin >> n;

    vector<string> s(2);
    cin >> s[0] >> s[1];

    bool not_unique = false;
    bool ok = true;

    int i = 0;

    for (; i < n - 1; i++) {
        if (s[0][i] == '.' && s[1][i] == '.' && s[0][i + 1] == '.' && s[1][i + 1] == '.') {
            not_unique = true;
            i++;
        } else if (s[0][i] == '.' && s[1][i] == '.') {
            // pass
        } else if (s[0][i] == '.' && s[0][i + 1] == '.') {
            s[0][i] = s[0][i + 1] = '#';
        } else if (s[1][i] == '.' && s[1][i + 1] == '.') {
            s[1][i] = s[1][i + 1] = '#';
        } else if (s[0][i] == '#' && s[1][i] == '#') {
            // pass
        } else {
            show(i);
            ok = false;
            break;
        }
    }

    if (!ok) {
        cout << "None\n";
        return;
    }

    if (i == n - 1) {
        ok = (s[0][i] == '.' && s[1][i] == '.') || (s[0][i] == '#' && s[1][i] == '#');
    }

    if (ok && not_unique) {
        cout << "Multiple\n";
    } else if (ok) {
        cout << "Unique\n";
    } else {
        cout << "None\n";
    }

}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n);
    vector<pair<int, int>> cur(n);
    for (int &x: a) cin >> x;
    for (int i = 0; i < n; i++) {
        cur[a[i] - 1] = {a[i] - 1, i};
    }
    vector<pair<int, int>> res;
    for (int i = 0; i < n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            res.push_back({cur[j + 1].first, cur[j].first});
            swap(cur[j], cur[j + 1]);
        }
        int p = 1;
        while (p <= i) {
            if (cur[p - 1].second > cur[p].second) {
                res.push_back({cur[p].first, cur[p - 1].first});
                swap(cur[p], cur[p - 1]);
            }
            p += 1;
        }
    }
    cout << res.size() << endl;
    for (auto it: res) {
        cout << it.first + 1 << ' ' << it.second + 1 << endl;
    }

    return 0;
}
