#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define show(x) cout << "[debug " << __LINE__ << "] " << ' ' << x << endl
#else
#define show(x) ((void)0)
#endif

void print(int x) {
    char q[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};
    array<char, 4> w;
    for (int i = 0; i < 4; i++) {
        w[i] = (q[x % 16]);
        x /= 16;
    }

    reverse(w.begin(), w.end());
    for (auto r: w) {
        cout << r;
    }

}

int l[(1 << 12) + 5];

void emulate(int x) {
    vector<int> d(1 << 12);
    for (int i = 0; i < d.size(); i++) {
        d[i] = l[i];
    }

    d[(1 << 12) - 1] = x;

    int ip = 0;

    while (ip < ((1 << 12) - 2)) {
        auto from = d[ip] >> 4;
        auto at = (d[ip] & 15);

        auto to = d[ip + 1] >> 4;
        auto to_at = (d[ip + 1] & 15);

        if (d[from] & (1 << at)) {
            d[to] |= (1 << to_at);
        } else if (d[to] & (1 << to_at)) {
            d[to] ^= (1 << to_at);
        }

        ip = d[ip + 2];
//        show(from << " " << at << " " << to << " " << to_at << " " << ip);
    }

    cout << d[(1 << 12) - 1] << " " << (d[(1 << 12) - 1] & 1) << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int x;
    cin >> x;

    auto IO = (1 << 12) - 1;

    auto build = [&](auto ptr, auto bit) {
        return (ptr << 4) | bit;
    };

    for (int i = 0; i < 16; i++) {
        l[16 * i] = build(IO, i);
        l[16 * i + 1] = build(16 * i + 2, 2);
        l[16 * i + 2] = 16 * i + 8;

        if ((x & (1 << i))) {

            l[16 * i + 8] = build(IO - 1, 0);
            l[16 * i + 9] = build(IO, 0);
            l[16 * i + 10] = IO;

            l[16 * i + 12] = build(0, 0);
            l[16 * i + 13] = build(0, 0);
            l[16 * i + 14] = 16 * (i + 1);
        } else {


            l[16 * i + 8] = build(0, 0);
            l[16 * i + 9] = build(0, 0);
            l[16 * i + 10] = 16 * (i + 1);

            l[16 * i + 12] = build(IO - 1, 0);
            l[16 * i + 13] = build(IO, 0);
            l[16 * i + 14] = IO;
        }
    }

    l[16 * 16] = build(16 * 16 + 3, 0);
    l[16 * 16 + 1] = build(IO, 0);
    l[16 * 16 + 2] = IO;
    l[16 * 16 + 3] = 0xffff;

//    emulate(0);
//    emulate(1);
//    emulate(1331);
//    emulate(228);
//    emulate(229);
//    emulate(1337);
//    emulate(65535);

    for (int i = 0; i < 512; i++) {
        print(l[i]);
        cout << " ";
    }

    return 0;
}
