// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//
#include <vector>
#include <iostream>
#include <algorithm>
#define ll long long
using namespace std;

struct HW {
	ll d;
	ll t;
	ll r;

};

int main()
{
	int t;
	cin >> t;
	while (t--) {
		ll n, m, q;
		cin >> n >> m >> q;
		vector<HW> hw(n); //deadline, time
		for (int i = 0; i < n; ++i) {
			cin >> hw[i].t;
		}
		for (int i = 0; i < n; ++i) {
			cin >> hw[i].d;
		}
		vector<ll> ep(m);
		for (int i = 0; i < m; ++i) {
			cin >> ep[i];
		}
		vector<ll> call(q);
		for (int i = 0; i < q; ++i) {
			cin >> call[i];
		}

		sort(hw.begin(), hw.end(), [](HW& l, HW& m) { return l.d < m.d || (l.d == m.d && l.t < m.t); });

		for (int i = 1; i < n; ++i) {
			hw[i].t = hw[i - 1].t + hw[i].t;
		}

		for (int i = 0; i < n; ++i) {
			hw[i].r = hw[i].d - hw[i].t;
		}

		ll mn = hw[n - 1].r;
		vector<ll> r(n);
		r[n - 1] = hw[n - 1].r;
		for (int i = n - 2; i >= 0; --i) {
			mn = min(hw[i].r, hw[i + 1].r);
			hw[i].r = mn;
			r[i] = mn;
		}

		ll sum = 0;
		vector<ll> ans;
		
		for (int i = 0; i < m; ++i) {
			auto x = lower_bound(r.begin(), r.end(), ep[i] + sum);
			if (x != r.begin()) {
				--x;
				int idx = x - r.begin();
				ans.push_back(hw[idx].t + ep[i] + sum);
			}
			else {
				ans.push_back(ep[i] + sum);
			}
			
			sum += ep[i];
		}

		for (int i = 0; i < q; ++i) {
			auto x = upper_bound(ans.begin(), ans.end(), call[i]);
			cout << x - ans.begin() << " ";
		}	

	}
}

