#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <stdlib.h>
#include <stdio.h>

//#define int long long
#define ll long long

using namespace std;

void solve() {
    ll n, m, q;
    cin >> n >> m >> q;

    vector<ll> a(n);
    vector<ll> d(n);
    vector<ll> l(m);
    vector<ll> t(q);

    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    for(int i = 0; i < n; i++){
        cin >> d[i];
    }
    for(int i = 0; i < m; i++){
        cin >> l[i];
    }
    for(int i = 0; i < q; i++){
        cin >> t[i];
    }

    vector<pair<ll, ll>> work;
    for(int i = 0; i < n; i++){
        work.push_back({d[i], a[i]});
    }

    sort(work.begin(), work.end());

    vector<pair<ll, ll>> segments;
    ll right = 1e18;
    for(ll i = n-1; i >= 0; i--){
        ll r = min(right, work[i].first);
        segments.push_back({r - work[i].second + 1, r});
        right = r - work[i].second;
    }

    sort(segments.begin(), segments.end());

    ll ptr = 0;
    ll total = 0;
    vector<pair<ll, ll>> res;
    res.push_back({0, 0});
    ll curr = segments[0].first - 1;
    ll sum = 0;
    while(ptr < m && curr >= l[ptr]){
        curr -= l[ptr];
        sum += l[ptr];
        total++;
        res.push_back({ sum, total}); // +1?
        ptr++;
    }
    if(1 < n){
        segments[1].first -= curr;
        segments[1].second -= curr;
    }
    for(int i = 1; i < n; i++){
        curr = segments[i].first - segments[i-1].second - 1;
        sum = 0;
        while(ptr < m && curr >= l[ptr]){
            curr -= l[ptr];
            sum += l[ptr];
            total++;
            res.push_back({ segments[i-1].second + sum, total});
            ptr++;
        }
        segments[i].first -= curr;
        segments[i].second -= curr;
    }

    sum = 0;
    while(ptr < m){
        curr -= l[ptr];
        sum += l[ptr];
        total++;
        res.push_back({ segments[n-1].second + sum, total});
        ptr++;
    }

    for(int i = 0; i < q; i++){
        ll l1 = 0;
        ll r1 = res.size();
        while(r1 > l1+1){
            ll m1 = (l1+r1)/2;
            if(res[m1].first <= t[i]){
                l1 = m1;
            }else{
                r1 = m1;
            }
        }

        cout << res[l1].second << " ";
    }

    cout << "\n";
}

int main() {
    std:ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    for(int i = 0; i < t; i++){
        solve();
    }
    return 0;
}
