#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <numeric>
#include <set>
#include <string>
#include <map>

using namespace std;

#define int long long
#define all(a) begin(a), end(a)
#define vi vector<int>
#define ve vector
#define pii pair<int,int>
#define rep(i, n) for(int i = 0; i < (n); i++)

void fast() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cout << fixed; cout.precision(10);
}

constexpr int N = 2e5;

string s[N];
vi g[N];
int cnt[N];

void solve() {
    queue<string> q;
    q.push("unset false");
    q.push("set true");
    q.push("set false");
    q.push("unset true");
    q.push("unset false");
    queue<int> qv;
    qv.push(0);
    qv.push(0);
    qv.push(1);
    qv.push(1);
    qv.push(0);
    queue<int> qn;
    qn.push(0);
    qn.push(1);
    qn.push(1);
    qn.push(0);
    qn.push(0);
    map<string, queue<int>> qs;
    int n;
    cin >> n;
    rep(i, n) {
        string a, b;
        cin >> a >> b;
        a = a + " " + b;
        s[i] = a;
    }
    int m;
    cin >> m;
    rep(_, m) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        g[a].push_back(b);
        cnt[b]++;
    }
    rep(i, n) {
        if (cnt[i] == 0) {
            qs[s[i]].push(i);
        }
    }
    vi ans;
    int curReg = 0;
    while (q.size()) {
        string c = q.front();
        q.pop();
        int cv = qv.front();
        qv.pop();
        int wv = qn.front();
        qn.pop();
        auto &qc = qs[c];
        while(qc.size()) {
            if (curReg != cv) {
                cout << "-1\n";
                return;
            }
            int x = qc.front();
            qc.pop();
            ans.push_back(x);
            for (int y : g[x]) {
                cnt[y]--;
                if (cnt[y] == 0) {
                    qs[s[y]].push(y);
                }
            }
            curReg = wv;
        }
    }
    if (ans.size() != n) {
        cout << "-1\n";
        return;
    }
    rep(i, n) {
        cout << ans[i] + 1 << " ";
    }
}

signed main() {
    fast();
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}