#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <numeric>
#include <set>
#include <string>
#include <map>

using namespace std;

#define int long long
#define all(a) begin(a), end(a)
#define vi vector<int>
#define ve vector
#define pii pair<int,int>

void fast() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cout << fixed; cout.precision(10);
}
constexpr int N = 2e5 + 20;
int n;
vector<string> a;
int dp[4][N];

int getans(int mask, int pos) {
    if (pos == n && mask == 3) return 1;
    if (pos == n && mask != 3) return 0;
    int& ans = dp[mask][pos];
    if (ans != -1) return ans;
    ans = 0;
    int x = 0;
    int y = 0;
    if (a[0][pos] == '#') {
        x = 1;
    }
    if (a[1][pos] == '#') {
        y = 2;
    }
    if (mask == 0) {
        if (a[0][pos] == '.' && a[1][pos] == '.') {
            ans += getans(3, pos + 1);
        }
    }
    if (mask == 1) {
        if (a[1][pos] == '.') {
            ans += getans(2 | x, pos + 1);
        }
    }
    if (mask == 2) {
        if (a[0][pos] == '.') {
            ans += getans(1 | y, pos + 1);
        }
    }
    if (mask == 3) {
        ans += getans(x | y, pos + 1);
        if (a[0][pos] == '.' && a[1][pos] == '.') {
            ans += getans(3, pos + 1);
        }
    }
    if (ans > 1) ans = 2;
    return ans;
}

void solve() {
    cin >> n;
    a.clear();
    a.resize(2);
    cin >> a[0] >> a[1];
    for (int i = 0; i < n + 10; i++) {
        dp[0][i] = dp[1][i] = dp[2][i] = dp[3][i] = -1;
    }
    int ans = getans(3, 0);
    if (ans == 0) {
        cout << "None\n";
    }
    else if(ans == 1) {
        cout << "Unique\n";
    }
    else {
        cout << "Multiple\n";
    }
}

signed main() {
    fast();
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}