#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int N = 1e5 + 7;

#define int long long
const int INF = 1e18;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<pair<int, int>> vecs(n);
    for (int i = 0; i < n; ++i) {
        cin >> vecs[i].second;
    }for (int i = 0; i < n; ++i) {
        cin >> vecs[i].first;
    }
    sort(vecs.begin(), vecs.end());
    vector<int> pref_dedl(n + 2), suff_dedl(n + 2);
    for (int i = 1; i <= n; ++i) {
        pref_dedl[i] = pref_dedl[i - 1] + vecs[i - 1].second;
    }
    suff_dedl[n + 1] = 1e18;
    suff_dedl[n] = vecs[n - 1].first - vecs[n - 1].second;
    for (int i = n - 1; i >= 1; --i) {
        suff_dedl[i] = min(suff_dedl[i + 1], vecs[i - 1].first) - vecs[i - 1].second;
    }
    vector<int> pref(m + 2);
    for (int i = 1; i <= m; ++i) {
        cin >> pref[i];
        pref[i] += pref[i - 1];
    }
    pref[m + 1] = INF;
    for (int tt = 0; tt < q; ++tt) {
        int t;
        cin >> t;
        int ind1 = lower_bound(vecs.begin(), vecs.end(), make_pair(t, 0LL)) - vecs.begin();
        int fre = min(suff_dedl[ind1 + 1], t) - pref_dedl[ind1];
        int ind2 = upper_bound(pref.begin(), pref.end(), fre) - 1 - pref.begin();
        cout << ind2 << " ";
    }
    cout << endl;
}

signed main() {
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}



