#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(x) (x).begin(), (x).end()
#define int long long
bool validate(string s) {
    int n = s.size();
    for (int i = 0; i < n; i++) {
        if (s[i] == '0') {
            if (i + 1 < n && '0' <= s[i + 1] && s[i + 1] <= '9') {
                return false;
            }
        }
    }
    return true;
}

struct comp {
    static bool operator() (pair<int,int> i1, pair<int, int> i2) {
        if (i1.second - i1.first != i2.second - i2.first) {
                return i1.second - i1.first < i2.second - i2.first;
            }
            if (i2.second != i1.second) {
                return i1.second < i2.second;
            }
            return i1.first > i2.first;
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef ON_PC
        freopen("input.txt", "r", stdin);
    #endif
    vector<int> ans;
    vector<bool> used;
    int T = 1;
    cin >> T;
    while (T--) {
        int n;
        cin >> n;
        int m;
        cin >> m;
        int q;
        cin >> q;
        vector<int> a(n);
        vector<int> d(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        for (int i = 0; i < n; i++)  {
            cin >> d[i];
        }
        vector<int> l(m);
        for (int i = 0; i < m; i++) {
            cin >> l[i];
        }
        vector<int> ans;
        set<pair<int, int>, comp> st;
        vector<int> ord(n);
        iota(ord.begin(), ord.end(), 0);
        sort(ord.begin(), ord.end(), [&](int i, int j) { 
            return comp::operator()({a[i], d[i]}, {a[j], d[j]});
        });
        int pref_sum = 0;
        multiset<pair<int, int> > s;
        for (int i = 0; i < ord.size(); i++) {
            pref_sum += a[ord[i]];
            s.insert({d[ord[i]] - pref_sum, ord[i]});
        }
        int cur_anime = 0;
        int cur_time = 0;
        int to_add = 0;
        while (s.size() != 0 || cur_anime != l.size()) {
            if (s.size() == 0) {
                ans.push_back(cur_time + l[cur_anime]);
                cur_time += l[cur_anime];
                cur_anime++;
            } else {
                if ((*s.begin()).first >= l[cur_anime] + to_add) {
                    ans.push_back(l[cur_anime] + cur_time);
                    to_add += l[cur_anime];
                    cur_time += l[cur_anime];
                    cur_anime++;
                } else {
                    cur_time += a[(*s.begin()).second];
                    s.erase(s.begin());
                }
            }
        }
        for (int i = 0; i < q; i++) {
            int t;
            cin >> t;
            auto it = upper_bound(ans.begin(), ans.end(), t);
            if (it == ans.end()) {
                cout << m << ' ';
            } else {
                cout << it - ans.begin() << ' ';
            }
        }
        cout << endl;
    } 
}
