#include <bits/stdc++.h>
using namespace std;

using ll = long long;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;

    vector<ll> a(n);
    vector<ll> d(n);
    vector<ll> l(m);

    for (ll &i : a) {
        cin >> i;
    }

    for (ll &i : d) {
        cin >> i;
    }

    for (ll &i : l) {
        cin >> i;
    }

    vector<int> ind(n);
    iota(ind.begin(), ind.end(), 0);

    sort(ind.begin(), ind.end(), [&d](int i, int j) {
        return d[i] < d[j];
    });

    ll time = 0;
    vector<ll> delta_to_deadline(n);
    for (int j = 0; j < n; j++) {
        int i = ind[j];

        time += a[i];
        delta_to_deadline[j] = d[i] - time;
    }

    vector<ll> suf_min(n);
    suf_min[n - 1] = delta_to_deadline[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        suf_min[i] = min(suf_min[i + 1], delta_to_deadline[i]);
    }

    vector<ll> end_time(m);

    int cur_i = 0;
    ll sm_delta = 0, pref_sum = 0;
    for (int k = 0; k < m; k++) {
        while (cur_i < n && suf_min[cur_i] - sm_delta < l[k]) {
            pref_sum += a[ind[cur_i]];
            cur_i++;
        }

        sm_delta += l[k];
        end_time[k] = pref_sum + sm_delta;
    }

    while (q--) {
        int t;
        cin >> t;

        size_t ind = upper_bound(end_time.begin(), end_time.end(), t) - end_time.begin();
        cout << ind << " ";
    }

    cout << "\n";
}

int32_t main() {
    int t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}
