#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>

#define int long long
// #define double long double

using namespace std;

void solve() {
	int n;
	cin >> n;
	vector<int> c(n);

	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		x--;

		c[x] = i;
    }

	vector<int> st(n);
	for (int i = 0; i < n; i++)
		st[i] = i;

	vector<pair<int, int>> ans;
	for (int i = 0; i < n; i++) {
		int cur = n - 1;
		for (int j = n - 2; j >= 0; j--) {
			if (st[cur] > st[j] || c[st[cur]] < c[st[j]]) {
				ans.push_back({ st[cur], st[j] });
				swap(st[cur], st[j]);
				cur = j;
			}
			else {
				break;
			}
		}
	}

	cout << ans.size() << '\n';
	for (auto p : ans) {
		cout << p.first + 1 << ' ' << p.second + 1 << '\n';
	}
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif

	int t = 1;
	while (t--) {
		solve();
	}

	return 0;
}