#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>

#define int long long
// #define double long double 

using namespace std;

void solve() {
	int n;
	cin >> n;

	string f, s;
	cin >> f >> s;

	bool unq = true;
	for (int i = 0; i < n - 1; i++) {
		if (f[i] == '#' && s[i] == '#') {
			continue;
		}

		if (f[i] == '#') {
			if (s[i + 1] == '.') {
				s[i + 1] = s[i] = '#';
				continue;
			}
			cout << "None\n";
			return;
		}

		if (s[i] == '#') {
			if (f[i + 1] == '.') {
				f[i + 1] = f[i] = '#';
				continue;
			}
			cout << "None\n";
			return;
		}

		if (f[i + 1] == '#' || s[i + 1] == '#') {
			f[i] = s[i] = '#';
			continue;
		}

		unq = false;
		f[i] = s[i] = '#';
	}

	if (s[n - 1] != f[n - 1]) {
		cout << "None\n";
	}
	else if (unq) {
		cout << "Unique\n";
	}
	else {
		cout << "Multiple\n";
	}
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}