#include<iostream>
#include<vector>
#include<cassert>

using namespace std;

void solve() {
	int n; cin >> n;
	string s1, s2;
	cin >> s1 >> s2;
	for (int i = 0; i < n; i++) {
		if (s1[i] == s2[i]) continue;
		if (s1[i] == '#') {
			s2[i] = '#';
			if (i == n - 1 || s2[i + 1] == '#') {
				cout << "None\n";
				return;
			}
			s2[i + 1] = '#';
		}
		else {
			s1[i] = '#';
			if (i == n - 1 || s1[i + 1] == '#') {
				cout << "None\n";
				return;
			}
			s1[i + 1] = '#';
		}
	}
	for (int i = 0; i < n; i++) {
		if (s1[i] != s2[i]) {
			cout << "None\n";
			return;
		}
		if (i < n - 1) {
			if (s1[i] == '.' && s1[i + 1] == '.' && s2[i + 1] == '.') {
				cout << "Multiple\n";
				return;
			}
		}
	}
	cout << "Unique\n";
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t;
	t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}