
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;
using ll = long long;
void solve() {
	ll n, m, q;
	cin >> n >> m >> q;
	vector<ll> hardness;
	vector<ll> time_to_solve;
	for (size_t i = 0; i < n; i++)
	{
		ll x;
		cin >> x;
		hardness.push_back(x);
	}
	for (size_t i = 0; i < n; i++)
	{
		ll x;
		cin >> x;
		time_to_solve.push_back(x);
	}
	//vector<pair<ll, ll>> tasks;
	map<ll, ll> tasks;
	for (size_t i = 0; i < n; i++)
	{
		//tasks.push_back({ time_to_solve[i], hardness[i] });
		tasks[time_to_solve[i]] += hardness[i];
	}
	//sort(tasks.begin(), tasks.end());
	hardness.clear();
	time_to_solve.clear();
	for (auto z : tasks) {
		hardness.push_back(z.second);
		time_to_solve.push_back(z.first);
	}

	// input serial
	vector<ll> serial_lenght;
	for (size_t i = 0; i < m; i++)
	{
		ll x;
		cin >> x;
		serial_lenght.push_back(x);
	}
	
	

	// pref sum for quick ask
	vector<long long> pref;
	pref.push_back(0);
	for (size_t i = 0; i < hardness.size(); i++)
	{
		pref.push_back(pref.back() + hardness[i]);
	}
	vector<ll> serial_pref(1);
	for (size_t i = 0; i < serial_lenght.size(); i++)
	{
		serial_pref.push_back(serial_pref.back() + serial_lenght[i]);
	}

	// free time

	vector <ll> free_times(n);
	free_times[n - 1] = time_to_solve.back() - pref.back();
	for (int i = n  - 2; i >= 0; i--)
	{
		free_times[i] = min(time_to_solve[i] - pref[i + 1], free_times[i+1]);
	}
	//qustion
	vector<ll>answer;
	for (size_t i = 0; i < q; i++)
	{
		ll call_time;
		cin >> call_time;
		ll positione = lower_bound(time_to_solve.begin(), time_to_solve.end(), call_time) - time_to_solve.begin();
		ll free_time = call_time;
		if (positione < time_to_solve.size()) {
			free_time = min(free_time, free_times[positione]);
		}
		else {
			free_time -= pref[lower_bound(time_to_solve.begin(), time_to_solve.end(), call_time) - time_to_solve.begin()];
		}
		//call_time;
		//lower_bound(time_to_solve.begin(), time_to_solve.end(), call_time);
		//cout << lower_bound(time_to_solve.begin(), time_to_solve.end(), call_time) - time_to_solve.begin();
		//
		ll count = lower_bound(serial_pref.begin(), serial_pref.end(), free_time) - serial_pref.begin();
		answer.push_back( min(count,(ll) serial_lenght.size()));
		//cout << answer.back()<<endl;
		//cout << serial_pref.end() - serial_pref.begin();
	}
	for (size_t i = 0; i < answer.size(); i++)
	{
		cout << answer[i] << ' ';
	}cout << endl;	
}

int main()
{
	int t;
	cin >> t;
	for (size_t i = 0; i < t; i++)
	{
		solve();
	}
}
/*
2
1 2 3
10
15
5 5
5 15 20



3 4 5
8 100 8
10 150 20
2 32 1 1
9 200 51 50 10



*/