#include <bits/stdc++.h>

using namespace std;
#define ll long long

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        string s1, s2;
        cin >> s1 >> s2;
        vector<set<int>> g(2 * n);
        set<pair<int, int>> free;
        for (int i = 0; i < n; ++i) {
            if (s1[i] != '.') continue;
            if (i > 0 && s1[i - 1] == '.') {
                g[i].insert(i - 1);
            }
            if (i + 1 < n && s1[i + 1] == '.') {
                g[i].insert(i + 1);
            }
            if (s2[i] == '.') {
                g[i].insert(i + n);
            }
            free.insert({g[i].size(), i});
        }

        for (int i = 0; i < n; ++i) {
            if (s2[i] != '.') continue;
            if (i > 0 && s2[i - 1] == '.') {
                g[i + n].insert(i + n - 1);
            }
            if (i + 1 < n && s2[i + 1] == '.') {
                g[i + n].insert(i + n + 1);
            }
            if (s1[i] == '.') {
                g[i + n].insert(i);
            }
            free.insert({g[i + n].size(), i + n});
        }

        if (free.size() % 2 == 1) {
            cout << "None\n";
            continue;
        }
        bool ok = true;
        while (!free.empty()) {
            auto pr = *free.begin();
            if (pr.first == 0) {
                ok = false;
                cout << "None\n";
                break;
            }
            if (pr.first > 1) {
                ok = false;
                cout << "Multiple\n";
                break;
            }

            int v = pr.second;
            int u = *g[v].begin();
            free.erase(free.find(pr));
            free.erase(free.find({g[u].size(), u}));
            for (int q : g[u]) {
                if (q == v) continue;
                free.erase(free.find({g[q].size(), q}));
                g[q].erase(u);
                free.insert({g[q].size(), q});
            }
            g[u].clear();
            g[v].clear();
        }
        if (ok) {
            cout << "Unique\n";
        }
    }
}