

def solve(n: int, target_arr: list):
    ans = []
    positions = [0] * n
    for i, val in enumerate(target_arr):
        positions[val-1] = i

    for curr_number in range(1, n+1):
        i = positions[curr_number-1]
        while i < n-1:
            ans.append([target_arr[i], target_arr[i+1]])
            target_arr[i], target_arr[i+1] = target_arr[i+1], target_arr[i]
            i += 1
            positions[target_arr[i-1]-1] = i-1
            positions[target_arr[i]-1] = i

        while i > curr_number-1:
            ans.append([target_arr[i - 1], target_arr[i]])
            target_arr[i], target_arr[i - 1] = target_arr[i - 1], target_arr[i]
            i -= 1
            positions[target_arr[i + 1]-1] = i + 1
            positions[target_arr[i]-1] = i

    return ans

if __name__ == '__main__':
    n = int(input())
    arr = list(map(int, input().split()))
    ans = solve(n, arr)
    ans = ans[::-1]
    print(len(ans))
    for i in ans:
        print(*i)

