#include <bits/stdc++.h>

using namespace std;

#define pb push_back

typedef long long ll;

ll eval(string s, bool &ok) {
    int n = s.size();
    ll sum = 0;
    string cur = "";
    int sgn = 1;
    for (int i = 0; i < n; ++i) {
        if (s[i] >= '0' && s[i] <= '9') {
            cur.push_back(s[i]);
        } else {
            if (cur.empty() || (cur[0] == '0' && cur.size() > 1) || cur.size() > 10) {
                ok = 0;
                return 0;
            }
            sum += sgn * stoll(cur);
            sgn = s[i] == '-' ? -1 : 1;
            cur.clear();
        }
    }
    if (cur.empty() || (cur[0] == '0' && cur.size() > 1) || cur.size() > 10) {
        ok = 0;
        return 0;
    }
    sum += sgn * stoll(cur);
    return sum;
}

bool check(string s) {
    int n = s.size();
    int pos = 0;
    while (s[pos] != '=') {
        ++pos;
    }
    if (pos == 0 || pos == n - 1) return 0;
    bool ok = 1;
    ll a = eval(s.substr(0, pos), ok);
    ll b = eval(s.substr(pos + 1, n - pos - 1), ok);
//    cout << a << " " << b << " " << ok << endl;
    return a == b && ok;
}

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    string s;
    cin >> s;
    if (check(s)) {
        cout << "Correct\n";
        return 0;
    }
    int n = s.size();
    for (int i = 0; i < n; ++i) {
        if (s[i] < '0' || s[i] > '9') continue;
        auto t = s;
        t.erase(t.begin() + i);
        for (int j = 0; j < n; ++j) {
            auto u = t;
            u.insert(u.begin() + j, s[i]);
            if (check(u)) {
                cout << u << "\n";
                return 0;
            }
        }
    }
    cout << "Impossible\n";
    return 0;
}
