#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <bits/stdc++.h>
#define int long long

#define len(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define allr(a) a.rbegin(), a.rend()

using namespace std;

void solve(){
    int W,H;
    cin>>W>>H;
    int w[2],h[2],x[2],y[2],dx[2],dy[2];
    for(int i=0;i<2;i++) cin>>w[i]>>h[i]>>x[i]>>y[i]>>dx[i]>>dy[i];
    int x_init[2],y_init[2],dx_init[2],dy_init[2];
    for(int i=0;i<2;i++){
        x_init[i]=x[i];
        y_init[i]=y[i];
        dx_init[i]=dx[i];
        dy_init[i]=dy[i];
    }

    {
        vector <int> xx,yy;

        int cur_x[2],cur_y[2],cur_dx[2],cur_dy[2];
        for(int i=0;i<2;i++){
            cur_x[i]=x[i];
            cur_y[i]=y[i];
            cur_dx[i]=dx[i];
            cur_dy[i]=dy[i];
        }
        while(true){
            if(max(cur_x[0],cur_x[1])<=min(cur_x[0]+w[0]-1,cur_x[1]+w[1]-1)) xx.push_back(1);
            else xx.push_back(0);
            for(int i=0;i<2;i++){
                cur_x[i]+=cur_dx[i];
                if(cur_x[i]<0){
                    cur_x[i]+=2;
                    cur_dx[i]=-cur_dx[i];
                }
                if(cur_x[i]+w[i]-1>=W){
                    cur_x[i]-=2;
                    cur_dx[i]=-cur_dx[i];
                }
            }

            if(cur_x[0]==x_init[0] && cur_x[1]==x_init[1] && cur_dx[0]==dx_init[0] && cur_dx[1]==dx_init[1]) break;
        }

        while(true){
            if(max(cur_y[0],cur_y[1])<=min(cur_y[0]+h[0]-1,cur_y[1]+h[1]-1)) yy.push_back(1);
            else yy.push_back(0);
            for(int i=0;i<2;i++){
                cur_y[i]+=cur_dy[i];
                if(cur_y[i]<0){
                    cur_y[i]+=2;
                    cur_dy[i]=-cur_dy[i];
                }
                if(cur_y[i]+h[i]-1>=H){
                    cur_y[i]-=2;
                    cur_dy[i]=-cur_dy[i];
                }
            }

            if(cur_y[0]==y_init[0] && cur_y[1]==y_init[1] && cur_dy[0]==dy_init[0] && cur_dy[1]==dy_init[1]) break;
        }

        int A=(int)xx.size();
        int B=(int)yy.size();
        int G=__gcd(A,B);
        vector <int> cntX(G+1),cntY(G+1);
        for(int i=0;i<A;i++){
            if(xx[i]){
                cntX[i%G]++;
            }
        }
        for(int i=0;i<B;i++){
            if(yy[i]){
                cntY[i%G]++;
            }
        }
        int TOTAL=A/__gcd(A,B)*B;
        int NUM=0;
        for(int i=0;i<G;i++) NUM+=cntX[i]*cntY[i];
        int GG=__gcd(NUM,TOTAL);
        NUM/=GG;
        TOTAL/=GG;
        cout<<NUM<<"/"<<TOTAL<<'\n';
    }
}

void solve2(){
    int W,H;
    cin>>W>>H;
    int w[2],h[2],x[2],y[2],dx[2],dy[2];
    for(int i=0;i<2;i++) cin>>w[i]>>h[i]>>x[i]>>y[i]>>dx[i]>>dy[i];
    int x_init[2],y_init[2],dx_init[2],dy_init[2];
    for(int i=0;i<2;i++){
        x_init[i]=x[i];
        y_init[i]=y[i];
        dx_init[i]=dx[i];
        dy_init[i]=dy[i];
    }
    int A=0,B=0;
    while(true){
        int lx1=x[0],rx1=x[0]+w[0]-1;
        int lx2=x[1],rx2=x[1]+w[1]-1;
        int ly1=y[0],ry1=y[0]+h[0]-1;
        int ly2=y[1],ry2=y[1]+h[1]-1;
        if(max(lx1,lx2)<=min(rx1,rx2) && max(ly1,ly2)<=min(ry1,ry2)) A++;
        B++;

        for(int i=0;i<2;i++){
            x[i]+=dx[i];
            if(x[i]+w[i]-1>=W){
                x[i]-=2;
                dx[i]=-dx[i];
            }
            if(x[i]<0){
                x[i]+=2;
                dx[i]=-dx[i];
            }

            y[i]+=dy[i];
            if(y[i]+h[i]-1>=H){
                y[i]-=2;
                dy[i]=-dy[i];
            }
            if(y[i]<0){
                y[i]+=2;
                dy[i]=-dy[i];
            }
        }
        if(x[0]==x_init[0] && x[1]==x_init[1] && y[0]==y_init[0] && y[1]==y_init[1] &&
           dx[0]==dx_init[0] && dx[1]==dx_init[1] && dy[0]==dy_init[0] && dy[1]==dy_init[1]){
            break;
        }
    }
    int G=__gcd(A,B);
    cout<<A/G<<'/'<<B/G<<'\n';
}

int32_t main() {
#ifdef MY_DEBUG
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
#define pb push_back
    int tt;
    cin>>tt;
    while(tt--) solve();
}