#include <bits/stdc++.h>

using namespace std;
using ll = long long ;
using ull = unsigned long long;
using ld = long double;
struct triple{
    ll first, second, third;
    auto operator<=>(const triple&) const = default;
};

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;

using pll = pair<ll,ll>;
using vll = vector<pll>;
using vvll = vector<vll>;

using vlll = vector<triple>;
using vvlll = vector<vlll>;

using vs = vector<string>;
using vld = vector<ld>;

#define fi first
#define se second
#define th third

#define X first
#define Y second
#define Z third

#define con continue
#define pb push_back
#define re return

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sz(x) (int)(x).size()

template <typename T>
inline void sort(T & v) {
    sort(all(v));
}

template <typename T>
inline void reverse(T & v) {
    reverse(all(v));
}

template <typename T>
inline void unique( T & v) {
    sort(all(v));
    v.resize(unique(all(v)) - v.begin());
}

template <typename T>
void smin(T& s, const T& ot) {
    s = min(s, ot);
}

template <typename T>
void smax(T& s, const T& ot) {
    s = max(s, ot);
}

template <typename T1, typename T2>
istream& operator>>(istream &in, pair<T1, T2> &p) {
    in >> p.fi >> p.se; return in;
}

template <typename T>
istream& operator>>(istream &in, vector<T> &p) {
    for (auto &x : p) in >> x; return in;
}

template <typename T1, typename T2>
ostream& operator<<(ostream &out, pair<T1, T2> &p) {
    out << p.fi << p.se; return out;
}

//template <typename T1, typename T2>
//ostream& operator<<(ostream &out, pair<T1, T2> &p) {
//    out << p.fi << p.se; return out;
//}

ll n;
vl gr;

vvl ne = {{0, 3}, {2}, {1}, {0}};

vvl dp;
ll get_dp(ll p, ll mask) {
    ll & ans = dp[p][mask];
    if (ans != -1) re ans;

    if (mask & gr[p]) re ans = 0;

    ll block = mask | gr[p];
    if (p == n && block == 3) re ans = 1;

    ans = 0;
    for (auto x : ne[block]) {
        ans += get_dp(p + 1, x);
    }
    if (ans > 1) ans = 2;

    re ans;
}

void solve()
{
    cin >> n;
    gr = vl(n + 1);
    gr[n] = 3;
    vs a(2); cin >> a;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 2; j++) {
            gr[i] |= (a[j][i] == '#') << j;
        }
    }

    dp = vvl(n + 1, vl(4, -1));
    ll ans = get_dp(0, 0);
    if (ans == 0) {
        cout << "None\n";
    } else if (ans == 1) {
        cout << "Unique\n";
    } else {
        cout << "Multiple\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll t = 1;
    cin >> t;
    while(t--)
        solve();

    return 0;
}
