#include <bits/stdc++.h>

using namespace std;

using ll = long long;

bool is_dig(char x) {
    return '0' <= x && x <= '9';
}

ll count228(const vector<ll>& a, const vector<char>& b) {
//    for (auto x : a) {
//        cout << x << " a ";
//    }
//    cout << endl;
    ll ans = a[0];
    assert(a.size() == b.size() + 1);
    for (int i = 0; i < b.size(); ++i) {
        if (b[i] == '+') {
            ans += a[i + 1];
        } else if (b[i] == '-') {
            ans -= a[i + 1];
        } else {
            assert(false);
        }
    }
    return ans;
}

bool check_correct(const string& s) {
//    if (s == "123456789+987654321=1111111100+11-1") {
//
//    }
    bool prev_number = false;
    for (int i = 0; i < s.size(); ++i) {
        if (!prev_number && s[i] == '0' && i + 1 != s.size() && is_dig(s[i + 1])) {
            return false;
        }
        if (s[i] == '+' || s[i] == '-' || s[i] == '=') {
            if (!prev_number) {
                return false;
            }
            prev_number = false;
        } else {
            prev_number = true;
        }
        // prev_number = true;
    }
    if (!prev_number) {
        return false;
    }
    vector<ll> left_num;
    vector<char> left_signs;
    vector<ll> right_num;
    vector<char> right_signs;
    bool was_eq = false;
    ll val = 0;

    ll max_val = 1e10;
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] == '+' || s[i] == '-') {
            if (!was_eq) {
                left_num.push_back(val);
                val = 0;
                left_signs.push_back(s[i]);
            } else {
                right_num.push_back(val);
                val = 0;
                right_signs.push_back(s[i]);
            }
        } else if (s[i] == '=') {
            was_eq = true;
            left_num.push_back(val);
            val = 0;
        } else {
            val = val * 10 + (s[i] -'0');
            if (val >= max_val) {
                return false;
            }
        }
    }
    right_num.push_back(val);
//    for (auto x : left_num) {
//        cout << x << " AA ";
//    }
//    cout << endl;
//    for (auto x : right_num) {
//        cout << x << " BB ";
//    }
//    cout << endl;
    //cout << count228(left_num, left_signs) << " vs " <<  count228(right_num, right_signs) << endl;
    if (count228(left_num, left_signs) == count228(right_num, right_signs)) {
        return true;
    }
    return false;
}

void solve() {
    string s = "123456789+987654321=1111111100+11-1";
    cin >> s;
    if (check_correct(s)) {
        cout << "Correct\n";
        return;
    }
    for (int pos = 0; pos < s.size(); ++pos) {
        for (int nx = 0; nx < s.size(); ++nx) {

            if (is_dig(s[pos])) {
                string new_s;
                for (int i = 0; i < s.size(); ++i) {
                    if (i == nx) {
                        new_s.push_back(s[pos]);
                    }
                    if (i != pos) {
                        new_s.push_back(s[i]);
                    }
                }
                if (check_correct(new_s)) {
                    cout << new_s;
                    return;
                }
            }
        }
    }
    cout << "Impossible\n";
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    cout.flush();
}
