#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    //cout << n << endl;
    string a, b;
    cin >> a >> b;
    vector<set<int>> g(n + n);
    for (int i = 1; i < n; ++i) {
        if (a[i] == '.' && a[i - 1] == '.') {
            g[i].insert(i - 1);
            g[i - 1].insert(i);
        }
    }
    for (int i = 1; i < n; ++i) {
        if (b[i] == '.' && b[i - 1] == '.') {
            g[i + n].insert(i - 1 + n);
            g[i - 1 + n].insert(i + n);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (a[i] == '.' && b[i] == '.') {
            g[i].insert(i + n);
            g[i + n].insert(i);
        }
    }
    set<pair<int, int>> non_empty_nod;

    for (int i = 0; i < n; ++i) {
        if (a[i] == '.') {
            non_empty_nod.insert({g[i].size(), i});
        }
    }
    for (int i = 0; i < n; ++i) {
        if (b[i] == '.') {
            non_empty_nod.insert({g[i + n].size(), i + n});
        }
    }
    while (!non_empty_nod.empty()) {
        if (non_empty_nod.begin()->first == 0) {
            cout << "None\n";
            return;
        }
        if (non_empty_nod.begin()->first != 1) {
            cout << "Multiple\n";
            return;
        }
//        for (auto [x, y] : non_empty_nod) {
//            cout << x << " sdf " << y << endl;
//        }
//        cout << endl << endl;
        auto tmp = non_empty_nod.begin()->second;
        non_empty_nod.erase(non_empty_nod.begin());
        for (auto to : g[tmp]) {
            non_empty_nod.erase({g[to].size(), to});
            for (auto it_s : g[to]) {
                if (it_s != tmp) {
                    non_empty_nod.erase({g[it_s].size(), it_s});
                    g[it_s].erase(to);
                    non_empty_nod.insert({g[it_s].size(), it_s});
                }
            }
        }
    }
    cout << "Unique\n";
}

int main() {
    //freopen("input.txt", "r", stdin);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    cout.flush();
}
