#include <bits/stdc++.h>

#define int long long
#define ld long double
#define endl '\n'

using namespace std;
constexpr int Q = 1e5+5;
int t[Q];
vector<int> g[Q];
vector<int> gr[Q];
vector<int> order,order1;
bool used[Q];
int key1 = -1, key2 = -1;
void dfs1(int v){
    used[v] = true;
    for (int u : gr[v]){
        if (!used[u]){
            dfs1(u);
        }
    }
    if (t[v] == 2) order.push_back(v);
}
void dfs2(int v){
    if (t[v] != 0){
        return;
    }
    used[v] = true;
    for (int u : gr[v]){
        if (!used[u]){
            dfs2(u);
        }
    }
    order.push_back(v);
}
void dfs3(int v){
    used[v] = true;
    for (int u : gr[v]){
        if (!used[u]){
            dfs3(u);
        }
    }
    order.push_back(v);
}
void solve() {
    int n,m;cin >> n;
    memset(used,false,sizeof(used));
    for (int i = 0; i < n; ++i) {
        string s, ss;
        cin >> s >> ss;
        int type = 0;
        if (s=="set"){
            if (ss=="false") {
                type = 0;
            }else{
                if (key1 != -1){
                    cout << -1 << endl;
                    return;
                }
                key1 = i;
                type = 1;
            }
        }else{
            if (ss=="false") {
                type = 2;
            }else{
                if (key2 != -1){
                    cout << -1 << endl;
                    return;
                }
                key2 = i;
                type = 3;
            }
        }
        t[i] = type;
    }
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int a,b;cin >> a >> b;
        a--;b--;
        g[a].push_back(b);
        gr[b].push_back(a);
    }
    auto& ord = order;
    if (key1 == -1 && key2 !=-1){
        cout << -1 << endl;
        return;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i] && t[i] != 2) {
            dfs1(i);
        }
    }
    if (key1!=-1) order.push_back(key1);
    memset(used,false,sizeof(used));
    for (int i = 0; i < n; ++i) {
        if (t[i]==0 && !used[i]) {
            dfs2(i);
        }
    }
    memset(used,false,sizeof(used));
    for (int x : order){
        used[x] = true;
    }
    if (key2!=-1) {
        order.push_back(key2);
        assert(!used[key2]);
        used[key2] = true;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs3(i);
        }
    }
    assert(order.size() == n);
    int part = 0;
    for (int i = 0; i < n; ++i) {
        int x = order[i];
        if (t[x] == 0){
            if (part != 2){
                cout << -1 << endl;
                return;
            }
        }else if(t[x]==1){
            if (part != 0){
                cout << -1 << endl;
                return;
            }
            part = 2;
        }else if(t[x] == 2){
            if (part == 0 || part==4){

            }else{
                cout << -1 << endl;
                return;
            }
        }else if(t[x]==3){
            if (part != 2){
                cout << -1 << endl;
                return;
            }
            part = 4;
        }else{
            assert(false);
        }
    }
    vector<int> pos(n,-1);
    for (int i = 0; i < n; ++i) {
        pos[order[i]] = i;
    }
    for (int i = 0; i < n; ++i) {
        assert(pos[i]!=-1);
        for (int j : g[i]){
            if (pos[j] < pos[i]){
                cout << -1 << endl;
                return;
            }
        }
    }
    for (int x : order){
        cout << x+1 << " ";
    }cout << endl;
}

signed  main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    //int q; cin >> q; while(q--)
        solve();
}
