#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>

using namespace std;

int main()
{
    long long T;
    cin >> T;
    for (long long t = 0; t < T; ++t) {
        long long n, m, q;
        cin >> n >> m >> q;
        vector<pair<long long, long long>> tasks;
        for (long long i = 0; i < n; ++i) {
            long long len;
            cin >> len;
            tasks.push_back({0, len});
        }
        for (long long i = 0; i < n; ++i) {
            long long dead;
            cin >> dead;
            tasks[i].first = dead;
        }

        sort(tasks.begin(), tasks.end());
        vector<long long> epis;
        for (long long i = 0 ; i < m; ++i) {
            long long len;
            cin >> len;
            epis.push_back(len);
        }

        vector<long long> tests;
        for (long long i = 0; i < q; ++i) {
            long long time;
            cin >> time;
            tests.push_back(time);
        }

        long long rtime = tasks[n-1].first; // last deadline
        vector<long long> tstart(n, 0); // latest possible time to start task
        for (long long i = n-1; i >= 0; --i) {
            rtime = min(rtime, tasks[i].first);
            rtime = rtime - tasks[i].second;
            tstart[i] = rtime;
        }

        vector<long long> estart(m, 0);
        long long ltime = 0;
        long long task_i = 0;
        for (long long ep_i = 0; ep_i < m; ++ep_i) {
            if (task_i >= tasks.size() || ltime + epis[ep_i] <= tstart[task_i]) {
                // good
                estart[ep_i] = ltime;
                ltime += epis[ep_i];
            } else {
                tstart[task_i] = ltime;
                ltime += tasks[task_i].second;
                task_i += 1;
                ep_i -= 1; // повторить пихнуть эпизод
            }
        }

        for (long long i = 0; i < m; ++i) {
            estart[i] += epis[i]; // !
         }
        for (long long i = 0; i < q; ++i) {
            long long tk = tests[i];

            long long l = 0; 
            long long r = m;
            long long mid;
            while (r - l > 1) {
                mid = (r + l) / 2;
                if (estart[mid] <= tk) l = mid;
                else r = mid;
            }
            cout << r << " ";
        }
        cout << '\n';
    }
}