#include <iostream>
#include <vector>
#include <queue>

using namespace std;

void Solve() {
    int n;
    cin >> n;
    string s[2];
    cin >> s[0] >> s[1];
    bool isMul = false;
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        if (s[0][i] == '#' && s[1][i] == '#') {
            continue;
        }
        if (s[0][i] == '.' && s[1][i] == '.') {
            s[0][i] = s[1][i] = '#';
            b[i] = 1;
            if (b[i - 1] == 1) {
                isMul = 1;
            }
        }
        if (s[0][i] == '.' && s[1][i] == '#') {
            if (i != n - 1 && s[0][i + 1] == '.') {
                s[0][i] = s[0][i + 1] = '#';
            } else {
                cout << "None\n";
                return;
            }
        }
        if (s[0][i] == '#' && s[1][i] == '.') {
            if (i != n - 1 && s[1][i + 1] == '.') {
                s[1][i] = s[1][i + 1] = '#';
            } else {
                cout << "None\n";
                return;
            }
        }
    }
    cout << (isMul ? "Multiple\n" : "Unique\n");
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    int q;
    cin >> q;
    for (int t = 0; t < q; t++) {
        Solve();
    }
}
