def statement_correctness(expr) -> bool:
    prev_numbering, numbering = False, False
    start, end = 0, 0
    for i, c in enumerate(expr):
        prev_numbering, numbering = numbering, c.isdigit()

        # Два раза подряд не число
        if not prev_numbering and not numbering:
            return False

        # Было не число, стало число
        if not prev_numbering and numbering:
            start = i
            if c == '0' and i < len(expr)-1 and expr[i+1].isdigit():
                return False

        # Было число, стало не число
        if prev_numbering and not numbering:
            end = i
            if end - start > 10:
                return False
    return True


def is_correct(expr):
    left, right = expr.split('=')
    try:
        return eval(left) == eval(right)
    except:
        return False


def main():
    expr = input()

    if is_correct(expr):
        print("Correct")
        return

    positions = [i for i in range(len(expr)) if expr[i].isdigit()]

    for p in positions:
        c = expr[p]
        for j in range(0, len(expr)+1):
            expr_copy = list(expr)

            if j < p:
                expr_copy.pop(p)
                expr_copy.insert(j, c)
            else:
                expr_copy.insert(j, c)
                expr_copy.pop(p)
            expr_copy = ''.join(expr_copy)

            if statement_correctness(expr_copy) and is_correct(expr_copy):
                print(expr_copy)
                return

    print("Impossible")


main()
