#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <random>
#include <numeric>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
mt19937 engine;

void solve();
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	
	engine.seed(time(nullptr));

	ll T = 1;
	//cin >> T;
	while (T--) {
		solve();
	}
}

bool check(string& str) {
	ll curr = 0;
	ll cnt = 0;
	bool isNull = false;

	if (str[0] == '+' || str[0] == '-') return false;
	if (str[str.size() - 2] == '+' || str[str.size() - 2] == '-') return false;

	ll sign = 1;

	ll res[2] = { 0, 0 };
	ll side = 0;

	for (char ch : str) {
		if (ch != '+' && ch != '-' && ch != '=' && ch != '*') {
			cnt++;
			if (cnt == 11) return false;

			ll digit = ch - '0';

			if (digit == 0 && !curr && !isNull) {
				isNull = true;
				continue;
			}

			if (digit == 0 && !curr) {
				return false;
			}

			if (isNull) return false;

			curr *= 10;
			curr += digit;
			continue;
		}

		if (!isNull && !curr) return false;

		cnt = 0;
		isNull = false;
		res[side] += curr * sign;
		if (ch == '-') sign = -1;
		else sign = 1;


		if (ch == '=') side = 1;

		curr = 0;
	}

	return res[0] == res[1];
}

void solve() {
	string str;
	cin >> str;

	str += '*';

	if (check(str)) {
		cout << "Correct";
		return;
	}


	for (ll i = 0; i < str.size(); ++i) {
		if (str[i] == '+' || str[i] == '-' || str[i] == '=' || str[i] == '*') continue;
		string curr = str;

		for (ll j = i - 1; j >= 0; --j) {
			swap(curr[j + 1], curr[j]);
		}

		if (check(curr)) {
			for (char ch : curr) if (ch != '*') cout << ch;
			return;
		}

		for (ll j = 0; j < str.size() - 2; ++j) {
			swap(curr[j], curr[j + 1]);
			if (check(curr)) {
				for (char ch : curr) if (ch != '*') cout << ch;
				return;
			}
		}
	}

	cout << "Impossible";
}