//*
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("tree-vectorize")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
//*/
#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef long double ld;
typedef pair<ll, ll> pll;

#define f first 
#define s second
#define x first 
#define y second

void solve() {
    int n;
    cin >> n;
    vector<int> c(n), pos(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i];
        c[i]--;
        pos[c[i]] = i;
    }
    vector<vector<bool>> ok(n, vector<bool>(n, true));
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (c[i] > c[j])
                ok[c[j]][c[i]] = false;
        }
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        for (int j = pos[i] - 1; j >= i; j--) {
            ans.push_back(make_pair(c[j] + 1, c[j + 1] + 1));
            swap(c[j], c[j + 1]);
            pos[c[j]] = j;
            pos[c[j + 1]] = j + 1;
        }
        if (i == 0)
            continue;
        if (ok[i - 1][i]) {
            ans.push_back(make_pair(i, i + 1));
            ans.push_back(make_pair(i + 1, i));
        }
    }
    reverse(ans.begin(), ans.end());
    cout << (int)ans.size() << '\n';
    for (auto p : ans) {
        cout << p.first << ' ' << p.second << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}