//*
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("tree-vectorize")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
//*/
#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef long double ld;
typedef pair<ll, ll> pll;

#define f first
#define s second
#define x first
#define y second

void solve() {
    int n;
    cin >> n;
    vector<int> c(n), pos(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i];
        c[i]--;
        pos[c[i]] = i;
    }
    for (int i = 0; i < n; i++)
        c[i] = i;
    vector<pair<int, int>> ans1;
    for (int i = n - 1; i >= 0; i--) {
        int k = -1;
        for (int j = 0; j < n; j++) {
            if (pos[j] == i)
                k = j;
        }
        int x = -1;
        for (int j = 0; j < n; j++) {
            if (c[j] == k)
                x = j;
        }
//        cout << k << ' ' << x << '\n';
        for (int j = x - 1; j >= 0; j--) {
            ans1.push_back(make_pair(c[j + 1] + 1, c[j] + 1));
            swap(c[j], c[j + 1]);
        }

        for (int j = 0; j < i; j++) {
            ans1.push_back(make_pair(c[j + 1] + 1, c[j] + 1));
            swap(c[j], c[j + 1]);
        }
    }
    for (int i = 0; i < n; i++)
        c[i] = i;
    vector<pair<int, int>> ans2;
    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < n; j++)
//            cout << c[j] << ' ';
//        cout << '\n';
        int k = -1;
        for (int j = 0; j < n; j++) {
            if (pos[j] == i)
                k = j;
        }
        int x = -1;
        for (int j = 0; j < n; j++) {
            if (c[j] == k)
                x = j;
        }
//        cout << k << ' ' << x << '\n';
        assert(k != -1);
        assert(x != -1);
        for (int j = x + 1; j < n; j++) {
            ans2.push_back(make_pair(c[j] + 1, c[j - 1] + 1));
            swap(c[j], c[j - 1]);
        }

        for (int j = n - 2; j >= i; j--) {
            ans2.push_back(make_pair(c[j + 1] + 1, c[j] + 1));
            swap(c[j], c[j + 1]);
        }
    }
    if (ans1.size() > ans2.size()) {
        cout << (int) ans1.size() << '\n';
        for (auto p: ans1) {
            cout << p.first << ' ' << p.second << '\n';
        }
    }
    else {
        cout << (int) ans2.size() << '\n';
        for (auto p: ans2) {
            cout << p.first << ' ' << p.second << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}