/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("tree-vectorize")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
//*/
#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef long double ld;
typedef pair<ll, ll> pll;

#define f first 
#define s second
#define x first 
#define y second

ll n, m;
const ll MAXN = 1e5 + 10;

string type[MAXN];

vector<ll> g[MAXN];
vector<ll> ord;
ll used[MAXN];
ll ma[MAXN];

bool dfs(ll v) {
    used[v] = 1;
    for (ll to: g[v]) {
        if (used[to] == 2) continue;
        if (used[to] == 1) {
            cout << "-1\n";
            exit(0);
        }
        dfs(to);
    }
    used[v] = 2;
    ord.push_back(v);
    return true;
}

void no() {
    cout << "-1" << endl;
    exit(0);
}

void solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        string s, b;
        cin >> s >> b;
        if (s == "set") s = "s";
        else s = "u";
        if (b == "true") b = "t";
        else b = "f";
        type[i] = s + b;
    }
    cin >> m;
    for (int i = 0; i < m; ++i) {
        ll a, b;
        cin >> a >> b;
        g[a].push_back(b);
    }
    ll cut = 0;
    ll cst = 0;
    ll st = -1;
    ll ut = -1;
    for (int i = 1; i <= n; ++i) {
        if (type[i] == "st") {
            ++cst;
            st = i;
        } else if (type[i] == "ut") {
            ++cut;
            ut = i;
        }
    }
    if (cst > 1 || cut > 1 || cut > cst) {
        no();
    }
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }
    reverse(ord.begin(), ord.end());
    for (int i = 0; i < n; ++i) {
        ll v = ord[i];
        ll delta = 0;
        if (type[v] == "st") delta = 0b1;
        else if (type[v] == "ut") delta = 0b10;
        else if (type[v] == "sf") delta = 0b100;
        else delta = 0b1000;
        delta |= ma[v];
        for (ll to: g[v]) {
            ma[to] |= delta;
        }
        if (type[v] == "st") {
            if ((ma[v] & 0b0111) != 0) no();
        } else if (type[v] == "sf") {
            if ((ma[v] & 0b0001) == 1 || st == -1) no();
        } else if (type[v] == "uf") {
            if ((ma[v] & 0b111) != 0 && (ut == -1 || st == -1)) no();
        }
    }
    if (st != -1) {
        for (int i = 1; i <= n; ++i) {
            if (type[i] == "uf" && (ma[i] & 0b0111) == 0) {
                g[i].push_back(st);
            } else if (type[i] == "sf") {
                g[st].push_back(i);
            }
        }
        if (ut != -1) {
            g[st].push_back(ut);
            for (int i = 1; i <= n; ++i) {
                if (type[i] == "uf" && (ma[i] & 0b0111) != 0) {
                    g[ut].push_back(i);
                } else if (type[i] == "sf") {
                    g[i].push_back(ut);
                }
            }
        }
    }
    ord.clear();
    fill(used, used + n + 1, 0);
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) dfs(i);
    }
    reverse(ord.begin(), ord.end());
    for (ll i: ord) cout << i << " ";
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}