#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
using namespace std;

#define int long long

bool key = true;

int calculate(string s) {
	vector <string> val;
	vector <char> sign;
	int pos = 0, pos2 = 0;
	while (pos < s.length()) {
		while (pos2 < s.length() && s[pos2] != '+' && s[pos2] != '-') pos2++;
		val.push_back(s.substr(pos, pos2 - pos));
		if (pos2 != s.length()) sign.push_back(s[pos2]);
		pos2++;
		pos = pos2;
	}

	for (int c = 0; c < val.size(); c++)
		if (val[c].size() > 10)
			key = false;

	int ans = stoll(val[0]);

	for (int i = 1; i < val.size(); i++)
		if (sign[i - 1] == '+')
			ans += stoll(val[i]);
		else
			ans -= stoll(val[i]);

	return ans;
}

bool check(string& s) {
	for (int i = 0; i < s.length(); i++)
		if (s[i] == '=')
			return calculate(s.substr(0, i)) == calculate(s.substr(i + 1, s.length() - i - 1));
	return false;
}

bool isSign(char c) {
	return c == '+' || c == '-' || c == '=';
}

signed main() {
#ifdef _DEBUG
	auto f1 = freopen("input.txt", "r", stdin);
	auto f2 = freopen("output.txt", "w", stdout);
#endif

	string s; cin >> s;
	int n = s.length();

	if (check(s)) {
		cout << "Correct";
		return 0;
	}

	for (int i = 0; i < n; i++) {
		if (isSign(s[i])) continue;
		for (int j = 0; j < n; j++) {
			if ((!i || isSign(s[i - 1])) && (i == n - 1 || isSign(s[i + 1]))) 
				continue;
			string temp = s;
			string add = s.substr(i, 1);
			temp.erase(i, 1);
			temp.insert(j, add);
			bool flag = true;
			for (int c = 0; c < n; c++)
				if (temp[c] == '0' && (c == 0 || isSign(temp[c - 1])))
					flag = false;
			key = true;
			if (flag && check(temp)) {
				if (key) {
					cout << temp;
					return 0;
				}
			}
		}
	}
	cout << "Impossible";

}