#include <iostream>
#include <vector>

using namespace std;

const int N = 1007;

int n;
int c[N];
int ind[N];

int main() {
  cin >> n;
  for (int i = 0; i < n; ++i) {
    cin >> c[i];
    --c[i];
    ind[c[i]] = i;
  }
  vector<int> cur;
  vector<pair<int, int>> ans;
  for (int i = 0; i < n; ++i) {
    cur.push_back(i);
    int j = cur.size() - 1;
    while (j) {
      ans.push_back({cur[j], cur[j - 1]});
      swap(cur[j], cur[j - 1]);
      --j;
    }
    while (j + 1 < cur.size() && ind[cur[j]] > ind[cur[j + 1]]) {
      ans.push_back({cur[j + 1], cur[j]});
      swap(cur[j], cur[j + 1]);
      ++j;
    }
  }
  cout << ans.size() << '\n';
  for (auto elem : ans) {
    cout << elem.first + 1 << ' ' << elem.second + 1 << '\n';
  }
  return 0;
}