#include <bits/stdc++.h>

using namespace std;


using ll = long long;
using ld = long double;
using vi = vector<int>;
using vl = vector<ll>;

bool isNum(char c)
{
    return c >= '0' && c <= '9';
}

bool check(string& s)
{
    // cout << s << endl;
    int n = s.size();

    {
        size_t eq = s.find('=');
        if(eq == string::npos || eq == 0 || eq == n-1)
            return false;
    }


    ll sum = 0;
    ll isEq = 1;
    ll isMinus = 1;

    ll cur = 0;
    int len = 0;
    for(int i = 0; i < n;)
    {
        if(i > 0 && !isNum(s[i]) && !isNum(s[i-1]))
            return false;

        if(s[i] == '=')
        {
            isEq = -1;
            i++;
            continue;
        }
        if(s[i] == '-')
        {
            isMinus = -1;
            i++;
            continue;
        }
        if(s[i] == '+')
        {
            i++;
            continue;
        }

        while(i+len < n && isNum(s[i+len]))
        {
            cur = cur * 10ll + s[i+len] - '0';
            len++;
        }

        if(len > 1 && s[i] == '0')
            return false;
        if(len > 10)
            return false;

        // cout << i << " " << cur << " " << len << " " << isMinus << " " << isEq << endl;

        i += len;

        sum += cur * isEq * isMinus;
        cur = 0;
        len = 0;
        isMinus = 1;

    }
    // cout << sum << endl;

    return sum == 0;
}

void solve()
{
    string s;
    cin >> s;

    int n = s.size();

    if(check(s))
    {
        cout << "Correct";
        return;
    }

    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
            if(i == j) continue;
            if(!isNum(s[j])) continue;

            string ss = s;
            ss.insert(ss.begin() + i, s[j]);
            ss.erase(ss.begin() + j + (i < j));

            if(check(ss))
            {
                cout << ss;
                return;
            }
        }
    }

    cout << "Impossible";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int T = 1;
    // cin >> T;

    while(T--> 0)
    {
        solve();
    }

    return 0;
}