#include <bits/stdc++.h>
using namespace std;

#define fi first
#define se second
#define pb push_back

using ll = long long;
using ld = long double;
using vi = vector<int>;
using vl = vector<ll>;
using pll = pair<ll, ll>;
using vll = vector<pll>;

const ll INFL = 2e18;
#define all(x) (x).begin(), (x).end()

struct event{
    ll x, type, id;
};

void solve(){
    int n, m, q;
    cin >> n >> m >> q;
    vll a(n);
    for(auto &[d, len] : a) cin >> len;
    for(auto &[d, len] : a) cin >> d;

    vl l(m+1), pr(m+1, 0); // 1..m
    for(int i = 1; i <= m; i++) cin >> l[i];
    for(int i = 1; i <= m; i++) pr[i] = pr[i-1] + l[i];

    vector<event> c;
    vl t(q);
    for(int i = 0; i < q; i++){
        cin >> t[i];
        c.pb({t[i], 2, i});
    }
    
    sort(all(a));
    vll b(n); ll lst = INFL;
    for(int i = n-1; i >= 0; i--){
        b[i].se = min(a[i].fi, lst);
        b[i].fi = b[i].se - a[i].se;
        lst = b[i].fi;

        c.pb({b[i].fi, 1, -1});
        c.pb({b[i].se, 0, -1});
    }
 
    sort(all(c), [&](event& u, event& v){
        return u.x < v.x || (u.x == v.x && u.type < v.type);
    });

    vi ans(q, -1);

    lst = -1; ll len = 0;
    for(auto [x, type, id] : c){
        if(type == 0){
            //assert(lst != -1);
            len += (x - lst);
            lst = -1;
        }
        else if(type == 1){
            lst = x;
        }
        else{
            ll tot = x - len;
            if(lst != -1) tot -= (x - lst);

            int l = 0, r = m+1;
            while(l + 1 < r){
                int m = (l + r) / 2;
                if(pr[m] > tot) r = m;
                else l = m;
            }
            ans[id] = l;

            //cout << "! " << id << " " << tot << " " << l << '\n';
        }
    }
    for(int i = 0 ; i < q; i++){
        cout << ans[i] << ' ';
    }
    cout << '\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int T = 1;
    cin >> T;

    while(T--> 0)
    {
        solve();
    }

    return 0;
}