#include <iostream>
#include <vector>
#include <string>
#include <array>
#include <algorithm>
#include <numeric>

using ll = long long;

std::string solve() {
    ll n;
    std::cin >> n;
    std::vector<std::string> v(2);
    for (auto &s: v) {
        std::cin >> s;
    }

    int ans = 1;
    for (ll i = 0; i + 1 < n; ++i) {
        if (v[0][i] == '.' && v[1][i] == '.' && v[0][i + 1] == '.' && v[1][i + 1] == '.') {
            ans = 2;
            v[0][i] = v[1][i] = v[0][i + 1] = v[1][i + 1] = '#';
            continue;
        }
        if (v[0][i] == '#' && v[1][i] == '#') {
            continue;
        }

        if (v[0][i] == '#' && v[1][i + 1] == '#' || v[1][i] == '#' && v[0][i + 1] == '#') {
            return "None";
        }

        if (v[0][i] == '.' && v[1][i] == '.') {
            v[0][i] = v[1][i] = '#';
            continue;
        }

        if (v[0][i] == '#') {
            v[1][i] = v[1][i + 1] = '#';
        } else if (v[1][i] == '#') {
            v[0][i] = v[0][i + 1] = '#';
        }
    }
    if (v[0].back() != v[1].back()) {
        return "None";
    }
    return ans == 1 ? "Unique" : "Multiple";
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    ll t = 0;
    std::cin >> t;

    while (t--) {
        std::cout << solve() << '\n';
    }

    return 0;
}

/*
12
10
#.......##
##..#.##..
6
...#..
..#...
8
........
........
3
###
###
5
#..##
..#..
3
##.
##.
4
#..#
....
6
#..#..
......
6
.#..#.
.#....
1
.
.
1
#
.
6
.#..#.
....#.

 */