#include <iostream>
#include <vector>

using namespace std;

const int maxn = 1e5 + 1329;

vector<int> g[maxn];

int used[maxn];
vector<int> out;
bool dfs(int u) {
    used[u] = 1;
    for (int v : g[u]) {
        if (used[v] == 1) return false;
        if (used[v] == 0 && !dfs(v)) return false;
    }
    used[u] = 2;
    out.push_back(u);
    return true;
}

signed main() {
    int n; cin >> n;
    vector<pair<char, bool>> q;
    int cnttrue = 0;
    for (int i = 0; i < n; ++i) {
        string t, r; cin >> t >> r;
        q.emplace_back(t[0], r == "true");
        cnttrue += (r == "true");
    }
    //cout << cnttrue << '\n';
    int m; cin >> m;
    for (int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v;
        u -= 1; v -= 1;
        g[u].push_back(v);
    }
    if (cnttrue == 0) {
        for (int i = 0; i < n; ++i) {
            if (q[i].first != 's') {
                cout << -1 << '\n';
                return 0;
            }
        }
    }
    if (cnttrue == 1) {
        int iset;
        for (int i = 0; i < n; ++i) {
            if (q[i].second) {
                if (q[i].first == 's') {
                    iset = i;
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            if (!q[i].second) {
                if (q[i].first == 'u') {
                    g[i].push_back(iset);
                } else {
                    g[iset].push_back(i);
                }
            }
        }
    }
    if (cnttrue == 2) {
        int iset, iunset;
        for (int i = 0; i < n; ++i) {
            if (q[i].second) {
                if (q[i].first == 's') {
                    iset = i;
                } else {
                    iunset = i;
                }
            }
        }
        g[iset].push_back(iunset);
        //cout << iset << ' ' << iunset << '\n';
        for (int i = 0; i < n; ++i) {
            if (!q[i].second) {
                if (q[i].first == 's') {
                    g[iset].push_back(i);
                    g[i].push_back(iunset);
                }
            }
        }
        fill(used, used + n, false);
        if (!dfs(iset)) {
            cout << -1 << '\n';
            return 0;
        }
        for (int i = 0; i < n; ++i) {
            if (!q[i].second && q[i].first == 'u') {
                if (used[i] == 2) g[iunset].push_back(i);
                else g[i].push_back(iset);
            }
        }
        
    }
    bool ok = true;
    fill(used, used + n, false);
    out.clear();
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            ok &= dfs(i);
        }
    }
    if (!ok) {
        cout << -1 << '\n';
        return 0;
    }
    for (int i = n - 1; i >= 0; --i) {
        cout << out[i] + 1 << ' ';
    } cout << '\n';
}