#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define F first
#define S second
#define endl '\n'

typedef long long ll;

using namespace std;

int n;
vector<int> v;
vector<vector<int>> g;
vector<vector<int>> g2;
vector<pair<int, int>> rg;

vector<pair<int, int>> c;
vector<bool> used, ok;

void dfs(int x, int last) {
    if (used[x]) return;
    used[x] = true;
    for (auto u : g2[x]) {
        if (last != -1 && u == last && !ok[x] && !ok[u]) {
            c.push_back({x, u});
            ok[x] = ok[u] = true;
            continue;
        }
        dfs(u, x);
    }
}

void solve() {
    cin >> n;
    int k = 2 * n;
    v.resize(k);
    used.assign(k, false);
    ok.assign(k, false);
    for (int i = 0; i < k; i++) cin >> v[i];
    rg.assign(n, {-1, -1});
    for (int i = 0; i < k; i++) {
        v[i]--;
        if (rg[v[i]] == make_pair(-1, -1)) rg[v[i]].F = i;
        else {
            rg[v[i]].S = i;
            if (rg[v[i]].S < rg[v[i]].F) swap(rg[v[i]].S, rg[v[i]].F);
        }
    }
    g.assign(k, {});
    for (int i = 0; i < k - 1; i++) {
        int a, b; cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    g2.assign(k, {});
    for (int i = 0; i < k; i++) {
        int ver = i, val = v[i];
        int ver2 = (rg[val].F == ver  ? rg[val].S : rg[v[i]].F);
        for (auto u : g[ver2]) {
            g2[ver].push_back(u);
        }
    }
    for (int i = 0; i < k; i++) dfs(i, -1);
    for (int a = 0; a < k; a++) {
        for (auto b : g2[a]) {
            if (ok[a] || ok[b]) continue;
            c.push_back({a, b});
            ok[a] = ok[b] = true;
        }
    }
    cout << c.size() << endl;
    for (auto [a, b] : c) {
        cout << a + 1 << ' ' << b + 1 << endl;
    }
}

int main() {
   int t; cin >> t;
   while (t--) solve();
}
