#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>

using namespace std;

int main() {
	int n; cin >> n;
	vector<string> a(n);
	for (int i = 0; i < n; i++) {
		string s, p;
		cin >> s >> p;
		a[i] = string(1, s[0]) + (p == "true" ? "1" : "0");
	}
	vector<vector<int>> g(n);
	vector<int> in(n, 0);
	int m; cin >> m;
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		x--, y--;
		g[x].push_back(y);
		in[y]++;
	}
	map<string, queue<int>> qs;
	for (int i = 0; i < n; i++) {
		if (in[i] == 0) {
			qs[a[i]].push(i);
		}
	}
	auto push = [&](int v) {
		for (auto i : g[v]) {
			in[i]--;
			if (in[i] == 0) {
				qs[a[i]].push(i);
			}
		}
	};
	vector<int> order;
	int state = 0;
	while (true) {
		bool was = false;
		if (state == 0) {
			{
				auto& cq = qs["u0"];
				while (cq.size()) {
					int v = cq.front();
					cq.pop();
					push(v);
					order.push_back(v);
					was = true;
				}				
			}
			{
				auto& cq = qs["s1"];
				while (cq.size()) {
					int v = cq.front();
					cq.pop();
					push(v);
					order.push_back(v);
					state = 1;
					was = true;
					break;
				}
			}
		}
		else {
			{
				auto& cq = qs["u1"];
				while (cq.size()) {
					int v = cq.front();
					cq.pop();
					push(v);
					order.push_back(v);
					was = true;
				}
			}
			{
				auto& cq = qs["s0"];
				while (cq.size()) {
					int v = cq.front();
					cq.pop();
					push(v);
					order.push_back(v);
					state = 0;
					was = true;
					break;
				}
			}
		}
		if(!was) break;
	}
	if (order.size() == n) {
		for (auto i : order) {
			cout << i + 1 << ' ';
		}
	}
	else cout << -1;
	return 0;
}