#include <bits/stdc++.h>
#define sz(_a) ((int)((_a).size()))

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> par;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const par tur[4] = {{-1, 0}, {0, -1}, {1, 0}, {0, 1}};

inline signed solve() {
    int n;
    cin >> n;
    string s[2];
    cin >> s[0] >> s[1];

    vector<int> cnt[2];
    cnt[0].resize(n);
    cnt[1].resize(n);
    set<par> st;
    vector<vector<int>> a(n + n);
    vector<bool> used(n + n);

    auto is_good = [&](int nx, int ny) -> bool {
        if (nx < 0 || nx >= 2 || ny < 0 || ny >= n) {
            return false;
        }
        if (s[nx][ny] == '#') {
            return false;
        }
        return true;
    };

    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            if (s[i][j] == '#') {
                continue;
            }
            int ind = i * n + j;
            for (auto [dx, dy] : tur) {
                int nx = i + dx;
                int ny = j + dy;
                if (!is_good(nx, ny)) {
                    continue;
                }
                a[ind].push_back(nx * n + ny);
            }
            st.emplace(sz(a[ind]), ind);
        }
    }
    while (!st.empty()) {
        auto [val, ind] = *st.begin();
        st.erase(st.begin());
        if (val > 1) {
            return cout << "Multiple", 0;
        }
        if (val == 0) {
            return cout << "None", 0;
        }
        used[ind] = true;

        int k = 0;
        for (auto sec : a[ind]) {
            if (used[sec]) {
                continue;
            }
            used[sec] = true;
            st.erase({sz(a[sec]), sec});
            for (auto trd : a[sec]) {
                if (used[trd]) {
                    continue;
                }
                int ps = -1;
                for (int ii = 0; ii < sz(a[trd]); ++ ii) {
                    if (a[trd][ii] == sec) {
                        ps = ii;
                        break;
                    }
                }
                st.erase({sz(a[trd]), trd});
                swap(a[trd][ps], a[trd].back());
                a[trd].pop_back();
                st.emplace(sz(a[trd]), trd);
            }
            ++k;
        }
        if (k != 1) {
                cerr << k << '\n';
            return cout << "None", 0;
        }
    }
    cout << "Unique";

    return 0;
}

signed main() {
#ifdef MAKS
    freopen("in.txt", "r", stdin);
#endif // MAKS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(10);
    cerr << fixed << setprecision(3);
    int t_t = 1;
    cin >> t_t;
    while (t_t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
