#include <iostream>
#include <vector>
#include <unordered_set>
#include <set>
#include <algorithm>

using namespace std;

bool used[1002][1002];
#define int long long

int cmp(pair<int, int>a, pair<int, int> b) {
    if (a.first < b.first) return -1;
    if (a.first > b.first) return 1;
    if (a.second < b.second) return -1;
    if (a.second > b.second) return 1;
    return 0;
}


void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> a(n);
    for (int i =0 ; i < n; i++) {
        cin >> a[i];
    }
    vector<pair<int, int>> d(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        d[i] = {t, i};
    }
    vector<int> l(m);
    vector<int> psl(m+1);
    psl[0] = 0;
    for (int i = 0; i < m; i++) {
        cin >> l[i];
        psl[i+1] = psl[i] + l[i];
    }
    vector<pair<int, int>> times(q);
    for (int i = 0; i < q; i++) {
        int t;
        cin >> t;
        times[i] = {t, i};
    }
    vector<int> delta(n);
    sort(d.begin(), d.end());
    int sum_time = 0;
    for (int i = 0 ; i < n; i++) {
        sum_time += a[d[i].second];
        delta[i] = d[i].first - sum_time;
    }
    vector<int> ost(n+1);
    ost[n] = 1000000000000000000;
    for (int i = n-1; i >= 0; i--) {
        ost[i] = min(ost[i+1], delta[i]);
    }
    sort(times.begin(), times.end());
    vector<int> ans(q);
    for (int i = 0; i < q; i++) {
        pair<int, int> p = {times[i].first, -1ll};
        int ind = std::distance(d.begin(), std::lower_bound(d.begin(), d.end(), p));
        int anss = -1;
        if (ind >= 1) {
            anss = times[i].first - d[ind-1].first + delta[ind-1];
        } else {
            anss = times[i].first;
        }
        anss = min(anss, ost[ind]);
        ans[times[i].second] = std::distance(psl.begin(), std::lower_bound(psl.begin(), psl.end(), anss));
        if (psl[ans[times[i].second]] != anss) {
            ans[times[i].second]--;
        }
    }
    for (int i = 0; i < q; i++) {
        cout << ans[i] << " ";
    }
    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie();

    int t;
    cin >> t;
    for (int i = 0 ; i< t; i++) {
        solve();
    }

    return 0;
}
