#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll INF = 1e18 + 100;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<pair<ll, ll>> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i].second;
    for (int i = 0; i < n; ++i) cin >> a[i].first;
    sort(a.begin(), a.end());
    for (int i = 1; i < n; ++i) {
        a[i].second += a[i - 1].second;
    }
    vector<ll> t(m);
    for (int i = 0; i < m; ++i) cin >> t[i];
    for (int i = 1; i < m; ++i) t[i] += t[i - 1];
    vector<ll> p(n + 1);
    ll mn = INF;
    for (int i = n; i >= 0; --i) {
        if (i < n) {
            mn = min(mn, a[i].first - a[i].second);
        }
        p[i] = mn;
    }
    vector<ll> x;
    int j = 0;
    for (int i = 0; i < m; ++i) {
        while (t[i] > p[j]) ++j;
        if (j > 0)
            x.push_back(a[j - 1].second + t[i]);
        else
            x.push_back(t[i]);
    }
    while (q--) {
        ll l;
        cin >> l;
        cout << upper_bound(x.begin(), x.end(), l) - x.begin() << ' ';
    }
    cout << '\n';
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int ts;
    cin >> ts;
    while (ts--) {
        solve();
    }
}
