#include <iostream>
#include <vector>

typedef long long ll;
typedef long double ld;

using namespace std;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int n;
	cin >> n;
	vector<int> res(n);
	vector<int> v(n);
	for (int i = 0; i < n; i++) {
		cin >> res[i];
		v[i] = i + 1;
	}
	vector<vector<int>> m(n+1, vector<int>(n+1));
	vector<pair<int, int>> ans;
	for (int r = 0; r < n; r++) {
		for (int i = r; i < n; i++) {
			if (res[r] == v[i]) {
				int t = i;
				while (t != r) {
					ans.push_back(make_pair(v[t], v[t - 1]));
					m[v[t]][v[t - 1]] = 1;
					swap(v[t], v[t - 1]);
					t--;
				}
				break;
			}
		}
	}
	for (int i = 0; i < n-1; i++) {
		if (m[v[i]][v[i + 1]] == 0 && m[v[i + 1]][v[i]] == 0) {
			ans.push_back(make_pair(v[i + 1], v[i]));
			ans.push_back(make_pair(v[i], v[i+ 1]));
		}
	}
	cout << ans.size()<<endl;
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i].first << ' ' << ans[i].second<<endl;
	}
}